#include "hud.h"
#include "cl_util.h"
#include "parsemsg.h"
#include <stdio.h>
#include <string.h>

#include "define_hud.h"

#define Gm_ICON_VIE		"hud_icon_vie"

DECLARE_MESSAGE( m_Health, Health )

int CHudHealth::Init( void )
{
	HOOK_MESSAGE( Health );
	m_iHealth = 100;
	m_iFlags = 0;

	gHUD.AddHudElem( this );
	return 1;
}

int CHudHealth:: MsgFunc_Health(const char *pszName,  int iSize, void *pbuf )
{
	// TODO: update local health data
	BEGIN_READ( pbuf, iSize );
	int x = READ_BYTE( );

	m_iFlags |= HUD_ACTIVE;

	// Only update the fade if we've changed health
	if( x != m_iHealth )
	{
		m_fFade = FADE_TIME;
		m_iHealth = x;
	}

	return 1;
}

int CHudHealth::Draw(float flTime)
{
	int r = 255;
	int b = 255;
	int g = 255;
	int x, y;

	y = ScreenHeight - gHUD.m_iFontHeight - gHUD.m_iFontHeight / 2;
	x = ScreenWidth / 5;

	HSPRITE GvSpriteReste = gHUD.GetSpriteIndex( Gm_ICON_VIE );
	SPR_Set( gHUD.GetSprite( GvSpriteReste ), 255, 255, 255);
	SPR_Draw( 0, x - 40, y, &gHUD.GetSpriteRect( GvSpriteReste ));

	gHUD.DrawHudNumber( x, y, DHN_3DIGITS | DHN_DRAWZERO, m_iHealth, r, g, b );

	return 1;
}