#include "hud.h"
#include "cl_util.h"
#include "parsemsg.h"
#include <stdio.h>
#include <string.h>
#include "fmod.h"


cvar_t *wm_volume;
bool music;


void musique_on_off() {music=!music;}



CHudMp3 :: ~CHudMp3()
{
	FSOUND_Stream_Close(stream);
	FSOUND_Close();
}


int CHudMp3 :: Init( void )
{
	m_iFlags |= HUD_ACTIVE;
	gHUD.AddHudElem( this );

	gEngfuncs.pfnAddCommand( "wm_music", musique_on_off );
	wm_volume=gEngfuncs.pfnRegisterVariable("wm_volume", "255", FCVAR_ARCHIVE);

	return 1;
}

int CHudMp3::VidInit(void)
{
	FSOUND_SetSFXMasterVolume(255);
	FSOUND_Stream_Close(stream);
	FSOUND_Close();

	deja_init=false; // sait on si le fichier existe ?
	no_music=false;  // le fichier n'existe pas
	en_route=false;  // la musique est joue en ce moment
	music=true;		 // veut-on la musique

	return 1;
}

int CHudMp3::Draw( float flTime )
{
	if(no_music)
	{
		if(music)
		{
			ConsolePrint("MUSIC : no music in this map !\n");
			music=false;
		}
		return 1;
	}
	if(music)
	{
		if(!deja_init)
		{
			deja_init=true;

			char mp3[255];

			const char * map=gEngfuncs.pfnGetLevelName();
			for(int i=0;map[i]!='.';i++)
			{
				mp3[i]=map[i];
			}
			mp3[i]='\0';
			sprintf(chemin_mp3,"%s\\%s.mp3",gEngfuncs.pfnGetGameDirectory(),mp3);

			FILE *f=fopen(chemin_mp3,"rb+");
			if(f==NULL)
			{
				no_music=true;
				return 1;
			}
			fclose(f);
		}
		if(!en_route)
		{
			ConsolePrint("MUSIC : loading !\n");

			en_route=true;

			FSOUND_SetOutput(FSOUND_OUTPUT_DSOUND);
			FSOUND_SetBufferSize(2000);
			FSOUND_SetDriver(0);
			FSOUND_Init(44100, 16, 0);
			stream = FSOUND_Stream_OpenFile(chemin_mp3, FSOUND_16BITS | FSOUND_STEREO | FSOUND_LOOP_NORMAL,0);
			FSOUND_Stream_Play(FSOUND_FREE, stream);
			FSOUND_SetSFXMasterVolume(255);
		}

		if(wm_volume->value<0)
		{
			ConsolePrint("VOLUME : min=0, max=255 (volume=0->use command wm_music to stop music)\n");
			gEngfuncs.pfnClientCmd("wm_volume 0");
		}
		else if(wm_volume->value>255)
		{
			ConsolePrint("VOLUME : min=0, max=255 (volume=255)\n");
			gEngfuncs.pfnClientCmd("wm_volume 255");
		}
		FSOUND_SetSFXMasterVolume(wm_volume->value);
	}
	else if(deja_init && en_route)
	{
		en_route=false;

		FSOUND_SetSFXMasterVolume(255);
		FSOUND_Stream_Close(stream);
		FSOUND_Close();
	}

	return 1;
}