#include "hud.h"
#include "cl_util.h"
#include "parsemsg.h"
#include <stdio.h>
#include <string.h>

#include "../dlls/gamerules_wormshl.h"
#include "define_hud.h"
#include "../dlls/define_slot.h"

DECLARE_MESSAGE( m_Prise, Prise ); 

int CHudPrise :: Init( void )
{
	HOOK_MESSAGE( Prise ); 
	m_iFlags |= HUD_ACTIVE; 
	gHUD.AddHudElem( this );
	
	return 1; 
} 

int CHudPrise::VidInit(void)
{
	Time=gEngfuncs.GetClientTime()-20;

	return 1;
}

int CHudPrise :: MsgFunc_Prise( const char *pszName, int iSize, void *pbuf ) 
{ 
	BEGIN_READ( pbuf, iSize );
	QuelleItem=READ_BYTE();
	// Groove - 03052002 - Pour que si l'on prends un 2eme items il s'affiche le temps normal.
	Time = gEngfuncs.GetClientTime( );
	return 1; 
} 


int CHudPrise :: Draw( float flTime ) 
{ 
	if( QuelleItem && !Time )
		Time = gEngfuncs.GetClientTime( );

	if( gEngfuncs.GetClientTime() < Time + 5.0 )
	{
		HSPRITE SpriteItem;
		
		int y=ScreenHeight/2-100;

		switch( QuelleItem )
		{
			default:
				break;
			case Gm_ITEM_TOMBE_BLEU : 
				SpriteItem=gHUD.GetSpriteIndex("item_tombe_bleue");
				SPR_Set(gHUD.GetSprite(SpriteItem), 255,255,255);
				SPR_Draw(0, 10, y, &gHUD.GetSpriteRect(SpriteItem));
				gHUD.DrawHudString(75, y+23, ScreenWidth, CHudTextMessage::BufferedLocaliseTextString( "#ITEM_TOMBE_BLEUE" ), 255, 255, 255 );
				break;
			case Gm_ITEM_TOMBE_ROUGE : 
				SpriteItem=gHUD.GetSpriteIndex("item_tombe_rouge");
				SPR_Set(gHUD.GetSprite(SpriteItem), 255,255,255);
				SPR_Draw(0, 10, y, &gHUD.GetSpriteRect(SpriteItem));
				gHUD.DrawHudString(75, y+23, ScreenWidth, CHudTextMessage::BufferedLocaliseTextString( "#ITEM_TOMBE_ROUGE" ), 255, 255, 255 );
				break;
			case Gm_ITEM_CAISSE_ARME : 
			{
				SpriteItem=gHUD.GetSpriteIndex("item_caisse_arme");
				SPR_Set(gHUD.GetSprite(SpriteItem), 255,255,255);
				SPR_Draw(0, 10, y, &gHUD.GetSpriteRect(SpriteItem));
				gHUD.DrawHudString(75, y+23, ScreenWidth, CHudTextMessage::BufferedLocaliseTextString( "#ITEM_CAISSE_ARME" ), 255, 255, 255 );
				char * arme="";
				switch(gHUD.arme_ramassee)
				{
					case Gm_AIR_STRIKE_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_AIR_STRIKE" );break;
//					case Gm_CAMERA_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_CAMERA" );break;
					case Gm_GRAPPIN_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_GRAPPIN" );break;
					case Gm_JETPACK_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_JETPACK" );break;
					case Gm_TELEPORTEUR_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_TELEPORTEUR" );break;
					case Gm_KAMIKAZE_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_KAMIKAZE" );break;
					case Gm_BATTE_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_BATTE" );break;
					case Gm_HACHE_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_HACHE" );break;
					case Gm_FUSIL_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_FUSIL" );break;
					case Gm_SNIPE_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_SNIPE" );break;
					case Gm_MINICANON_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_MINICANON" );break;
//					case Gm_LASER_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_LASER" );break;
					case Gm_MORVE_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_MORVE" );break;
					case Gm_KAMEHA_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_KAMEHA" );break;
					case Gm_BAZOOKA_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_BAZOOKA" );break;
					case Gm_MORTIER_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_MORTIER" );break;
					case Gm_PIGEON_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_PIGEON" );break;
					case Gm_SUPER_MOUTON_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_SUPER_MOUTON" );break;
					case Gm_GRENADE_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_GRENADE" );break;
					case Gm_CLUSTER_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_CLUSTER" );break;
					case Gm_MOLOTOV_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_MOLOTOV" );break;
					case Gm_BANANE_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_BANANE" );break;
					case Gm_SAINTE_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_SAINTE" );break;
					case Gm_DYNAMITE_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_DYNAMITE" );break;
					case Gm_MINE_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_MINE" );break;
					case Gm_MOUTON_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_MOUTON" );break;
					case Gm_NAPALM_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_NAPALM" );break;
//					case Gm_HELICO_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_HELICO" );break;
					case Gm_CROIX_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_CROIX" );break;
					case Gm_TRIDENT_ID : arme = CHudTextMessage::BufferedLocaliseTextString( "#MSG_TRIDENT" );break;
				}
		
				int Resolution = int( ScreenWidth / 256 );
				int fond = gHUD.GetSpriteIndex( "fondmsg" );
				SPR_Set( gHUD.GetSprite( fond ),255, 255, 255 );

				for( short I = 0; I < ( Resolution + 1 ); I++ )
					SPR_Draw( 0, I*256, 4, &gHUD.GetSpriteRect(fond));
		
				if( gHUD.localplayer->curstate.iuser4 )
					FillRGBA( 0, 0, ScreenWidth, 32, Gm_HUD_COULEUR_BLEU_3P, Gm_HUD_INTENSITE );		
				else
					FillRGBA( 0, 0, ScreenWidth, 32, Gm_HUD_COULEUR_ROUGE_3P, Gm_HUD_INTENSITE );
				
				int PosX = ( ScreenWidth / 2 ) - 10 * ( strlen( arme ) / 2 );
				gHUD.DrawHudString( PosX, 6, ScreenWidth, arme, 255, 255, 255 );
				break;
			}
			case Gm_ITEM_CAISSE_MEGA : 
				SpriteItem=gHUD.GetSpriteIndex("item_caisse_mega");
				SPR_Set(gHUD.GetSprite(SpriteItem), 255,255,255);
				SPR_Draw(0, 10, y, &gHUD.GetSpriteRect(SpriteItem));
				gHUD.DrawHudString(75, y+23, ScreenWidth, CHudTextMessage::BufferedLocaliseTextString( "#ITEM_CAISSE_MEGA" ), 255, 255, 255 );
				break;
			case Gm_ITEM_CAISSE_OUTIL : 
				SpriteItem=gHUD.GetSpriteIndex("item_caisse_outil");
				SPR_Set(gHUD.GetSprite(SpriteItem), 255,255,255);
				SPR_Draw(0, 10, y, &gHUD.GetSpriteRect(SpriteItem));
				gHUD.DrawHudString(75, y+23, ScreenWidth, CHudTextMessage::BufferedLocaliseTextString( "#ITEM_CAISSE_OUTIL" ), 255, 255, 255 );
				break;
			case Gm_ITEM_CAISSE_VIE : 
				SpriteItem=gHUD.GetSpriteIndex("item_caisse_vie");
				SPR_Set(gHUD.GetSprite(SpriteItem), 255,255,255);
				SPR_Draw(0, 10, y, &gHUD.GetSpriteRect(SpriteItem));
				gHUD.DrawHudString(75, y+23, ScreenWidth, CHudTextMessage::BufferedLocaliseTextString( "#ITEM_CAISSE_VIE" ), 255, 255, 255 );
				break;
		}
	}
	else
	{
		Time = 0;
		QuelleItem = 0;
	}

	return 1; 
}
