#include "hud.h"
#include "cl_util.h"
#include "parsemsg.h"
#include <stdio.h>
#include <string.h>

#include "define_hud.h"


DECLARE_MESSAGE( m_Radar, Radar );


#define PI 3.14159265358979


bool PrintRadar=false;


void PrintRadarYES()
{
	PrintRadar=true;
	gEngfuncs.pfnClientCmd("p_radar");
	gHUD.enlever_crosshair();
}
void PrintRadarNO()
{
	PrintRadar=false;
	gHUD.remettre_crosshair();
}


int CHudRadar :: Init( void )
{
	gEngfuncs.pfnAddCommand( "+wm_radar", PrintRadarYES );
	gEngfuncs.pfnAddCommand( "-wm_radar", PrintRadarNO );

	HOOK_MESSAGE( Radar );
	m_iFlags |= HUD_ACTIVE;
	gHUD.AddHudElem( this );

	return 1;
}

int CHudRadar::VidInit(void)
{
	Objets[0].type=RADAR_FIN;
	return 1;
}


int CHudRadar :: MsgFunc_Radar( const char *pszName, int iSize, void *pbuf )
{
	int i=0;
	int nb=0;
	int type;

	BEGIN_READ( pbuf, iSize );
	
	max_vision=READ_BYTE();
	if(max_vision==RADAR_VISION_ELARGIE)max_vision=RADAR_MAXVISION2;
	else max_vision=RADAR_MAXVISION1;

	type=READ_BYTE();

	while(type!=RADAR_FIN)
	{
		nb=READ_BYTE();

		for(int w=0;w<nb;w++)
		{
			Objets[i].orgx=READ_COORD();
			Objets[i].orgy=READ_COORD();
			Objets[i].type=type;

			i++;
		}

		type=READ_BYTE();
	}

	Objets[i].type=RADAR_FIN;

	return 1;
}


inline void VectorToAngles( const vec3_t vector, vec3_t *angles )
{
	float	avance, pente;	

	if (vector.y==0 && vector.x==0)
	{
		avance=0;
		pente=90;
	}
	else
	{
		avance=(atan2(vector.y,vector.x)*180/PI);
		if(avance<0) avance+=360;

		pente=(atan2(vector.z,sqrt(vector.x*vector.x+vector.y*vector.y))*180/PI);
		if(pente<0)	pente+=360;
	}

	angles->x=pente;
	angles->y=avance;
	angles->z=0;
}



int CHudRadar :: Draw( float flTime )
{
	if ( !gHUD.localplayer ) return 0;

	if(PrintRadar)
	{
		gEngfuncs.pfnClientCmd("p_radar");

		int x=(ScreenWidth-762)/2;
		int y=(ScreenHeight-550)/2;

		Vector2D centre;
		centre.x=x+286;
		centre.y=y+263;

		HSPRITE sprite_courant;

	//fond
		sprite_courant = gHUD.GetSpriteIndex( "radar_1" );
		SPR_Set(gHUD.GetSprite(sprite_courant), 255,255,255);
		SPR_DrawHoles(0, x, y, &gHUD.GetSpriteRect(sprite_courant));
		sprite_courant = gHUD.GetSpriteIndex( "radar_2" );
		SPR_Set(gHUD.GetSprite(sprite_courant), 255,255,255);
		SPR_DrawHoles(0, x+256, y, &gHUD.GetSpriteRect(sprite_courant));
		sprite_courant = gHUD.GetSpriteIndex( "radar_3" );
		SPR_Set(gHUD.GetSprite(sprite_courant), 255,255,255);
		SPR_DrawHoles(0, x+512, y, &gHUD.GetSpriteRect(sprite_courant));
		sprite_courant = gHUD.GetSpriteIndex( "radar_4" );
		SPR_Set(gHUD.GetSprite(sprite_courant), 255,255,255);
		SPR_DrawHoles(0, x, y+256, &gHUD.GetSpriteRect(sprite_courant));
		sprite_courant = gHUD.GetSpriteIndex( "radar_5" );
		SPR_Set(gHUD.GetSprite(sprite_courant), 255,255,255);
		SPR_DrawHoles(0, x+256, y+256, &gHUD.GetSpriteRect(sprite_courant));
		sprite_courant = gHUD.GetSpriteIndex( "radar_6" );
		SPR_Set(gHUD.GetSprite(sprite_courant), 255,255,255);
		SPR_DrawHoles(0, x+512, y+256, &gHUD.GetSpriteRect(sprite_courant));
		sprite_courant = gHUD.GetSpriteIndex( "radar_7" );
		SPR_Set(gHUD.GetSprite(sprite_courant), 255,255,255);
		SPR_DrawHoles(0, x, y+512, &gHUD.GetSpriteRect(sprite_courant));
		sprite_courant = gHUD.GetSpriteIndex( "radar_8" );
		SPR_Set(gHUD.GetSprite(sprite_courant), 255,255,255);
		SPR_DrawHoles(0, x+256, y+512, &gHUD.GetSpriteRect(sprite_courant));

	//traits
		sprite_courant = gHUD.GetSpriteIndex( "radar_trait" );
		SPR_Set(gHUD.GetSprite(sprite_courant), 255,255,255);
		for(int i=0;i<462/3;i+=3)
			SPR_Draw(0, centre.x, y+43+i*3, &gHUD.GetSpriteRect(sprite_courant));
		for(i=0;i<460/3;i+=3)
			SPR_Draw(0, x+61+i*3, centre.y, &gHUD.GetSpriteRect(sprite_courant));

	// items
		i=0;
		while( Objets[i].type!=RADAR_FIN)
		{
			int distance=sqrt((gHUD.localplayer->origin.x-Objets[i].orgx)*(gHUD.localplayer->origin.x-Objets[i].orgx)+(gHUD.localplayer->origin.y-Objets[i].orgy)*(gHUD.localplayer->origin.y-Objets[i].orgy));
					
			distance=(distance/float(max_vision))*230;//distance max*moitie de la taille du radar

			vec3_t angleplayer,objetorigin;
			objetorigin.x=Objets[i].orgx;
			objetorigin.y=Objets[i].orgy;
			objetorigin.z=0;
			VectorToAngles(objetorigin-gHUD.localplayer->origin,&angleplayer);
			if (angleplayer.y<0) angleplayer.y+=360;
			float angle=gHUD.localplayer->curstate.vuser1.y;
			if(angle<0) angle+=360;
			angle=(angle-angleplayer.y);
			angle=angle*PI/180;//passage en radian

			if(max_vision==RADAR_MAXVISION1)
			switch( Objets[i].type )
			{
				case RADAR_BARIL		:sprite_courant = gHUD.GetSpriteIndex( "radar_baril" );break;
				case RADAR_MINE			:sprite_courant = gHUD.GetSpriteIndex( "radar_mine" );break;
				case RADAR_CAISSEARME	:sprite_courant = gHUD.GetSpriteIndex( "radar_caissearme" );break;
				case RADAR_CAISSEVIE	:sprite_courant = gHUD.GetSpriteIndex( "radar_caissevie" );break;
				case RADAR_CAISSEMEGA	:sprite_courant = gHUD.GetSpriteIndex( "radar_caissemega" );break;
				case RADAR_CAISSEOUTIL	:sprite_courant = gHUD.GetSpriteIndex( "radar_caisseoutil" );break;
				case RADAR_TOMBEROUGE	:sprite_courant = gHUD.GetSpriteIndex( "radar_tomberouge" );break;
				case RADAR_TOMBEBLEUE	:sprite_courant = gHUD.GetSpriteIndex( "radar_tombebleue" );break;
				case RADAR_BANANIER		:sprite_courant = gHUD.GetSpriteIndex( "radar_bananier" );break;
			}
			else
			switch( Objets[i].type )
			{
				case RADAR_BARIL		:sprite_courant = gHUD.GetSpriteIndex( "radar_baril2" );break;
				case RADAR_MINE			:sprite_courant = gHUD.GetSpriteIndex( "radar_mine2" );break;
				case RADAR_CAISSEARME	:sprite_courant = gHUD.GetSpriteIndex( "radar_caissearme2" );break;
				case RADAR_CAISSEVIE	:sprite_courant = gHUD.GetSpriteIndex( "radar_caissevie2" );break;
				case RADAR_CAISSEMEGA	:sprite_courant = gHUD.GetSpriteIndex( "radar_caissemega2" );break;
				case RADAR_CAISSEOUTIL	:sprite_courant = gHUD.GetSpriteIndex( "radar_caisseoutil2" );break;
				case RADAR_TOMBEROUGE	:sprite_courant = gHUD.GetSpriteIndex( "radar_tomberouge2" );break;
				case RADAR_TOMBEBLEUE	:sprite_courant = gHUD.GetSpriteIndex( "radar_tombebleue2" );break;
				case RADAR_BANANIER		:sprite_courant = gHUD.GetSpriteIndex( "radar_bananier2" );break;
			}

			SPR_Set(gHUD.GetSprite(sprite_courant), 255,255,255);
			SPR_DrawHoles(0, centre.x+(int)(sin(angle) * distance)-(gHUD.GetSpriteRect(sprite_courant).right - gHUD.GetSpriteRect(sprite_courant).left)/2, centre.y-(int)(cos(angle) * distance)-(gHUD.GetSpriteRect(sprite_courant).bottom - gHUD.GetSpriteRect(sprite_courant).top)/2, &gHUD.GetSpriteRect(sprite_courant));
		
			i++;
		}
		Objets[0].type=RADAR_FIN;


	// joueurs
		for ( i=1; i < MAX_PLAYERS; i++ )
		{
			cl_entity_t *player;
			player = gEngfuncs.GetEntityByIndex( i );
			if ( player && player->player && player!=gHUD.localplayer)
			{
				int distance=sqrt((gHUD.localplayer->origin.x-player->origin.x)*(gHUD.localplayer->origin.x-player->origin.x)+(gHUD.localplayer->origin.y-player->origin.y)*(gHUD.localplayer->origin.y-player->origin.y));
					
				if(distance<max_vision)
				{
					distance=(distance/float(max_vision))*230;//distance max*moitie de la taille du radar

					vec3_t angleplayer;
					VectorToAngles(player->origin-gHUD.localplayer->origin,&angleplayer);
					if (angleplayer.y<0) angleplayer.y+=360;
					float angle=gHUD.localplayer->curstate.vuser1.y;
					if(angle<0) angle+=360;
					angle=(angle-angleplayer.y);
					angle=angle*PI/180;//passage en radian

					if(player->curstate.iuser4)	sprite_courant = gHUD.GetSpriteIndex( "radar_wormbleu" );
					else sprite_courant = gHUD.GetSpriteIndex( "radar_wormrouge" );
					SPR_Set(gHUD.GetSprite(sprite_courant), 255,255,255);

					SPR_DrawHoles(0, centre.x+(int)(sin(angle) * distance)-(gHUD.GetSpriteRect(sprite_courant).right - gHUD.GetSpriteRect(sprite_courant).left)/2, centre.y-(int)(cos(angle) * distance)-(gHUD.GetSpriteRect(sprite_courant).bottom - gHUD.GetSpriteRect(sprite_courant).top)/2, &gHUD.GetSpriteRect(sprite_courant));
				}
			}
		}


	}//if printradar

	return 1;
}
