//	EurOPiuM - 08/05/02 
//	--------------------
//	Moteur de Particules 
//	--------------------


#include "hud.h"
#include "cl_util.h"
#include "triangleapi.h"
#include "particles.h"

CParticleRenderer::CParticleRenderer()
{
    m_iParticleCount = 0;
    m_pParticles = NULL;
    m_pFreed = NULL;
    m_fInitialized = false;
	NULL;
}

CParticleRenderer::~CParticleRenderer()
{
    ClearAll();
}


void CParticleRenderer::Init(char * sprite)
{
    int m_iSprite = SPR_Load( sprite );
    m_pSprite = (struct model_s *)gEngfuncs.GetSpritePointer( m_iSprite );
    m_flLastTime = gEngfuncs.GetClientTime();
	m_fInitialized = true;
}


particles_t *CParticleRenderer::Create(int max_p)
{
	if( m_iParticleCount < max_p )
	{
		particles_t *p;
		if( m_pFreed )
		{
		p = m_pFreed;
		m_pFreed = p->next;
		}
		else p = new particles_t;
   
		p->next = m_pParticles;
		m_pParticles = p;
		m_iParticleCount++;

		/*char *m="";
		sprintf(m,"new particle : %d\n",m_iParticleCount);
		ConsolePrint(m);*/
    
		p->age = 0.0;
  
		return p;
	}
	return NULL;
}


void CParticleRenderer::ClearAll()
{
    particles_t *p;
    
    ClearFreed();

    while( m_pParticles )
    {
        p = m_pParticles;
        m_pParticles = p->next;
        delete p;
        m_iParticleCount--;
    }
}

void CParticleRenderer::ClearFreed()
{
    particles_t *p;
    while( m_pFreed )
    {
        p = m_pFreed;
        m_pFreed = p->next;
        delete p;
    }
}


void CParticleRenderer::Update()
{
    m_flFrametime = gEngfuncs.GetClientTime() - m_flLastTime;
    
    if( m_iParticleCount > 0 && m_fInitialized )
        Draw();
    
    m_flLastTime = gEngfuncs.GetClientTime();
}

void CParticleRenderer::CalcDeltas( particles_t* p )
{
	if( p )
    {
        for( int i=0; i < 4; i++ )
        {
            p->d_color[i] = (p->color_end[i] - p->color[i]) / p->life;
        }
        p->d_size[0] = (p->size_end[0] - p->size[0]) / p->life;
        p->d_size[1] = (p->size_end[1] - p->size[1]) / p->life;
    }
}
