//	EurOPiuM - 08/05/02 
//	--------------------
//	Moteur de Particules 
//	--------------------


struct particles_t {
    float age;
    float life;
    vec3_t origin;
    vec3_t vel;
    float fadein_time;
    float color[4];
    float d_color[4];
    float color_end[4];
    float size[2];
    float d_size[2];
    float size_end[2];
    float gravity;
	particles_t *next;
};


// CLASSE GENERIQUE
///////////////////

class CParticleRenderer
{
public:
    CParticleRenderer();
    ~CParticleRenderer();
    void Init(char * sprite);
    void Reset()
	{
        ClearAll();
        m_fInitialized = false;
    }

    particles_t *Create(int max_p);
    void ClearFreed();
    void ClearAll();
        
    void Update();
 
	virtual int Draw(){
		return 0;
	}

	void CalcDeltas( particles_t* p );

    bool m_fInitialized;
    float m_flFrametime;
    
//    int m_iSprite;
    model_s *m_pSprite;
    
    float m_flLastTime;
	int m_iParticleCount;

    particles_t *m_pParticles;
    particles_t *m_pFreed;
};



// CLASSE LANCE FLAMME
///////////////////////


class CParticleLanceflamme : public CParticleRenderer
{
public:
    int Draw();
};

typedef struct
{
	CParticleLanceflamme gLanceflamme;
	bool affiche;
}lanceflamme_t;

extern lanceflamme_t tab_lanceflamme[MAX_PLAYERS];

// CLASSE FLAMME
////////////////


class CParticleFlamme : public CParticleRenderer
{
public:
    int Draw();
};

typedef struct
{
	CParticleFlamme gFlamme;
	float quand;
	int duree;
	vec3_t ou;
}flamme_t;

extern flamme_t tab_flamme[MAX_PARTICLES_FLAMME];






// CLASSE SAINTE
////////////////


class CParticleSainte : public CParticleRenderer
{
public:
    int Draw();
};

typedef struct
{
	CParticleSainte gSainte;
	float quand;
	int type;
	vec3_t ou;
}sainte_t;

extern sainte_t tab_sainte_explosion[MAX_PARTICLES_SAINTE_EXPLOSION];
extern sainte_t tab_sainte_rebond[MAX_PARTICLES_SAINTE_REBOND];
extern sainte_t tab_sainte_attente[MAX_PARTICLES_SAINTE_ATTENTE];




// EurOPiuM - 22/08/02 - explosions stadards


// CLASSE EXPLOSION
///////////////////


class CParticleExplosion : public CParticleRenderer
{
public:
    int Draw();
	int Draw2();
	void Update2();
};

typedef struct
{
	CParticleExplosion gExplosion;
	CParticleExplosion gExplosion2;
	float quand;
	int puissance;
	int couleur;
	vec3_t ou;
}explosion_t;

extern explosion_t tab_explosion[MAX_PARTICLES_EXPLOSION];

