//	EurOPiuM - 22/08/02
//	---------------------------------------
//	Effets visuels des explosions standards
//	---------------------------------------


#include "hud.h"
#include "cl_util.h"
#include "triangleapi.h"
#include "particles.h"
#include "const.h"


float pvie,pcouleurdebut[4],pcouleurfin[4],ptailledebut,ptaillefin,pvitesse,pdecalage;
float tailleactuelle;
float angledecalagex,angledecalagey;


void CParticleExplosion::Update2()
{
    m_flFrametime = gEngfuncs.GetClientTime() - m_flLastTime;
    
    if( m_iParticleCount > 0 && m_fInitialized )
        Draw2();
    
    m_flLastTime = gEngfuncs.GetClientTime();
}


int CParticleExplosion::Draw()
{
	cl_entity_t *localplayer;
	localplayer = gEngfuncs.GetLocalPlayer();
	if ( !localplayer )  return 0;

	particles_t *p, *pprev, *pnext;
	pprev = NULL;
	p = m_pParticles;

	float gravity = CVAR_GET_FLOAT( "sv_gravity" );

	float a; //transparence
	
	//division angle de vue
	vec3_t v_forward, v_right, v_up;
	AngleVectors(localplayer->curstate.vuser1, v_forward, v_right, v_up );
  
	// initialisation de l'affichage
	gEngfuncs.pTriAPI->SpriteTexture( m_pSprite, 0 );
	gEngfuncs.pTriAPI->RenderMode( kRenderTransAdd );
	gEngfuncs.pTriAPI->CullFace( TRI_NONE );
	gEngfuncs.pTriAPI->Begin( TRI_QUADS );

	tailleactuelle=0.0;
	angledecalagex=angledecalagey=0.0;

	while( p )
	{
		pnext = p->next;

		// transparence
		a = (p->color[3] += p->d_color[3] * m_flFrametime);
		float delta = (p->fadein_time - p->age);
		if(delta>=0.0) a = p->color[3] * (1.0 - delta / p->fadein_time);

		// couleur
		p->color[0] += p->d_color[0] * m_flFrametime;
		p->color[1] += p->d_color[1] * m_flFrametime;
		p->color[2] += p->d_color[2] * m_flFrametime;

		// taille
		p->size[0] += p->d_size[0] * m_flFrametime;
		p->size[1] += p->d_size[1] * m_flFrametime;
		if(p->size[0]>tailleactuelle)tailleactuelle=p->size[0];
		
		// affichage
		if( p->age >= p->life )
		{
			if( pprev ) pprev->next = pnext;
			else m_pParticles = pnext;
			p->next = m_pFreed;
			m_pFreed = p;
			m_iParticleCount--;
		}
		else
		{
			pprev = p;

			v_right.x+=angledecalagex;
			v_right.y+=angledecalagey;
			if(v_right.x>1.0)v_right.x-=1.0;
			if(v_right.y>1.0)v_right.y-=1.0;
			if(v_right.x<-1.0)v_right.x+=1.0;
			if(v_right.y<-1.0)v_right.y+=1.0;

			if(angledecalagex>=0.0 && angledecalagey>=0.0)
			{
				angledecalagex-=0.1;
				angledecalagey+=0.1;
			}
			else if(angledecalagex>=0.0 && angledecalagey<0.0)
			{
				angledecalagex+=0.1;
				angledecalagey+=0.1;
			}
			else if(angledecalagex<0.0 && angledecalagey>=0.0)
			{
				angledecalagex-=0.1;
				angledecalagey-=0.1;
			}
			else
			{
				angledecalagex+=0.1;
				angledecalagey-=0.1;
			}
			if(angledecalagex>1.0)angledecalagex=0.9;
			if(angledecalagey>1.0)angledecalagey=0.9;
			if(angledecalagex<-1.0)angledecalagex=0.1;
			if(angledecalagey<-1.0)angledecalagey=0.1;

		

			gEngfuncs.pTriAPI->Color4f( p->color[0], p->color[1], p->color[2], a );
			gEngfuncs.pTriAPI->Brightness( 1 );
			gEngfuncs.pTriAPI->TexCoord2f( 0, 0 );
			gEngfuncs.pTriAPI->Vertex3fv( p->origin - v_right * p->size[0]/2 - v_up * p->size[1]/2 );
			gEngfuncs.pTriAPI->TexCoord2f( 0, 1 );
			gEngfuncs.pTriAPI->Vertex3fv( p->origin + v_right * p->size[0]/2 - v_up * p->size[1]/2 );
			gEngfuncs.pTriAPI->TexCoord2f( 1, 1 );
			gEngfuncs.pTriAPI->Vertex3fv( p->origin + v_right * p->size[0]/2 + v_up * p->size[1]/2 );
			gEngfuncs.pTriAPI->TexCoord2f( 1, 0 );
			gEngfuncs.pTriAPI->Vertex3fv( p->origin - v_right * p->size[0]/2 + v_up * p->size[1]/2 );
   
			p->age += m_flFrametime;
		}
		p = pnext;
	}
	gEngfuncs.pTriAPI->End();

	return 1;
}


int CParticleExplosion::Draw2()
{
	cl_entity_t *localplayer;
	localplayer = gEngfuncs.GetLocalPlayer();
	if ( !localplayer )  return 0;

	
	particles_t *p, *pprev, *pnext;
	pprev = NULL;
	p = m_pParticles;

	float gravity = CVAR_GET_FLOAT( "sv_gravity" );

	float a; //transparence
	
	//division angle de vue
	vec3_t v_forward, v_right, v_up;
	AngleVectors(localplayer->curstate.vuser1, v_forward, v_right, v_up );

  
	// initialisation de l'affichage
	gEngfuncs.pTriAPI->SpriteTexture( m_pSprite, 0 );
	gEngfuncs.pTriAPI->RenderMode( kRenderTransAdd );
	gEngfuncs.pTriAPI->CullFace( TRI_NONE );
	gEngfuncs.pTriAPI->Begin( TRI_QUADS );

	while( p )
	{
		pnext = p->next;

		// transparence
		a = (p->color[3] += p->d_color[3] * m_flFrametime);
		float delta = (p->fadein_time - p->age);
		if(delta>=0.0) a = p->color[3] * (1.0 - delta / p->fadein_time);

		// couleur
		p->color[0] += p->d_color[0] * m_flFrametime;
		p->color[1] += p->d_color[1] * m_flFrametime;
		p->color[2] += p->d_color[2] * m_flFrametime;

		// taille
		p->size[0] += p->d_size[0] * m_flFrametime;
		p->size[1] += p->d_size[1] * m_flFrametime;
		
		// gravite
		p->vel.z -= gravity * m_flFrametime * p->gravity;

		// emplacement
		p->origin = p->origin + p->vel* m_flFrametime;


		// collision
		if( gEngfuncs.PM_PointContents( p->origin, NULL )!=CONTENTS_EMPTY )
			p->life = 0.0;


		// affichage
		if( p->age >= p->life )
		{
			if( pprev ) pprev->next = pnext;
			else m_pParticles = pnext;
			p->next = m_pFreed;
			m_pFreed = p;
			m_iParticleCount--;
		}
		else
		{
			pprev = p;

			gEngfuncs.pTriAPI->Color4f( p->color[0], p->color[1], p->color[2], a );
			gEngfuncs.pTriAPI->Brightness( 1 );
			gEngfuncs.pTriAPI->TexCoord2f( 0, 0 );
			gEngfuncs.pTriAPI->Vertex3fv( p->origin - v_right * p->size[0]/2 - v_up * p->size[1]/2 );
			gEngfuncs.pTriAPI->TexCoord2f( 0, 1 );
			gEngfuncs.pTriAPI->Vertex3fv( p->origin + v_right * p->size[0]/2 - v_up * p->size[1]/2 );
			gEngfuncs.pTriAPI->TexCoord2f( 1, 1 );
			gEngfuncs.pTriAPI->Vertex3fv( p->origin + v_right * p->size[0]/2 + v_up * p->size[1]/2 );
			gEngfuncs.pTriAPI->TexCoord2f( 1, 0 );
			gEngfuncs.pTriAPI->Vertex3fv( p->origin - v_right * p->size[0]/2 + v_up * p->size[1]/2 );
   
			p->age += m_flFrametime;
		}
		p = pnext;
	}
	gEngfuncs.pTriAPI->End();

	return 1;
}

void Draw_One_Explosion(int max_particles,int index)
{
	particles_t *p;

    if( !tab_explosion[index].gExplosion.m_fInitialized )
		tab_explosion[index].gExplosion.Init("sprites/jeu/armes/feu.spr");

	
	switch(tab_explosion[index].puissance)
	{
		case PARTICLES_EXPLOSION_PUISSANCE_25 :
			pvie = 0.4;
			ptailledebut = 5.0;
			ptailledebut = 5.0;
			ptaillefin = 50.0;
			ptaillefin = 50.0;
			pvitesse = 35.0;
			pdecalage = 1.0;
			break;
		case PARTICLES_EXPLOSION_PUISSANCE_50 :
			pvie = 0.5;
			ptailledebut = 10.0;
			ptailledebut = 10.0;
			ptaillefin = 80.0;
			ptaillefin = 80.0;
			pvitesse = 60.0;
			pdecalage = 5.0;
			break;
		case PARTICLES_EXPLOSION_PUISSANCE_75 :
			pvie = 0.6;
			ptailledebut = 10.0;
			ptailledebut = 10.0;
			ptaillefin = 110.0;
			ptaillefin = 110.0;
			pvitesse = 85.0;
			pdecalage = 5.0;
			break;
		case PARTICLES_EXPLOSION_PUISSANCE_100 :
			pvie = 0.7;
			ptailledebut = 15.0;
			ptailledebut = 15.0;
			ptaillefin = 190.0;
			ptaillefin = 190.0;
			pvitesse = 150.0;
			pdecalage = 5.0;
			break;
		case PARTICLES_EXPLOSION_PUISSANCE_150 :
			pvie = 0.8;
			ptailledebut = 20.0;
			ptailledebut = 20.0;
			ptaillefin = 210.0;
			ptaillefin = 210.0;
			pvitesse = 170.0;
			pdecalage = 7.0;
			break;
		case PARTICLES_EXPLOSION_PUISSANCE_200 :
			pvie = 0.9;
			ptailledebut = 30.0;
			ptailledebut = 30.0;
			ptaillefin = 350.0;
			ptaillefin = 350.0;
			pvitesse = 250.0;
			pdecalage = 10.0;
		break;
		case PARTICLES_EXPLOSION_PUISSANCE_225 :
			pvie = 0.9;
			ptailledebut = 30.0;
			ptailledebut = 30.0;
			ptaillefin = 350.0;
			ptaillefin = 350.0;
			pvitesse = 300.0;
			pdecalage = 12.0;
			break;
		case PARTICLES_EXPLOSION_PUISSANCE_300 :
			pvie = 1.0;
			ptailledebut = 35.0;
			ptailledebut = 35.0;
			ptaillefin = 400.0;
			ptaillefin = 400.0;
			pvitesse = 400.0;
			pdecalage = 15.0;
			break;
		case PARTICLES_EXPLOSION_PUISSANCE_450 :
			pvie = 1.5;
			ptailledebut = 50.0;
			ptailledebut = 50.0;
			ptaillefin = 650.0;
			ptaillefin = 650.0;
			pvitesse = 100.0;
			pdecalage = 30.0;
			break;
	}
	pcouleurdebut[3] = 0.4;
	pcouleurfin[3] = 0.0;
	switch(tab_explosion[index].couleur)
	{
		case PARTICLES_EXPLOSION_COULEUR_VERT :
			pcouleurdebut[0] = 0.25;
			pcouleurdebut[1] = 0.6;
			pcouleurdebut[2] = 0.1;
			pcouleurfin[0] = 0.7;
			pcouleurfin[1] = 0.9;
			pcouleurfin[2] = 0.5;
			break;
		case PARTICLES_EXPLOSION_COULEUR_JAUNE :
			pcouleurdebut[0] = 0.9;
			pcouleurdebut[1] = 1.0;
			pcouleurdebut[2] = 0.1;
			pcouleurfin[0] = 1.0;
			pcouleurfin[1] = 1.0;
			pcouleurfin[2] = 0.5;
			break;
		case PARTICLES_EXPLOSION_COULEUR_ROUGE :
			pcouleurdebut[0] = 1.0;
			pcouleurdebut[1] = 0.0;
			pcouleurdebut[2] = 0.0;
			pcouleurfin[0] = 1.0;
			pcouleurfin[1] = 0.5;
			pcouleurfin[2] = 0.5;
			break;
		case PARTICLES_EXPLOSION_COULEUR_VIOLET :
			pcouleurdebut[0] = 1.0;
			pcouleurdebut[1] = 0.0;
			pcouleurdebut[2] = 0.5;
			pcouleurfin[0] = 1.0;
			pcouleurfin[1] = 0.5;
			pcouleurfin[2] = 0.75;
			break;
		case PARTICLES_EXPLOSION_COULEUR_BLEU :
			pcouleurdebut[0] = 0.0;
			pcouleurdebut[1] = 0.0;
			pcouleurdebut[2] = 0.1;
			pcouleurfin[0] = 0.5;
			pcouleurfin[1] = 0.5;
			pcouleurfin[2] = 1.0;
			break;
		case PARTICLES_EXPLOSION_COULEUR_ORANGE :
			pcouleurdebut[0] = 1.0;
			pcouleurdebut[1] = 0.7;
			pcouleurdebut[2] = 0.1;
			pcouleurfin[0] = 1.0;
			pcouleurfin[1] = 0.8;
			pcouleurfin[2] = 0.4;
			break;
	}

    int iCount = tab_explosion[index].gExplosion.m_flFrametime * 450.0f;
    for( int i = 0; i < iCount; i++ )
    {
        if( p = tab_explosion[index].gExplosion.Create(max_particles) )
        {	
			p->vel.x = 0.0;
			p->vel.y = 0.0;
			p->vel.z = 0.0;
			p->gravity = 0.0;
			p->origin.x=tab_explosion[index].ou.x;
			p->origin.y=tab_explosion[index].ou.y;
			p->origin.z=tab_explosion[index].ou.z;
			p->fadein_time = 0.00000000001;
			p->life = pvie;
			p->size[0] = ptailledebut;
			p->size[1] = ptailledebut;
			p->size_end[0] = ptaillefin;
			p->size_end[1] = ptaillefin;
			p->color[0] = pcouleurdebut[0];
			p->color[1] = pcouleurdebut[1];
			p->color[2] = pcouleurdebut[2];
			p->color[3] = pcouleurdebut[3];
			p->color_end[0] = pcouleurfin[0];
			p->color_end[1] = pcouleurfin[1];
			p->color_end[2] = pcouleurfin[2];
			p->color_end[3] = pcouleurfin[3];
                        
            tab_explosion[index].gExplosion.CalcDeltas( p );
        }
    }
    tab_explosion[index].gExplosion.Update();
}


void Draw_One_Explosion2(int max_particles,int index)
{
	particles_t *p;

    if( !tab_explosion[index].gExplosion2.m_fInitialized )
		tab_explosion[index].gExplosion2.Init("sprites/jeu/armes/feu.spr");

	tailleactuelle=tailleactuelle/2;

    int iCount = tab_explosion[index].gExplosion2.m_flFrametime * 450.0f;
    for( int i = 0; i < iCount; i++ )
    {
        if( p = tab_explosion[index].gExplosion2.Create(max_particles) )
        {	
			p->gravity = 0.0;
			int dir=gEngfuncs.pfnRandomLong(0,1);
			if(dir==0)dir=-1;
			float dec=gEngfuncs.pfnRandomFloat(0,tailleactuelle);
			p->origin.x=tab_explosion[index].ou.x+dir*dec;
			dir=gEngfuncs.pfnRandomLong(0,1);
			if(dir==0)dir=-1;
			float dec2=gEngfuncs.pfnRandomFloat(0,tailleactuelle);
			p->origin.y=tab_explosion[index].ou.y+dir*dec2;
			dir=gEngfuncs.pfnRandomLong(0,1);
			if(dir==0)dir=-1;
			p->origin.z=tab_explosion[index].ou.z+dir*sqrt((tailleactuelle*tailleactuelle-dec*dec-dec2*dec2));
			float pourcvit=gEngfuncs.pfnRandomFloat(0.0,1.0);
			p->vel.x = pourcvit*(p->origin.x-tab_explosion[index].ou.x)/2;
			p->vel.y = pourcvit*(p->origin.y-tab_explosion[index].ou.y)/2;
			p->vel.z = pourcvit*(p->origin.z-tab_explosion[index].ou.z)/2;
			p->fadein_time = 0.00000000001;
			p->life = pvie;
			p->size[0] = 10;//ptailledebut;
			p->size[1] = 10;//ptailledebut;
			p->size_end[0] = 5;//ptaillefin;
			p->size_end[1] = 5;//ptaillefin;
			p->color[0] = pcouleurdebut[0];
			p->color[1] = pcouleurdebut[1];
			p->color[2] = pcouleurdebut[2];
			p->color[3] = 1.5;
			p->color_end[0] = pcouleurfin[0];
			p->color_end[1] = pcouleurfin[1];
			p->color_end[2] = pcouleurfin[2];
			p->color_end[3] = 0.0;
                        
            tab_explosion[index].gExplosion2.CalcDeltas( p );
        }
    }
    tab_explosion[index].gExplosion2.Update2();
}

void Draw_Explosion()
{
	for(int i=0;i<MAX_PARTICLES_EXPLOSION;i++)
	{
		float actuel=gEngfuncs.GetClientTime();
		float duree;
		switch(tab_explosion[i].puissance)
		{
			case PARTICLES_EXPLOSION_PUISSANCE_25 :
				duree=0.4;
				break;
			case PARTICLES_EXPLOSION_PUISSANCE_50 :
				duree = 0.5;
				break;
			case PARTICLES_EXPLOSION_PUISSANCE_75 :
				duree = 0.6;
				break;
			case PARTICLES_EXPLOSION_PUISSANCE_100 :
				duree = 0.7;
				break;
			case PARTICLES_EXPLOSION_PUISSANCE_150 :
				duree = 0.8;
				break;
			case PARTICLES_EXPLOSION_PUISSANCE_200 :
				duree = 0.9;
				break;
			case PARTICLES_EXPLOSION_PUISSANCE_225 :
				duree = 0.9;
				break;
			case PARTICLES_EXPLOSION_PUISSANCE_300 :
				duree = 1.0;
				break;
			case PARTICLES_EXPLOSION_PUISSANCE_450 :
				duree = 1.5;
				break;
		}
		if(actuel-tab_explosion[i].quand<duree)
		{
			Draw_One_Explosion(100,i);
			Draw_One_Explosion2(10000,i);
		}
		else if(actuel-tab_explosion[i].quand<=3.0)
		{
			Draw_One_Explosion(0,i);
			Draw_One_Explosion2(0,i);
		}

	}
}