//	EurOPiuM - 08/05/02
//	--------------------------
//	Effets visuels des flammes
//	--------------------------


#include "hud.h"
#include "cl_util.h"
#include "triangleapi.h"
#include "particles.h"
#include "const.h"


int CParticleFlamme::Draw()
{
	cl_entity_t *localplayer;
	localplayer = gEngfuncs.GetLocalPlayer();
	if ( !localplayer )  return 0;

	
	particles_t *p, *pprev, *pnext;
	pprev = NULL;
	p = m_pParticles;

	float gravity = CVAR_GET_FLOAT( "sv_gravity" );

	float a; //transparence
	
	//division angle de vue
	vec3_t v_forward, v_right, v_up;
	AngleVectors(localplayer->curstate.vuser1, v_forward, v_right, v_up );

  
	// initialisation de l'affichage
	gEngfuncs.pTriAPI->SpriteTexture( m_pSprite, 0 );
	gEngfuncs.pTriAPI->RenderMode( kRenderTransAdd );
	gEngfuncs.pTriAPI->CullFace( TRI_NONE );
	gEngfuncs.pTriAPI->Begin( TRI_QUADS );

	while( p )
	{
		pnext = p->next;

		// transparence
		a = (p->color[3] += p->d_color[3] * m_flFrametime);
		float delta = (p->fadein_time - p->age);
		if(delta>=0.0) a = p->color[3] * (1.0 - delta / p->fadein_time);

		// couleur
		p->color[0] += p->d_color[0] * m_flFrametime;
		p->color[1] += p->d_color[1] * m_flFrametime;
		p->color[2] += p->d_color[2] * m_flFrametime;

		// taille
		p->size[0] += p->d_size[0] * m_flFrametime;
		p->size[1] += p->d_size[1] * m_flFrametime;
		
		// gravite
		p->vel.z -= gravity * m_flFrametime * p->gravity;

		// emplacement
		p->origin = p->origin + p->vel* m_flFrametime;


		// affichage
		if( p->age >= p->life )
		{
			if( pprev ) pprev->next = pnext;
			else m_pParticles = pnext;
			p->next = m_pFreed;
			m_pFreed = p;
			m_iParticleCount--;
		}
		else
		{
			pprev = p;

			gEngfuncs.pTriAPI->Color4f( p->color[0], p->color[1], p->color[2], a );
			gEngfuncs.pTriAPI->Brightness( 1 );
			gEngfuncs.pTriAPI->TexCoord2f( 0, 0 );
			gEngfuncs.pTriAPI->Vertex3fv( p->origin );
			gEngfuncs.pTriAPI->TexCoord2f( 0, 1 );
			gEngfuncs.pTriAPI->Vertex3fv( p->origin + v_right * p->size[0] );
			gEngfuncs.pTriAPI->TexCoord2f( 1, 1 );
			gEngfuncs.pTriAPI->Vertex3fv( p->origin + v_right * p->size[0] + v_up * p->size[1] );
			gEngfuncs.pTriAPI->TexCoord2f( 1, 0 );
			gEngfuncs.pTriAPI->Vertex3fv( p->origin + v_up * p->size[1] );
   
			p->age += m_flFrametime;
		}
		p = pnext;
	}
	gEngfuncs.pTriAPI->End();

	return 1;
}

void /*CParticleFlamme::*/CalcDeltas( particles_t* p )
{
	if( p )
    {
        for( int i=0; i < 4; i++ )
        {
            p->d_color[i] = (p->color_end[i] - p->color[i]) / p->life;
        }
        p->d_size[0] = (p->size_end[0] - p->size[0]) / p->life;
        p->d_size[1] = (p->size_end[1] - p->size[1]) / p->life;
    }
}


void Draw_One_Flamme(int max_particles,int index)
{
	particles_t *p;
	Vector devant,cote,dessus;


    if( !tab_flamme[index].gFlamme.m_fInitialized )
        tab_flamme[index].gFlamme.Init("sprites/jeu/armes/feu.spr");


		vec3_t angles;
		angles.x=0.2;
		angles.y=0.2;
		angles.z=1.0;
		AngleVectors( angles, devant, cote, dessus );
		
		vec3_t temporigin;
		temporigin.x=tab_flamme[index].ou.x+gEngfuncs.pfnRandomFloat(-6, 6);
		temporigin.y=tab_flamme[index].ou.y+gEngfuncs.pfnRandomFloat(-6, 6);
		temporigin.z=tab_flamme[index].ou.z;


    int iCount = tab_flamme[index].gFlamme.m_flFrametime * 250.0f;
    for( int i = 0; i < iCount; i++ )
    {
        if( p = tab_flamme[index].gFlamme.Create(max_particles) )
        {
            p->life = gEngfuncs.pfnRandomFloat(0.5, 1.2);
            p->vel.x = 0;
			float dist=sqrt(abs(temporigin.x-tab_flamme[index].ou.x)*abs(temporigin.x-tab_flamme[index].ou.x)+abs(temporigin.y-tab_flamme[index].ou.y)*abs(temporigin.y-tab_flamme[index].ou.y));
			dist=int(dist*10)/10;
			/*if(dist<1)
				p->vel.z = -28*dist+50;//+gEngfuncs.pfnRandomFloat(0,7);
			else if(dist<5)
				p->vel.z = -5*dist+45;//+gEngfuncs.pfnRandomFloat(0,5);
			else
				p->vel.z = -20*dist+130;//+gEngfuncs.pfnRandomFloat(0,3);
            */
			p->vel.y = 0; 
			p->vel.z = gEngfuncs.pfnRandomFloat(20,3.33*dist+50);
			p->vel=p->vel.y*devant.Normalize()+p->vel.x*cote.Normalize()+p->vel.z*dessus.Normalize();
            p->origin = temporigin;
            p->color[0] = 0.5;
            p->color[1] = 0.0;
            p->color[2] = 0.0;
            p->color[3] = 0.8;
            p->color_end[0] = 1.0;
            p->color_end[1] = 0.5;
            p->color_end[2] = 0.0;
            p->color_end[3] = 0.2;
            p->fadein_time = 0.1;
            p->size[0] = 15.0;
            p->size[1] = 15.0;
            p->size_end[0] = 7.0;
            p->size_end[1] = 7.0;
            p->gravity = -0.01;
            tab_flamme[index].gFlamme.CalcDeltas( p );
        }
    }
    tab_flamme[index].gFlamme.Update();
}


void Draw_Flamme()
{
	for(int i=0;i<MAX_PARTICLES_FLAMME;i++)
	{
		float actuel=gEngfuncs.GetClientTime();
		float reste=tab_flamme[i].duree-(actuel-tab_flamme[i].quand);
		//---------------------------------
		//EurOPiuM - 19/08/02 - flammes infinies
		//un cas en plus ( mettre en premier)
		if(tab_flamme[i].duree==-1)
			Draw_One_Flamme(250,i);
		else
		//---------------------------------	
			if(actuel-tab_flamme[i].quand<0.5)
			Draw_One_Flamme(int(470*int(actuel-tab_flamme[i].quand)+5),i);
		else if(reste<1)
			Draw_One_Flamme(int(261*int(reste)+5),i);
		else if(reste>0)
			Draw_One_Flamme(250,i);
	}
}
