//	EurOPiuM - 08/05/02
//	------------------------------
//	Effets visuels du lance flamme
//	------------------------------

//////// CONFIGURATION //////////////////////

#define MAX_PARTICLES 80

/////////////////////////////////////////////


#include "hud.h"
#include "cl_util.h"
#include "triangleapi.h"
#include "particles.h"



int CParticleLanceflamme::Draw()
{
	cl_entity_t *localplayer;
	localplayer = gEngfuncs.GetLocalPlayer();
	if ( !localplayer )  return 0;

	
	particles_t *p, *pprev, *pnext;
	pprev = NULL;
	p = m_pParticles;

	float gravity = CVAR_GET_FLOAT( "sv_gravity" );

	float a; //transparence
	
	//division angle de vue
	vec3_t v_forward, v_right, v_up;
	AngleVectors(localplayer->curstate.vuser1, v_forward, v_right, v_up );
  
	// initialisation de l'affichage
	gEngfuncs.pTriAPI->SpriteTexture( m_pSprite, 0 );
	gEngfuncs.pTriAPI->RenderMode( kRenderTransAdd );
	gEngfuncs.pTriAPI->CullFace( TRI_NONE );
	gEngfuncs.pTriAPI->Begin( TRI_QUADS );

	while( p )
	{
		pnext = p->next;

		// transparence
		a = (p->color[3] += p->d_color[3] * m_flFrametime);
		float delta = (p->fadein_time - p->age);
		if(delta>=0.0) a = p->color[3] * (1.0 - delta / p->fadein_time);

		// couleur
		p->color[0] += p->d_color[0] * m_flFrametime;
		p->color[1] += p->d_color[1] * m_flFrametime;
		p->color[2] += p->d_color[2] * m_flFrametime;

		// taille
		p->size[0] += p->d_size[0] * m_flFrametime;
		p->size[1] += p->d_size[1] * m_flFrametime;
		
		// gravite
		p->vel.z -= gravity * m_flFrametime * p->gravity;

		// emplacement
		p->origin = p->origin + p->vel* m_flFrametime;

		// collision
		if( gEngfuncs.PM_PointContents( p->origin, NULL ) != CONTENTS_EMPTY )
		{
			p->vel.x=-p->vel.x/3;
			p->vel.y=-p->vel.y/3;
			p->vel.z=-p->vel.z/3;
			p->vel=p->vel.y*v_forward.Normalize()+p->vel.x*v_right.Normalize()+p->vel.z*v_up.Normalize();
		}


		// affichage
		if( p->age >= p->life )
		{
			if( pprev ) pprev->next = pnext;
			else m_pParticles = pnext;
			p->next = m_pFreed;
			m_pFreed = p;
			m_iParticleCount--;
		}
		else
		{
			pprev = p;

			gEngfuncs.pTriAPI->Color4f( p->color[0], p->color[1], p->color[2], a );
			gEngfuncs.pTriAPI->Brightness( 1 );
			gEngfuncs.pTriAPI->TexCoord2f( 0, 0 );
			gEngfuncs.pTriAPI->Vertex3fv( p->origin );
			gEngfuncs.pTriAPI->TexCoord2f( 0, 1 );
			gEngfuncs.pTriAPI->Vertex3fv( p->origin + v_right * p->size[0] );
			gEngfuncs.pTriAPI->TexCoord2f( 1, 1 );
			gEngfuncs.pTriAPI->Vertex3fv( p->origin + v_right * p->size[0] + v_up * p->size[1] );
			gEngfuncs.pTriAPI->TexCoord2f( 1, 0 );
			gEngfuncs.pTriAPI->Vertex3fv( p->origin + v_up * p->size[1] );
   
			p->age += m_flFrametime;
		}
		p = pnext;
	}
	gEngfuncs.pTriAPI->End();

	return 1;
}
/*
void CParticleLanceflamme::CalcDeltas( particles_t* p )
{
	if( p )
    {
        for( int i=0; i < 4; i++ )
        {
            p->d_color[i] = (p->color_end[i] - p->color[i]) / p->life;
        }
        p->d_size[0] = (p->size_end[0] - p->size[0]) / p->life;
        p->d_size[1] = (p->size_end[1] - p->size[1]) / p->life;
    }
}*/



void Draw_One_Lanceflamme(int index)
{
    cl_entity_t *player;
	player = gEngfuncs.GetLocalPlayer();
    if ( !player ) return;

    particles_t *p;
	Vector devant,cote,dessus;

    if( !tab_lanceflamme[index].gLanceflamme.m_fInitialized )
        tab_lanceflamme[index].gLanceflamme.Init("sprites/jeu/armes/feu.spr");
 
	// angle de vue du joueur
	AngleVectors( player->curstate.vuser1, devant, cote, dessus ); 

    int iCount = tab_lanceflamme[index].gLanceflamme.m_flFrametime * 100.0f;
    for( int i = 0; i < iCount; i++ )
    {
        if( p = tab_lanceflamme[index].gLanceflamme.Create(MAX_PARTICLES) )
        {
            p->life = gEngfuncs.pfnRandomFloat(0.5,1.1);
            p->vel.x = -37.0;
            p->vel.y = gEngfuncs.pfnRandomFloat(75.0,650.0);
            p->vel.z = gEngfuncs.pfnRandomFloat(-0.15,0.15);
			p->vel=p->vel.y*devant.Normalize()+p->vel.x*cote.Normalize()+p->vel.z*dessus.Normalize();
            p->origin = player->origin+30*devant+10*cote+25*dessus;;
            p->color[0] = 0.0;
            p->color[1] = 0.0;
            p->color[2] = 0.5;
            p->color[3] = 0.8;
            p->color_end[0] = 1.0;
            p->color_end[1] = 0.5;
            p->color_end[2] = 0.0;
            p->color_end[3] = 0.2;
            p->fadein_time = 0.1;
            p->size[0] = 5.0;
            p->size[1] = 5.0;
            p->size_end[0] = 120.0;
            p->size_end[1] = 120.0;
            p->gravity = -0.01;
            tab_lanceflamme[index].gLanceflamme.CalcDeltas( p );
        }
    }
    tab_lanceflamme[index].gLanceflamme.Update();
}

void Draw_Lanceflamme()
{
	for(int i=0;i<MAX_PLAYERS;i++)
	{
		if(tab_lanceflamme[i].affiche)Draw_One_Lanceflamme(i);
	}


}