//	EurOPiuM - 22/07/02
//	-------------------------
//	Effets visuels des saintes
//	-------------------------


#include "hud.h"
#include "cl_util.h"
#include "triangleapi.h"
#include "particles.h"
#include "const.h"


int CParticleSainte::Draw()
{
	cl_entity_t *localplayer;
	localplayer = gEngfuncs.GetLocalPlayer();
	if ( !localplayer )  return 0;

	
	particles_t *p, *pprev, *pnext;
	pprev = NULL;
	p = m_pParticles;

	float gravity = CVAR_GET_FLOAT( "sv_gravity" );

	float a; //transparence
	
	//division angle de vue
	vec3_t v_forward, v_right, v_up;
	AngleVectors(localplayer->curstate.vuser1, v_forward, v_right, v_up );

  
	// initialisation de l'affichage
	gEngfuncs.pTriAPI->SpriteTexture( m_pSprite, 0 );
	gEngfuncs.pTriAPI->RenderMode( kRenderTransAdd );
	gEngfuncs.pTriAPI->CullFace( TRI_NONE );
	gEngfuncs.pTriAPI->Begin( TRI_QUADS );

	while( p )
	{
		pnext = p->next;

		// transparence
		a = (p->color[3] += p->d_color[3] * m_flFrametime);
		float delta = (p->fadein_time - p->age);
		if(delta>=0.0) a = p->color[3] * (1.0 - delta / p->fadein_time);

		// couleur
		p->color[0] += p->d_color[0] * m_flFrametime;
		p->color[1] += p->d_color[1] * m_flFrametime;
		p->color[2] += p->d_color[2] * m_flFrametime;

		// taille
		p->size[0] += p->d_size[0] * m_flFrametime;
		p->size[1] += p->d_size[1] * m_flFrametime;
		
		// gravite
		p->vel.z -= gravity * m_flFrametime * p->gravity;

		// emplacement
		p->origin = p->origin + p->vel* m_flFrametime;


		// collision
		if( gEngfuncs.PM_PointContents( p->origin, NULL )!=CONTENTS_EMPTY )
			p->life = 0.0;


		// affichage
		if( p->age >= p->life )
		{
			if( pprev ) pprev->next = pnext;
			else m_pParticles = pnext;
			p->next = m_pFreed;
			m_pFreed = p;
			m_iParticleCount--;
		}
		else
		{
			pprev = p;

			gEngfuncs.pTriAPI->Color4f( p->color[0], p->color[1], p->color[2], a );
			gEngfuncs.pTriAPI->Brightness( 1 );
			gEngfuncs.pTriAPI->TexCoord2f( 0, 0 );
			gEngfuncs.pTriAPI->Vertex3fv( p->origin );
			gEngfuncs.pTriAPI->TexCoord2f( 0, 1 );
			gEngfuncs.pTriAPI->Vertex3fv( p->origin + v_right * p->size[0] );
			gEngfuncs.pTriAPI->TexCoord2f( 1, 1 );
			gEngfuncs.pTriAPI->Vertex3fv( p->origin + v_right * p->size[0] + v_up * p->size[1] );
			gEngfuncs.pTriAPI->TexCoord2f( 1, 0 );
			gEngfuncs.pTriAPI->Vertex3fv( p->origin + v_up * p->size[1] );
   
			p->age += m_flFrametime;
		}
		p = pnext;
	}
	gEngfuncs.pTriAPI->End();

	return 1;
}



void Draw_One_Sainte_Rebond(int max_particles,int index)
{
	particles_t *p;
	Vector devant,cote,dessus;


    if( !tab_sainte_rebond[index].gSainte.m_fInitialized )
        tab_sainte_rebond[index].gSainte.Init("sprites/jeu/armes/feu.spr");


		vec3_t angles;
		angles.x=0.2;
		angles.y=0.2;
		angles.z=1.0;
		AngleVectors( angles, devant, cote, dessus );
		


    int iCount = tab_sainte_rebond[index].gSainte.m_flFrametime * 450.0f;
    for( int i = 0; i < iCount; i++ )
    {
        if( p = tab_sainte_rebond[index].gSainte.Create(max_particles) )
        {
            p->life = 1.0;
            p->vel.x = gEngfuncs.pfnRandomFloat(-20.0,20.0);
			p->vel.y = gEngfuncs.pfnRandomFloat(-20.0,20.0);
			p->vel.z = gEngfuncs.pfnRandomFloat(-20.0,20.0);
			p->vel=p->vel.y*devant.Normalize()+p->vel.x*cote.Normalize()+p->vel.z*dessus.Normalize();
			p->origin.x=tab_sainte_rebond[index].ou.x+gEngfuncs.pfnRandomFloat(-3.0, 3.0);
			p->origin.y=tab_sainte_rebond[index].ou.y+gEngfuncs.pfnRandomFloat(-3.0, 3.0);
			p->origin.z=tab_sainte_rebond[index].ou.z+gEngfuncs.pfnRandomFloat(-3.0, 3.0);
            p->color[0] = 1.0;
            p->color[1] = 0.0;
            p->color[2] = 0.5;
            p->color[3] = 0.8;
            p->color_end[0] = 1.0;
            p->color_end[1] = 0.5;
            p->color_end[2] = 0.75;
            p->color_end[3] = 0.2;
            p->fadein_time = 0.0000001;
            p->size[0] = 20.0;
            p->size[1] = 20.0;
            p->size_end[0] = 20.0;
            p->size_end[1] = 20.0;
            p->gravity = 0.0;
            tab_sainte_rebond[index].gSainte.CalcDeltas( p );
        }
    }
    tab_sainte_rebond[index].gSainte.Update();
}



void Draw_One_Sainte_Attente(int max_particles,int index)
{
	particles_t *p;
	Vector devant,cote,dessus;


    if( !tab_sainte_attente[index].gSainte.m_fInitialized )
        tab_sainte_attente[index].gSainte.Init("sprites/jeu/armes/feu.spr");


		vec3_t angles;
		angles.x=0.2;
		angles.y=0.2;
		angles.z=1.0;
		AngleVectors( angles, devant, cote, dessus );
		


    int iCount = tab_sainte_attente[index].gSainte.m_flFrametime * 450.0f;
    for( int i = 0; i < iCount; i++ )
    {
        if( p = tab_sainte_attente[index].gSainte.Create(max_particles) )
        {			
            p->life = gEngfuncs.pfnRandomFloat(0.8, 2.0);
            p->vel.x = gEngfuncs.pfnRandomFloat(-20.0,20.0);
			p->vel.y = gEngfuncs.pfnRandomFloat(-20.0,20.0);
			p->vel.z = gEngfuncs.pfnRandomFloat(-20.0,20.0);
			p->vel=p->vel.y*devant.Normalize()+p->vel.x*cote.Normalize()+p->vel.z*dessus.Normalize();
			p->origin.x=tab_sainte_attente[index].ou.x+gEngfuncs.pfnRandomFloat(-10.0, 10.0);
			p->origin.y=tab_sainte_attente[index].ou.y+gEngfuncs.pfnRandomFloat(-10.0, 10.0);
			p->origin.z=tab_sainte_attente[index].ou.z+gEngfuncs.pfnRandomFloat(-10.0, 10.0);	
            p->color[0] = 1.0;
            p->color[1] = 0.0;
            p->color[2] = 0.5;
            p->color[3] = 1.0;
            p->color_end[0] = 1.0;
            p->color_end[1] = 0.5;
            p->color_end[2] = 0.75;
            p->color_end[3] = 0.2;
            p->fadein_time = 0.0000001;
            p->size[0] = 30.0;
            p->size[1] = 30.0;
            p->size_end[0] = 5.0;
            p->size_end[1] = 5.0;
            p->gravity = 0.0;
            tab_sainte_attente[index].gSainte.CalcDeltas( p );
        }
    }
    tab_sainte_attente[index].gSainte.Update();
}


void Draw_One_Sainte_Explosion(int max_particles,int index)
{
	particles_t *p;
	Vector devant,cote,dessus;


    if( !tab_sainte_explosion[index].gSainte.m_fInitialized )
        tab_sainte_explosion[index].gSainte.Init("sprites/jeu/armes/feu.spr");


		vec3_t angles;
		angles.x=0.2;
		angles.y=0.2;
		angles.z=1.0;
		AngleVectors( angles, devant, cote, dessus );
		


    int iCount = tab_sainte_explosion[index].gSainte.m_flFrametime * 450.0f;
    for( int i = 0; i < iCount; i++ )
    {
        if( p = tab_sainte_explosion[index].gSainte.Create(max_particles) )
        {			
            p->life = gEngfuncs.pfnRandomFloat(0.5, 1.5);
            p->vel.x = gEngfuncs.pfnRandomFloat(-650.0,650.0);
			p->vel.y = gEngfuncs.pfnRandomFloat(-650.0,650.0);
			p->vel.z = gEngfuncs.pfnRandomFloat(-650.0,650.0);
			p->vel=p->vel.y*devant.Normalize()+p->vel.x*cote.Normalize()+p->vel.z*dessus.Normalize();
			p->origin.x=tab_sainte_explosion[index].ou.x+gEngfuncs.pfnRandomFloat(-70.0, 70.0);
			p->origin.y=tab_sainte_explosion[index].ou.y+gEngfuncs.pfnRandomFloat(-70.0, 70.0);
			p->origin.z=tab_sainte_explosion[index].ou.z+gEngfuncs.pfnRandomFloat(-70.0, 70.0);	
            p->color[0] = 1.0;
            p->color[1] = 0.0;
            p->color[2] = 0.5;
            p->color[3] = 1.0;
            p->color_end[0] = 1.0;
            p->color_end[1] = 0.5;
            p->color_end[2] = 0.75;
            p->color_end[3] = 0.2;
            p->fadein_time = 0.0000001;
            p->size[0] = 150.0;
            p->size[1] = 150.0;
            p->size_end[0] = 5.0;
            p->size_end[1] = 5.0;
            p->gravity = 0.0;
            tab_sainte_explosion[index].gSainte.CalcDeltas( p );
        }
    }
    tab_sainte_explosion[index].gSainte.Update();
}


void Draw_Sainte()
{
	for(int i=0;i<MAX_PARTICLES_SAINTE_REBOND;i++)
	{
		int dureep=0.5;
		float actuel=gEngfuncs.GetClientTime();
		float reste=dureep-(actuel-tab_sainte_rebond[i].quand);
		if(actuel-tab_sainte_rebond[i].quand<0.5)
			Draw_One_Sainte_Rebond(240*int(actuel-tab_sainte_rebond[i].quand)+5,i);
		else if(reste<1)
			Draw_One_Sainte_Rebond(int(130*int(reste)+5),i);
		else if(reste>0)
			Draw_One_Sainte_Rebond(125,i);
		else
			tab_sainte_rebond[i].type=PARTICLES_NULL;
	}
	
	for(i=0;i<MAX_PARTICLES_SAINTE_ATTENTE;i++)
	{
		float actuel=gEngfuncs.GetClientTime();
		if(actuel-tab_sainte_attente[i].quand<2.0)
		{
			Draw_One_Sainte_Attente(50,i);
		}
		else if(actuel-tab_sainte_attente[i].quand<=4.0)
			Draw_One_Sainte_Attente(0,i);
		else
			tab_sainte_attente[i].type=PARTICLES_NULL;
	}

	for(i=0;i<MAX_PARTICLES_SAINTE_EXPLOSION;i++)
	{
		float actuel=gEngfuncs.GetClientTime();
		if(actuel-tab_sainte_explosion[i].quand<0.5)
		{
			Draw_One_Sainte_Explosion(50,i);
		}
		else if(actuel-tab_sainte_explosion[i].quand<=2.0)
			Draw_One_Sainte_Explosion(0,i);
		else
			tab_sainte_explosion[i].type=PARTICLES_NULL;
	}
}
