#include "profil.h"
#include <stdio.h>
#include <string.h>
#include "hud.h"
#include "cl_util.h"
#include "define_hud.h"


//--------------------------------------------------
// NOM DU FICHIER PROFIL
//--------------------------------------------------
const char * NOM_DU_FICHIER_PROFIL="whl_profil_b3.0.prf";
// changer suffixe chaque fois que les donnees dedans changent
// donc qu'un fichier de la version precedente sera illisible pour cette version
//--------------------------------------------------







//--------------------------------------------------
// VARIABLES
//--------------------------------------------------
profil_t LocalProfil;
int nb_parties;
int nb_victoires;
int niveau;
const char * nom_du_fichier_decrypte="hlprf.txt";
const char * nom_du_fichier_temporaire="hlprft.txt";
extern char * pseudo;



//--------------------------------------------------
// LECTURE DU PROFIL
//--------------------------------------------------
void profil_initialisation()
{
	profil_RAZ();

	char pseudolu[32];
	short tempshort=0;

	cryptage(DECODE);

	FILE * f = fopen (nom_du_fichier_decrypte, "rb+");//ouverture du fichier
	if (f == NULL)return;

	bool cassos=false;
	while (!feof(f) && !cassos)
	{
		fread(&tempshort,1,1,f);
		fread(pseudolu,tempshort,1,f);
		pseudolu[tempshort]='\0';
		if(!strcmp(pseudolu,pseudo))
		{
			cassos=true;
			fread(&LocalProfil,sizeof(profil_t),1,f);
			fread(&nb_parties,4,1,f);
			fread(&nb_victoires,4,1,f);
			niveau=profil_niveau();
		}
	}
	fclose(f);


	if(cassos)
	{
		if(profil_test())profil_erreurintegrite();
	}
	else profil_nouveaupseudo();

	remove(nom_du_fichier_decrypte);
}



//--------------------------------------------------
// SAUVEGARDE DU PROFIL
//--------------------------------------------------
void profil_sauvegarde(int gagnant,profil_t TheProfil)
{
	if(!gHUD.localplayer) return;


// on compte les joueurs dans chaque equipe
// sans prendre en compte les bots
	int nbr=0,nbb=0;	
	for ( int i=1; i < MAX_PLAYERS; i++ )
	{
		cl_entity_t * player;
		player = gEngfuncs.GetEntityByIndex( i );
		if ( player && player->player && gHUD.IsBot[i]>0 && gHUD.IsBot[i]<=101 )
		{
			if(player->curstate.iuser4) nbb++;
			else nbr++;
		}
	}

// il faut au moins 2 joueurs humains dans chaque equipe pour que le
// profil soit pris en compte
	if(nbr<2 || nbb<2)
	{
		ConsolePrint("PROFIL : sauvegarde annule : minimum 2 contre 2 (bots exclus)");
	}
	else
	{
		cryptage(DECODE);

		// mise  jour des variables
		nb_parties++;
		if(gHUD.localplayer->curstate.iuser4==gagnant) nb_victoires++;
		LocalProfil.iGvToucheCollegue+=TheProfil.iGvToucheCollegue;
		LocalProfil.iGvNoyer+=TheProfil.iGvNoyer;
		LocalProfil.iGvTombeAllier+=TheProfil.iGvTombeAllier;
		LocalProfil.iGvTombeEnnemie+=TheProfil.iGvTombeEnnemie;
		LocalProfil.iGvDeathNb+=TheProfil.iGvDeathNb;
		LocalProfil.iGvKillNb+=TheProfil.iGvKillNb;
		LocalProfil.iGvKillDommageMax+=TheProfil.iGvKillDommageMax;
		LocalProfil.iGvCaissesNb+=TheProfil.iGvCaissesNb;
		LocalProfil.iGvBilleBocketNb+=TheProfil.iGvBilleBocketNb;
		LocalProfil.iGvBilleBocketMax+=TheProfil.iGvBilleBocketMax;
		LocalProfil.iGvStupide+=TheProfil.iGvStupide;
		LocalProfil.iGvApocalipse+=TheProfil.iGvApocalipse;
		LocalProfil.iGvDieu+=TheProfil.iGvDieu;
		LocalProfil.iGvSatan+=TheProfil.iGvSatan;


		FILE *depart;
		FILE *arrivee;

		char pseudolu[32];
		short tempshort=0;
		profil_t prof;
		int nbp,nbv;

		depart=fopen(nom_du_fichier_decrypte,"rb+");
		if(depart==NULL) return;

		arrivee=fopen(nom_du_fichier_temporaire,"wb");
		if(arrivee==NULL) return;

		// longueur premier pseudo
		fread(&tempshort,1,1,depart);
		fwrite(&tempshort,1,1,arrivee);

		while (!feof(depart))
		{
			// pseudo
			fread(pseudolu,tempshort,1,depart);
			pseudolu[tempshort]='\0';
			fwrite(pseudolu,tempshort,1,arrivee);

			fread(&prof,sizeof(profil_t),1,depart);
			fread(&nbp,4,1,depart);
			fread(&nbv,4,1,depart);

			// si c'est le bon pseudo, on ne recopie pas
			if(!strcmp(pseudolu,pseudo))
			{
				fwrite(&LocalProfil,sizeof(profil_t),1,arrivee);
				fwrite(&nb_parties,4,1,arrivee);
				fwrite(&nb_victoires,4,1,arrivee);
			}
			// si c'est pas le bon pseudo, on recopie
			else
			{
				fwrite(&prof,sizeof(profil_t),1,arrivee);
				fwrite(&nbp,4,1,arrivee);
				fwrite(&nbv,4,1,arrivee);
			}

			// longueur pseudo suivant
			fread(&tempshort,1,1,depart);
			fwrite(&tempshort,1,1,arrivee);
		}

		fclose(depart);
		fclose(arrivee);

		cryptage(ENCODE);

		remove(nom_du_fichier_temporaire);
		remove(nom_du_fichier_decrypte);
	}
}


//--------------------------------------------------
// TEST SUR L'INTEGRITE DU FICHIER PROFIL
//--------------------------------------------------
int profil_test()
{
	if ( nb_victoires>nb_parties ) return 1;
	else return 0;
	// sera srement amen  tre complet
}


//--------------------------------------------------
// CREATION D'UN NOUVEAU PROFIL
//--------------------------------------------------
void profil_RAZ()
{
	LocalProfil.iGvToucheCollegue=0;
	LocalProfil.iGvNoyer=0;
	LocalProfil.iGvTombeAllier=0;
	LocalProfil.iGvTombeEnnemie=0;
	LocalProfil.iGvDeathNb=0;
	LocalProfil.iGvKillNb=0;
	LocalProfil.iGvKillDommageMax=0;
	LocalProfil.iGvCaissesNb=0;
	LocalProfil.iGvBilleBocketNb=0;
	LocalProfil.iGvBilleBocketMax=0;
	LocalProfil.iGvStupide=0;
	LocalProfil.iGvApocalipse=0;
	LocalProfil.iGvDieu=0;
	LocalProfil.iGvSatan=0;

	nb_parties=0;
	nb_victoires=0;
	niveau=profil_niveau();
}


//--------------------------------------------------
// CALCUL DU NIVEAU
//--------------------------------------------------
int profil_niveau()
{
	int pourcentage=0;
	
	// premiere estimation
	if(nb_victoires>9*nb_parties/10)pourcentage=95;
	else if(nb_victoires>3*nb_parties/4)pourcentage=83;
	else if(nb_victoires>2*nb_parties/3)pourcentage=66;
	else if(nb_victoires>nb_parties/2)pourcentage=52;
	else if(nb_victoires>nb_parties/4)pourcentage=38;
	
	// bridage suivant nb de parties
	if(!pourcentage && nb_parties>5)pourcentage=10;
	else if(nb_parties<3 && pourcentage>52)pourcentage=52;
	else if(nb_parties<5 && pourcentage>66)pourcentage=66;
	else if(nb_parties<10 && pourcentage>83)pourcentage=83;

	// affinage par rapport au profil_t
	pourcentage+=int(0.1*(-LocalProfil.iGvToucheCollegue-LocalProfil.iGvNoyer+LocalProfil.iGvTombeAllier+LocalProfil.iGvTombeEnnemie-LocalProfil.iGvDeathNb+LocalProfil.iGvKillNb+LocalProfil.iGvBilleBocketNb-LocalProfil.iGvStupide+LocalProfil.iGvDieu-LocalProfil.iGvSatan)+0.05*LocalProfil.iGvCaissesNb);
	if(LocalProfil.iGvKillDommageMax>185)pourcentage++;
	if(LocalProfil.iGvBilleBocketMax>185)pourcentage++;
	pourcentage-=LocalProfil.iGvApocalipse;

	// au minimum 1% quand meme !
	if(pourcentage<1)pourcentage=1;

	return pourcentage;
}



//--------------------------------------------------
// MISE A JOUR DES VERSIONS PRECEDENTES DES PROFILS
//--------------------------------------------------
void profil_MAJ(FILE * f)
{
	NULL; // rien pour l'instant
}


//--------------------------------------------------
// NOUVEAU PROFIL (si pseudo inconnu)
//--------------------------------------------------
void profil_nouveaupseudo()
{
	ConsolePrint("PROFIL : creation d'un nouveau profil (");
	ConsolePrint(pseudo);
	ConsolePrint(")\n");

	profil_RAZ();

	cryptage(DECODE);

	rename(nom_du_fichier_decrypte,nom_du_fichier_temporaire);

	FILE * f = fopen(nom_du_fichier_temporaire,"rb+");

	fseek(f,0,SEEK_END); // on va a la fin du fichier

	short tempshort=taille(pseudo);
	fwrite(&tempshort,1,1,f);
	fwrite(pseudo,tempshort,1,f);
	fwrite(&LocalProfil,sizeof(profil_t),1,f);
	fwrite(&nb_parties,4,1,f);
	fwrite(&nb_victoires,4,1,f);

	fclose(f);
	cryptage(ENCODE);
	remove(nom_du_fichier_temporaire);
}

//--------------------------------------------------
// ERREUR D'INTEGRITE
//--------------------------------------------------
void profil_erreurintegrite()
{
	ConsolePrint("PROFIL : erreur d'integrite -> RAZ\n");
	
	profil_RAZ();

	cryptage(DECODE);

	FILE *depart;
	FILE *arrivee;
	char pseudolu[32];
	short tempshort=0;
	profil_t prof;
	int nbp,nbv;

	depart=fopen(nom_du_fichier_decrypte,"rb+");
	if(depart==NULL) return;
	arrivee=fopen(nom_du_fichier_temporaire,"wb");
	if(arrivee==NULL) return;

	// longueur premier pseudo
	fread(&tempshort,1,1,depart);
	fwrite(&tempshort,1,1,arrivee);
	while (!feof(depart))
	{
		// pseudo
		fread(pseudolu,tempshort,1,depart);
		pseudolu[tempshort]='\0';
		fwrite(pseudolu,tempshort,1,arrivee);
		fread(&prof,sizeof(profil_t),1,depart);
		fread(&nbp,4,1,depart);
		fread(&nbv,4,1,depart);
		// si c'est le bon pseudo, on ne recopie pas
		if(!strcmp(pseudolu,pseudo))
		{
			fwrite(&LocalProfil,sizeof(profil_t),1,arrivee);
			fwrite(&nb_parties,4,1,arrivee);
			fwrite(&nb_victoires,4,1,arrivee);
		}
		// si c'est pas le bon pseudo, on recopie
		else
		{
			fwrite(&prof,sizeof(profil_t),1,arrivee);
			fwrite(&nbp,4,1,arrivee);
			fwrite(&nbv,4,1,arrivee);
		}
		// longueur pseudo suivant
		fread(&tempshort,1,1,depart);
		fwrite(&tempshort,1,1,arrivee);
	}
	fclose(depart);
	fclose(arrivee);
	cryptage(ENCODE);
	remove(nom_du_fichier_temporaire);
	remove(nom_du_fichier_decrypte);
}

//--------------------------------------------------
// NOUVEAU FICHIER (si inexistant)
//--------------------------------------------------
void profil_nouveaufichier()
{
	ConsolePrint("PROFIL : creation d'un fichier profil\n");

	profil_RAZ();

	FILE * f = fopen (nom_du_fichier_temporaire, "wb");//ouverture du fichier
	if (f == NULL)return;

	short tempshort=taille(pseudo);

	fwrite(&tempshort,1,1,f);
	fwrite(pseudo,tempshort,1,f);
	fwrite(&LocalProfil,sizeof(profil_t),1,f);
	fwrite(&nb_parties,4,1,f);
	fwrite(&nb_victoires,4,1,f);

	fclose(f);
	cryptage(ENCODE);
	remove(nom_du_fichier_temporaire);
}


//--------------------------------------------------
// ENCODE / DECODE
//--------------------------------------------------
void cryptage(int type)
{
	unsigned long taille;	// taille du fichier
    unsigned char cle;		// cle du codage
	FILE *original;			// fichier de depart
    FILE *crypte;			// fichier d'arrive

	original=fopen(type==ENCODE?nom_du_fichier_temporaire:NOM_DU_FICHIER_PROFIL,"rb+");
    if(original==NULL)
	{
		profil_MAJ(original);
		original=fopen(type==ENCODE?nom_du_fichier_temporaire:NOM_DU_FICHIER_PROFIL,"rb+");
		if(original==NULL)
		{
			profil_nouveaufichier();
			original=fopen(type==ENCODE?nom_du_fichier_temporaire:NOM_DU_FICHIER_PROFIL,"rb+");
			if(original==NULL) return;
		}
	}

    crypte=fopen(type==ENCODE?NOM_DU_FICHIER_PROFIL:nom_du_fichier_decrypte,"wb");
    if(crypte==NULL) return;
 
	fseek(original,0,SEEK_END);
    taille=ftell(original);
    fseek(original,0,SEEK_SET);

	cle=(unsigned char)taille&0xFF;

	for(unsigned long index=0;index<taille;index++)
    {
		char temp=(unsigned char)getc(original);
		temp^=cle++;
		cle+=(1+4*((cle+1)%21));
		fwrite(&temp,1,1,crypte);
    }

	fclose(original);
	fclose(crypte);
}



//--------------------------------------------------
// AFFICHAGE DANS LE HUD
//--------------------------------------------------
void afficher_etoiles(int x,int y,int nb)
{
	HSPRITE sprite_courant = gHUD.GetSpriteIndex( "profil_etoile_pleine" );
	SPR_Set(gHUD.GetSprite(sprite_courant), 255,255,255);

	int i;
	for(i=0;i<nb;i++)
		SPR_Draw(0, x+328+18*i, y+185, &gHUD.GetSpriteRect(sprite_courant));

	sprite_courant = gHUD.GetSpriteIndex( "profil_etoile_vide" );
	SPR_Set(gHUD.GetSprite(sprite_courant), 255,255,255);

	while(i<6)
	{
		SPR_Draw(0, x+328+18*i, y+185, &gHUD.GetSpriteRect(sprite_courant));
		i++;
	}

}

void profil_afficher()
{
	if(!gHUD.localplayer) return;

	int x=(ScreenWidth-630)/2;
	int y=(ScreenHeight-470)/2;

	HSPRITE sprite_courant;

	if(gHUD.localplayer->curstate.iuser4)
		sprite_courant = gHUD.GetSpriteIndex( "profil_1_bleu" );
	else
		sprite_courant = gHUD.GetSpriteIndex( "profil_1_rouge" );

	SPR_Set(gHUD.GetSprite(sprite_courant), 255,255,255);
	SPR_Draw(0, x, y, &gHUD.GetSpriteRect(sprite_courant));

	sprite_courant = gHUD.GetSpriteIndex( "profil_2" );
	SPR_Set(gHUD.GetSprite(sprite_courant), 255,255,255);
	SPR_Draw(0, x, y+256, &gHUD.GetSpriteRect(sprite_courant));

	sprite_courant = gHUD.GetSpriteIndex( "profil_3" );
	SPR_Set(gHUD.GetSprite(sprite_courant), 255,255,255);
	SPR_Draw(0, x+256, y, &gHUD.GetSpriteRect(sprite_courant));

	sprite_courant = gHUD.GetSpriteIndex( "profil_4" );
	SPR_Set(gHUD.GetSprite(sprite_courant), 255,255,255);
	SPR_Draw(0, x+256, y+256, &gHUD.GetSpriteRect(sprite_courant));

	sprite_courant = gHUD.GetSpriteIndex( "profil_5" );
	SPR_Set(gHUD.GetSprite(sprite_courant), 255,255,255);
	SPR_Draw(0, x+512, y, &gHUD.GetSpriteRect(sprite_courant));

	sprite_courant = gHUD.GetSpriteIndex( "profil_6" );
	SPR_Set(gHUD.GetSprite(sprite_courant), 255,255,255);
	SPR_Draw(0, x+512, y+256, &gHUD.GetSpriteRect(sprite_courant));

	gHUD.DrawHudString(x+325, y+23, ScreenWidth,pseudo, 255, 255, 255 );

	hud_player_info_t *pl_info = &g_PlayerInfoList[gHUD.localplayer->index];
	gHUD.DrawHudString(x+309, y+83, ScreenWidth,pl_info->name, 255, 255, 255 );
	
	gHUD.DrawHudNumberString(x+337, y+124, 0,nb_parties, 255, 255, 255 );
	gHUD.DrawHudNumberString(x+345, y+145, 0,nb_victoires, 255, 255, 255 );

//etoiles
	if(niveau<=85 && niveau>70) afficher_etoiles(x,y,5);
	else if(niveau<=70 && niveau>55) afficher_etoiles(x,y,4);
	else if(niveau<=55 && niveau>40) afficher_etoiles(x,y,3);
	else if(niveau<=40 && niveau>20) afficher_etoiles(x,y,2);
	else if(niveau<=20) afficher_etoiles(x,y,1);
	else afficher_etoiles(x,y,6);
	char * t="";
	char * r="%";
	sprintf(t,"( %d %s )",niveau,r);
	gHUD.DrawHudString(x+450, y+186, ScreenWidth,t, 255, 255, 255 );

	gHUD.DrawHudNumberString(x+595, y+295, 0,LocalProfil.iGvToucheCollegue, 255, 255, 255 );
	gHUD.DrawHudNumberString(x+440, y+314, 0,LocalProfil.iGvNoyer, 255, 255, 255 );
	gHUD.DrawHudNumberString(x+200, y+315, 0,LocalProfil.iGvTombeAllier, 255, 255, 255 );
	gHUD.DrawHudNumberString(x+225, y+337, 0,LocalProfil.iGvTombeEnnemie, 255, 255, 255 );
	gHUD.DrawHudNumberString(x+415, y+275, 0,LocalProfil.iGvDeathNb, 255, 255, 255 );
	gHUD.DrawHudNumberString(x+115, y+274, 0,LocalProfil.iGvKillNb, 255, 255, 255 );
	gHUD.DrawHudNumberString(x+245, y+293, 0,LocalProfil.iGvKillDommageMax, 255, 255, 255 );
	gHUD.DrawHudNumberString(x+235, y+356, 0,LocalProfil.iGvCaissesNb, 255, 255, 255 );
	gHUD.DrawHudNumberString(x+500, y+337, 0,LocalProfil.iGvBilleBocketNb, 255, 255, 255 );
	gHUD.DrawHudNumberString(x+520, y+356, 0,LocalProfil.iGvBilleBocketMax, 255, 255, 255 );
	gHUD.DrawHudNumberString(x+445, y+375, 0,LocalProfil.iGvStupide, 255, 255, 255 );
	gHUD.DrawHudNumberString(x+470, y+397, 0,LocalProfil.iGvApocalipse, 255, 255, 255 );
	gHUD.DrawHudNumberString(x+185, y+374, 0,LocalProfil.iGvDieu, 255, 255, 255 );
	gHUD.DrawHudNumberString(x+500, y+418, 0,LocalProfil.iGvSatan, 255, 255, 255 );
}




//--------------------------------------------------
// ENVOIE D'INFORMATIONS AU SERVEUR
//--------------------------------------------------
void profil_commande()
{
	char sz[256]; 
	sprintf(sz, "ntrp %d", niveau);
	gEngfuncs.pfnClientCmd(sz);
}


//--------------------------------------------------
// TAILLE D'UN CHAR *
//--------------------------------------------------
int taille(char * c)
{
	int i=0;
	while (c[i]!='\0')
		i++;
	return i;
}