//	EurOPiuM - 08/05/02
//	------------------------------
//	Indicateurs pyramides / textes
//	------------------------------

//////// CONFIGURATION //////////////////////

#define HAUTEUR			55	// au dessus de la tete
#define LETTRE_LARGEUR	5	// largeur des lettres
#define LETTRE_HAUTEUR	7.5	// hauteur des lettres

////////////////////////////////////////////



#include "hud.h"
#include "cl_util.h"
#include "triangleapi.h"

#define VIE player->curstate.fuser1 // plus facile a manier pour avoir la vie du joueur
extern cvar_t *p_pyramide;
extern cvar_t *p_ma_pyramide;

void Draw_Pyramides( void )
{
	if ( !gHUD.localplayer ) 
		return;

	for ( int i = 1; i < MAX_PLAYERS; i++ )
	{
		cl_entity_t *player;
		player = gEngfuncs.GetEntityByIndex( i );
		if ( player && player->player && (player!=gHUD.localplayer || p_ma_pyramide->value==MA_PYRAMIDE_OUI) )
		{
			if(int(VIE)!=255) // on affiche seulement si la vie>0 (qui correspond  255 dans delta.lst)
			{
				vec3_t org;
				org=player->origin;

				if(p_pyramide->value==PYRAMIDE_TEXTES ) //mode "texte"
				{
					hud_player_info_t *pl_info = &g_PlayerInfoList[i]; //pour recuperer nom du joueur

					int nblettres=0,nbchiffres;
					while(pl_info->name[nblettres]!='\0')
					{
						nblettres++;
					}

// vecteurs directeurs
					Vector devant,cote,dessus; 
					AngleVectors( gHUD.localplayer->angles, devant, cote, dessus ); 

// point de depart pour la vie
					vec3_t orgvie,deb,debvie;
					if(player->curstate.fuser1>99) // si vie comporte 3 chiffres
					{
						orgvie=org-1.5*LETTRE_LARGEUR*cote;
						nbchiffres=3;
					}
					else if(player->curstate.fuser1>9) // 2 chiffres
					{
						orgvie=org-LETTRE_LARGEUR*cote;
						nbchiffres=2;
					}
					else
					{
						orgvie=org-0.5*LETTRE_LARGEUR*cote;
						nbchiffres=1;
					}
					orgvie.z+=HAUTEUR;

//point de depart pour le nom
					org=org-((float(nblettres)/2)*LETTRE_LARGEUR*cote);
					org.z=org.z+HAUTEUR+LETTRE_HAUTEUR+0.25;

// onsauvegarde les points de debut d'ecriture
					VectorCopy(org,deb);
					VectorCopy(orgvie,debvie);
// couleur des lettres suivant l'equipe
					float r,b;
					if(player->curstate.iuser4)
					{
						r=0;
						b=150;
					}
					else
					{
						b=0;
						r=150;
					}

					////////////// LETTRES POUR NOM
					gEngfuncs.pTriAPI->RenderMode( kRenderTransAlpha );
					gEngfuncs.pTriAPI->CullFace( TRI_FRONT );
					gEngfuncs.pTriAPI->Color4f( 255,255,255, 1.0);
					for(int j=0;j<nblettres;j++)
					{
						switch(pl_info->name[j])
						{
							case 'a' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/a_min.spr" );break;
							case 'A' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/a_maj.spr" );break;
							case 'b' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/b_min.spr" );break;
							case 'B' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/b_maj.spr" );break;
							case 'c' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/c_min.spr" );break;
							case 'C' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/c_maj.spr" );break;
							case 'd' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/d_min.spr" );break;
							case 'D' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/d_maj.spr" );break;
							case 'e' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/e_min.spr" );break;
							case 'E' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/e_maj.spr" );break;
							case 'f' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/f_min.spr" );break;
							case 'F' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/f_maj.spr" );break;
							case 'g' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/g_min.spr" );break;
							case 'G' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/g_maj.spr" );break;
							case 'h' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/h_min.spr" );break;
							case 'H' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/h_maj.spr" );break;
							case 'i' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/i_min.spr" );break;
							case 'I' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/i_maj.spr" );break;
							case 'j' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/j_min.spr" );break;
							case 'J' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/j_maj.spr" );break;
							case 'k' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/k_min.spr" );break;
							case 'K' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/k_maj.spr" );break;
							case 'l' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/l_min.spr" );break;
							case 'L' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/l_maj.spr" );break;
							case 'm' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/m_min.spr" );break;
							case 'M' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/m_maj.spr" );break;
							case 'n' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/n_min.spr" );break;
							case 'N' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/n_maj.spr" );break;
							case 'o' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/o_min.spr" );break;
							case 'O' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/o_maj.spr" );break;
							case 'p' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/p_min.spr" );break;
							case 'P' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/p_maj.spr" );break;
							case 'q' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/q_min.spr" );break;
							case 'Q' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/q_maj.spr" );break;
							case 'r' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/r_min.spr" );break;
							case 'R' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/r_maj.spr" );break;
							case 's' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/s_min.spr" );break;
							case 'S' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/s_maj.spr" );break;
							case 't' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/t_min.spr" );break;
							case 'T' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/t_maj.spr" );break;
							case 'u' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/u_min.spr" );break;
							case 'U' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/u_maj.spr" );break;
							case 'v' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/v_min.spr" );break;
							case 'V' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/v_maj.spr" );break;
							case 'w' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/w_min.spr" );break;
							case 'W' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/w_maj.spr" );break;
							case 'x' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/x_min.spr" );break;
							case 'X' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/x_maj.spr" );break;
							case 'y' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/y_min.spr" );break;
							case 'Y' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/y_maj.spr" );break;
							case 'z' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/z_min.spr" );break;
							case 'Z' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/z_maj.spr" );break;
							case '0' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/0.spr" );break;
							case '1' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/1.spr" );break;
							case '2' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/2.spr" );break;
							case '3' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/3.spr" );break;
							case '4' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/4.spr" );break;
							case '5' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/5.spr" );break;
							case '6' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/6.spr" );break;
							case '7' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/7.spr" );break;
							case '8' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/8.spr" );break;
							case '9' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/9.spr" );break;
							case '.' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/point.spr" );break;
							case '-' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/moins.spr" );break;
							case '*' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/etoile.spr" );break;
							case '/' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/divise.spr" );break;
							case '+' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/plus.spr" );break;
							case ')' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/parf.spr" );break;
							case '(' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/paro.spr" );break;
							case '[' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/crocho.spr" );break;
							case ']' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/crochf.spr" );break;
							case '=' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/egal.spr" );break;
							case '#' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/diese.spr" );break;
							case '_' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/souligne.spr" );break;
							case '@' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/smiley.spr" );break;
							case '&' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/couleurs.spr" );break;
							case ':' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/deuxpoints.spr" );break;
							case '!' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/exclamation.spr" );break;
							case '?' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/interrogation.spr" );break;
							case '' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/bite.spr" );break;
							case ',' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/flecheg.spr" );break;
							case ';' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/fleched.spr" );break;
							case '$' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/dollar.spr" );break;
							default  : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/vide.spr" );break;
						}
						if ( !gEngfuncs.pTriAPI->SpriteTexture( (struct model_s *)gEngfuncs.GetSpritePointer( gHUD.m_hsprCursor ), 0 ))return;

						gEngfuncs.pTriAPI->Begin( TRI_QUADS );		
							gEngfuncs.pTriAPI->Brightness( 1 );
							gEngfuncs.pTriAPI->TexCoord2f( 1, 0 );
							gEngfuncs.pTriAPI->Vertex3f( org.x+cote.x*LETTRE_LARGEUR, org.y+cote.y*LETTRE_LARGEUR, org.z+LETTRE_HAUTEUR );
							gEngfuncs.pTriAPI->TexCoord2f( 1, 1 );
							gEngfuncs.pTriAPI->Vertex3f( org.x+cote.x*LETTRE_LARGEUR, org.y+cote.y*LETTRE_LARGEUR, org.z );		
							gEngfuncs.pTriAPI->TexCoord2f( 0, 1 );
							gEngfuncs.pTriAPI->Vertex3f( org.x, org.y , org.z );			
							gEngfuncs.pTriAPI->TexCoord2f( 0, 0 );
							gEngfuncs.pTriAPI->Vertex3f( org.x, org.y, org.z+LETTRE_HAUTEUR );
						gEngfuncs.pTriAPI->End();


						switch(pl_info->name[nblettres-j-1])
						{
							case 'a' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/a_min.spr" );break;
							case 'A' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/a_maj.spr" );break;
							case 'b' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/b_min.spr" );break;
							case 'B' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/b_maj.spr" );break;
							case 'c' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/c_min.spr" );break;
							case 'C' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/c_maj.spr" );break;
							case 'd' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/d_min.spr" );break;
							case 'D' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/d_maj.spr" );break;
							case 'e' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/e_min.spr" );break;
							case 'E' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/e_maj.spr" );break;
							case 'f' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/f_min.spr" );break;
							case 'F' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/f_maj.spr" );break;
							case 'g' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/g_min.spr" );break;
							case 'G' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/g_maj.spr" );break;
							case 'h' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/h_min.spr" );break;
							case 'H' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/h_maj.spr" );break;
							case 'i' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/i_min.spr" );break;
							case 'I' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/i_maj.spr" );break;
							case 'j' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/j_min.spr" );break;
							case 'J' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/j_maj.spr" );break;
							case 'k' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/k_min.spr" );break;
							case 'K' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/k_maj.spr" );break;
							case 'l' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/l_min.spr" );break;
							case 'L' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/l_maj.spr" );break;
							case 'm' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/m_min.spr" );break;
							case 'M' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/m_maj.spr" );break;
							case 'n' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/n_min.spr" );break;
							case 'N' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/n_maj.spr" );break;
							case 'o' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/o_min.spr" );break;
							case 'O' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/o_maj.spr" );break;
							case 'p' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/p_min.spr" );break;
							case 'P' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/p_maj.spr" );break;
							case 'q' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/q_min.spr" );break;
							case 'Q' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/q_maj.spr" );break;
							case 'r' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/r_min.spr" );break;
							case 'R' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/r_maj.spr" );break;
							case 's' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/s_min.spr" );break;
							case 'S' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/s_maj.spr" );break;
							case 't' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/t_min.spr" );break;
							case 'T' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/t_maj.spr" );break;
							case 'u' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/u_min.spr" );break;
							case 'U' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/u_maj.spr" );break;
							case 'v' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/v_min.spr" );break;
							case 'V' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/v_maj.spr" );break;
							case 'w' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/w_min.spr" );break;
							case 'W' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/w_maj.spr" );break;
							case 'x' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/x_min.spr" );break;
							case 'X' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/x_maj.spr" );break;
							case 'y' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/y_min.spr" );break;
							case 'Y' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/y_maj.spr" );break;
							case 'z' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/z_min.spr" );break;
							case 'Z' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/z_maj.spr" );break;
							case '0' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/0.spr" );break;
							case '1' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/1.spr" );break;
							case '2' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/2.spr" );break;
							case '3' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/3.spr" );break;
							case '4' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/4.spr" );break;
							case '5' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/5.spr" );break;
							case '6' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/6.spr" );break;
							case '7' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/7.spr" );break;
							case '8' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/8.spr" );break;
							case '9' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/9.spr" );break;
							case '.' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/point.spr" );break;
							case '-' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/moins.spr" );break;
							case '*' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/etoile.spr" );break;
							case '/' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/divise.spr" );break;
							case '+' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/plus.spr" );break;
							case ')' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/parf.spr" );break;
							case '(' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/paro.spr" );break;
							case '[' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/crocho.spr" );break;
							case ']' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/crochf.spr" );break;
							case '=' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/egal.spr" );break;
							case '#' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/diese.spr" );break;
							case '_' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/souligne.spr" );break;
							case '@' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/smiley.spr" );break;
							case '&' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/couleurs.spr" );break;
							case ':' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/deuxpoints.spr" );break;
							case '!' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/exclamation.spr" );break;
							case '?' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/interrogation.spr" );break;
							case '' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/bite.spr" );break;
							case ',' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/flecheg.spr" );break;
							case ';' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/fleched.spr" );break;
							case '$' : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/dollar.spr" );break;
							default  : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/vide.spr" );break;
						}
						if ( !gEngfuncs.pTriAPI->SpriteTexture( (struct model_s *)gEngfuncs.GetSpritePointer( gHUD.m_hsprCursor ), 0 ))return;

						gEngfuncs.pTriAPI->Begin( TRI_QUADS );		
							gEngfuncs.pTriAPI->Brightness( 1 );
							gEngfuncs.pTriAPI->TexCoord2f( 1, 0 );
							gEngfuncs.pTriAPI->Vertex3f( org.x, org.y, org.z+LETTRE_HAUTEUR );
							gEngfuncs.pTriAPI->TexCoord2f( 1, 1 );
							gEngfuncs.pTriAPI->Vertex3f( org.x, org.y , org.z );
							gEngfuncs.pTriAPI->TexCoord2f( 0, 1 );
							gEngfuncs.pTriAPI->Vertex3f( org.x+cote.x*LETTRE_LARGEUR, org.y+cote.y*LETTRE_LARGEUR, org.z );
							gEngfuncs.pTriAPI->TexCoord2f( 0, 0 );
							gEngfuncs.pTriAPI->Vertex3f( org.x+cote.x*LETTRE_LARGEUR, org.y+cote.y*LETTRE_LARGEUR, org.z+LETTRE_HAUTEUR );
						gEngfuncs.pTriAPI->End();

						org=org+cote*LETTRE_LARGEUR;
				}


				/////////////// CHIFFRES POUR VIE
					int centaine, dizaine, unite;
					if(VIE>=200 || VIE<0)
					{
						centaine=2;
						dizaine=0;
						unite=0;
					}
					else
					{
						centaine=int(VIE/100);
						dizaine=int((VIE-centaine*100)/10);
						unite=VIE-centaine*100-dizaine*10;
					}

				/////////////////////////// CENTAINES
					if(player->curstate.fuser1>99)
					{
						switch(centaine)
						{
							case 1 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/1.spr" );break;
							case 2 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/2.spr" );break;
							case 3 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/3.spr" );break;
							case 4 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/4.spr" );break;
							case 5 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/5.spr" );break;
							case 6 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/6.spr" );break;
							case 7 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/7.spr" );break;
							case 8 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/8.spr" );break;
							case 9 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/9.spr" );break;
							default : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/0.spr" );break;
						}
						if ( !gEngfuncs.pTriAPI->SpriteTexture( (struct model_s *)gEngfuncs.GetSpritePointer( gHUD.m_hsprCursor ), 0 ))return;
						gEngfuncs.pTriAPI->Begin( TRI_QUADS );	
							gEngfuncs.pTriAPI->TexCoord2f( 1, 0 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x+cote.x*LETTRE_LARGEUR, orgvie.y+cote.y*LETTRE_LARGEUR, orgvie.z+LETTRE_HAUTEUR );
							gEngfuncs.pTriAPI->TexCoord2f( 1, 1 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x+cote.x*LETTRE_LARGEUR, orgvie.y+cote.y*LETTRE_LARGEUR, orgvie.z );		
							gEngfuncs.pTriAPI->TexCoord2f( 0, 1 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x, orgvie.y , orgvie.z);			
							gEngfuncs.pTriAPI->TexCoord2f( 0, 0 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x, orgvie.y, orgvie.z+LETTRE_HAUTEUR );
						gEngfuncs.pTriAPI->End();

						switch(unite)
						{
							case 1 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/1.spr" );break;
							case 2 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/2.spr" );break;
							case 3 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/3.spr" );break;
							case 4 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/4.spr" );break;
							case 5 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/5.spr" );break;
							case 6 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/6.spr" );break;
							case 7 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/7.spr" );break;
							case 8 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/8.spr" );break;
							case 9 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/9.spr" );break;
							default : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/0.spr" );break;
						}
						if ( !gEngfuncs.pTriAPI->SpriteTexture( (struct model_s *)gEngfuncs.GetSpritePointer( gHUD.m_hsprCursor ), 0 ))return;
						gEngfuncs.pTriAPI->Begin( TRI_QUADS );
							gEngfuncs.pTriAPI->TexCoord2f( 1, 0 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x, orgvie.y, orgvie.z+LETTRE_HAUTEUR );
							gEngfuncs.pTriAPI->TexCoord2f( 1, 1 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x, orgvie.y , orgvie.z );
							gEngfuncs.pTriAPI->TexCoord2f( 0, 1 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x+cote.x*LETTRE_LARGEUR, orgvie.y+cote.y*LETTRE_LARGEUR, orgvie.z );					
							gEngfuncs.pTriAPI->TexCoord2f( 0, 0 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x+cote.x*LETTRE_LARGEUR, orgvie.y+cote.y*LETTRE_LARGEUR, orgvie.z+LETTRE_HAUTEUR );
						gEngfuncs.pTriAPI->End();

						orgvie=orgvie+cote*LETTRE_LARGEUR;
					}
				/////////////////////////// DIZAINES
					if(player->curstate.fuser1>9)
					{
						switch(dizaine)
						{
							case 1 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/1.spr" );break;
							case 2 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/2.spr" );break;
							case 3 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/3.spr" );break;
							case 4 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/4.spr" );break;
							case 5 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/5.spr" );break;
							case 6 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/6.spr" );break;
							case 7 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/7.spr" );break;
							case 8 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/8.spr" );break;
							case 9 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/9.spr" );break;
							default : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/0.spr" );break;
						}
						if ( !gEngfuncs.pTriAPI->SpriteTexture( (struct model_s *)gEngfuncs.GetSpritePointer( gHUD.m_hsprCursor ), 0 ))return;
						gEngfuncs.pTriAPI->Begin( TRI_QUADS );		
							gEngfuncs.pTriAPI->TexCoord2f( 1, 0 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x+cote.x*LETTRE_LARGEUR, orgvie.y+cote.y*LETTRE_LARGEUR, orgvie.z+LETTRE_HAUTEUR );
							gEngfuncs.pTriAPI->TexCoord2f( 1, 1 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x+cote.x*LETTRE_LARGEUR, orgvie.y+cote.y*LETTRE_LARGEUR, orgvie.z );		
							gEngfuncs.pTriAPI->TexCoord2f( 0, 1 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x, orgvie.y , orgvie.z );			
							gEngfuncs.pTriAPI->TexCoord2f( 0, 0 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x, orgvie.y, orgvie.z+LETTRE_HAUTEUR );
						gEngfuncs.pTriAPI->End();

						switch(player->curstate.fuser1>99?dizaine:unite)
						{
							case 1 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/1.spr" );break;
							case 2 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/2.spr" );break;
							case 3 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/3.spr" );break;
							case 4 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/4.spr" );break;
							case 5 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/5.spr" );break;
							case 6 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/6.spr" );break;
							case 7 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/7.spr" );break;
							case 8 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/8.spr" );break;
							case 9 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/9.spr" );break;
							default : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/0.spr" );break;
						}
						if ( !gEngfuncs.pTriAPI->SpriteTexture( (struct model_s *)gEngfuncs.GetSpritePointer( gHUD.m_hsprCursor ), 0 ))return;
						gEngfuncs.pTriAPI->Begin( TRI_QUADS );
							gEngfuncs.pTriAPI->TexCoord2f( 1, 0 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x, orgvie.y, orgvie.z+LETTRE_HAUTEUR );
							gEngfuncs.pTriAPI->TexCoord2f( 1, 1 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x, orgvie.y , orgvie.z );
							gEngfuncs.pTriAPI->TexCoord2f( 0, 1 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x+cote.x*LETTRE_LARGEUR, orgvie.y+cote.y*LETTRE_LARGEUR, orgvie.z );		
							gEngfuncs.pTriAPI->TexCoord2f( 0, 0 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x+cote.x*LETTRE_LARGEUR, orgvie.y+cote.y*LETTRE_LARGEUR, orgvie.z+LETTRE_HAUTEUR );
						gEngfuncs.pTriAPI->End();

						orgvie=orgvie+cote*LETTRE_LARGEUR;
					}
				/////////////////////////// UNITES
					if(player->curstate.fuser1>0)
					{
						switch(unite)
						{
							case 1 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/1.spr" );break;
							case 2 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/2.spr" );break;
							case 3 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/3.spr" );break;
							case 4 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/4.spr" );break;
							case 5 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/5.spr" );break;
							case 6 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/6.spr" );break;
							case 7 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/7.spr" );break;
							case 8 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/8.spr" );break;
							case 9 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/9.spr" );break;
							default : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/0.spr" );break;
						}
						if ( !gEngfuncs.pTriAPI->SpriteTexture( (struct model_s *)gEngfuncs.GetSpritePointer( gHUD.m_hsprCursor ), 0 ))return;
						gEngfuncs.pTriAPI->Begin( TRI_QUADS );	
							gEngfuncs.pTriAPI->TexCoord2f( 1, 0 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x+cote.x*LETTRE_LARGEUR, orgvie.y+cote.y*LETTRE_LARGEUR, orgvie.z+LETTRE_HAUTEUR );
							gEngfuncs.pTriAPI->TexCoord2f( 1, 1 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x+cote.x*LETTRE_LARGEUR, orgvie.y+cote.y*LETTRE_LARGEUR, orgvie.z );		
							gEngfuncs.pTriAPI->TexCoord2f( 0, 1 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x, orgvie.y , orgvie.z );			
							gEngfuncs.pTriAPI->TexCoord2f( 0, 0 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x, orgvie.y, orgvie.z+LETTRE_HAUTEUR );
						gEngfuncs.pTriAPI->End();

						if(player->curstate.fuser1>9)
						{
							switch(player->curstate.fuser1>99?centaine:dizaine)
							{
								case 1 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/1.spr" );break;
								case 2 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/2.spr" );break;
								case 3 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/3.spr" );break;
								case 4 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/4.spr" );break;
								case 5 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/5.spr" );break;
								case 6 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/6.spr" );break;
								case 7 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/7.spr" );break;
								case 8 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/8.spr" );break;
								case 9 : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/9.spr" );break;
								default : gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/symboles/0.spr" );break;
							}
							if ( !gEngfuncs.pTriAPI->SpriteTexture( (struct model_s *)gEngfuncs.GetSpritePointer( gHUD.m_hsprCursor ), 0 ))return;
						}
						gEngfuncs.pTriAPI->Begin( TRI_QUADS );	
							gEngfuncs.pTriAPI->TexCoord2f( 1, 0 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x, orgvie.y, orgvie.z+LETTRE_HAUTEUR );
							gEngfuncs.pTriAPI->TexCoord2f( 1, 1 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x, orgvie.y , orgvie.z);
							gEngfuncs.pTriAPI->TexCoord2f( 0, 1 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x+cote.x*LETTRE_LARGEUR, orgvie.y+cote.y*LETTRE_LARGEUR, orgvie.z );					
							gEngfuncs.pTriAPI->TexCoord2f( 0, 0 );
							gEngfuncs.pTriAPI->Vertex3f( orgvie.x+cote.x*LETTRE_LARGEUR, orgvie.y+cote.y*LETTRE_LARGEUR, orgvie.z+LETTRE_HAUTEUR );
						gEngfuncs.pTriAPI->End();
					}
				//////////// FONDS TRANSPARENTS
						gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/pyramide.spr" );
						if ( !gEngfuncs.pTriAPI->SpriteTexture( (struct model_s *)gEngfuncs.GetSpritePointer( gHUD.m_hsprCursor ), 0 )) return;
						gEngfuncs.pTriAPI->RenderMode( kRenderTransAdd );		
						gEngfuncs.pTriAPI->CullFace( TRI_NONE );
						gEngfuncs.pTriAPI->Color4f( r,0.0,b, 1.0);
						gEngfuncs.pTriAPI->Begin( TRI_QUADS );
							gEngfuncs.pTriAPI->TexCoord2f( 1, 0 );
							gEngfuncs.pTriAPI->Vertex3f( deb.x, deb.y, deb.z+LETTRE_HAUTEUR );
							gEngfuncs.pTriAPI->TexCoord2f( 1, 1 );
							gEngfuncs.pTriAPI->Vertex3f( deb.x, deb.y, deb.z );		
							gEngfuncs.pTriAPI->TexCoord2f( 0, 1 );
							gEngfuncs.pTriAPI->Vertex3f( deb.x+cote.x*nblettres*LETTRE_LARGEUR, deb.y+cote.y*nblettres*LETTRE_LARGEUR , deb.z );			
							gEngfuncs.pTriAPI->TexCoord2f( 0, 0 );
							gEngfuncs.pTriAPI->Vertex3f( deb.x+cote.x*nblettres*LETTRE_LARGEUR, deb.y+cote.y*nblettres*LETTRE_LARGEUR, deb.z+LETTRE_HAUTEUR );
						gEngfuncs.pTriAPI->End();
						gEngfuncs.pTriAPI->Begin( TRI_QUADS );
							gEngfuncs.pTriAPI->TexCoord2f( 1, 0 );
							gEngfuncs.pTriAPI->Vertex3f( debvie.x, debvie.y, debvie.z+LETTRE_HAUTEUR );
							gEngfuncs.pTriAPI->TexCoord2f( 1, 1 );
							gEngfuncs.pTriAPI->Vertex3f( debvie.x, debvie.y, debvie.z );
							gEngfuncs.pTriAPI->TexCoord2f( 0, 1 );
							gEngfuncs.pTriAPI->Vertex3f( debvie.x+cote.x*nbchiffres*LETTRE_LARGEUR, debvie.y+cote.y*nbchiffres*LETTRE_LARGEUR , debvie.z );
							gEngfuncs.pTriAPI->TexCoord2f( 0, 0 );
							gEngfuncs.pTriAPI->Vertex3f( debvie.x+cote.x*nbchiffres*LETTRE_LARGEUR, debvie.y+cote.y*nbchiffres*LETTRE_LARGEUR, debvie.z+LETTRE_HAUTEUR );
						gEngfuncs.pTriAPI->End();
				}
				else if(p_pyramide->value==PYRAMIDE_PYRAMIDES)
				{

					float cote,demicote;

					cote = 0.225*VIE+5;
					demicote=cote/2;

					org.x -= demicote;
					org.y -= demicote;
					org.z+=(HAUTEUR+demicote);

					float r,b;
					
					if(player->curstate.iuser4)
					{
						r=0;
						b=0.0035*VIE+0.2;
					}
					else
					{
						b=0;
						r=0.0035*VIE+0.2;
					}

					gHUD.m_hsprCursor = SPR_Load( "sprites/pyramide/pyramide.spr");
					if ( !gEngfuncs.pTriAPI->SpriteTexture( (struct model_s *)gEngfuncs.GetSpritePointer( gHUD.m_hsprCursor ), 0 ))return;

					
					gEngfuncs.pTriAPI->RenderMode( kRenderTransAdd );
					gEngfuncs.pTriAPI->CullFace( TRI_NONE );
					gEngfuncs.pTriAPI->Color4f( r, 0.0, b, 1.0);
	/////// CARRE (base)
					gEngfuncs.pTriAPI->Begin( TRI_QUADS );			
						gEngfuncs.pTriAPI->Brightness( 1 );
						gEngfuncs.pTriAPI->TexCoord2f( 1, 0 );
						gEngfuncs.pTriAPI->Vertex3f( org.x, org.y, org.z );
						//gEngfuncs.pTriAPI->Brightness( 1 );
						gEngfuncs.pTriAPI->TexCoord2f( 1, 1 );
						gEngfuncs.pTriAPI->Vertex3f( org.x, org.y + cote, org.z );		
						//gEngfuncs.pTriAPI->Brightness( 1 );
						gEngfuncs.pTriAPI->TexCoord2f( 0, 1 );
						gEngfuncs.pTriAPI->Vertex3f( org.x + cote, org.y + cote, org.z );			
						//gEngfuncs.pTriAPI->Brightness( 1 );
						gEngfuncs.pTriAPI->TexCoord2f( 0, 0 );
						gEngfuncs.pTriAPI->Vertex3f( org.x + cote, org.y, org.z );
					gEngfuncs.pTriAPI->End();
	//////////// TRIANGLES (cots)
					gEngfuncs.pTriAPI->Begin( TRI_TRIANGLE_FAN );
		////////////// TRIANGLE 1
						//gEngfuncs.pTriAPI->Brightness( 1 );
						gEngfuncs.pTriAPI->TexCoord2f( 0.5, 1 );
						gEngfuncs.pTriAPI->Vertex3f( org.x+demicote, org.y+demicote, org.z-demicote );
						//gEngfuncs.pTriAPI->Brightness( 1 );
						gEngfuncs.pTriAPI->TexCoord2f( 1, 0 );
						gEngfuncs.pTriAPI->Vertex3f( org.x+cote, org.y, org.z );
						//gEngfuncs.pTriAPI->Brightness( 1 );
						gEngfuncs.pTriAPI->TexCoord2f( 0, 0);
						gEngfuncs.pTriAPI->Vertex3f( org.x+cote, org.y+cote, org.z );
		////////////// TRIANGLE 2
						//gEngfuncs.pTriAPI->Brightness( 1 );
						gEngfuncs.pTriAPI->TexCoord2f( 1, 0 );
						gEngfuncs.pTriAPI->Vertex3f( org.x, org.y+cote, org.z );
		////////////// TRIANGLE 3
						//gEngfuncs.pTriAPI->Brightness( 1 );
						gEngfuncs.pTriAPI->TexCoord2f( 0, 0 );
						gEngfuncs.pTriAPI->Vertex3f( org.x, org.y, org.z);
						gEngfuncs.pTriAPI->End();
		////////////// TRIANGLE 4
					gEngfuncs.pTriAPI->Begin( TRI_TRIANGLES );
						gEngfuncs.pTriAPI->TexCoord2f( 0, 0 );
						gEngfuncs.pTriAPI->Vertex3f( org.x, org.y, org.z );
						//gEngfuncs.pTriAPI->Brightness( 1 );
						gEngfuncs.pTriAPI->TexCoord2f( 1, 0);
						gEngfuncs.pTriAPI->Vertex3f( org.x+cote, org.y, org.z );
						//gEngfuncs.pTriAPI->Brightness( 1 );
						gEngfuncs.pTriAPI->TexCoord2f( 0.5, 1 );
						gEngfuncs.pTriAPI->Vertex3f( org.x+demicote, org.y+demicote, org.z-demicote );
					gEngfuncs.pTriAPI->End();
				}
			}
		}
	}
}
