// Menu Choix de lequipe
// fortement bas sur la classe CTeamMenu ;)

#define WIN32_LEAN_AND_MEAN  // pour accerler la compil et diminuer la taille de la dll
#include <windows.h>		// quand on utilise window.h 
#include "vgui_int.h"
#include "VGUI_Font.h"
#include "VGUI_ScrollPanel.h"
#include "VGUI_TextImage.h"

#include "hud.h"
#include "cl_util.h"
#include "vgui_TeamFortressViewport.h"
#include "vgui_WormshlMenu.h"

// Model Menu Dimensions
#define TAILLE_ECRAN_X				XRES(640)
#define TAILLE_ECRAN_Y				YRES(480)

#define TAILLE_TITRE_Y				YRES(30)

#define TAILLE_FENETRE_X			XRES(280)
#define TAILLE_FENETRE_Y			YRES(300)
#define POSITION_FENETRE_X			XRES(30)
#define POSITION_FENETRE_Y			YRES(100)

#define POSITION_FENETRE2_X			TAILLE_ECRAN_X - POSITION_FENETRE_X - TAILLE_FENETRE_X
 
#define TAILLE_FENETRE_IMAGE_X		265
#define TAILLE_FENETRE_IMAGE_Y		265

#define	TAILLE_SCROLL_BOUTON		XRES(16)
#define COMBO_NB_ELEMENT_MAX		6 //ca va merder si >= 16 !

#define TAILLE_BOUTON_X				XRES(150)
#define TAILLE_BOUTON_Y		        YRES(25)
#define POSITION_BOUTON_X			POSITION_FENETRE_X + (TAILLE_FENETRE_X - TAILLE_BOUTON_X-TAILLE_SCROLL_BOUTON)/2
#define POSITION_BOUTON_Y		    POSITION_FENETRE_Y + (TAILLE_FENETRE_X - TAILLE_BOUTON_X-TAILLE_SCROLL_BOUTON)/2


#define POSITION_ANNULER_X			TAILLE_ECRAN_X/2 - TAILLE_VALIDER_X/2
#define POSITION_ANNULER_Y			YRES(410)


#define TAILLE_VALIDER_X			XRES(110)
#define POSITION_VALIDER_X			TAILLE_FENETRE_X/2 - TAILLE_VALIDER_X/2 
#define POSITION_VALIDER_Y			TAILLE_FENETRE_Y - TAILLE_BOUTON_Y - YRES(10)

#define POSITION_FENETRE_IMAGE_X	(TAILLE_FENETRE_X -TAILLE_FENETRE_IMAGE_X)/2
#define POSITION_FENETRE_IMAGE_Y	(TAILLE_FENETRE_Y -TAILLE_FENETRE_IMAGE_Y)/2



int TailleTexte;


// Creation
CWormshlModelMenuPanel::CWormshlModelMenuPanel(int iTrans, int iRemoveMe, int x,int y,int wide,int tall) : CMenuPanel(iTrans, iRemoveMe, x,y,wide,tall)
{
	int bgr, bgg, bgb, bga;
	int lbr, lbg, lbb, lba;
	int fgr, fgg, fgb, fga;
	int abgr, abgg, abgb, abga;
	int cpt=1;


	// Get the scheme used for the Titles
	CSchemeManager *pSchemes = gViewPort->GetSchemeManager();

	// schemes
	SchemeHandle_t hTitleScheme = pSchemes->getSchemeHandle( "Title Font" );
	SchemeHandle_t hTeamWindowText = pSchemes->getSchemeHandle( "Primary Button Text" );
	SchemeHandle_t hLineBorder = pSchemes->getSchemeHandle( "Line Border" );
	SchemeHandle_t hTeamInfoText = pSchemes->getSchemeHandle( "Team Info Text" );
	SchemeHandle_t hComboBox = pSchemes->getSchemeHandle( "ComboBox" );

	// get the Font used for the Titles
	Font *pTitleFont = pSchemes->getFont( hTitleScheme );
	//Font *pNormalFont = pSchemes->getFont( hLineBorder);

	Font *pComboBoxFont = pSchemes->getFont( hComboBox );
	
	// couleur de fond
	pSchemes->getBgColor( hTeamWindowText, bgr, bgg, bgb, bga );
	// couleur de trait
	pSchemes->getFgColor( hLineBorder, lbr, lbg, lbb, lba );
	// couleur du text
	pSchemes->getFgColor( hTeamWindowText, fgr, fgg, fgb, fga );
	// couleur de fond lorsque la souris passe dessus (bouton)
	pSchemes->getBgArmedColor( hTeamWindowText, abgr, abgg, abgb, abga );
	


	// Titre																					
	pTitle = new Label( CHudTextMessage::BufferedLocaliseTextString( "#Model_SelectYourModel") , POSITION_FENETRE_X , POSITION_FENETRE_Y-TAILLE_TITRE_Y,TAILLE_ECRAN_X - POSITION_FENETRE_X*2,TAILLE_TITRE_Y );
	pTitle->setParent( this );
	pTitle->setFont( pTitleFont );
	pTitle->setFgColor( fgr, fgg , fgb, fga);
	pTitle->setBgColor( bgr, bgg, bgb, bga );
	//pTitle->setContentAlignment( vgui::Label::a_center );
	pTitle->setBorder( new LineBorder( Color(lbr,lbg,lbb,lba )) );


	m_pCancelButton = new ColorButton( CHudTextMessage::BufferedLocaliseTextString( "#Menu_Cancel" ), POSITION_ANNULER_X, POSITION_ANNULER_Y, TAILLE_VALIDER_X, TAILLE_BOUTON_Y,fgr,fgg,fgb,fga,bgr,bgg,bgb,bga,abgr,abgg,abgb,abga);
	m_pCancelButton->setParent( this );
	m_pCancelButton->setBoundKey( '2' );
	m_pCancelButton->addActionSignal( new CMenuHandler_TextWindow(HIDE_TEXTWINDOW) );
    m_pCancelButton->setContentAlignment( vgui::Label::a_center );
	m_pCancelButton->setVisible(true);

	m_pFenetre  = new CTransparentColorPanel( bga,POSITION_FENETRE_X , POSITION_FENETRE_Y, TAILLE_FENETRE_X, TAILLE_FENETRE_Y ,bgr, bgg, bgb);
	m_pFenetre->setParent( this );
	m_pFenetre->setBorder( new LineBorder( Color(lbr,lbg,lbb,lba )) );
	m_pFenetre->setVisible(true);
		
												
	m_pFenetre2  = new CTransparentColorPanel( bga,POSITION_FENETRE2_X , POSITION_FENETRE_Y, TAILLE_FENETRE_X, TAILLE_FENETRE_Y ,bgr, bgg, bgb);
	m_pFenetre2->setParent( this );
	m_pFenetre2->setBorder( new LineBorder( Color(lbr,lbg,lbb,lba )) );
	m_pFenetre2->setVisible(true);

	m_pValidButton = new ColorButton( CHudTextMessage::BufferedLocaliseTextString( "#Menu_Valid" ), POSITION_VALIDER_X, POSITION_VALIDER_Y, TAILLE_VALIDER_X, TAILLE_BOUTON_Y,fgr,fgg,fgb,fga,bgr,bgg,bgb,bga,abgr,abgg,abgb,abga);
	m_pValidButton->setParent(m_pFenetre);
	m_pValidButton->setBoundKey( '1' );
	m_pValidButton->addInputSignal( new CHandler_MenuButtonOver(this, 17  ));
	m_pValidButton->addActionSignal( new CMenuHandler_TextWindow(HIDE_TEXTWINDOW) );
	m_pValidButton->setContentAlignment( vgui::Label::a_center );
	m_pValidButton->setVisible(true);

	m_pFenetreImage  = new CTransparentColorPanel( bga,POSITION_FENETRE_IMAGE_X , POSITION_FENETRE_IMAGE_Y, TAILLE_FENETRE_IMAGE_X, TAILLE_FENETRE_IMAGE_Y ,bgr, bgg, bgb);
	m_pFenetreImage->setParent( m_pFenetre2 );
	m_pFenetreImage->setBorder( new LineBorder( Color(lbr,lbg,lbb,lba )) );
	m_pFenetreImage->setVisible(true);

	m_pImageModel = new CImageLabelPiv("worms", 0, 0);
	m_pImageModel->setParent(m_pFenetreImage);
	m_pImageModel->setVisible(true);
	
	//combo

	m_pBoutonCorps = new ColorButton("worms", POSITION_BOUTON_X , POSITION_BOUTON_Y, TAILLE_BOUTON_X,TAILLE_BOUTON_Y,fgr,fgg,fgb,fga,bgr,bgg,bgb,bga,abgr,abgg,abgb,abga);	
	m_pBoutonCorps->setParent(this);
	m_pBoutonCorps->setContentAlignment( vgui::Label::a_west );
	m_pBoutonCorps->setVisible(true);
	m_pBoutonCorps->setFont(pComboBoxFont);
	m_pBoutonCorps->addInputSignal( new CHandler_MenuButtonOver(this, 18  ));
	
	m_pBoutonFleche = new ColorButton("V  ", POSITION_BOUTON_X + TAILLE_BOUTON_X , POSITION_BOUTON_Y, TAILLE_BOUTON_Y,TAILLE_BOUTON_Y,fgr,fgg,fgb,fga,bgr,bgg,bgb,bga,abgr,abgg,abgb,abga);	
	m_pBoutonFleche->setParent(this);
	m_pBoutonFleche->setContentAlignment( vgui::Label::a_east );
	m_pBoutonFleche->setVisible(true);
	m_pBoutonFleche->setFont(pComboBoxFont);
	m_pBoutonFleche->addInputSignal( new CHandler_MenuButtonOver(this, 19  ));

	TailleTexte = pComboBoxFont->getTall();

	
	m_pListeFenetre  = new CTransparentColorPanel( bga,POSITION_BOUTON_X + TAILLE_BOUTON_X-TAILLE_SCROLL_BOUTON, POSITION_BOUTON_Y+ TAILLE_BOUTON_Y, TAILLE_SCROLL_BOUTON+1,TailleTexte* COMBO_NB_ELEMENT_MAX,bgr, bgg, bgb);
	m_pListeFenetre->setParent( this );
	m_pListeFenetre->setBorder( new LineBorder( Color(lbr,lbg,lbb,lba )) );
	m_pListeFenetre->setVisible(true);

	m_pListeFenetre2  = new CTransparentColorPanel( bga,POSITION_BOUTON_X , POSITION_BOUTON_Y+ TAILLE_BOUTON_Y, TAILLE_BOUTON_X-TAILLE_SCROLL_BOUTON,TailleTexte*COMBO_NB_ELEMENT_MAX,bgr, bgg, bgb);
	m_pListeFenetre2->setParent( this );
	m_pListeFenetre2->setBorder( new LineBorder( Color(lbr,lbg,lbb,lba )) );
	m_pListeFenetre2->setVisible(true);

	
	m_pBoutonScrollHaut = new ColorButton("^", 0 , 0, TAILLE_SCROLL_BOUTON,TAILLE_SCROLL_BOUTON,fgr,fgg,fgb,fga,bgr,bgg,bgb,bga,abgr,abgg,abgb,abga);	
	m_pBoutonScrollHaut->setParent(m_pListeFenetre);
	m_pBoutonScrollHaut->setContentAlignment( vgui::Label::a_west );
	m_pBoutonScrollHaut->setVisible(true);
	m_pBoutonScrollHaut->setFont(pComboBoxFont);
	m_pBoutonScrollHaut->addInputSignal( new CHandler_MenuButtonOver( this, 15) );
		

	m_pBoutonScrollBas = new ColorButton("v", 0 , TailleTexte*COMBO_NB_ELEMENT_MAX-TAILLE_SCROLL_BOUTON, TAILLE_SCROLL_BOUTON,TAILLE_SCROLL_BOUTON,fgr,fgg,fgb,fga,bgr,bgg,bgb,bga,abgr,abgg,abgb,abga);	
	m_pBoutonScrollBas->setParent(m_pListeFenetre);
	m_pBoutonScrollBas->setContentAlignment( vgui::Label::a_west );
	m_pBoutonScrollBas->setVisible(true);
	m_pBoutonScrollBas->setFont(pComboBoxFont);
	m_pBoutonScrollBas->addInputSignal( new CHandler_MenuButtonOver( this, 16) );

	for (int i=0 ; i< COMBO_NB_ELEMENT_MAX;i++)
	{
		m_pBoutonListeTexte[i] = new ColorButton("v", POSITION_BOUTON_X , POSITION_BOUTON_Y + TAILLE_BOUTON_Y + i*TailleTexte,TAILLE_BOUTON_X -TAILLE_SCROLL_BOUTON, TailleTexte,fgr,fgg,fgb,255,bgr,bgg,bgb,255,abgr,abgg,abgb,abga);	
		m_pBoutonListeTexte[i]->setParent(this);
		m_pBoutonListeTexte[i]->setContentAlignment( vgui::Label::a_west );
		m_pBoutonListeTexte[i]->setVisible(true);
		m_pBoutonListeTexte[i]->setFont(pComboBoxFont);
		m_pBoutonListeTexte[i]->setBorder( new LineBorder( Color(fgr,fgb,fgg, 255)) );
		m_pBoutonListeTexte[i]->addInputSignal( new CHandler_MenuButtonOver( this, i) );
	}

	Initialize();
}

//-----------------------------------------------------------------------------
// Purpose: Called each time a new level is started.
//-----------------------------------------------------------------------------
void CWormshlModelMenuPanel::Initialize( void )
{
//rien
}

//-----------------------------------------------------------------------------
// Purpose: Called everytime the Team Menu is displayed
//-----------------------------------------------------------------------------
void CWormshlModelMenuPanel::Update( void )
{
	HANDLE handle; 
    WIN32_FIND_DATA FileData; 
	int cpt12=0;
	const char *gamedir;
	char sz[200];
	int i;	


	//reinitialise toutes les variables
	m_iIndex = 0;
	m_iTailleCombo = COMBO_NB_ELEMENT_MAX;
	m_iNombreElement = 0;

	// recherche tous les models existant pour l'equipe du joueur
	gamedir = gEngfuncs.pfnGetGameDirectory();
	sprintf(sz,"%s/models/player/*%s.*",gamedir,Equipe);
	handle = FindFirstFile(sz, &FileData); 
	
	do 
	{ 
		if ((FileData.dwFileAttributes == FILE_ATTRIBUTE_DIRECTORY) && (strcmp(FileData.cFileName,".") != 0) && (strcmp(FileData.cFileName,"..") != 0))
		{
			sprintf(pListe[cpt12++],"%.*s",strlen(FileData.cFileName )-strlen(Equipe),FileData.cFileName);
		}
	} 
	while (FindNextFile(handle, &FileData)); 
	FindClose(handle); 

	m_iNombreElement = cpt12;

	// redefini er redimensionne le coprs de la combo
	if (m_iNombreElement < m_iTailleCombo)
	{
		for (i = m_iNombreElement;i < m_iTailleCombo;i++)
		{
			m_pBoutonListeTexte[i]->setVisible(false);
		}
		m_iTailleCombo = m_iNombreElement;
		m_pListeFenetre->setVisible(false);
		m_pListeFenetre2->setSize(TAILLE_BOUTON_X-TAILLE_SCROLL_BOUTON,TailleTexte*m_iTailleCombo);
		m_pBoutonScrollBas->setVisible(false);
		m_pBoutonScrollHaut->setVisible(false);
	}
	else
	{
		m_pListeFenetre2->setSize(TAILLE_BOUTON_X-TAILLE_SCROLL_BOUTON,TailleTexte*m_iTailleCombo);
	}
	
	// affiche les choix de la combo et la ferme
	for (int ii=0;ii < m_iTailleCombo; ii++)
	{
		m_pBoutonListeTexte[ii]->setText(pListe[ii]);
		m_pBoutonListeTexte[ii]->setVisible(false);
	}
	m_pListeFenetre->setVisible(false);
	m_pListeFenetre2->setVisible(false);
}


//=====================================
// Key inputs
// cette fonction est utilis lorsqu'on defini des touches associ a chaque bouton
bool CWormshlModelMenuPanel::SlotInput( int iSlot )
{
	char sz[21];
	// si on appuis sur la touche n n 
	// alors on lance l'action attribu au bouton n+1
	if ( iSlot == 0)
	{
		if (ModelEnCours != ModelSelectionne)
		{
			strcpy(ModelEnCours,ModelSelectionne);
			sprintf(sz,"model %s%s",ModelEnCours,Equipe);
			ClientCmd(sz);
		}
		m_pValidButton->fireActionSignal();
		return true;
	}
	if ( iSlot == 1) 
	{
		m_pCancelButton->fireActionSignal();
		return true;
	}

	return false;
}

//======================================
// Update the Team menu before opening it
void CWormshlModelMenuPanel::Open( void )
{
	Update();
	CMenuPanel::Open();
	
	// enleve la selection des boutons
	m_pCancelButton->setArmed(false);
}

//======================================
// Mouse is over a team button, bring up the class info
// cette fonction est utilise lorsqu'on glisse ou click sur un bouton
// lorsqu'on glisse iInput = numero bouton
// lorsqu'on click iInput = numero bouton +100
void CWormshlModelMenuPanel::SetActiveInfo( int iInput )
{
	char sz[21];
	int i;

	// appuie sur bouton haut du scroll
	if (iInput == 115)
	{
		if (m_iIndex > 0)
		{
			m_iIndex--;
			for (i=0 ; i<m_iTailleCombo;i++)
			{
				m_pBoutonListeTexte[i]->setText(pListe[i+ m_iIndex]);
			}
		}
	}	

	// appuie sur bouton bas du scroll
	if (iInput == 116)
	{
		if (m_iIndex + m_iTailleCombo < m_iNombreElement)
		{
			m_iIndex++;
			for (i=0 ; i< m_iTailleCombo;i++)
			{
				m_pBoutonListeTexte[i]->setText(pListe[i+ m_iIndex]);
			}
		}
	}	

	// appuie dans la liste de la combo
	if ((iInput >= 100) && (iInput <= 100 + m_iTailleCombo))
	{
		strcpy(ModelSelectionne,pListe[m_iIndex + iInput-100]);
		m_pBoutonCorps->setText(ModelSelectionne);

		// change limage
		m_pImageModel->ChangeImage( ModelSelectionne,0,0 );
		
		//remet la combo dans sa forme initial
		m_pListeFenetre2->setVisible(false);
		for (i = 0;i < m_iTailleCombo;i++)
		{
			m_pBoutonListeTexte[i]->setVisible(false);
		}
		
		m_pListeFenetre->setVisible(false);
	}

	// appuie sur valid
	if (iInput == 117)
	{
		if (ModelEnCours != ModelSelectionne)
		{
			strcpy(ModelEnCours,ModelSelectionne);
			sprintf(sz,"model %s%s",ModelEnCours,Equipe);
			ClientCmd(sz);
		}
	}	

	// appuie sur la combo ou le fleche
	if ((iInput == 118) || (iInput == 119))
	{
		if (m_pListeFenetre2->isVisible())
		{
			m_pListeFenetre2->setVisible(false);
			for ( i = 0;i < m_iTailleCombo;i++)
			{
				m_pBoutonListeTexte[i]->setVisible(false);
			}
			m_pListeFenetre->setVisible(false);
		}
		else
		{
			m_pListeFenetre2->setVisible(true);
			for ( i = 0;i < m_iTailleCombo;i++)
			{
				m_pBoutonListeTexte[i]->setVisible(true);
			}
			// si on besoin de scroller, on affiche les scroll
			if (m_iNombreElement > m_iTailleCombo)
			{
				m_pListeFenetre->setVisible(true);
			}
		}
	}
}

