// Menu Choix de lequipe
// fortement bas sur la classe CTeamMenu ;)

#include "vgui_int.h"
#include "VGUI_Font.h"
#include "VGUI_ScrollPanel.h"
#include "VGUI_TextImage.h"

#include "hud.h"
#include "cl_util.h"
#include "vgui_TeamFortressViewport.h"
#include "vgui_WormshlMenu.h"

// Team Menu Dimensions
#define TAILLE_ECRAN_X				XRES(640)
#define TAILLE_ECRAN_Y				YRES(480)

#define TAILLE_TITRE_Y				YRES(30)

#define TAILLE_FENETRE_X			XRES(280)
#define TAILLE_FENETRE_Y			YRES(300)
#define POSITION_FENETRE_X			XRES(30)
#define POSITION_FENETRE_Y			YRES(100)

#define POSITION_INFOJOUEUR_X		XRES(10)			
#define POSITION_INFOJOUEUR_Y		YRES(100)
#define TAILLE_INFOJOUEUR_X			XRES(250)			
#define TAILLE_INFOJOUEUR_Y			YRES(150)

#define POSITION_TITREINFOJOUEUR_X  XRES(10)
#define POSITION_TITREINFOJOUEUR_Y  YRES(84)
#define TAILLE_TITREINFOJOUEUR_Y  YRES(14)

#define TAILLE_BOUTON_X				XRES(110)
#define TAILLE_BOUTON_Y		        XRES(25)    

#define POSITION_ANNULER_X			TAILLE_ECRAN_X/2 - TAILLE_BOUTON_X/2
#define POSITION_ANNULER_Y			YRES(410)

#define POSITION_BOUTON_EQUIPE_X	TAILLE_FENETRE_X/2 - TAILLE_BOUTON_X/2
#define POSITION_BOUTON_EQUIPE_Y	TAILLE_FENETRE_Y - TAILLE_BOUTON_Y - YRES(10)

// Creation
CWormshlTeamMenuPanel::CWormshlTeamMenuPanel(int iTrans, int iRemoveMe, int x,int y,int wide,int tall) : CMenuPanel(iTrans, iRemoveMe, x,y,wide,tall)
{
	int bgr, bgg, bgb, bga;
	int lbr, lbg, lbb, lba;
	int fgr, fgg, fgb, fga;
	int abgr, abgg, abgb, abga;
	int taille_b,taille_r;

	// Get the scheme used for the Titles
	CSchemeManager *pSchemes = gViewPort->GetSchemeManager();

	// schemes
	SchemeHandle_t hTitleScheme = pSchemes->getSchemeHandle( "Title Font" );
	SchemeHandle_t hTeamWindowText = pSchemes->getSchemeHandle( "Primary Button Text" );
	SchemeHandle_t hLineBorder = pSchemes->getSchemeHandle( "Line Border" );
	SchemeHandle_t hTeamInfoText = pSchemes->getSchemeHandle( "Team Info Text" );

	// get the Font used for the Titles
	Font *pTitleFont = pSchemes->getFont( hTitleScheme );
	//Font *pNormalFont = pSchemes->getFont( hLineBorder);

	// couleur de fond
	pSchemes->getBgColor( hTeamWindowText, bgr, bgg, bgb, bga );
	// couleur de trait
	pSchemes->getFgColor( hLineBorder, lbr, lbg, lbb, lba );
	// couleur du text
	pSchemes->getFgColor( hTeamWindowText, fgr, fgg, fgb, fga );
	// couleur de fond lorsque la souris passe dessus (bouton)
	pSchemes->getBgArmedColor( hTeamWindowText, abgr, abgg, abgb, abga );


	// Titre
	pTitle = new Label( CHudTextMessage::BufferedLocaliseTextString( "#Team_SelectYourTeam") , POSITION_FENETRE_X , POSITION_FENETRE_Y-TAILLE_TITRE_Y,TAILLE_ECRAN_X - POSITION_FENETRE_X*2,TAILLE_TITRE_Y );
	pTitle->setParent( this );
	pTitle->setFont( pTitleFont );
	pTitle->setFgColor( fgr, fgg , fgb, fga);
	pTitle->setBgColor( bgr, bgg, bgb, bga );
	//pTitle->setContentAlignment( vgui::Label::a_center );
	pTitle->setBorder( new LineBorder( Color(lbr,lbg,lbb,lba )) );


	m_pCancelButton = new ColorButton( CHudTextMessage::BufferedLocaliseTextString( "#Menu_Cancel" ), POSITION_ANNULER_X, POSITION_ANNULER_Y, TAILLE_BOUTON_X, TAILLE_BOUTON_Y,fgr,fgg,fgb,fga,bgr,bgg,bgb,bga,abgr,abgg,abgb,abga);
	m_pCancelButton->setParent( this );
	m_pCancelButton->setBoundKey( '3' );
	m_pCancelButton->addInputSignal( new CHandler_MenuButtonOver(this, 3 ));
	m_pCancelButton->addActionSignal( new CMenuHandler_TextWindow(HIDE_TEXTWINDOW) );
    m_pCancelButton->setContentAlignment( vgui::Label::a_center );
	m_pCancelButton->setVisible(false);

//*********************EKIP BLEU****************

	// fenetre ekip bleu
	m_pFenetreBleu  = new CTransparentColorPanel( bga,POSITION_FENETRE_X , POSITION_FENETRE_Y, TAILLE_FENETRE_X, TAILLE_FENETRE_Y ,bgr, bgg, bgb);
	m_pFenetreBleu->setParent( this );
	m_pFenetreBleu->setBorder( new LineBorder( Color(lbr,lbg,lbb,lba )) );

	m_pImageTeam[1] = new CImageLabel("teamblue", 0, 0);
	m_pImageTeam[1]->setParent(m_pFenetreBleu);
	m_pImageTeam[1]->setVisible(true);
	taille_b = m_pImageTeam[1]->getImageWide();
	m_pImageTeam[1]->setPos(TAILLE_FENETRE_X /2 - taille_b/2,0); 


	// Fenetre info joueurs
	m_pScrollPanelBleu = new CTFScrollPanel( POSITION_INFOJOUEUR_X, POSITION_INFOJOUEUR_Y, TAILLE_INFOJOUEUR_X, TAILLE_INFOJOUEUR_Y);
	m_pScrollPanelBleu->setParent(m_pFenetreBleu);
	m_pScrollPanelBleu->setScrollBarAutoVisible(false, true);
	m_pScrollPanelBleu->setScrollBarVisible(false, true);
	m_pScrollPanelBleu->setFgColor(fgr,fgg,fgb,fga);
	m_pScrollPanelBleu->setBorder( new LineBorder( Color(lbr,lbg,lbb,lba )) );
	m_pScrollPanelBleu->validate();

	// Texte info joueur
	m_pInfoJoueurBleu = new TextPanel("",0 ,0, TAILLE_INFOJOUEUR_X, TAILLE_INFOJOUEUR_Y*2 );
	m_pInfoJoueurBleu->setParent( m_pScrollPanelBleu->getClient() );
	m_pInfoJoueurBleu->setFont( pSchemes->getFont(hTeamWindowText) );
	m_pInfoJoueurBleu->setFgColor( fgr, fgg, fgb, fga );
	m_pInfoJoueurBleu->setBgColor( bgr, bgg, bgb, 255 );
    
	
	// titre info joueur
	pTitle = new Label( CHudTextMessage::BufferedLocaliseTextString( "#Team_Players") , POSITION_TITREINFOJOUEUR_X , POSITION_TITREINFOJOUEUR_Y ,TAILLE_INFOJOUEUR_X,TAILLE_TITREINFOJOUEUR_Y );
	pTitle->setParent(m_pFenetreBleu );
	//pTitle->setFont( pNormalFont );
	pTitle->setFgColor( fgr, fgg , fgb, fga);
	pTitle->setBgColor( bgr, bgg, bgb, bga );
	pTitle->setContentAlignment( vgui::Label::a_west );

	// Team button
	m_pButtons[1] = new ColorButton( gHUD.m_TextMessage.BufferedLocaliseTextString("#Team_premiere"), POSITION_BOUTON_EQUIPE_X, POSITION_BOUTON_EQUIPE_Y, TAILLE_BOUTON_X, TAILLE_BOUTON_Y,fgr,fgg,fgb,fga,bgr,bgg,bgb,bga,abgr,abgg,abgb,abga, false);
	m_pButtons[1]->setParent( m_pFenetreBleu );
	m_pButtons[1]->setContentAlignment( vgui::Label::a_center );
	//m_pButtons[1]->addActionSignal( new CMenuHandler_StringCommandWatch( "model Wormsblue",true ));
	m_pButtons[1]->addActionSignal( new CMenuHandler_TextWindow(HIDE_TEXTWINDOW) );
	m_pButtons[1]->addInputSignal( new CHandler_MenuButtonOver(this, 1) );
	m_pButtons[1]->setBoundKey( '1' );
	m_pButtons[1]->setVisible( true );


	

//*********************EKIP ROUGE****************

	// fenetre ekip rouge
	m_pFenetreRouge  = new CTransparentColorPanel( bga,TAILLE_ECRAN_X - POSITION_FENETRE_X - TAILLE_FENETRE_X , POSITION_FENETRE_Y, TAILLE_FENETRE_X, TAILLE_FENETRE_Y ,bgr, bgg, bgb);
	m_pFenetreRouge->setParent( this );
	m_pFenetreRouge->setBorder( new LineBorder( Color(lbr,lbg,lbb,lba )) );

	m_pImageTeam[2] = new CImageLabel("teamred", 0 , 0);
	m_pImageTeam[2]->setParent(m_pFenetreRouge);
	m_pImageTeam[2]->setVisible(true);
	taille_r = m_pImageTeam[2]->getImageWide();
	m_pImageTeam[2]->setPos(TAILLE_FENETRE_X /2 - taille_r/2,0); 


	// Fenetre info joueurs
	m_pScrollPanelRouge = new CTFScrollPanel( POSITION_INFOJOUEUR_X, POSITION_INFOJOUEUR_Y, TAILLE_INFOJOUEUR_X, TAILLE_INFOJOUEUR_Y);
	m_pScrollPanelRouge->setParent(m_pFenetreRouge);
	m_pScrollPanelRouge->setScrollBarAutoVisible(false, true);
	m_pScrollPanelRouge->setScrollBarVisible(false, true);
	m_pScrollPanelRouge->setFgColor(fgr,fgg,fgb,fga);
	m_pScrollPanelRouge->setBorder( new LineBorder( Color(lbr,lbg,lbb,lba )) );
	m_pScrollPanelRouge->validate();

	
	// Texte info joueur
	m_pInfoJoueurRouge = new TextPanel("",0 ,0, TAILLE_INFOJOUEUR_X, TAILLE_INFOJOUEUR_Y *2);
	m_pInfoJoueurRouge->setParent( m_pScrollPanelRouge->getClient() );
	m_pInfoJoueurRouge->setFont( pSchemes->getFont(hTeamWindowText) );
	m_pInfoJoueurRouge->setFgColor( fgr, fgg, fgb, fga );
	m_pInfoJoueurRouge->setBgColor( bgr, bgg, bgb, 255 );
    
	
	// titre info joueur
	pTitle = new Label( CHudTextMessage::BufferedLocaliseTextString( "#Team_Players") , POSITION_TITREINFOJOUEUR_X , POSITION_TITREINFOJOUEUR_Y ,TAILLE_INFOJOUEUR_X,TAILLE_TITREINFOJOUEUR_Y );
	pTitle->setParent(m_pFenetreRouge );
	pTitle->setFgColor( fgr, fgg , fgb, fga);
	pTitle->setBgColor( bgr, bgg, bgb, bga );
	pTitle->setContentAlignment( vgui::Label::a_west );

	// Team button
	m_pButtons[2] = new ColorButton( gHUD.m_TextMessage.BufferedLocaliseTextString("#Team_seconde"), POSITION_BOUTON_EQUIPE_X, POSITION_BOUTON_EQUIPE_Y, TAILLE_BOUTON_X, TAILLE_BOUTON_Y,fgr,fgg,fgb,fga,bgr,bgg,bgb,bga,abgr,abgg,abgb,abga, false);
	m_pButtons[2]->setParent( m_pFenetreRouge );
	m_pButtons[2]->setContentAlignment( vgui::Label::a_center );
	//m_pButtons[2]->addActionSignal( new CMenuHandler_StringCommandWatch( "model Wormsred",true) );
	m_pButtons[2]->addActionSignal( new CMenuHandler_TextWindow(HIDE_TEXTWINDOW) );
	m_pButtons[2]->addInputSignal( new CHandler_MenuButtonOver(this, 2) );
	m_pButtons[2]->setBoundKey( '2' );
	m_pButtons[2]->setVisible( true );

	Initialize();
}

//-----------------------------------------------------------------------------
// Purpose: Called each time a new level is started.
//-----------------------------------------------------------------------------
void CWormshlTeamMenuPanel::Initialize( void )
{
	m_pScrollPanelBleu->setScrollValue( 0, 0 );
	m_pScrollPanelRouge->setScrollValue( 0, 0 );
}

//-----------------------------------------------------------------------------
// Purpose: Called everytime the Team Menu is displayed
//-----------------------------------------------------------------------------
void CWormshlTeamMenuPanel::Update( void )
{
	gViewPort->GetAllPlayersInfo();
	strcpy(	m_sNomsJoueursBleu,"");
	strcpy(	m_sNomsJoueursRouge,"");

	for ( int i = 1; i < MAX_PLAYERS; i++ )
	{
		if ( g_PlayerInfoList[i].name == NULL )
			continue; // empty player slot, skip

		if ( g_PlayerExtraInfo[i].teamname[0] == 0 )
			continue; // skip over players who are not in a team

		if ( stricmp(g_PlayerExtraInfo[i].teamname,"wormsblue") == 0 )
			sprintf(m_sNomsJoueursBleu,"%s\n %s",m_sNomsJoueursBleu,g_PlayerInfoList[i].name);
		if ( stricmp(g_PlayerExtraInfo[i].teamname,"wormsred") == 0 )
			sprintf(m_sNomsJoueursRouge,"%s\n %s",m_sNomsJoueursRouge,g_PlayerInfoList[i].name);

		if ( g_PlayerInfoList[i].thisplayer )
		{
			if ( stricmp(g_PlayerExtraInfo[i].teamname,"wormsblue") == 0 )
			{
				m_pCancelButton->setVisible(true);
			}
			else
			{
				if ( stricmp(g_PlayerExtraInfo[i].teamname,"wormsblue") == 0 )
				{
					m_pCancelButton->setVisible(true);
				}
				else
				{
					m_pCancelButton->setVisible(false);
				}
			}
		}
		
	}
	
	
	m_pInfoJoueurBleu->setText(this->m_sNomsJoueursBleu);
	m_pInfoJoueurRouge->setText(this->m_sNomsJoueursRouge);
	
	m_pScrollPanelBleu->validate();
	m_pScrollPanelRouge->validate();

	
	
}


//=====================================
// Key inputs
bool CWormshlTeamMenuPanel::SlotInput( int iSlot )
{

	// si on appuis sur la touche n n 
	// alors on lance l'action attribu au bouton n+1
	if ( iSlot == 0)
	{
		ClientCmd("model wormsblue");
		strcpy(gViewPort->m_pWormshlModelMenu->Equipe,"blue");
		strcpy(gViewPort->m_pWormshlModelMenu->ModelSelectionne,"worms");
		gViewPort->m_pWormshlModelMenu->m_pBoutonCorps->setText("worms");
		ClientCmd("wm_model");
		m_pButtons[ 1 ]->fireActionSignal();
		return true;
	}
	if ( iSlot == 1) 
	{
		ClientCmd("model wormsred");
		strcpy(gViewPort->m_pWormshlModelMenu->ModelSelectionne,"worms");
		gViewPort->m_pWormshlModelMenu->m_pBoutonCorps->setText("worms");
		strcpy(gViewPort->m_pWormshlModelMenu->Equipe,"red");
		ClientCmd("wm_model");
		m_pButtons[ 2 ]->fireActionSignal();
		return true;
	}
	if ( iSlot == 2) 
	{
		m_pCancelButton->fireActionSignal();
		return true;
	}

	return false;

}

//======================================
// Update the Team menu before opening it
void CWormshlTeamMenuPanel::Open( void )
{
	Update();
	CMenuPanel::Open();
	
	// enleve la selection des boutons

	m_pButtons[1]->setArmed(false);
	m_pButtons[2]->setArmed(false);
	m_pCancelButton->setArmed(false);
	
}

//======================================
// Mouse is over a team button, bring up the class info
void CWormshlTeamMenuPanel::SetActiveInfo( int iInput )
{
/*
	m_pTeamInfoPanel[1]->setVisible( false );
	m_pTeamInfoPanel[2]->setVisible( false );
	m_pTeamInfoPanel[5]->setVisible( false );
	m_pImageTeam[1]->setVisible( false );
	m_pImageTeam[2]->setVisible( false );
	m_pMapTitle->setVisible(false);
	m_pScrollPanel->setVisible(false);
	m_pBriefing->setVisible(false);

	if (iInput == 1)
	{
		m_pTeamInfoPanel[1]->setVisible( true );
		m_pImageTeam[1]->setVisible( true );
	}	

	if (iInput == 2)
	{
		m_pTeamInfoPanel[2]->setVisible( true );
		m_pImageTeam[2]->setVisible( true );
	}
	if (iInput == 5)
	{
		m_pTeamInfoPanel[5]->setVisible( true );
		m_pBriefing->setVisible(true);
		m_pMapTitle->setVisible(true);
		m_pScrollPanel->setVisible(true);
	}
*/
//	m_pScrollPanelBleu->validate();
//	m_pScrollPanelRouge->validate();
	
	if (iInput == 101)
	{
		ClientCmd("model wormsblue");
		strcpy(gViewPort->m_pWormshlModelMenu->Equipe,"blue");
		strcpy(gViewPort->m_pWormshlModelMenu->ModelSelectionne,"worms");
		gViewPort->m_pWormshlModelMenu->m_pBoutonCorps->setText("worms");
		ClientCmd("wm_model");
	}

	if (iInput == 102)
	{
		ClientCmd("model wormsred");
		strcpy(gViewPort->m_pWormshlModelMenu->ModelSelectionne,"worms");
		gViewPort->m_pWormshlModelMenu->m_pBoutonCorps->setText("worms");
		strcpy(gViewPort->m_pWormshlModelMenu->Equipe,"red");
		ClientCmd("wm_model");
	}
}


