/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_air_strike.h			*
*		19122001				*
\*******************************/

#ifndef AIR_STRIKE_H
#define AIR_STRIKE_H

#include "define_slot.h"

#ifdef Gd_ARME_AIR_STRIKE

#define Gm_AIR_STRIKE_FICHIER_MODEL_P			"models/armes/p_air_strike.mdl"
#define Gm_AIR_STRIKE_FICHIER_MODEL_R			"models/armes/r_air_strike.mdl"
#define Gm_AIR_STRIKE_FICHIER_MODEL_V			"models/armes/v_air_strike.mdl"
#define Gm_AIR_STRIKE_FICHIER_SON_TRAINE		"weapons/air_strike/air_strike1.wav"
#define Gm_AIR_STRIKE_FICHIER_SON_CIBLE			"weapons/commun/cible1.wav"
#define Gm_AIR_STRIKE_FICHIER_SPRITE_TRAINE		"sprites/smoke.spr"
#define Gm_AIR_STRIKE_FICHIER_SPRITE_CIBLE		"sprites/jeu/armes/croix1.spr"

#define Gm_AIR_STRIKE_DOMMAGE					25
#define Gm_AIR_STRIKE_MUNITION					1
#define Gm_AIR_STRIKE_TEMPS_DEPLACEMENT			0

#define Gm_AIR_STRIKE_TOUR_NUM_OK				5

class GcAirStrike : public CBasePlayerWeapon
{
public:
	int GetItemInfo( ItemInfo *p );
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );

private:
	void GfTire1( void );
	void GfTire2( void );

	CSprite *m_pSprite;
	float GvTempsAnim_f;
	float GvTempsFDT_f;
	short GvChoixTire_i;
};

class GcAirStrikeRocket : public GcGrenadeGeneric
{
public:
	void Spawn( void );
	void Precache( void );
	static GcAirStrikeRocket *CreateRocket( CBasePlayer *pGvPlayer, Vector GvOrigin, Vector GvAngles, int iGvDommage );
	
	CBasePlayer *pGvPlayer;

private:
	void EXPORT GfActualise( void );
	void EXPORT GfTouch( CBaseEntity *pOther );
	void GfTraine( void );

	Vector GvPosition_c;
	int GvTrail_i;
};

enum
{
	Ga_AIR_STRIKE_DRAW = 0,
	Ga_AIR_STRIKE_IDLE1,
	Ga_AIR_STRIKE_IDLE2,
	Ga_AIR_STRIKE_ATTACK_PREPA,
	Ga_AIR_STRIKE_ATTACK_ILDE,
	Ga_AIR_STRIKE_ATTACK
};

#endif
#endif // AIR_STRIKE_H