/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_banane.cpp				*
*		19022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "generic_arme.h"
#include "arme_banane.h"
#include "gamerules.h"

#ifdef Gd_ARME_BANANE

LINK_ENTITY_TO_CLASS( weapon_banane, GcBanane );

int GcBanane::GetItemInfo( ItemInfo *p )
{
	p->pszName = STRING( pev->classname );
	p->pszAmmo1 = "munition_banane";
	p->iMaxAmmo1 = Gm_MUNI_MAX;
	p->iSlot = Gm_BANANE_SLOT;
	p->iPosition = Gm_BANANE_POSITION;
	p->iId = m_iId = Gm_BANANE_ID;
	p->iWeight = Gm_BANANE_POID;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;
	return 1;
}

void GcBanane::Spawn( void )
{
	Precache( );

	SET_MODEL( ENT( pev ), Gm_BANANE_FICHIER_MODEL_R );

	m_iId = Gm_BANANE_ID;
	iGvAmmoDefault = Gm_BANANE_MUNITION;

	GvTempsPuis_f = 0;
	GvTempsFDT_f = 0;

	FallInit( );
}

void GcBanane::Precache( void )
{
	PRECACHE_MODEL( Gm_BANANE_FICHIER_MODEL_P );
	PRECACHE_MODEL( Gm_BANANE_FICHIER_MODEL_V );
	PRECACHE_MODEL( Gm_BANANE_FICHIER_MODEL_R );
	PRECACHE_SOUND( Gm_BANANE_FICHIER_SON_REBOND );
}

BOOL GcBanane::Deploy( void )
{
	GvTempsAnim_f = gpGlobals->time + 2.0;
	return DefaultDeploy( Gm_BANANE_FICHIER_MODEL_V, Gm_BANANE_FICHIER_MODEL_P, Ga_BANANE_DRAW, "banane" );
}

void GcBanane::Holster( void )
{
	if( m_pSpot )
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		//m_pPlayer->iGvArmes &= ~( 1<<Gm_BANANE_ID );
		m_pPlayer->iGvArmes[Gm_BANANE_SLOT] &= ~( 1<<Gm_BANANE_POSITION );
		SetThink( DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}

	GfFinDeTour( &GvTempsFDT_f, 0 );
}

void GcBanane::GfAttack1( void )
{
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		GfAttack0( );
		return;
	}

	if( !GvTempsPuis_f )
	{
		SendWeaponAnim( Ga_BANANE_TIRE_PREPARE );
		GvTempsPuis_f = gpGlobals->time;
		GfSonPuissanceOn( );
	}

	if( GfPuissanceProgressive( GvTempsPuis_f ))
		GfTire( Gm_ARME_TEMPS_TIRE_MAX );

	fGvAttack1 = fGvAttack0 = gpGlobals->time + 0.02;
}

void GcBanane::GfTire( float GvTempsPuisTire )
{
	GfPuissanceAffichage( WEAPON_PUISS_PROG_OFF, Gm_WORM_DEFAUT );
	GfSonAttack( );

	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );
	SendWeaponAnim( Ga_BANANE_TIRE );

	Vector GvAngle_c = m_pPlayer->pev->v_angle + m_pPlayer->pev->punchangle;

	if( GvAngle_c.x < 0 )
		GvAngle_c.x = -10 + GvAngle_c.x * ((90 - 10) / 90.0);
	else
		GvAngle_c.x = -10 + GvAngle_c.x * ((90 + 10) / 90.0);

	float GvVelocity_f = (90 - GvAngle_c.x) * 4;
	if( GvVelocity_f > 500 )
		GvVelocity_f = 500;

	UTIL_MakeVectors( GvAngle_c );
	
	Vector GvOrigin_c = m_pPlayer->GetGunPosition( ) + gpGlobals->v_forward * 16;
	Vector GvVelocity_c = gpGlobals->v_forward * (( GvVelocity_f / Gm_BANANE_COEF_TIRE ) * static_cast<int>( GvTempsPuisTire * 100 )) + m_pPlayer->pev->velocity;

	GvVelocity_c += g_pGameRules->GvVent;

	if( GvTempsPuis_f <= 1 )
		GvTempsPuis_f = 1;

	GcGrenadeGeneric::GfBanane( m_pPlayer, GvOrigin_c, GvVelocity_c, Gm_BANANE_EXPLOSE, GfDommage( Gm_BANANE_DOMMAGE ));

	m_pPlayer->m_rgAmmo[iGvAmmoID]--;
	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
		fGvAttack0 = fGvAttack2 = fGvAttack1 = gpGlobals->time + 0.1;

	GvTempsPuis_f = 0;
	GvTempsAnim_f = gpGlobals->time + 3.0;

	m_pPlayer->GvPlayerTPT.bAmmo = true;
	m_pPlayer->GvPlayerTPT.bTire = false;
	GvTempsFDT_f = gpGlobals->time;
}

void GcBanane::GfAttack2( void )
{
	GfAttack0( );
	fGvAttack2 = gpGlobals->time + 0.5;
}

void GcBanane::GfAttack0( void )
{
	fGvAttack0 = gpGlobals->time + 1.0;
	GfFinDeTour( &GvTempsFDT_f, Gm_BANANE_TEMPS_DEPLACEMENT );

	if( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE )
		UpdateSpot( );
	else if(( m_pSpot )&&!( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE ))
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( GvTempsPuis_f )
	{		
		if( !m_pPlayer->IsAlive( ))
			GvTempsPuis_f = 0.0;
		else 
			GfTire( gpGlobals->time - GvTempsPuis_f );
		return;
	}

	if( GvTempsAnim_f &&( GvTempsAnim_f < gpGlobals->time ))
	{
		if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		{
			int GvAnim_i;
			switch( RANDOM_LONG( 1,2 ))
			{
			case 1:
				GvAnim_i = Ga_BANANE_IDLE_02;
				GvTempsAnim_f = gpGlobals->time + 2.0;
				break;
			case 2:
				GvAnim_i = Ga_BANANE_IDLE_03;
				GvTempsAnim_f = gpGlobals->time + 2.0;
				break;
			default:
				GvAnim_i = Ga_BANANE_IDLE_02;
				GvTempsAnim_f = gpGlobals->time + 2.0;
				break;
			}
			SendWeaponAnim( GvAnim_i );
		}
		else
		{
			m_pPlayer->pev->viewmodel = 0; 
			m_pPlayer->pev->weaponmodel = 0;
		}
	}
}
#endif