/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_banane.h				*
*		06122001				*
\*******************************/

#ifndef ARME_BANANE_H
#define ARME_BANANE_H

#include "define_slot.h"

#ifdef Gd_ARME_BANANE

#define Gm_BANANE_FICHIER_MODEL_P			"models/armes/p_banane.mdl"
#define Gm_BANANE_FICHIER_MODEL_V			"models/armes/v_banane.mdl"
#define Gm_BANANE_FICHIER_MODEL_R			"models/armes/r_banane.mdl"
#define Gm_BANANE_FICHIER_SON_REBOND		"weapons/banane/banane1.wav"

#define Gm_BANANE_DOMMAGE					75
#define Gm_BANANE_MUNITION					1
#define Gm_BANANE_TEMPS_DEPLACEMENT			0

#define Gm_BANANE_COEF_TIRE					75 // Plus le nb et petit plus la grenade est puissante
#define Gm_BANANE_EXPLOSE					5.0
#define Gm_BANANE_GRAVITE					0.4
#define Gm_BANANE_HAUTEUR_MAX				65
#define Gm_BANANE_HAUTEUR_MINI				55
#define Gm_BANANE_PRECISION					9
#define Gm_BANANE_REBOND					0.01

class GcBanane : public CBasePlayerWeapon
{
public:
	int GetItemInfo( ItemInfo *p );
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );

private:
	void GfTire( float GvTirePuis_f );

	float GvTempsAnim_f;
	float GvTempsPuis_f;
	float GvTempsFDT_f;
};

enum
{
	Ga_BANANE_IDLE_01 = 0,
	Ga_BANANE_IDLE_02,
	Ga_BANANE_IDLE_03,
	Ga_BANANE_DRAW,
	Ga_BANANE_TIRE_PREPARE,
	Ga_BANANE_TIRE
};

#endif
#endif // ARME_BANANE_H