/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_batte.cpp				*
*		25022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "generic_arme.h"
#include "arme_batte.h"
#include "gamerules.h"

#ifdef Gd_ARME_BATTE

LINK_ENTITY_TO_CLASS( weapon_batte, GcBatte );

int GcBatte::GetItemInfo( ItemInfo *p )
{
	p->pszName = STRING( pev->classname );
	p->pszAmmo1 = "munition_batte";
	p->iMaxAmmo1 = Gm_MUNI_MAX;
	p->iSlot = Gm_BATTE_SLOT;
	p->iPosition = Gm_BATTE_POSITION;
	p->iId = Gm_BATTE_ID;
	p->iWeight = Gm_BATTE_POID;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;
	return 1;
}

void GcBatte::Spawn( void )
{
	Precache( );

	m_iId = Gm_BATTE_ID;
	iGvAmmoDefault = Gm_BATTE_MUNITION;

	GvTempsFDT_f = 0;

	FallInit( );
}

void GcBatte::Precache( void )
{
	PRECACHE_MODEL( Gm_BATTE_FICHIER_MODEL_V );
	PRECACHE_MODEL( Gm_BATTE_FICHIER_MODEL_P );

	PRECACHE_SOUND( Gm_BATTE_FICHIER_SON_HIT_01 );
	PRECACHE_SOUND( Gm_BATTE_FICHIER_SON_HIT_CORPS_01 );
	PRECACHE_SOUND( Gm_BATTE_FICHIER_SON_HIT_CORPS_02 );
	PRECACHE_SOUND( Gm_BATTE_FICHIER_SON_HIT_CORPS_03 );
	PRECACHE_SOUND( Gm_BATTE_FICHIER_SON_MANQUER );
}

BOOL GcBatte::Deploy( void )
{
	GvTempsAnim_f = gpGlobals->time + 2.0;
	return DefaultDeploy( Gm_BATTE_FICHIER_MODEL_V, Gm_BATTE_FICHIER_MODEL_P, Ga_BATTE_AFFICHE, "batte" );
}

void GcBatte::Holster( void )
{
	if( m_pSpot )
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		m_pPlayer->iGvArmes[Gm_BATTE_SLOT] &= ~( 1<<Gm_BATTE_POSITION );
		SetThink( DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}

	GfFinDeTour( &GvTempsFDT_f, 0 );
}

void GcBatte::GfAttack1( void )
{	
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		GfAttack0( );
		return;
	}

	if( g_pGameRules->iGfGamerulesActif( ) != Gm_GAMERULES_BATTE )
		m_pPlayer->m_rgAmmo[iGvAmmoID]--;

	GfTire( );

	fGvAttack1 = fGvAttack0 = gpGlobals->time + 0.1;
}

void GcBatte::GfTire( void )
{
/* EurOPiuM - 19/07/2002 - Demo Tri api
	MESSAGE_BEGIN( MSG_ALL, gmsgLanceflamme);
		WRITE_BYTE( pPlayer->entindex( )); //index du joueur
	MESSAGE_END( );

	MESSAGE_BEGIN( MSG_ALL, gmsgFlamme);
		WRITE_BYTE( 5 ); // nombre de flammes (max 20  la fois !)
		for(int w=0;w<5;w++) // pour toutes les flammes
		{
			int tempx=RANDOM_LONG( -50, 50 );
			int tempy=RANDOM_LONG( -50, 50 );
			WRITE_BYTE( 45 ); //duree en secondes que la flamme brulera
			WRITE_COORD( m_pPlayer->pev->origin.x+tempx ); // coordonne x de l'emplacement de la flamme
			WRITE_COORD( m_pPlayer->pev->origin.y+tempy ); // coordonne y de l'emplacement de la flamme
			WRITE_COORD( 0 ); // coordonne z de l'emplacement de la flamme
		}
	MESSAGE_END( );*/


	m_pPlayer->GvPlayerTPT.bTire = false;
	GvTempsFDT_f = gpGlobals->time;

	TraceResult tr;

	UTIL_MakeVectors( m_pPlayer->pev->v_angle );
	Vector vecSrc	= m_pPlayer->GetGunPosition( );
	Vector vecEnd	= vecSrc + gpGlobals->v_forward * 32;

	UTIL_TraceLine( vecSrc, vecEnd, dont_ignore_monsters, ENT( m_pPlayer->pev ), &tr );

	if ( tr.flFraction >= 1.0 )
	{
		UTIL_TraceHull( vecSrc, vecEnd, dont_ignore_monsters, head_hull, ENT( m_pPlayer->pev ), &tr );
		if ( tr.flFraction < 1.0 )
		{
			// Calculate the point of intersection of the line (or hull) and the object we hit
			// This is and approximation of the "best" intersection
			CBaseEntity *pHit = CBaseEntity::Instance( tr.pHit );
			if ( !pHit || pHit->IsBSPModel() )
				FindHullIntersection( vecSrc, tr, VEC_DUCK_HULL_MIN, VEC_DUCK_HULL_MAX, m_pPlayer->edict() );
			vecEnd = tr.vecEndPos;	// This is the point on the actual surface (the hull could have hit space)
		}
	}


	// Groove - 15032002 - Animation
	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

	if( tr.flFraction >= 1.0 )
	{
		// Groove - 12122001 - Hop un msg inutile
		GfMsgStupide( m_pPlayer );

		SendWeaponAnim( Ga_BATTE_ATTACK_MANQUER );

		fGvAttack1 = gpGlobals->time + 0.5;
		// Un son lorsque le joueur frappe dans le vide
		EMIT_SOUND_DYN(ENT(m_pPlayer->pev), CHAN_WEAPON, Gm_BATTE_FICHIER_SON_MANQUER, 1, ATTN_NORM, 0, 94 + RANDOM_LONG(0,0xF));
	}
	else
	{
		GfSonAttack( );

		// Groove - 15032002 - Animation
		SendWeaponAnim( Ga_BATTE_ATTACK );
		
		CBaseEntity *pEntity = CBaseEntity::Instance(tr.pHit);

		ClearMultiDamage( );
		
		if( g_pGameRules->iGfGamerulesActif( ) != Gm_GAMERULES_BATTE )
			pEntity->TraceAttack( m_pPlayer->pev, Gm_BATTE_DOMMAGE, gpGlobals->v_forward, &tr, Gm_DMG_CONTACT ); 
		else
			pEntity->TraceAttack( m_pPlayer->pev, 0, gpGlobals->v_forward, &tr, Gm_DMG_CONTACT ); 
		
		if( !( FClassnameIs( pEntity->pev, "info_bananier" )||FClassnameIs( pEntity->pev, "info_sapin" )))
		{
			pEntity->pev->velocity += ( gpGlobals->v_forward * Gm_BATTE_COEF_PUISSANCE );
			ApplyMultiDamage( m_pPlayer->pev, m_pPlayer->pev );
		}

		fGvAttack1 = gpGlobals->time + 0.25;

		bool GvTouchWorld_b = true;

		if( pEntity )
		{
			if(( pEntity->Classify( ) != CLASS_NONE ) && ( pEntity->Classify( ) != CLASS_MACHINE ) && ( !FClassnameIs( pEntity->pev, "info_bananier" )) && ( !FClassnameIs( pEntity->pev, "info_sapin" )))
			{
				// Joue un son quand le joueur touche un joueur
				switch( RANDOM_LONG( 0,2 ))
				{
				case 0:
					EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_WEAPON, Gm_BATTE_FICHIER_SON_HIT_CORPS_01, 1, ATTN_NORM); break;
				case 1:
					EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_WEAPON, Gm_BATTE_FICHIER_SON_HIT_CORPS_02, 1, ATTN_NORM); break;
				case 2:
					EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_WEAPON, Gm_BATTE_FICHIER_SON_HIT_CORPS_03, 1, ATTN_NORM); break;
				}
				
				// Groove - 15032002 - L'enti est un baril ou une caisse
				if( pEntity->GvNiveauVie_i )
				{
					pEntity->pev->velocity.z += 128 + pev->dmg;
					pEntity->GvNiveauVie_i -= pev->dmg;
				}

				GvTouchWorld_b = false;
			}
		}

		// Groove - 15032002 - Joue un son quand le joueur touche un lment autre que le joueur
		if( GvTouchWorld_b )
			EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_WEAPON, Gm_BATTE_FICHIER_SON_HIT_01, 1, ATTN_NORM );

		m_trHit = tr;
		pev->nextthink = gpGlobals->time + 0.2;

	}
	
	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
		fGvAttack0 = fGvAttack2 = fGvAttack1 = gpGlobals->time + 0.1;

	GvTempsAnim_f = gpGlobals->time + 3;

	GvTempsFDT_f = gpGlobals->time;
	m_pPlayer->GvPlayerTPT.bTire = false;
}

void GcBatte::GfAttack2( void )
{
	GfAttack0( );
	fGvAttack2 = gpGlobals->time + 0.5;
}

void GcBatte::GfAttack0( void )
{
	fGvAttack0 = gpGlobals->time + 1.0;
	GfFinDeTour( &GvTempsFDT_f, Gm_BATTE_TEMPS_DEPLACEMENT );

	if( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE )
		UpdateSpot( );
	else if(( m_pSpot )&&!( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE ))
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( GvTempsAnim_f &&( GvTempsAnim_f < gpGlobals->time ))
	{
		if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		{
			GvTempsAnim_f = gpGlobals->time + 100.0;
			SendWeaponAnim( Ga_BATTE_AFFICHE );

/* EurOPiuM - 19/07/2002 - Demo Tri Api

	MESSAGE_BEGIN( MSG_ALL, gmsgLanceflamme);
		WRITE_BYTE( pPlayer->entindex( )); //index du joueur
	MESSAGE_END( );*/
		}
		else
		{
			m_pPlayer->pev->viewmodel = 0; 
			m_pPlayer->pev->weaponmodel = 0;
		}
	}
}

#endif