/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_batte.h				*
*		09122001				*
\*******************************/

#ifndef ARME_BATTE_H
#define ARME_BATTE_H

#include "define_slot.h"

#ifdef Gd_ARME_BATTE

#define Gm_BATTE_FICHIER_MODEL_P				"models/armes/p_batte.mdl"
#define Gm_BATTE_FICHIER_MODEL_V				"models/armes/v_batte.mdl"
#define Gm_BATTE_FICHIER_SON_PLOUF				"weapons/batte/batte01.wav"
#define Gm_BATTE_FICHIER_SON_HIT_01				"weapons/batte/batte06.wav"
#define Gm_BATTE_FICHIER_SON_HIT_CORPS_01		"weapons/batte/batte02.wav"
#define Gm_BATTE_FICHIER_SON_HIT_CORPS_02		"weapons/batte/batte03.wav"
#define Gm_BATTE_FICHIER_SON_HIT_CORPS_03		"weapons/batte/batte04.wav"
#define Gm_BATTE_FICHIER_SON_MANQUER			"weapons/batte/batte05.wav"

#define Gm_BATTE_DOMMAGE						25
#define Gm_BATTE_MUNITION						3
#define Gm_BATTE_TEMPS_DEPLACEMENT				3.0

#define	Gm_BATTE_BODYHIT_VOLUME					256
#define Gm_BATTE_COEF_PUISSANCE					1000
#define Gm_BATTE_COEF_PUISSANCE_Z				300
#define	Gm_BATTE_WALLHIT_VOLUME					512

class GcBatte : public CBasePlayerWeapon
{
public:
	int GetItemInfo( ItemInfo *p );
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );

private:
	void GfTire( void );

	TraceResult m_trHit;
	float GvTempsFDT_f;
	float GvTempsAnim_f;
};

enum
{
	Ga_BATTE_IDLE1 = 0,
	Ga_BATTE_IDLE2,
	Ga_BATTE_IDLE3,
	Ga_BATTE_ATTACK,
	Ga_BATTE_ATTACK_MANQUER,
	Ga_BATTE_AFFICHE
};

#endif
#endif // ARME_BATTE_H