/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_bazooka.h				*
*		06122001				*
\*******************************/

#ifndef ARME_BAZOOKA_H
#define ARME_BAZOOKA_H

#include "define_slot.h"

#ifdef Gd_ARME_BAZOOKA

#define Gm_BAZOOKA_FICHIER_MODEL_P				"models/armes/p_bazooka.mdl"
#define Gm_BAZOOKA_FICHIER_MODEL_R				"models/armes/r_bazooka.mdl"
#define Gm_BAZOOKA_FICHIER_MODEL_V				"models/armes/v_bazooka.mdl"
#define Gm_BAZOOKA_FICHIER_SON_TIRE				"weapons/bazooka/bazooka1.wav"
#define Gm_BAZOOKA_FICHIER_SON_TRAINE			"weapons/bazooka/bazooka2.wav"

#define Gm_BAZOOKA_DOMMAGE						75
#define Gm_BAZOOKA_MUNITION						10
#define Gm_BAZOOKA_TEMPS_DEPLACEMENT			3.0

#define Gm_BAZOOKA_RECUL						15

class GcBazooka : public CBasePlayerWeapon
{
public:
	int GetItemInfo( ItemInfo *p );
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );	

private:
	void GfTire( float GvTirePuis_f );

	float GvTempsAnim_f;
	float GvTempsPuis_f;
	float GvTempsFDT_f;
};

enum
{
	Ga_BAZOOKA_IDLE = 0,
	Ga_BAZOOKA_TIRE,
	Ga_BAZOOKA_DRAW,
	Ga_BAZOOKA_PREPARE_TIRE,
	Ga_BAZOOKA_RECHARGE
};

#endif
#endif // ARME_BAZOOKA_H