/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_camera.cpp				*
*		08032002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "generic_arme.h"
#include "generic_balle.h"
#include "arme_camera.h"
#include "gamerules.h"
#include "shake.h"

#ifdef Gd_ARME_CAMERA

LINK_ENTITY_TO_CLASS( weapon_camera, GcCamera );

int GcCamera::GetItemInfo( ItemInfo *p )
{
	p->pszName = STRING( pev->classname );
	p->pszAmmo1 = "munition_camera";
	p->iMaxAmmo1 = Gm_MUNI_MAX;
	p->iSlot = Gm_CAMERA_SLOT;
	p->iPosition = Gm_CAMERA_POSITION;
	p->iId = m_iId = Gm_CAMERA_ID;
	p->iWeight = Gm_CAMERA_POID;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;
	return 1;
}

void GcCamera::Spawn( void )
{
	Precache( );

	m_iId = Gm_CAMERA_ID;
	iGvAmmoDefault = Gm_CAMERA_MUNITION;

	GvTempsFDT_f = 0;
	GvTempsTire_f = 0;
	GvViewSave_b = false;
	bGvVitesseCameraChange = true;

	FallInit( );
}

void GcCamera::Precache( void )
{
	PRECACHE_MODEL( Gm_CAMERA_FICHIER_MODEL_P );
	PRECACHE_MODEL( Gm_CAMERA_FICHIER_MODEL_V );
	PRECACHE_MODEL( Gm_CAMERA_FICHIER_MODEL_R );
	PRECACHE_SOUND( Gm_CAMERA_FICHIER_SON_TIRE );
}

BOOL GcCamera::Deploy( void )
{
	GvTempsAnim_f = gpGlobals->time + 0.64;
	return DefaultDeploy( Gm_CAMERA_FICHIER_MODEL_V, Gm_CAMERA_FICHIER_MODEL_P, Ga_CAMERA_DRAW, "camera" );
}

void GcCamera::Holster( void )
{
	if( m_pSpot )
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( pCamera )
	{
		UTIL_ScreenFade( m_pPlayer, Vector( 0, 0, 0 ), 0.25, 0.5, 255, FFADE_IN );
		SET_VIEW( m_pPlayer->edict(), m_pPlayer->edict( ));
		if( pCamera )
		{
			UTIL_Remove( pCamera );
			pCamera = NULL;
		}
	}

	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		//m_pPlayer->iGvArmes &= ~( 1<<Gm_CAMERA_ID );
		m_pPlayer->iGvArmes[Gm_CAMERA_SLOT] &= ~( 1<<Gm_CAMERA_POSITION );
		SetThink( DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}

	GfFinDeTour( &GvTempsFDT_f, 0 );
}

void GcCamera::GfAttack1( void )
{
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] )
		GfAttack0( );

	if( pCamera )
	{
		SendWeaponAnim( Ga_CAMERA_DRAW );
		GvTempsAnim_f = gpGlobals->time + 0.64;
		UTIL_ScreenFade( m_pPlayer, Vector( 0, 0, 0 ), 0.25, 0.5, 255, FFADE_IN );
		SET_VIEW( m_pPlayer->edict( ), m_pPlayer->edict( ));
		UTIL_Remove( pCamera );
		pCamera = NULL;
	}
	else
	{
		SendWeaponAnim( Ga_CAMERA_TIRE );
		m_pPlayer->SetAnimation( PLAYER_ATTACK1 );
		GvTempsAnim_f = GvTempsTire_f = gpGlobals->time + 1.875;
//			GfTire( );
	}

	fGvAttack1 = fGvAttack0 = gpGlobals->time + 0.5;
}

void GcCamera::GfTire( void )
{
	UTIL_ScreenFade( m_pPlayer, Vector( 0, 0, 0 ), 0.25, 0.5, 255, FFADE_IN );

	Vector GvOrigin_c = m_pPlayer->GetGunPosition( ) + gpGlobals->v_forward * 16 + gpGlobals->v_up * 32;
	
	short GvTraineCouleurRouge[3][6] = 
	{
		{128,  1, 255,   0,   0, 255 },// Life, Width, r, v, b, brightness
		{  0,  0,   0,   0,   0,   0 },// Life, Width, r, v, b, brightness
		{  0,  0,   0,   0,   0,   0 } // Life, Width, r, v, b, brightness
	};

	short GvTraineCouleurBleu[3][6] = 
	{
		{128,  1,   0,   0, 255, 255 },// Life, Width, r, v, b, brightness
		{  0,  0,   0,   0,   0,   0 },// Life, Width, r, v, b, brightness
		{  0,  0,   0,   0,   0,   0 } // Life, Width, r, v, b, brightness
	};

	short GvTraineCouleurVert[3][6] = 
	{
		{128,  1,   0, 255,   0, 255 },// Life, Width, r, v, b, brightness
		{  0,  0,   0,   0,   0,   0 },// Life, Width, r, v, b, brightness
		{  0,  0,   0,   0,   0,   0 } // Life, Width, r, v, b, brightness
	};

	int GvBalleOption_i = Gm_BALLE_VUE_SUR_NORMAL | Gm_BALLE_FUMEE | Gm_BALLE_VUE_INTERIEUR | Gm_BALLE_ANIM | Gm_BALLE_CONTROLE_VITESSE;

	pCamera = NULL;
	if( m_pPlayer && ( FStrEq( m_pPlayer->m_szTeamName,"Wormsred" )))
		pCamera = GcGenericBalle::GfCreateBalle( GvOrigin_c,
												   m_pPlayer->pev->angles, 
												   0, 
												   Gm_CAMERA_VITESSE,
												   Gm_CAMERA_DOMMAGE, 
												   10,								// Duree de vie de la balle si option active.
												   GvTraineCouleurRouge,			// Couleur de la trainee
												   1,								// Nombre de trainees
												   GvBalleOption_i,					//short GvOptionCreate, 
												   m_pPlayer, 
												   this,
												   Gm_CAMERA_ID );
	else if( m_pPlayer && ( FStrEq( m_pPlayer->m_szTeamName,"Wormsblue" )))
		pCamera = GcGenericBalle::GfCreateBalle( GvOrigin_c,
													m_pPlayer->pev->angles, 
													0, 
													Gm_CAMERA_VITESSE,
													Gm_CAMERA_DOMMAGE, 
													10,					// Duree de vie de la balle si option active.
													GvTraineCouleurBleu,	// Couleur de la trainee
													1,						// Nombre de trainees
													GvBalleOption_i,			// short GvOptionCreate, 
													m_pPlayer, 
													this,
													Gm_CAMERA_ID );
	else
		pCamera = GcGenericBalle::GfCreateBalle( GvOrigin_c,
													m_pPlayer->pev->angles, 
													0, 
													Gm_CAMERA_VITESSE,
													Gm_CAMERA_DOMMAGE, 
													10,					// Duree de vie de la balle si option active.
													GvTraineCouleurVert,	// Couleur de la trainee
													1,						// Nombre de trainees
													GvBalleOption_i,			// short GvOptionCreate, 
													m_pPlayer, 
													this,
													Gm_CAMERA_ID );
	iGvVitesseCamera = Gm_CAMERA_VITESSE;

	EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_ITEM, Gm_CAMERA_FICHIER_SON_TIRE, 1, ATTN_NORM );
	
	GvTempsTire_f = 0;
	GvViewSave_b = true;
}

void GcCamera::GfAttack2( void )
{
	GfFinDeTour( &GvTempsFDT_f, Gm_CAMERA_TEMPS_DEPLACEMENT );
	
	if( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE )
		UpdateSpot( );
	else if( m_pSpot &&!( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE ))
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}
	
	if( pCamera )
	{
		iGvVitesseCamera += iGvVitesseCameraSens;
		if( iGvVitesseCamera > 1000 )
			iGvVitesseCamera = 1000;
		else if( iGvVitesseCamera <= 0 )
			iGvVitesseCamera = 0;
		
		pCamera->pev->velocity = gpGlobals->v_forward * iGvVitesseCamera;

		bGvVitesseCameraChange = true;
	}

	fGvAttack2 = gpGlobals->time + 0.1;
}

void GcCamera::GfAttack0( void )
{
	fGvAttack0 = gpGlobals->time + 1.0;
	GfFinDeTour( &GvTempsFDT_f, Gm_CAMERA_TEMPS_DEPLACEMENT );
	
	if( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE )
		UpdateSpot( );
	else if(( m_pSpot )&&!( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE ))
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( pCamera )
	{
		pCamera->pev->velocity = gpGlobals->v_forward * iGvVitesseCamera;
		if( bGvVitesseCameraChange )
		{
			if( iGvVitesseCamera <= Gm_CAMERA_VITESSE )
				iGvVitesseCameraSens = 50;
			else
				iGvVitesseCameraSens = -50;
		}
	}
	
	if( GvTempsTire_f &&( GvTempsTire_f < gpGlobals->time ))
		GfTire( );

	if( !pCamera && GvViewSave_b )
	{
		GvViewSave_b = false;
		UTIL_ScreenFade( m_pPlayer, Vector( 0, 0, 0 ), 0.25, 0.5, 255, FFADE_IN );
		SET_VIEW( m_pPlayer->edict( ), m_pPlayer->edict() );
		UTIL_Remove( pCamera );
		pCamera = NULL;
	}
	
	if( GvTempsAnim_f && ( GvTempsAnim_f < gpGlobals->time ))
	{
		if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		{
			int GvAnim_i;
			switch( RANDOM_LONG( 1,2 ))
			{
			case 1:
				GvAnim_i = Ga_CAMERA_IDLE_01;
				GvTempsAnim_f = gpGlobals->time + 2.0;
				break;
			case 2:
				GvAnim_i = Ga_CAMERA_IDLE_02;
				GvTempsAnim_f = gpGlobals->time + 1.68;
				break;
			default:
				GvAnim_i = Ga_CAMERA_IDLE_01;
				GvTempsAnim_f = gpGlobals->time + 2.0;
				break;
			}
			SendWeaponAnim( GvAnim_i );
		}
		else
		{
			m_pPlayer->pev->viewmodel = 0; 
			m_pPlayer->pev->weaponmodel = 0;
		}
	}
}

#endif