/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_camera.h				*
*		19122001				*
\*******************************/

#ifndef ARME_CAMERA_H
#define ARME_CAMERA_H

#include "define_slot.h"

#ifdef Gd_ARME_CAMERA

#define Gm_CAMERA_FICHIER_MODEL_P				"models/armes/p_camera.mdl"
#define Gm_CAMERA_FICHIER_MODEL_R				"models/armes/w_camera.mdl"
#define Gm_CAMERA_FICHIER_MODEL_V				"models/armes/v_camera.mdl"
#define Gm_CAMERA_FICHIER_SON_TIRE				"weapons/camera/camera1.wav"
#define Gm_CAMERA_FICHIER_SPRITE_FUMEE			"sprites/smoke.spr"

#define Gm_CAMERA_DOMMAGE						0
#define Gm_CAMERA_MUNITION						1
#define Gm_CAMERA_TEMPS_DEPLACEMENT				0

#define Gm_CAMERA_VITESSE						300

class GcCamera : public CBasePlayerWeapon
{
public:
	int GetItemInfo( ItemInfo *p );
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );	

private:
	void GfTire( void );
	
	CBaseEntity *pCamera;
	float GvTempsTire_f;
	float GvTempsAnim_f;
	float GvTempsFDT_f;
	bool GvViewSave_b;

	int iGvVitesseCameraSens;
	int iGvVitesseCamera;
	bool bGvVitesseCameraChange;
};

enum
{
	Ga_CAMERA_DRAW = 0,
	Ga_CAMERA_IDLE_01,
	Ga_CAMERA_IDLE_02,
	Ga_CAMERA_TIRE
};

#endif
#endif // ARME_CAMERA_H