/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_cluster.cpp			*
*		19022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "generic_arme.h"
#include "arme_cluster.h"
#include "gamerules.h"

#ifdef Gd_ARME_CLUSTER

LINK_ENTITY_TO_CLASS( weapon_cluster, GcCluster );

int GcCluster::GetItemInfo( ItemInfo *p )
{
	p->pszName = STRING( pev->classname );
	p->pszAmmo1 = "munition_cluster";
	p->iMaxAmmo1 = Gm_MUNI_MAX;
	p->iSlot = Gm_CLUSTER_SLOT;
	p->iPosition = Gm_CLUSTER_POSITION;
	p->iId = m_iId = Gm_CLUSTER_ID;
	p->iWeight = Gm_CLUSTER_POID;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;
	return 1;
}

void GcCluster::Spawn( void )
{
	Precache( );

	m_iId = Gm_CLUSTER_ID;
	iGvAmmoDefault = Gm_CLUSTER_MUNITION;

	GvTempsPuis_f = 0;
	GvTempsFDT_f = 0;
	GvTempsExplose_i = 3;

	FallInit( );
}

void GcCluster::Precache( void )
{
	PRECACHE_MODEL( Gm_CLUSTER_FICHIER_MODEL_W );
	PRECACHE_MODEL( Gm_CLUSTER_FICHIER_MODEL_V );
	PRECACHE_MODEL( Gm_CLUSTER_FICHIER_MODEL_P );
	PRECACHE_MODEL( Gm_CLUSTER_FICHIER_MODEL_R );
}

BOOL GcCluster::Deploy( void )
{
	GvTempsAnim_f = gpGlobals->time + 2.0;
	return DefaultDeploy( Gm_CLUSTER_FICHIER_MODEL_V, Gm_CLUSTER_FICHIER_MODEL_P, Ga_CLUSTER_AFFICHE, "crowbar" );
}

void GcCluster::Holster( void )
{
	if( m_pSpot )
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		//m_pPlayer->iGvArmes &= ~( 1<<Gm_CLUSTER_ID );
		m_pPlayer->iGvArmes[Gm_CLUSTER_SLOT] &= ~( 1<<Gm_CLUSTER_POSITION );
		SetThink( DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}

	GfFinDeTour( &GvTempsFDT_f, 0 );
}

void GcCluster::GfAttack1( void )
{
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		GfAttack0( );
		return;
	}

	if( !GvTempsPuis_f )
	{
		GvTempsPuis_f = gpGlobals->time;
		SendWeaponAnim( Ga_CLUSTER_TIRE_PREPARE );
		GfSonPuissanceOn( );
	}

	// Groove - 17032002 - Tire quand on arrvie a la puissance max.
	if( GfPuissanceProgressive( GvTempsPuis_f ))
		GfTire( Gm_ARME_TEMPS_TIRE_MAX );
	
	fGvAttack1 = fGvAttack0 = gpGlobals->time + 0.02;
}

void GcCluster::GfTire( float GvTirePuis_f )
{
	GfPuissanceAffichage( WEAPON_PUISS_PROG_OFF, Gm_WORM_DEFAUT );
	GfSonAttack( );

	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );
	SendWeaponAnim( Ga_CLUSTER_TIRE );

	Vector GvAngle_c = m_pPlayer->pev->v_angle + m_pPlayer->pev->punchangle;

	if( GvAngle_c.x < 0 )
		GvAngle_c.x = -10 + GvAngle_c.x * ((90 - 10) / 90.0);
	else
		GvAngle_c.x = -10 + GvAngle_c.x * ((90 + 10) / 90.0);

	float GvVelocity_f = (90 - GvAngle_c.x) * 4;
	if( GvVelocity_f > 500 )
		GvVelocity_f = 500;

	UTIL_MakeVectors( GvAngle_c );

	Vector GvOrigine_c = m_pPlayer->GetGunPosition( ) + gpGlobals->v_forward * 16;
	Vector GvVelocity_c = gpGlobals->v_forward * (( GvVelocity_f / Gm_CLUSTER_COEF_TIRE ) * static_cast<int>( GvTirePuis_f * 100 )) + m_pPlayer->pev->velocity;
	GvVelocity_c += g_pGameRules->GvVent;

	GcGrenadeGeneric::GfCluster( m_pPlayer, GvOrigine_c, GvVelocity_c, GvTempsExplose_i, GfDommage( Gm_CLUSTER_DOMMAGE ));

	m_pPlayer->m_rgAmmo[iGvAmmoID]--;
	GvTempsAnim_f = gpGlobals->time + 3.0;
	GvTempsPuis_f = 0;

	m_pPlayer->GvPlayerTPT.bAmmo = true;
	m_pPlayer->GvPlayerTPT.bTire = false;
	GvTempsFDT_f = gpGlobals->time;
}

void GcCluster::GfAttack2( void )
{
	if( GvTempsPuis_f != 0 )
		GfTire( gpGlobals->time - GvTempsPuis_f );

	if(( GvTempsChange_f < gpGlobals->time  )|| !GvTempsChange_f )
	{
		if( GvTempsExplose_i >= 5 )
			GvTempsExplose_i = 1;
		else
			GvTempsExplose_i++;

		int GvMsgHUD;
		switch( GvTempsExplose_i )
		{
		case 1:
			GvMsgHUD = Gm_MSG_ARME_GRENADE_TEMPS_1;
			break;
		case 2:
			GvMsgHUD = Gm_MSG_ARME_GRENADE_TEMPS_2;
			break;
		default:
		case 3:
			GvMsgHUD = Gm_MSG_ARME_GRENADE_TEMPS_3;
			break;
		case 4:
			GvMsgHUD = Gm_MSG_ARME_GRENADE_TEMPS_4;
			break;
		case 5:
			GvMsgHUD = Gm_MSG_ARME_GRENADE_TEMPS_5;
			break;
		}

		MESSAGE_BEGIN( MSG_ONE, gmsgBarreMsg, NULL, m_pPlayer->pev );
			WRITE_BYTE( GvMsgHUD );
		MESSAGE_END( );

		SendWeaponAnim( Ga_CLUSTER_CHANGE_TEMPS );
		GvTempsChange_f = gpGlobals->time + 0.9;
	}
}

void GcCluster::GfAttack0( void )
{
	fGvAttack0 = gpGlobals->time + 1.0;
	GfFinDeTour( &GvTempsFDT_f, Gm_CLUSTER_TEMPS_DEPLACEMENT );

	if( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE )
		UpdateSpot( );
	else if(( m_pSpot )&&!( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE ))
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( GvTempsPuis_f )
	{
		if(( gpGlobals->time - GvTempsPuis_f ) < 0.2 )
			GfMsgStupide( m_pPlayer );
		
		if( !m_pPlayer->IsAlive( ))
			GvTempsPuis_f = 0.0;
		else 
			GfTire( gpGlobals->time - GvTempsPuis_f );
	}

	if( GvTempsAnim_f &&( GvTempsAnim_f < gpGlobals->time ))
	{
		if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		{
			SendWeaponAnim( Ga_CLUSTER_AFFICHE );
			GvTempsAnim_f = gpGlobals->time + 100.0;
		}
		else
		{
			m_pPlayer->pev->viewmodel = 0; 
			m_pPlayer->pev->weaponmodel = 0;
		}
	}
	fGvAttack1 = fGvAttack2 = fGvAttack0 = 0.2;
}
#endif