/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_cluster.h				*
*		06122001				*
\*******************************/

#ifndef ARME_CLUSTER_H
#define ARME_CLUSTER_H

#include "define_slot.h"

#ifdef Gd_ARME_CLUSTER

#define Gm_CLUSTER_FICHIER_MODEL_P				"models/armes/p_cluster.mdl"
#define Gm_CLUSTER_FICHIER_MODEL_R				"models/armes/r_cluster.mdl"
#define Gm_CLUSTER_FICHIER_MODEL_V				"models/armes/v_cluster.mdl"
#define Gm_CLUSTER_FICHIER_MODEL_W				"models/armes/w_cluster.mdl"

#define Gm_CLUSTER_DOMMAGE						25
#define Gm_CLUSTER_MUNITION						2
#define Gm_CLUSTER_TEMPS_DEPLACEMENT			0

#define Gm_CLUSTER_COEF_TIRE					75 // Plus le nb et petit plus la grenade est puissante
#define Gm_CLUSTER_GRAVITE						0.6
#define Gm_CLUSTER_GRAVITE_FRAGMENT				0.3
#define Gm_CLUSTER_HAUTEUR_MAX					15
#define Gm_CLUSTER_HAUTEUR_MINI					10
#define Gm_CLUSTER_PRECISION					6
#define Gm_CLUSTER_REBOND						0.75

class GcCluster : public CBasePlayerWeapon
{
public:
	int GetItemInfo( ItemInfo *p );
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );
	
private:
	void GfTire( float GvTirePuis_f );

	float GvTempsPuis_f;
	float GvTempsFDT_f;
	float GvTempsAnim_f;
	float GvTempsChange_f;
	short GvTempsExplose_i;
};

enum
{
	Ga_CLUSTER_IDLE1 = 0,
	Ga_CLUSTER_IDLE2,
	Ga_CLUSTER_TIRE,
	Ga_CLUSTER_TIRE_PREPARE,
	Ga_CLUSTER_TIRE_ATTENTE,
	Ga_CLUSTER_CHANGE_TEMPS,
	Ga_CLUSTER_AFFICHE
};

#endif
#endif // ARME_CLUSTER_H