/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_croix.cpp				*
*		19022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "fx_explode.h"
#include "fx_sprite.h"
#include "generic_arme.h"
#include "arme_croix.h"
#include "gamerules.h"

#ifdef Gd_ARME_CROIX

LINK_ENTITY_TO_CLASS( weapon_croix, GcCroix );
LINK_ENTITY_TO_CLASS( rocket_croix, GcCroixRocket );

int GcCroix::GetItemInfo( ItemInfo *p )
{
	p->pszName = STRING( pev->classname );
	p->pszAmmo1 = "munition_croix";
	p->iMaxAmmo1 = Gm_MUNI_MAX;
	p->iSlot = Gm_CROIX_SLOT;
	p->iPosition = Gm_CROIX_POSITION;
	p->iId = m_iId = Gm_CROIX_ID;
	p->iWeight = Gm_CROIX_POID;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;
	return 1;
}

void GcCroix::Spawn( void )
{
	Precache( );

	m_iId = Gm_CROIX_ID;
	iGvAmmoDefault = Gm_CROIX_MUNITION;

	GvTempsAttack_f = 0;
	GvMerciDieu_i = 0;

	FallInit( );
}

void GcCroix::Precache( void )
{
	PRECACHE_MODEL( Gm_CROIX_FICHIER_MODEL_R );
	PRECACHE_MODEL( Gm_CROIX_FICHIER_MODEL_V );
	PRECACHE_MODEL( Gm_CROIX_FICHIER_MODEL_P );

	PRECACHE_SOUND( Gm_CROIX_FICHIER_SON_TIRE_APPEL );
	PRECACHE_SOUND( Gm_CROIX_FICHIER_SON_TIRE_FIN );
	PRECACHE_SOUND( Gm_CROIX_FICHIER_SON_APARTE );
	PRECACHE_SOUND( Gm_CROIX_FICHIER_SON_ELEC );
}

BOOL GcCroix::Deploy( void )
{
	GvTempsAnim_f = gpGlobals->time + 2.0;
	return DefaultDeploy( Gm_CROIX_FICHIER_MODEL_V, Gm_CROIX_FICHIER_MODEL_P, Ga_CROIX_DRAW, "croix" );
}

void GcCroix::Holster( void )
{
	if( m_pSpot )
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		//m_pPlayer->iGvArmes &= ~( 1<<Gm_CROIX_ID );
		m_pPlayer->iGvArmes[Gm_CROIX_SLOT] &= ~( 1<<Gm_CROIX_POSITION );
		SetThink( DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}

	GfFinDeTour( &GvTempsFDT_f, 0 );
}

void GcCroix::GfAttack1( void )
{
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		GfAttack0( );
		return;
	}

	GvOriginNuage_c = UpdateSpot( );
	GvOriginNuage_c.z += 250;

	SendWeaponAnim( Ga_CROIX_ATTACK_CALL );
	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

	EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_WEAPON, Gm_CROIX_FICHIER_SON_TIRE_APPEL, 0.9, ATTN_NORM );

	m_pSprite = CSprite::SpriteCreate( Gm_CROIX_FICHIER_SPRITE_CIBLE, GvPosition_c, FALSE );
	m_pSprite->pev->scale = 2.0;
	m_pSprite->SetTransparency( kRenderGlow, 255, 255, 255, 255,kRenderFxNoDissipation );
	
//	EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_WEAPON, Gm_AIR_STRIKE_FICHIER_SON_CIBLE, 0.7, ATTN_NORM );

	GvTempsAttack_f = gpGlobals->time + 5.0;
	m_pPlayer->m_rgAmmo[iGvAmmoID]--;
	
	m_pPlayer->GvPlayerTPT.bAmmo = true;
	m_pPlayer->GvPlayerTPT.bTire = false;
	GvTempsFDT_f = gpGlobals->time;
}

void GcCroix::GfTire( void )
{
	m_pPlayer->sGvProfil.iGvDieu++;

	GcCroixRocket::CreateRocket( m_pPlayer, GvOriginNuage_c );
	GvTempsAnim_f = gpGlobals->time + 2.5;
	GvMerciDieu_i = 1;
	fGvAttack0 = gpGlobals->time + 2.5;
}

void GcCroix::GfAttack2( void )
{
	GfAttack0( );
	fGvAttack2 = gpGlobals->time + 0.5;
}

void GcCroix::GfAttack0( void )
{
	fGvAttack0 = gpGlobals->time + 1.0;
	GfFinDeTour( &GvTempsFDT_f, Gm_CROIX_TEMPS_DEPLACEMENT );

	UpdateSpot( );

	if( GvTempsAttack_f != 0 )
	{
		if( GvTempsAttack_f < gpGlobals->time )
		{
			GfTire( );
			GvTempsAttack_f = 0;
		}
		return;
	}

	if( GvTempsAnim_f < gpGlobals->time )
	{
		if( GvMerciDieu_i == 1 )
		{
			if(( m_pSprite )&&( !m_pPlayer->GvPlayerTPT.bTire ))
			{
				UTIL_Remove( m_pSprite );
				m_pSprite = NULL;
			}
			EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_WEAPON, Gm_CROIX_FICHIER_SON_TIRE_FIN, 0.9, ATTN_NORM );
			GvMerciDieu_i = 2;
			GvTempsAnim_f = gpGlobals->time + 2.5;
			return;
		}
		else if( GvMerciDieu_i == 2 )
		{
			if(( m_pSprite )&&( !m_pPlayer->GvPlayerTPT.bTire ))
			{
				UTIL_Remove( m_pSprite );
				m_pSprite = NULL;
			}
			EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_WEAPON, Gm_CROIX_FICHIER_SON_APARTE, 0.9, ATTN_NORM );
			m_pPlayer->pev->punchangle.x -= 15;
			SendWeaponAnim( Ga_CROIX_ATTACK_FIN );
			GvTempsAnim_f = gpGlobals->time + 2.5;
			GvMerciDieu_i = 0;
			return;
		}

		if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		{
			int GvAnim_i;
			switch( RANDOM_LONG( 1,5 ))
			{
			case 1:	case 2:
				GvAnim_i = Ga_CROIX_IDLE_01;
				GvTempsAnim_f = gpGlobals->time + 10.0;
				break;
			case 3:
				GvAnim_i = Ga_CROIX_IDLE_02;
				GvTempsAnim_f = gpGlobals->time + 1.0;
				break;
			case 4:
				GvAnim_i = Ga_CROIX_IDLE_03;
				GvTempsAnim_f = gpGlobals->time + 1.25;
				break;
			case 5:
				GvAnim_i = Ga_CROIX_IDLE_04;
				GvTempsAnim_f = gpGlobals->time + 2.0;
				break;
			default:
				GvAnim_i = Ga_CROIX_IDLE_01;
				GvTempsAnim_f = gpGlobals->time + 2.0;
				break;
			}
			SendWeaponAnim( GvAnim_i );
		}
		else
		{
			m_pPlayer->pev->viewmodel = 0; 
			m_pPlayer->pev->weaponmodel = 0;
		}
	}
}

//////////////////////////////////////////////////////////////////////////

GcCroixRocket *GcCroixRocket::CreateRocket( CBasePlayer *pGvPlayer, Vector GvOrigin )
{
	GcCroixRocket *pRocket = GetClassPtr(( GcCroixRocket *)NULL );
	
	pRocket->pGvPlayer = pGvPlayer;
	if( pGvPlayer )
		pRocket->pev->owner = ENT( pGvPlayer->pev );

	UTIL_SetOrigin( pRocket->pev, GvOrigin );
	pRocket->pev->angles = Vector( 0,0,0 );
	pRocket->Spawn( );
	return pRocket;
}

void GcCroixRocket :: Spawn( void )
{
	Precache( );

	pev->classname = MAKE_STRING( "croix" );
	pev->movetype = MOVETYPE_NONE;
	pev->solid = SOLID_BBOX;
	pev->sequence = 1;
	pev->dmg = Gm_CROIX_DOMMAGE;

	SET_MODEL( ENT( pev ), Gm_CROIX_FICHIER_MODEL_R );
	EMIT_SOUND( ENT( pev ), CHAN_ITEM, Gf_SOUND_JEU_CAISSE_SPAWN_01, 0.75, ATTN_NORM );

	SetThink( GfThink );
	pev->nextthink = gpGlobals->time;

	GvTempsTire_f = gpGlobals->time + 2.5;
	GvTempsVie_f = gpGlobals->time + 5.0;
}

void GcCroixRocket :: Precache( void )
{
	GvTrail_i = PRECACHE_MODEL( Gm_CROIX_FICHIER_SPRITE_TRAINE );
}

void GcCroixRocket :: GfThink( void  )
{
	pev->movetype = MOVETYPE_NONE;
	pev->nextthink = gpGlobals->time + 0.05;
	pev->frame = ((int)pev->frame + 10 ) % 255;

	if(( GvTempsTire_f < gpGlobals->time )&& GvTempsTire_f )
	{
		GvTempsTire_f = 0;

		EMIT_SOUND( ENT( pev ), CHAN_WEAPON, Gm_CROIX_FICHIER_SON_ELEC, 0.9, ATTN_NORM );

		Vector GvOriginEntity = pev->origin;
		GvOriginEntity.z -= 250;

		MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
			WRITE_BYTE( TE_BEAMPOINTS);
			WRITE_COORD( pev->origin.x );
			WRITE_COORD( pev->origin.y );
			WRITE_COORD( pev->origin.z + 32 );
			WRITE_COORD( GvOriginEntity.x );
			WRITE_COORD( GvOriginEntity.y );
			WRITE_COORD( GvOriginEntity.z );
			WRITE_SHORT( GvTrail_i );
			WRITE_BYTE( 1 );					// framestart
			WRITE_BYTE( pev->framerate );		// framerate
			WRITE_BYTE( 25 );					// life
			WRITE_BYTE( 25 );					// width
			WRITE_BYTE( 50 );					// noise
			WRITE_BYTE( 192 );					// r
			WRITE_BYTE( 192 );					// g
			WRITE_BYTE( 255 );					// b
			WRITE_BYTE( 255 );					// brightness
			WRITE_BYTE( 10 );					// speed
		MESSAGE_END( );
	}
	
	if(( GvTempsVie_f > gpGlobals->time )&& !GvTempsTire_f )
	{
		Vector GvOriginEntity = pev->origin;
		GvOriginEntity.z -= 250;

		m_pEntity = NULL;
			
		bool GvExplose_b = false;
		while(( m_pEntity = UTIL_FindEntityInSphere( m_pEntity, GvOriginEntity, 50 )) !=NULL)
		{
			if(( FClassnameIs( m_pEntity->pev, "player" ))&&( m_pEntity->pev->health >= 0 ))
				m_pEntity->TakeDamage( VARS( eoNullEntity ), VARS( eoNullEntity ), Gm_CROIX_DOMMAGE, Gm_DMG_ECLAIR );

			if((( FClassnameIs( m_pEntity->pev, "item_caisse_arme" )) 
			||  ( FClassnameIs( m_pEntity->pev, "item_caisse_outil" )) 
			||  ( FClassnameIs( m_pEntity->pev, "item_caisse_vie" )) 
			||  ( FClassnameIs( m_pEntity->pev, "item_caisse_mega" ))
			||  ( FClassnameIs( m_pEntity->pev, "item_baril" ))
			||  ( FClassnameIs( m_pEntity->pev, "item_baril_bleu" ))
			||  ( FClassnameIs( m_pEntity->pev, "item_baril_rouge" ))
			||  ( FClassnameIs( m_pEntity->pev, "info_bananier" ))
			||  ( FClassnameIs( m_pEntity->pev, "info_sapin" )))
			&& m_pEntity )
				m_pEntity->GvNiveauVie_i -= Gm_CROIX_DOMMAGE;

			if(( m_pEntity->pev->health <= ( Gm_CROIX_DOMMAGE + 1 ))&&( m_pEntity->pev->health > 0 ))
				if( GvExplose_b == false )
				{
					ExplosionCreate( m_pEntity->pev->origin, pev->angles, m_pEntity->edict( ), 25, true );
					GvExplose_b = true;
				}
		}
	}
	
	if(( GvTempsVie_f + 2.5 ) < gpGlobals->time )
	{
		if( pGvPlayer )
			pGvPlayer->GvPlayerTPT.bAmmo = false;
		UTIL_Remove( this );
	}
}
#endif
