/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_croix.h				*
*		16012002				*
\*******************************/

#ifndef ARME_CROIX_H
#define ARME_CROIX_H

#include "define_slot.h"

#ifdef Gd_ARME_CROIX

#define Gm_CROIX_FICHIER_MODEL_P				"models/armes/p_croix.mdl"
#define Gm_CROIX_FICHIER_MODEL_R				"models/armes/r_croix.mdl"
#define Gm_CROIX_FICHIER_MODEL_V				"models/armes/v_croix.mdl"
#define Gm_CROIX_FICHIER_SON_TIRE_APPEL			"weapons/croix/croix1.wav"
#define Gm_CROIX_FICHIER_SON_TIRE_FIN			"weapons/croix/croix2.wav"
#define Gm_CROIX_FICHIER_SON_APARTE				"weapons/croix/croix3.wav"
#define Gm_CROIX_FICHIER_SON_ELEC				"weapons/croix/croix4.wav"
#define Gm_CROIX_FICHIER_SPRITE_TRAINE			"sprites/smoke.spr"
#define Gm_CROIX_FICHIER_SPRITE_CIBLE			"sprites/jeu/armes/croix1.spr"

#define Gm_CROIX_DOMMAGE						3
#define Gm_CROIX_MUNITION						1
#define Gm_CROIX_TEMPS_DEPLACEMENT				10

class GcCroix : public CBasePlayerWeapon
{
public:
	int GetItemInfo( ItemInfo *p );
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );

private:
	void GfTire( void );

	CSprite *m_pSprite;
	float GvTempsFDT_f;
	float GvTempsAnim_f;
	float GvTempsAttack_f;
	short GvMerciDieu_i;
	Vector GvOriginNuage_c;
};

class GcCroixRocket : public GcGrenadeGeneric
{
public:
	void Spawn( void );
	void Precache( void );
	static GcCroixRocket *CreateRocket( CBasePlayer *pGvPlayer, Vector GvOrigin );

private:
	void EXPORT GfThink( void );

	CBaseEntity *m_pEntity;
	float GvTempsVie_f;
	float GvTempsTire_f;
	int GvTrail_i;
};

enum
{
	Ga_CROIX_IDLE_01 = 0,
	Ga_CROIX_IDLE_02,
	Ga_CROIX_IDLE_03,
	Ga_CROIX_IDLE_04,
	Ga_CROIX_DRAW,
	Ga_CROIX_ATTACK_CALL,
	Ga_CROIX_ATTACK_WAIT,
	Ga_CROIX_ATTACK_FIN
};

#endif
#endif //ARME_CROIX_H