/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_dynamite.cpp			*
*		19022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "generic_arme.h"
#include "arme_dynamite.h"

#ifdef Gd_ARME_DYNAMITE

LINK_ENTITY_TO_CLASS( weapon_dynamite, GcDynamite );

int GcDynamite::GetItemInfo( ItemInfo *p )
{
	p->pszName = STRING( pev->classname );
	p->pszAmmo1 = "munition_dynamite";
	p->iMaxAmmo1 = Gm_MUNI_MAX;
	p->iSlot = Gm_DYNAMITE_SLOT;
	p->iPosition = Gm_DYNAMITE_POSITION;
	p->iId = m_iId = Gm_DYNAMITE_ID;
	p->iWeight = Gm_DYNAMITE_POID;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;
	return 1;
}

void GcDynamite::Spawn( void )
{
	Precache( );

	m_iId = Gm_DYNAMITE_ID;
	iGvAmmoDefault = Gm_DYNAMITE_MUNITION;

	GvTempsFDT_f = 0;

	FallInit( );
}

void GcDynamite::Precache( void )
{
	PRECACHE_MODEL( Gm_DYNAMITE_FICHIER_MODEL_P );
	PRECACHE_MODEL( Gm_DYNAMITE_FICHIER_MODEL_V );
	PRECACHE_MODEL( Gm_DYNAMITE_FICHIER_MODEL_W );
}

BOOL GcDynamite::Deploy( void )
{
	GvTempsAnim_f = gpGlobals->time + 2.0;
	return DefaultDeploy( Gm_DYNAMITE_FICHIER_MODEL_V, Gm_DYNAMITE_FICHIER_MODEL_P, Ga_DYNAMITE_AFFICHE, "dynamite" );
}

void GcDynamite::Holster( void )
{
	if( m_pSpot )
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		SendWeaponAnim( Ga_DYNAMITE_HOLSTER );
	else
	{
		//m_pPlayer->iGvArmes &= ~( 1<<Gm_DYNAMITE_ID );
		m_pPlayer->iGvArmes[Gm_DYNAMITE_SLOT] &= ~( 1<<Gm_DYNAMITE_POSITION );
		SetThink( DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}

	GfFinDeTour( &GvTempsFDT_f, 0 );
}

void GcDynamite::GfAttack1( void )
{
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		GfAttack0( );
		return;
	}

	if( GvTempsTire_f == 0 )
	{
		SendWeaponAnim( Ga_DYNAMITE_TIRE );
		m_pPlayer->SetAnimation( PLAYER_ATTACK1 );
		fGvAttack1 = gpGlobals->time + 0.5;
		GvTempsFDT_f = gpGlobals->time + 3.0;
		GvTempsTire_f = gpGlobals->time + 2.0;
	}

	fGvAttack1 = fGvAttack0 = gpGlobals->time + 0.02;
}

void GcDynamite::GfAttack2( void )
{
	GfAttack0( );
	fGvAttack2 = gpGlobals->time + 0.5;
}

void GcDynamite::GfTire( void )
{
	GfSonAttack( );

	if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		SendWeaponAnim( Ga_DYNAMITE_RELOAD );
	else
		SendWeaponAnim( Ga_DYNAMITE_TIRE_VIDE );
	GvTempsAnim_f = gpGlobals->time + 4.0;

	Vector GvOrigin_c = m_pPlayer->pev->origin + gpGlobals->v_forward * 20;

	GcGrenadeGeneric::GfDynamite( m_pPlayer, GvOrigin_c, Vector( 0,0,0 ), ( Gm_DYNAMITE_TEMPS_EXPLOSE + 0.75 ), GfDommage( Gm_DYNAMITE_DOMMAGE ));

	GvTempsTire_f = 0;	
	m_pPlayer->m_rgAmmo[iGvAmmoID]--;

	m_pPlayer->GvPlayerTPT.bAmmo = true;
	m_pPlayer->GvPlayerTPT.bTire = false;
	GvTempsFDT_f = gpGlobals->time;
}

void GcDynamite::GfAttack0( void )
{
	fGvAttack0 = gpGlobals->time + 1.0;
	GfFinDeTour( &GvTempsFDT_f, Gm_DYNAMITE_TEMPS_DEPLACEMENT );

	if( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE )
		UpdateSpot( );
	else if( m_pSpot &&!( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE ))
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( GvTempsTire_f &&( GvTempsTire_f < gpGlobals->time ))
		GfTire( );

	if( GvTempsAnim_f  &&( GvTempsAnim_f < gpGlobals->time ))
	{
		if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		{
			int GvAnim_i;
			switch( RANDOM_LONG( 1,2 ))
			{
			default:
			case 1:
				GvAnim_i = Ga_DYNAMITE_IDLE_02;
				GvTempsAnim_f = gpGlobals->time + 2.5;
				break;
			case 2:
				GvAnim_i = Ga_DYNAMITE_IDLE_01;
				GvTempsAnim_f = gpGlobals->time + 5;
				break;
			}
			SendWeaponAnim( GvAnim_i );
		}
		else
		{
			m_pPlayer->pev->viewmodel = 0; 
			m_pPlayer->pev->weaponmodel = 0;
		}
	}
}

#endif
