/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_dynamite.h				*
*		06122001				*
\*******************************/

#ifndef ARME_DYNAMITE_H
#define ARME_DYNAMITE_H

#include "define_slot.h"

#ifdef Gd_ARME_DYNAMITE

#define Gm_DYNAMITE_FICHIER_MODEL_P			"models/armes/p_dynamite.mdl"
#define Gm_DYNAMITE_FICHIER_MODEL_V			"models/armes/v_dynamite.mdl"
#define Gm_DYNAMITE_FICHIER_MODEL_W			"models/armes/w_dynamite.mdl"

#define Gm_DYNAMITE_DOMMAGE					100
#define Gm_DYNAMITE_MUNITION				1
#define Gm_DYNAMITE_TEMPS_DEPLACEMENT		5

#define Gm_DYNAMITE_GRAVITE					0.5
#define Gm_DYNAMITE_REBOND					0.5
#define Gm_DYNAMITE_TEMPS_EXPLOSE			5

class GcDynamite : public CBasePlayerWeapon
{
public:
	int GetItemInfo(ItemInfo *p);
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );

private:
	void GfTire( void );

	float GvTempsTire_f;
	float GvTempsFDT_f;
	float GvTempsAnim_f;
	short GvTempsExplose_i;
};

enum
{
	Ga_DYNAMITE_IDLE_01 = 0,
	Ga_DYNAMITE_TIRE,
	Ga_DYNAMITE_TIRE_VIDE,
	Ga_DYNAMITE_AFFICHE,
	Ga_DYNAMITE_IDLE_02,
	Ga_DYNAMITE_HOLSTER,
	Ga_DYNAMITE_RELOAD
};

#endif
#endif // ARME_DYNAMITE_H