/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_fusil.cpp				*
*		14122001				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "monsters.h"			// Pour la douille
#include "player.h"
#include "generic_arme.h"
#include "generic_balle.h"
#include "arme_fusil.h"
#include "game.h"
#include "shake.h"
#include "gamerules.h"

#ifdef Gd_ARME_FUSIL

LINK_ENTITY_TO_CLASS( weapon_fusil, GcFusil );

int GcFusil::GetItemInfo(ItemInfo *p)
{
	p->pszName = STRING(pev->classname);
	p->pszAmmo1 = "munition_fusil";
	p->iMaxAmmo1 = Gm_MUNI_MAX;
	p->iSlot = Gm_FUSIL_SLOT;
	p->iPosition = Gm_FUSIL_POSITION;
	p->iId = m_iId = Gm_FUSIL_ID;
	p->iWeight = Gm_FUSIL_POID;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;
	return 1;
}

void GcFusil::Spawn( void )
{
	Precache( );
	m_iId = Gm_FUSIL_ID;
	iGvAmmoDefault = Gm_FUSIL_MUNITION;

	GvTempsFDT_f = 0;
	GvTempsDouille_f = 0;
	GvNbTire_i = 0;
	GvPump_b = false;

	FallInit( );
}

void GcFusil::Precache( void )
{
	PRECACHE_MODEL( Gm_FUSIL_FICHIER_MODEL_P );
	PRECACHE_MODEL( Gm_FUSIL_FICHIER_MODEL_V );
	PRECACHE_MODEL( Gm_FUSIL_FICHIER_MODEL_R );
	GvShell_i = PRECACHE_MODEL( "models/shell.mdl" );
	PRECACHE_SOUND( Gm_FUSIL_FICHIER_SON_TIRE );
}

BOOL GcFusil::Deploy( void )
{
	GvTempsAnim_f = gpGlobals->time + 2.0;
	return DefaultDeploy( Gm_FUSIL_FICHIER_MODEL_V, Gm_FUSIL_FICHIER_MODEL_P, Ga_FUSIL_AFFICHE, "bazooka" );
}

void GcFusil::Holster( void )
{
	if( m_pSpot )
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		//m_pPlayer->iGvArmes &= ~( 1<<Gm_FUSIL_ID );
		m_pPlayer->iGvArmes[Gm_FUSIL_SLOT] &= ~( 1<<Gm_FUSIL_POSITION );
		SetThink( DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}

	if( GvNbTire_i )
		GvTempsFDT_f = gpGlobals->time;

	GfFinDeTour( &GvTempsFDT_f, 0 );
}

void GcFusil::GfAttack1( void )
{
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		GfAttack0( );
		return;
	}

	GfTire( );

	if( g_pGameRules->GvMortSubite )
		UTIL_ScreenFade( m_pPlayer, Vector( 255, 0, 0 ), 1, 0.5, 64, FFADE_OUT | FFADE_STAYOUT );
	else
		UTIL_ScreenFade( m_pPlayer, Vector( 1,1,1 ), 0.25, 0.25, 64, FFADE_IN );

	fGvAttack1 = fGvAttack0 = gpGlobals->time + 0.5;
}

void GcFusil::GfTire( void )
{
	// Groove - 18032002 - Animations
	SendWeaponAnim( Ga_FUSIL_TIRE );
	GvTempsAnim_f = gpGlobals->time + 1.0;
	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

	EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_ITEM, Gm_FUSIL_FICHIER_SON_TIRE, 0.7, ATTN_NORM );

	// Groove - 13022002 - flash en bout de canon
	m_pPlayer->m_iWeaponFlash = BRIGHT_GUN_FLASH;
	m_pPlayer->pev->effects = (int)( m_pPlayer->pev->effects ) | EF_MUZZLEFLASH;
	
	Vector GvMuzeOrigin_c = m_pPlayer->GetGunPosition( ) + gpGlobals->v_forward * 96 + gpGlobals->v_right * 20 + gpGlobals->v_up * -16;

	Vector GvOrigin_c = m_pPlayer->GetGunPosition( ) + gpGlobals->v_forward * 16;
	
	short GvTraineCouleur_18i[3][6] = 
	{
		{ 10,  1, 255, 128,   0, 192 },// Life, Width, r, v, b, brightness
		{ 20, 10, 255, 128,   0,  32 },// Life, Width, r, v, b, brightness
		{  0,  0,   0,   0,   0,   0 } // Life, Width, r, v, b, brightness
	};

	int GvBalleOption_i = Gm_BALLE_EXPLOSE | Gm_BALLE_BRIANTE | Gm_BALLE_FUMEE | Gm_BALLE_BRUIT_RICOCHE;

	GcGenericBalle::GfCreateBalle( GvOrigin_c,
								   m_pPlayer->pev->angles, 
								   Gm_FUSIL_PRECISION, 
								   Gm_FUSIL_BALLE_VITESSE,
								   Gm_FUSIL_DOMMAGE, 
								   0,					// Groove - 18032002 - Dure de vie de la balle si option active.
								   GvTraineCouleur_18i,
								   1,					// Groove - 18032002 - Nombre de trainees
								   GvBalleOption_i,		
								   m_pPlayer, 
								   this,
								   Gm_FUSIL_ID );

	m_pPlayer->GfSentirDommange( Gm_FUSIL_SENTIR_DOMMAGE, 0 );
	m_pPlayer->pev->punchangle.x -= Gm_FUSIL_RECUL;
	
	GvPump_b = true;

	GvNbTire_i++;
	if( GvNbTire_i >= Gm_FUSIL_NB_TIRE )
	{
		if( GvQSmokeCMD_i )
		{
			int GvSprite_i = PRECACHE_MODEL( Gm_BALLE_FUMEE_1 );
				
			MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, pev->origin );
				WRITE_BYTE( TE_SMOKE );
				WRITE_COORD( GvMuzeOrigin_c.x );
				WRITE_COORD( GvMuzeOrigin_c.y );
				WRITE_COORD( GvMuzeOrigin_c.z );
				WRITE_SHORT( GvSprite_i );
				WRITE_BYTE( 10 );
				WRITE_BYTE( 12  );
			MESSAGE_END( );
		}

		GvNbTire_i = 0;
		m_pPlayer->m_rgAmmo[iGvAmmoID]--;
		
		m_pPlayer->GvPlayerTPT.bAmmo = true;
		m_pPlayer->GvPlayerTPT.bTire = false;
		GvTempsFDT_f = gpGlobals->time;
	}
}

void GcFusil::GfAttack2( void )
{
	GfAttack0( );
	fGvAttack2 = gpGlobals->time + 0.5;
}

void GcFusil::GfAttack0( void )
{
	fGvAttack0 = gpGlobals->time + 1.0;
	GfFinDeTour( &GvTempsFDT_f, Gm_FUSIL_TEMPS_DEPLACEMENT );
	
	if( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE )
		UpdateSpot( );
	else if( m_pSpot &&!( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE ))
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( !m_pPlayer->GvPlayerTPT.bTire && GvNbTire_i )
	{
		GvNbTire_i = 0;
		m_pPlayer->m_rgAmmo[iGvAmmoID]--;
	}

	if( GvTempsDouille_f &&( GvTempsDouille_f < gpGlobals->time )&& GvQDouilleCMD_i )
	{
		GvTempsDouille_f = 0;
		Vector GvOrigin_c  = pev->origin + m_pPlayer->pev->view_ofs
							+ gpGlobals->v_up * -32
							+ gpGlobals->v_forward * 24
							+ gpGlobals->v_right * 24;
		
		Vector GvVelocity_c = m_pPlayer->pev->velocity 
							+ gpGlobals->v_right * -RANDOM_FLOAT( 64,96 ) 
							+ gpGlobals->v_up * RANDOM_FLOAT( 160,240) 
							+ gpGlobals->v_forward * RANDOM_FLOAT( 48,96 );

		EjectBrass ( GvOrigin_c, GvVelocity_c, pev->angles.y, GvShell_i, TE_BOUNCE_SHELL); 
	}

	if( GvTempsAnim_f &&( GvTempsAnim_f < gpGlobals->time ))
	{
		if( GvPump_b == true )
		{
			GvPump_b = false;
			GvTempsAnim_f = gpGlobals->time + 1.0;
			GvTempsDouille_f = gpGlobals->time + 0.75;
			SendWeaponAnim( Ga_FUSIL_RECHARGE );
		}
		else if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		{
			GvTempsAnim_f = gpGlobals->time + 2.0;
			SendWeaponAnim( Ga_FUSIL_ATTENTE );
		}
		else
		{
			m_pPlayer->pev->viewmodel = 0; 
			m_pPlayer->pev->weaponmodel = 0;
		}
	}
}

#endif