/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_fusil.h				*
*		14122001				*
\*******************************/

#ifndef ARME_FUSIL_H
#define ARME_FUSIL_H

#include "define_slot.h"

#ifdef Gd_ARME_FUSIL

#define Gm_FUSIL_FICHIER_MODEL_P		"models/armes/p_fusil.mdl"
#define Gm_FUSIL_FICHIER_MODEL_V		"models/armes/v_fusil.mdl"
#define Gm_FUSIL_FICHIER_SON_TIRE		"weapons/fusil/fusil1.wav"

#define Gm_FUSIL_DOMMAGE				25
#define Gm_FUSIL_MUNITION				4
#define Gm_FUSIL_TEMPS_DEPLACEMENT		3

#define Gm_FUSIL_BALLE_VITESSE			2000
#define Gm_FUSIL_NB_TIRE				2
#define Gm_FUSIL_PRECISION				50
#define Gm_FUSIL_RECUL					15
#define Gm_FUSIL_SENTIR_DOMMAGE			3

class GcFusil : public CBasePlayerWeapon
{
public:
	int GetItemInfo( ItemInfo *p );
	BOOL Deploy( void );
	void Holster( void );
	void Spawn( void );
	void Precache( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );	

private:
	void GfTire( void );
	
	short GvNbTire_i;
	float GvTempsAnim_f;
	float GvTempsFDT_f;
	float GvTempsDouille_f;
	bool GvPump_b;
	int GvShell_i;
};

enum
{
	Ga_FUSIL_ATTENTE = 0,
	Ga_FUSIL_TIRE,
	Ga_FUSIL_RECHARGE,
	Ga_FUSIL_AFFICHE
};

#endif
#endif // ARME_FUSIL_H