/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_grappin.cpp			*
*		19022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "shake.h"
#include "customentity.h"
#include "fx_beam.h"
#include "generic_arme.h"
#include "generic_balle.h"
#include "arme_grappin.h"
#include "game.h"
#include "gamerules.h"

#ifdef Gd_ARME_GRAPPIN

LINK_ENTITY_TO_CLASS( weapon_grappin, GcGrappin );

int GcGrappin::GetItemInfo( ItemInfo *p )
{
	p->pszName = STRING( pev->classname );
	p->pszAmmo1 = "munition_grappin";
	p->iMaxAmmo1 = Gm_MUNI_MAX;
	p->iSlot = Gm_GRAPPIN_SLOT;
	p->iPosition = Gm_GRAPPIN_POSITION;
	p->iId = m_iId = Gm_GRAPPIN_ID;
	p->iWeight = Gm_GRAPPIN_POID;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;
	return 1;
}

void GcGrappin::Spawn( void )
{
	Precache( );
	m_iId = Gm_GRAPPIN_ID;
	iGvAmmoDefault = Gm_GRAPPIN_MUNITION;

	GvTempsFDT_f = 0;
	GvNbTire_i = 0;
	GvTempsTire_f = 0;
	GvPosition_c = Vector( 0,0,0 );

	FallInit( );
}

void GcGrappin::Precache( void )
{
	PRECACHE_MODEL( Gm_GRAPPIN_FICHIER_MODEL_P );
	PRECACHE_MODEL( Gm_GRAPPIN_FICHIER_MODEL_V );
	PRECACHE_MODEL( Gm_GRAPPIN_FICHIER_MODEL_R );
	PRECACHE_MODEL( Gm_GRAPPIN_SPRITE );
	PRECACHE_SOUND( Gm_GRAPPIN_FICHIER_SON_TIRE );
}

BOOL GcGrappin::Deploy( void )
{
	pBalle = NULL;
	GvTempsAnim_f = gpGlobals->time + 2.0;
	return DefaultDeploy( Gm_GRAPPIN_FICHIER_MODEL_V, Gm_GRAPPIN_FICHIER_MODEL_P, Ga_GRAPPIN_DRAW, "grappin" );
}

void GcGrappin::Holster( void )
{
	if( m_pSpot )
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		m_pPlayer->iGvArmes[Gm_GRAPPIN_SLOT] &= ~( 1<<Gm_GRAPPIN_POSITION );
		SetThink( DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}

	// '0' Si l'on change d'arme la fin de tour ce fait directement.
//	GvTempsFDT_f = GfFinDeTour( GvTempsFDT_f, 0, Gm_ARME_PUISSANCE_PROGRESSIVE );
}

void GcGrappin::GfAttack1( void )
{
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		GfAttack0( );
		return;
	}

	if( GvTempsTire_f == 0 )
	{
		SendWeaponAnim( Ga_GRAPPIN_TIRE );
		GvTempsTire_f = gpGlobals->time + 0.25;
	}
	else if(( GvTempsTire_f < gpGlobals->time )&&( GvNbTire_i == 0 ))
	{
		GfTire1( );
		GvTempsCorde_f = gpGlobals->time + 2.5;
		SendWeaponAnim( Ga_GRAPPIN_TIRE_DEROULE );

		if( g_pGameRules->GvMortSubite )
			UTIL_ScreenFade( m_pPlayer, Vector( 255, 0, 0 ), 1, 0.5, 64, FFADE_OUT | FFADE_STAYOUT );
		else
			UTIL_ScreenFade( m_pPlayer, Vector( 1,1,1 ), 0.25, 0.25, 64, FFADE_IN );
	}
	else if( GvNbTire_i > 0 )
	{
		if( pBalle != NULL )
			UpdateEffect( m_pPlayer->GetGunPosition( ), pBalle->pev->origin, 0.01 );
		else
			DestroyEffect( );

		if( GvPosition_c != Vector( 0,0,0 ))
		{
			GfTire2( );
			Vector GvDistance_c = ( m_pPlayer->GetGunPosition( ) - pBalle->pev->origin );
			if( GfUtilLongueur_c( GvDistance_c ) < 96 )
				DestroyEffect( );
		}
		else
		{
			if( GvTempsCorde_f < gpGlobals->time )
				DestroyEffect( );
		}
	}

	fGvAttack1 = fGvAttack0 = gpGlobals->time + 0.02;
}

void GcGrappin::GfTire1( void )
{
	EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_ITEM, Gm_GRAPPIN_FICHIER_SON_TIRE, 0.7, ATTN_NORM );

	m_pPlayer->m_iWeaponFlash = BRIGHT_GUN_FLASH;
	m_pPlayer->pev->effects = (int)(m_pPlayer->pev->effects) | EF_MUZZLEFLASH;
	
	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

	Vector GvOrigin_c = m_pPlayer->GetGunPosition( );// + gpGlobals->v_forward * 16;

	short GvTraineCouleur_18i[3][6] = 
	{
		{ 50,  1, 128, 128, 128, 255 },// Life, Width, r, v, b, brightness
		{  0,  0,   0,   0,   0,   0 },// Life, Width, r, v, b, brightness
		{  0,  0,   0,   0,   0,   0 } // Life, Width, r, v, b, brightness
	};

	int GvBalleOption_i = Gm_BALLE_AUTO_DESTRUCTION | Gm_BALLE_BRIANTE | Gm_BALLE_ALLREADY_LIFE | Gm_BALLE_FUMEE | Gm_BALLE_BRUIT_RICOCHE;

	pBalle = GcGenericBalle::GfCreateBalle( GvOrigin_c,
											m_pPlayer->pev->angles, 
											0,
											Gm_GRAPPIN_BALLE_VITESSE,
											1, 
											2.5,				// Duree de vie de la balle si option active.
											GvTraineCouleur_18i,
											0,				// Nombre de trainees
											GvBalleOption_i,
											m_pPlayer, 
											this,
											Gm_GRAPPIN_ID );
	
	UpdateEffect( pBalle->pev->origin, pBalle->pev->origin, 0.01 );

	GvTempsCorde_f = gpGlobals->time + 4.0;
	m_pPlayer->m_rgAmmo[iGvAmmoID]--;
	GvNbTire_i++;
}

void GcGrappin::GfTire2( void )
{
	if( GvCorde_b == false )
	{
		GvCorde_b = true;
		SendWeaponAnim( Ga_GRAPPIN_TIRE_ENROULE );
	}
	m_pPlayer->pev->movetype = MOVETYPE_FLY;
	m_pPlayer->pev->velocity = ( GvPosition_c - m_pPlayer->pev->origin ) + gpGlobals->v_forward * 100;
}

void GcGrappin::UpdateEffect( const Vector &startPoint, const Vector &endPoint, float timeBlend )
{
	if( !m_pBeam )
		CreateEffect( );

	m_pBeam->SetStartPos( endPoint );
	m_pBeam->SetScrollRate( 25 );
	m_pBeam->SetBrightness( 255 );
	m_pBeam->SetWidth( 5 );
	m_pBeam->SetColor( 255, 255, 255 );
}

void GcGrappin::CreateEffect( void )
{
	DestroyEffect( );

	m_pBeam = CBeam::BeamCreate( Gm_GRAPPIN_SPRITE, 10 );
	m_pBeam->PointEntInit( m_pPlayer->GetGunPosition( ), m_pPlayer->entindex() );
	m_pBeam->SetFlags( BEAM_FSINE );
	m_pBeam->SetEndAttachment( 1 );
	m_pBeam->pev->spawnflags |= SF_BEAM_TEMPORARY;	// Flag these to be destroyed on save/restore or level transition
}

void GcGrappin::DestroyEffect( void )
{
	if ( m_pBeam )
	{
		UTIL_Remove( m_pBeam );
		m_pBeam = NULL;
	}
}

void GcGrappin::GfAttack2( void )
{
	GfAttack0( );
	fGvAttack2 = gpGlobals->time + 0.5;
}

void GcGrappin::GfAttack0( void )
{
	fGvAttack0 = gpGlobals->time + 1.0;
//	GvTempsFDT_f = GfFinDeTour( GvTempsFDT_f, Gm_GRAPPIN_TEMPS_DEPLACEMENT, Gm_ARME_NORMAL );

	if( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE )
		UpdateSpot( );
	else if(( m_pSpot )&&!( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE ))
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}
	
	if( GvNbTire_i )
	{
		DestroyEffect( );
		UTIL_Remove( pBalle );
		pBalle = NULL;
		GvNbTire_i = 0;
		GvTempsTire_f = 0;
		GvCorde_b = false;

		GvPosition_c = Vector( 0,0,0 );
		SendWeaponAnim( Ga_GRAPPIN_IDLE_PREPARE );
		m_pPlayer->pev->movetype = MOVETYPE_WALK;
	}
	
	if( GvTempsAnim_f &&( GvTempsAnim_f < gpGlobals->time ))
	{
		if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		{
			int GvAnim_i;
			switch( RANDOM_LONG( 1,2 ))
			{
			default:
			case 1:
				GvAnim_i = Ga_GRAPPIN_IDLE_01;
				GvTempsAnim_f = gpGlobals->time + 6.0;
				break;
			case 2:
				GvAnim_i = Ga_GRAPPIN_IDLE_02;
				GvTempsAnim_f = gpGlobals->time + 2.0;
				break;
			}
			SendWeaponAnim( GvAnim_i );
		}
		else
		{
			m_pPlayer->pev->viewmodel = 0; 
			m_pPlayer->pev->weaponmodel = 0;
		}
	}
}

#endif