/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_grappin.h				*
*		30012002				*
\*******************************/

#ifndef ARME_GRAPPIN_H
#define ARME_GRAPPIN_H

#include "define_slot.h"

#ifdef Gd_ARME_GRAPPIN

#define Gm_GRAPPIN_FICHIER_MODEL_P			"models/armes/p_grappin.mdl"
#define Gm_GRAPPIN_FICHIER_MODEL_R			"models/armes/r_grappin.mdl"
#define Gm_GRAPPIN_FICHIER_MODEL_V			"models/armes/v_grappin.mdl"
#define Gm_GRAPPIN_FICHIER_SON_TIRE			"weapons/fusil/fusil1.wav"
#define Gm_GRAPPIN_SPRITE					"sprites/xbeam5.spr"

#define Gm_GRAPPIN_DOMMAGE					0
#define Gm_GRAPPIN_MUNITION					5
#define Gm_GRAPPIN_TEMPS_DEPLACEMENT		-1	// Groove - 02052002 - Temps de dplacmeent infini

#define Gm_GRAPPIN_BALLE_VITESSE			500

class GcGrappin : public CBasePlayerWeapon
{
public:
	int GetItemInfo(ItemInfo *p);
	BOOL Deploy( void );
	void Holster( void );
	void Spawn( void );
	void Precache( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );	

private:
	void GfTire1( void );
	void GfTire2( void );
	void UpdateEffect( const Vector &startPoint, const Vector &endPoint, float timeBlend );
	void CreateEffect( void );
	void DestroyEffect( void );

	GcGenericBalle *pBalle;
	CBeam *m_pBeam;

	short GvNbTire_i;
	float GvTempsTire_f;
	float GvTempsAnim_f;
	float GvTempsFDT_f;
	float GvTempsCorde_f;
	bool GvCorde_b;
};

enum
{
	Ga_GRAPPIN_DRAW = 0,
	Ga_GRAPPIN_IDLE_01,
	Ga_GRAPPIN_IDLE_02,
	Ga_GRAPPIN_TIRE,
	Ga_GRAPPIN_TIRE_DEROULE,
	Ga_GRAPPIN_TIRE_ENROULE,
	Ga_GRAPPIN_IDLE_PREPARE
};

#endif
#endif // ARME_GRAPPIN_H