/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_grenade.cpp			*
*		19022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "generic_arme.h"
#include "arme_grenade.h"
#include "gamerules.h"

#ifdef Gd_ARME_GRENADE

LINK_ENTITY_TO_CLASS( weapon_grenade, GcGrenade );

int GcGrenade::GetItemInfo( ItemInfo *p )
{
	p->pszName = STRING( pev->classname );
	p->pszAmmo1 = "munition_grenade";
	p->iMaxAmmo1 = Gm_MUNI_MAX;
	p->iSlot = Gm_GRENADE_SLOT;
	p->iPosition = Gm_GRENADE_POSITION;
	p->iId = m_iId = Gm_GRENADE_ID;
	p->iWeight = Gm_GRENADE_POID;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;
	return 1;
}

void GcGrenade::Spawn( void )
{
	Precache( );

	m_iId = Gm_GRENADE_ID;
	iGvAmmoDefault = Gm_GRENADE_MUNITION;

	GvTempsPuis_f = 0;
	GvTempsFDT_f = 0;
	GvTempsExplose_i = 3;

	FallInit( ); 	// Groove - 20122001 - Pour que le Worm conserve l'arme
}

void GcGrenade::Precache( void )
{
	PRECACHE_MODEL( Gm_GRENADE_FICHIER_MODEL_P );
	PRECACHE_MODEL( Gm_GRENADE_FICHIER_MODEL_V );
	PRECACHE_MODEL( Gm_GRENADE_FICHIER_MODEL_W );
}

BOOL GcGrenade::Deploy( void )
{
	GvTempsAnim_f = gpGlobals->time + 2.0;
	return DefaultDeploy( Gm_GRENADE_FICHIER_MODEL_V, Gm_GRENADE_FICHIER_MODEL_P, Ga_GRENADE_AFFICHE, "grenade" );
}

void GcGrenade::Holster( void )
{
	if( m_pSpot )
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		//m_pPlayer->iGvArmes &= ~( 1<<Gm_GRENADE_ID );
		m_pPlayer->iGvArmes[Gm_GRENADE_SLOT] &= ~( 1<<Gm_GRENADE_POSITION );
		SetThink( DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}

	// '0' Si l'on change d'arme la fin de tour ce fait directement.
	GfFinDeTour( &GvTempsFDT_f, 0 );
}

void GcGrenade::GfAttack1( void )
{
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		GfAttack0( );
		return;
	}

	if( !GvTempsPuis_f )
	{
		SendWeaponAnim( Ga_GRENADE_TIRE_PREPARE );
		GvTempsPuis_f = gpGlobals->time;
		GfSonPuissanceOn();
	}

	if( GfPuissanceProgressive( GvTempsPuis_f ))
		GfTire( Gm_ARME_TEMPS_TIRE_MAX );

	fGvAttack1 = fGvAttack0 = gpGlobals->time + 0.02;
}

void GcGrenade::GfTire( float fGvTempsTire )
{
	GfPuissanceAffichage( WEAPON_PUISS_PROG_OFF, Gm_WORM_DEFAUT );
	GfSonAttack( );

	SendWeaponAnim( Ga_GRENADE_TIRE );
	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

	Vector GvAngle = m_pPlayer->pev->v_angle + m_pPlayer->pev->punchangle;

	if( GvAngle.x < 0 )
		GvAngle.x = -10 + GvAngle.x * ((90 - 10) / 90.0);
	else
		GvAngle.x = -10 + GvAngle.x * ((90 + 10) / 90.0);

	float GvVelocity_f = (90 - GvAngle.x) * 4;
	if( GvVelocity_f > 500 )
		GvVelocity_f = 500;

	UTIL_MakeVectors( GvAngle );

	Vector GvOrigin = m_pPlayer->GetGunPosition( ) + gpGlobals->v_forward * 16;
	Vector GvVelocity = gpGlobals->v_forward * (( GvVelocity_f / Gm_GRENADE_COEF_TIRE ) * static_cast<int>( fGvTempsTire * 100 )) + m_pPlayer->pev->velocity;
	GvVelocity += g_pGameRules->GvVent;

	GcGrenadeGeneric::GfGrenade( m_pPlayer, GvOrigin, GvVelocity, GvTempsExplose_i, GfDommage( Gm_GRENADE_DOMMAGE ));

	m_pPlayer->m_rgAmmo[iGvAmmoID]--;
	GvTempsAnim_f = gpGlobals->time + 3.0;
	GvTempsPuis_f = 0;

	m_pPlayer->GvPlayerTPT.bAmmo = true;
	m_pPlayer->GvPlayerTPT.bTire = false;
	GvTempsFDT_f = gpGlobals->time;
}

void GcGrenade::GfAttack2( void )
{
	if( GvTempsPuis_f != 0 )
		GfTire( gpGlobals->time - GvTempsPuis_f );

	if(( GvTempsChange_f < gpGlobals->time  )|| !GvTempsChange_f )
	{
		if( GvTempsExplose_i >= 5 )
			GvTempsExplose_i = 1;
		else
			GvTempsExplose_i++;

		int GvMsgHUD;
		switch( GvTempsExplose_i )
		{
		case 1:
			GvMsgHUD = Gm_MSG_ARME_GRENADE_TEMPS_1;
			break;
		case 2:
			GvMsgHUD = Gm_MSG_ARME_GRENADE_TEMPS_2;
			break;
		default:
		case 3:
			GvMsgHUD = Gm_MSG_ARME_GRENADE_TEMPS_3;
			break;
		case 4:
			GvMsgHUD = Gm_MSG_ARME_GRENADE_TEMPS_4;
			break;
		case 5:
			GvMsgHUD = Gm_MSG_ARME_GRENADE_TEMPS_5;
			break;
		}

		MESSAGE_BEGIN( MSG_ONE, gmsgBarreMsg, NULL, m_pPlayer->pev );
			WRITE_BYTE( GvMsgHUD );
		MESSAGE_END( );

		SendWeaponAnim( Ga_GRENADE_CHANGE_TEMPS );
		GvTempsChange_f = gpGlobals->time + 0.9;
	}
}

void GcGrenade::GfAttack0( void )
{
	fGvAttack0 = gpGlobals->time + 1.0;
	GfFinDeTour( &GvTempsFDT_f, Gm_GRENADE_TEMPS_DEPLACEMENT );	

	if( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE )
		UpdateSpot( );
	else if( m_pSpot &&!( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE ))
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( GvTempsPuis_f )
	{
		if(( gpGlobals->time - GvTempsPuis_f ) < 0.2 )
			GfMsgStupide( m_pPlayer );
		
		if( !m_pPlayer->IsAlive( ))
			GvTempsPuis_f = 0.0;
		else 
			GfTire( gpGlobals->time - GvTempsPuis_f );
	}

	if( GvTempsAnim_f &&( GvTempsAnim_f < gpGlobals->time ))
	{
		if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		{
			SendWeaponAnim( Ga_GRENADE_AFFICHE );
			GvTempsAnim_f = gpGlobals->time + 100.0;
		}
		else
		{
			m_pPlayer->pev->viewmodel = 0; 
			m_pPlayer->pev->weaponmodel = 0;
		}
	}
}

#endif