/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_grenade.h				*
*		06122001				*
\*******************************/

#ifndef ARME_GRENADE_H
#define ARME_GRENADE_H

#include "define_slot.h"

#ifdef Gd_ARME_GRENADE

#define Gm_GRENADE_FICHIER_MODEL_P		"models/armes/p_grenade.mdl"
#define Gm_GRENADE_FICHIER_MODEL_V		"models/armes/v_grenade.mdl"
#define Gm_GRENADE_FICHIER_MODEL_W		"models/armes/w_grenade.mdl"

#define Gm_GRENADE_DOMMAGE				75
#define Gm_GRENADE_MUNITION				10
#define Gm_GRENADE_TEMPS_DEPLACEMENT	0

#define Gm_GRENADE_COEF_TIRE			75 // Plus le nb et petit plus la grenade est puissante
#define Gm_GRENADE_GRAVITE				0.6
#define Gm_GRENADE_REBOND				0.75

class GcGrenade : public CBasePlayerWeapon
{
public:
	int GetItemInfo( ItemInfo *p );
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );

private:
	void GfTire( float GvTirePuis_f );

	float GvTempsPuis_f;
	float GvTempsFDT_f;
	float GvTempsAnim_f;
	float GvTempsChange_f;
	short GvTempsExplose_i;
};

enum GeGrenade
{
	Ga_GRENADE_ATTENTE1 = 0,
	Ga_GRENADE_ATTENTE2,
	Ga_GRENADE_TIRE,
	Ga_GRENADE_TIRE_PREPARE,
	Ga_GRENADE_TIRE_ATTENTE,
	Ga_GRENADE_CHANGE_TEMPS,
	Ga_GRENADE_AFFICHE
};

#endif
#endif //Gd_P_ARME_GRENADE