/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_hache.cpp				*
*		07112001				*
\*******************************/

#ifndef ARME_HACHE_H
#define ARME_HACHE_H

#include "define_slot.h"

#ifdef Gd_ARME_HACHE

#define Gm_HACHE_FICHIER_MODEL_P			"models/armes/p_hache.mdl"
#define Gm_HACHE_FICHIER_MODEL_V			"models/armes/v_hache.mdl"
#define Gm_HACHE_FICHIER_SON_HIT_01			"weapons/hache/hache1.wav"
#define Gm_HACHE_FICHIER_SON_HIT_02			"weapons/hache/hache2.wav"
#define Gm_HACHE_FICHIER_SON_HIT_CORPS_01	"weapons/hache/hache3.wav"
#define Gm_HACHE_FICHIER_SON_MANQUER		"weapons/hache/hache4.wav"
#define Gm_HACHE_FICHIER_SON_DEDLOY			"weapons/hache/hache5.wav"

#define Gm_HACHE_DOMMAGE					25
#define Gm_HACHE_MUNITION					2
#define Gm_HACHE_TEMPS_DEPLACEMENT			5.0

#define Gm_HACHE_COUPE_VIE_PAR				2	// Divise la vie par la valeur donne la vie du joueur touch.
#define	Gm_VOLUME_SON_CONTACT_CORP			128
#define	Gm_VOLUME_SON_CONTACT_MUR			512

class GcHache : public CBasePlayerWeapon
{
public:
	int GetItemInfo( ItemInfo *p );
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );

	int m_iSwing;
	TraceResult m_trHit;

private:
	void GvTire( void );

	float GvTempsFDT_f;
	float GvTempsAnim_f;
};

enum
{
	Ga_HACHE_DRAW = 0,
	Ga_HACHE_IDLE_01,
	Ga_HACHE_IDLE_02,
	Ga_HACHE_IDLE_03,
	Ga_HACHE_ATTACK
};

#endif
#endif // ARME_HACHE_H