/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_jetpack.cpp			*
*		19022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "generic_arme.h"
#include "gamerules.h"
#include "arme_jetpack.h"

#ifdef Gd_ARME_JETPACK

LINK_ENTITY_TO_CLASS( weapon_jetpack, GcJetpack );

int GcJetpack::GetItemInfo( ItemInfo *p )
{
	p->pszName = STRING( pev->classname );
	p->pszAmmo1 = "munition_jetpack";
	p->iMaxAmmo1 = Gm_MUNI_MAX;
	p->iSlot = Gm_JETPACK_SLOT;
	p->iPosition = Gm_JETPACK_POSITION;
	p->iId = m_iId = Gm_JETPACK_ID;
	p->iWeight = Gm_JETPACK_POID;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;
	return 1;
}

void GcJetpack::Spawn( void )
{
	Precache( );

	m_iId = Gm_JETPACK_ID;
	iGvAmmoDefault = Gm_JETPACK_MUNITION;

	GvTempsFDT_f = 0;
	
	FallInit( );
}

void GcJetpack::Precache( void )
{
	PRECACHE_MODEL( Gm_JETPACK_FICHIER_MODEL_V );
	PRECACHE_MODEL( Gm_JETPACK_FICHIER_MODEL_P );
	PRECACHE_MODEL( Gm_JETPACK_BEAM_SPRITE );
	PRECACHE_MODEL( Gm_JETPACK_FLARE_SPRITE );

	PRECACHE_SOUND( Gm_JETPACK_SOUND_OFF );
	PRECACHE_SOUND( Gm_JETPACK_SOUND_RUN );
	PRECACHE_SOUND( Gm_JETPACK_SOUND_STARTUP );

	PRECACHE_MODEL( "sprites/smoke.spr" );
}

BOOL GcJetpack::Deploy( void )
{
	GvTempsAnim_f = gpGlobals->time + 2.0;
	return DefaultDeploy( Gm_JETPACK_FICHIER_MODEL_V, Gm_JETPACK_FICHIER_MODEL_P, Ga_JETPACK_DRAW, "jetpack" );
}

void GcJetpack::Holster( void )
{
	if( m_pSpot )
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		m_pPlayer->iGvArmes[Gm_JETPACK_SLOT] &= ~( 1<<Gm_JETPACK_POSITION );
		SetThink( DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}

	//GfFinDeTour( &GvTempsFDT_f, 0 );
}

void GcJetpack::GfStopSon( void )
{
	STOP_SOUND( ENT( m_pPlayer->pev ), CHAN_WEAPON/*CHAN_STATIC*/, Gm_JETPACK_SOUND_RUN );
	STOP_SOUND( ENT( m_pPlayer->pev ), CHAN_WEAPON, Gm_JETPACK_SOUND_STARTUP );
}

void GcJetpack::GfAttack1( void )
{
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		GfStopSon( );
		GfAttack0( );
		return;
	}
	else
	{
		GfMarche_i( Gm_JETPACK_VITESSE_1 );
	}
}

void GcJetpack::GfAttack2( void )
{
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		GfStopSon( );
		GfAttack0( );
		return;
	}
	else
		GfMarche_i( Gm_JETPACK_VITESSE_2 );
	fGvAttack2 = gpGlobals->time + 0.5;
}

void GcJetpack::GfMarche_i( int GvVitesse_i )
{
	// Groove, Jetpack au demarrage.
	if( GvDemarrage_b )
	{
		if( GvSonDebut_b )
		{
			SendWeaponAnim( Ga_JETPACK_TIRE );
			EMIT_SOUND_DYN( ENT( m_pPlayer->pev ), CHAN_WEAPON, Gm_JETPACK_SOUND_STARTUP, 0.9, ATTN_NORM, 0, 100 );
			GvSonDebut_b = false;
		}
		GvDirectionD_i += 5;
		GvDirectionR_f = GfUtilDegRad_f( GvDirectionD_i );
		GvVitesseCos_f = sqrtl( powl(( GvVitesse_i * cosl( GvDirectionR_f ) + 1 ),2 ));
		GvVitesseSin_f = sqrtl( powl(( GvVitesse_i * sinl( GvDirectionR_f ) + 1 ),2 ));
		if( GvDirectionD_i >= 90 )
		{
			GvDemarrage_b = false;
			GvSonDebut_b = true;
		}
		if(( GvVitesseSin_f <= 0 )||( GvVitesseSin_f >= 255 ))
		{
			GvVitesseSin_f = 200;
		}
	}
	// Groove, Jetpack en fonctionnement normal.
	else
	{
		if( GvSonDebut_b )
		{
			GfStopSon( );
			EMIT_SOUND_DYN( ENT( m_pPlayer->pev ), CHAN_WEAPON, Gm_JETPACK_SOUND_RUN, 0.9, ATTN_NORM, 0, 100 );
			GvSonDebut_b = false;
		}
		GvVitesseCos_f = Gm_JETPACK_VITESSE_HAUT;
		GvVitesseSin_f = GvVitesse_i;
	}
// Groove Consomation
	if( GvRegulConso_i >= ( ceil(( Gm_JETPACK_VITESSE_2 * 3/2 - GvVitesse_i ) * Gm_JETPACK_CONSO_REGUL ))) //Conso proporcionnel a la vitesse
	{
		m_pPlayer->m_rgAmmo[iGvAmmoID]--;
		GvRegulConso_i = 0;
	}
	else
	{
		GvRegulConso_i++;
	}

	fGvAttack2 = fGvAttack1 = gpGlobals->time + 0.1;

	// Groove vitesse en x et z
	m_pPlayer->pev->velocity = gpGlobals->v_forward * GvVitesseSin_f;
	m_pPlayer->pev->velocity.z += GvVitesseCos_f;

	GvTempsAnim_f = gpGlobals->time + 2.0;
}

void GcJetpack::GfAttack0( void )
{
	fGvAttack0 = gpGlobals->time + 1.0;
//	GvTempsFDT_f = GfFinDeTour_3p( GvTempsFDT_f, Gm_JETPACK_TEMPS_DEPLACEMENT, Gm_ARME_PUISSANCE_PROGRESSIVE );

	if( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE )
		UpdateSpot( );
	else if(( m_pSpot )&&!( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE ))
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	GfStopSon( );

	GvDirectionD_i = 0;
	GvDemarrage_b = true;
	GvSonDebut_b = true;

	if( GvTempsAnim_f &&( GvTempsAnim_f < gpGlobals->time ))
	{
		if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		{
			int GvAnim_i;
			switch( RANDOM_LONG( 1,2 ))
			{
			case 1:
				GvAnim_i = Ga_JETPACK_IDLE_01;
				GvTempsAnim_f = gpGlobals->time + 2.0;
				break;
			case 2:
				GvAnim_i = Ga_JETPACK_IDLE_02;
				GvTempsAnim_f = gpGlobals->time + 2.0;
				break;
			default:
				GvAnim_i = Ga_JETPACK_IDLE_01;
				GvTempsAnim_f = gpGlobals->time + 2.0;
				break;
			}
			SendWeaponAnim( GvAnim_i );
		}
		else
		{
			m_pPlayer->pev->viewmodel = 0; 
			m_pPlayer->pev->weaponmodel = 0;
		}
	}
}

#endif
