/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_jetpack.h				*
*		18122001				*
\*******************************/

#ifndef ARME_JETPACK_H
#define ARME_JETPACK_H

#include "define_slot.h"

#ifdef Gd_ARME_JETPACK

#define Gm_JETPACK_FICHIER_MODEL_P		"models/armes/p_jetpack.mdl"
#define Gm_JETPACK_FICHIER_MODEL_V		"models/armes/v_jetpack.mdl"
#define Gm_JETPACK_BEAM_SPRITE			"sprites/xbeam1.spr"
#define Gm_JETPACK_FLARE_SPRITE			"sprites/XSpark1.spr"
#define Gm_JETPACK_SOUND_OFF			"weapons/egon_off1.wav"
#define Gm_JETPACK_SOUND_RUN			"weapons/egon_run3.wav"
#define Gm_JETPACK_SOUND_STARTUP		"weapons/egon_windup2.wav"

#define Gm_JETPACK_DOMMAGE				0
#define Gm_JETPACK_MUNITION				10
#define Gm_JETAPCK_TEMPS_DEPLACEMENT	3

#define Gm_JETPACK_CONSO_REGUL			0.1		// Controle de la consommation ici
#define Gm_JETPACK_TEMP_SON_RUN			214		// Dur du son "egon_run3.wav"
#define Gm_JETPACK_VITESSE_2			500		// Vitesse de dplacement rapide
#define Gm_JETPACK_VITESSE_1			250		// Vitesse de dplacement lente
#define Gm_JETPACK_VITESSE_HAUT			50		// Vitesse de dplacement normal vers le haut.

class GcJetpack : public CBasePlayerWeapon
{
public:
	int GetItemInfo(ItemInfo *p);
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );

private:
	bool GfArretJetpack( void );
	void GfMarche_i( int GvVitesse_i );
	void GfStopSon( void );
	
	bool GvDemarrage_b;
	bool GvSonDebut_b;
	float GvVitesseCos_f;
	float GvVitesseSin_f;
	float GvDirectionR_f;
	int	GvDirectionD_i;
	int	GvRegulConso_i;

	float GvTempsFDT_f;
	float GvTempsAnim_f;
};

enum 
{
	Ga_JETPACK_IDLE_01 = 0,
	Ga_JETPACK_IDLE_02,
	Ga_JETPACK_TIRE,
	Ga_JETPACK_DRAW
};

#endif
#endif // ARME_JETPACK_H