/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_kameha.cpp				*
*		14062002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "fx_sprite.h"
#include "shake.h"
#include "generic_arme.h"
#include "generic_balle.h"
#include "arme_kameha.h"
#include "gamerules.h"

#ifdef Gd_ARME_KAMEHA

LINK_ENTITY_TO_CLASS( weapon_kameha, GcKameha );

int GcKameha::GetItemInfo( ItemInfo *p )
{
	p->pszName = STRING( pev->classname );
	p->pszAmmo1 = "munition_KAMEHA";
	p->iMaxAmmo1 = Gm_MUNI_MAX;
	p->iSlot = Gm_KAMEHA_SLOT;
	p->iPosition = Gm_KAMEHA_POSITION;
	p->iId = m_iId = Gm_KAMEHA_ID;
	p->iWeight = Gm_KAMEHA_POID;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;
	return 1;
}

void GcKameha::Spawn( void )
{
	Precache( );

	m_iId = Gm_KAMEHA_ID;
	iGvAmmoDefault = Gm_KAMEHA_MUNITION;

	GvTempsFDT_f = 0;
	GvNbTire_i = 0;
	fGvTempsAttack = 0;

	FallInit( );
}

void GcKameha::Precache( void )
{
//	PRECACHE_MODEL( Gm_KAMEHA_FICHIER_MODEL_P );
	PRECACHE_MODEL( Gm_KAMEHA_FICHIER_MODEL_V );
	PRECACHE_MODEL( Gm_KAMEHA_FICHIER_SPRITE_R );
	PRECACHE_MODEL( Gm_KAMEHA_FICHIER_SPRITE_S );
	PRECACHE_MODEL( Gm_KAMEHA_FICHIER_SPRITE_T );
	PRECACHE_SOUND( Gm_KAMEHA_FICHIER_SON_KAMEHAME );
	PRECACHE_SOUND( Gm_KAMEHA_FICHIER_SON_HAA );
	PRECACHE_SOUND( Gm_KAMEHA_FICHIER_SON_TIRE );
}

BOOL GcKameha::Deploy( void )
{
	GvTempsAnim_f = gpGlobals->time + 0.625;
	return DefaultDeploy( Gm_KAMEHA_FICHIER_MODEL_V, 0, Ga_KAMEHA_DRAW, "kameha" );
}

void GcKameha::Holster( void )
{
	if( m_pSpot )
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		//m_pPlayer->iGvArmes &= ~( 1<<Gm_KAMEHA_ID );
		m_pPlayer->iGvArmes[Gm_KAMEHA_SLOT] &= ~( 1<<Gm_KAMEHA_POSITION );
		SetThink( DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}

	if( GvNbTire_i )
		GvTempsFDT_f = gpGlobals->time;
	
	GfFinDeTour( &GvTempsFDT_f, 0 );
}

void GcKameha::GfAttack1( void )
{
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		GfAttack0( );
		return;
	}

	if( fGvTempsAttack == 0.0 )
	{
		EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_VOICE, Gm_KAMEHA_FICHIER_SON_KAMEHAME, 0.7, ATTN_NORM );
		// Groove - 18062002 - Couleur joueur
		m_pPlayer->pev->rendermode = kRenderNormal;
		m_pPlayer->pev->renderfx = kRenderFxGlowShell;
		m_pPlayer->pev->rendercolor.x = 0;			// r
		m_pPlayer->pev->rendercolor.y = 255;		// v
		m_pPlayer->pev->rendercolor.z = 255;		// b
		m_pPlayer->iGvPlayerOutil |= Gm_PLAYER_OUTIL_POWER;
		
		m_pSprite = CSprite::SpriteCreate( Gm_KAMEHA_FICHIER_SPRITE_R, m_pPlayer->GetGunPosition( ) + gpGlobals->v_forward * 16 + gpGlobals->v_right * 12 + gpGlobals->v_up * -12, FALSE );
		m_pSprite->pev->scale = 0.01;
		m_pSprite->SetTransparency( kRenderGlow, 255, 255, 255, 255,kRenderFxNoDissipation );
		m_pSprite->pev->spawnflags |= SF_SPRITE_TEMPORARY ;
		m_pSprite->pev->frame = 0.8;
		m_pSprite->pev->movetype = MOVETYPE_FLY;
		m_pSprite->pev->gravity = 1;
		m_pSprite->pev->velocity = Vector( 0,0,0 );
		m_pSprite->pev->solid = SOLID_NOT;
//		m_pSprite->pev->effects = EF_BRIGHTLIGHT;

		SendWeaponAnim( Ga_KAMEHA_PREPARE );
		fGvTempsAttack = gpGlobals->time + 3.0; // Exact : 3.680 s
	}	
	else if( fGvTempsAttack &&( fGvTempsAttack < gpGlobals->time ))
	{
		fGvTempsAttack = 0.0;
		GfTire( );
		UTIL_Remove( m_pSprite );
		m_pSprite = NULL;
	}

	if( m_pSprite )
	{
		if(( fGvTempsAttack - 3.0 ) < gpGlobals->time )
			m_pSprite->pev->scale += 0.001;
		m_pSprite->pev->origin = m_pPlayer->GetGunPosition( ) + gpGlobals->v_forward * 16 + gpGlobals->v_right * 12 + gpGlobals->v_up * -12;
	}

	fGvAttack1 = fGvAttack0 = gpGlobals->time + 0.005;
}

void GcKameha::GfTire( void )
{
	// Groove - 18032002 - Animations
	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );
	GvTempsAnim_f = gpGlobals->time + 1.0; // Exact : 0.860 s
	SendWeaponAnim( Ga_KAMEHA_STOP );

	EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_ITEM, Gm_KAMEHA_FICHIER_SON_TIRE, 0.7, ATTN_NORM );
	EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_VOICE, Gm_KAMEHA_FICHIER_SON_HAA, 0.7, ATTN_NORM );

	// Groove - 13022002 - flash en bout de canon
	m_pPlayer->m_iWeaponFlash = BRIGHT_GUN_FLASH;
	m_pPlayer->pev->effects = (int)(m_pPlayer->pev->effects) | EF_MUZZLEFLASH;

	if( g_pGameRules->GvMortSubite )
		UTIL_ScreenFade( m_pPlayer, Vector( 255, 0, 0 ), 1, 0.5, 64, FFADE_OUT | FFADE_STAYOUT );
	else
		UTIL_ScreenFade( m_pPlayer, Vector( 1,1,1 ), 0.25, 0.25, 64, FFADE_IN );

	Vector GvOrigin_c = m_pPlayer->GetGunPosition( ) + gpGlobals->v_forward * 4 + gpGlobals->v_right * 24 + gpGlobals->v_up * -24;
	
	short GvTraineCouleur_18i[3][6] = 
	{
		{  64, 10, 255, 255, 255, 255 },// Life, Width, r, v, b, brightness
		{  96, 25, 128, 128, 255,  64 },// Life, Width, r, v, b, brightness
		{ 128, 50,   0,   0, 255,  16 } // Life, Width, r, v, b, brightness
	};

	int GvBalleOption_i = Gm_BALLE_SON | Gm_BALLE_BRIANTE | Gm_BALLE_EJECT | Gm_BALLE_EXPLOSE;

	GcGenericBalle::GfCreateBalle( GvOrigin_c,
								   m_pPlayer->pev->angles, 
								   0, 
								   Gm_KAMEHA_BALLE_VITESSE,
								   Gm_KAMEHA_DOMMAGE, 
								   0,					// Groove - 18032002 - Dure de vie de la balle si option active.
								   GvTraineCouleur_18i,
								   3,					// Groove - 18032002 - Nombre de trainees
								   GvBalleOption_i,		
								   m_pPlayer, 
								   this,
								   Gm_KAMEHA_ID );

	MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, pev->origin );
		WRITE_BYTE( TE_DLIGHT );

		WRITE_COORD( pev->origin.x );    // Position...
		WRITE_COORD( pev->origin.y );
		WRITE_COORD( pev->origin.z );
		WRITE_BYTE( 64 );     // Radius, in 10s (therefore, this is 300 units)
    
		WRITE_BYTE(   0 );    // Color: red
		WRITE_BYTE( 128 );    // Color: green
		WRITE_BYTE( 255 );    // Color: blue
        
		WRITE_BYTE( 128 );     // Life
		WRITE_BYTE( 16 );     // Decay rate
	MESSAGE_END();
	
	m_pPlayer->m_rgAmmo[iGvAmmoID]--;
		
	m_pPlayer->GvPlayerTPT.bAmmo = true;
	m_pPlayer->GvPlayerTPT.bTire = false;
	GvTempsFDT_f = gpGlobals->time;
}

void GcKameha::GfAttack2( void )
{
	GfAttack0( );
	fGvAttack2 = gpGlobals->time + 0.5;
}

void GcKameha::GfAttack0( void )
{
	fGvAttack0 = gpGlobals->time + 1.0;
	GfFinDeTour( &GvTempsFDT_f, Gm_KAMEHA_TEMPS_DEPLACEMENT );
	
	if( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE )
		UpdateSpot( );
	else if( m_pSpot &&!( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE ))
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( !m_pPlayer->GvPlayerTPT.bTire && GvNbTire_i )
	{
		GvNbTire_i = 0;
		m_pPlayer->m_rgAmmo[iGvAmmoID]--;
	}

	if( fGvTempsAttack )
	{
		UTIL_Remove( m_pSprite );
		m_pSprite = NULL;
		fGvTempsAttack = 0;
		GvTempsAnim_f = gpGlobals->time + 1.0; // Exact : 0.860 s
		SendWeaponAnim( Ga_KAMEHA_STOP );
	}	
	else if( GvTempsAnim_f &&( GvTempsAnim_f < gpGlobals->time ))
	{
		if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		{
			int GvAnim_i;
			switch( RANDOM_LONG( 1,5 ))
			{
			default:
			case 1:
			case 2:
			case 3:
				GvAnim_i = Ga_KAMEHA_IDLE_01;
				GvTempsAnim_f = gpGlobals->time + 2.0;
				break;
			case 4:
				GvAnim_i = Ga_KAMEHA_IDLE_02;
				GvTempsAnim_f = gpGlobals->time + 1.6;
				break;
			case 5:
				GvAnim_i = Ga_KAMEHA_IDLE_03;
				GvTempsAnim_f = gpGlobals->time + 1.0;
				break;
			}
			SendWeaponAnim( GvAnim_i );
		}
		else
		{
			GvTempsAnim_f = 0.0;
			SendWeaponAnim( Ga_KAMEHA_HOLSTER );
			//m_pPlayer->pev->viewmodel = 0; 
			//m_pPlayer->pev->weaponmodel = 0;
		}
	}
}

#endif