/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_kamea.h				*
*		16042002				*
\*******************************/

#ifndef ARME_KAMEHA_H
#define ARME_KAMEHA_H

#include "define_slot.h"

#ifdef Gd_ARME_KAMEHA

#define Gm_KAMEHA_FICHIER_MODEL_V		"models/armes/v_kameha.mdl"

#define Gm_KAMEHA_FICHIER_SPRITE_R		"sprites/jeu/kamea2.spr"
#define Gm_KAMEHA_FICHIER_SPRITE_S		"sprites/jeu/kamea1.spr"
#define Gm_KAMEHA_FICHIER_SPRITE_T		"sprites/jeu/kamea3.spr"

#define Gm_KAMEHA_FICHIER_SON_KAMEHAME	"weapons/kameha/kameha1.wav"
#define Gm_KAMEHA_FICHIER_SON_HAA		"weapons/kameha/kameha2.wav"
#define Gm_KAMEHA_FICHIER_SON_TIRE		"weapons/kameha/kameha3.wav"

#define Gm_KAMEHA_PRECISION				50
#define Gm_KAMEHA_MUNITION				1
#define Gm_KAMEHA_TEMPS_DEPLACEMENT		3.0

#define Gm_KAMEHA_BALLE_VITESSE			500
#define Gm_KAMEHA_DOMMAGE				25
#define Gm_KAMEHA_NB_TIRE				1
#define Gm_KAMEHA_ROCKET_GRAVITE		1.0
#define Gm_KAMEHA_SENTIR_DOMMAGE		3

class GcKameha : public CBasePlayerWeapon
{
public:
	int GetItemInfo( ItemInfo *p );
	BOOL Deploy( void );
	void Holster( void );
	void Spawn( void );
	void Precache( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );	

private:
	void GfTire( void );
	
	CSprite *m_pSprite;
	short GvNbTire_i;
	float fGvTempsAttack;
	float GvTempsAnim_f;
	float GvTempsFDT_f;
};

enum
{
	Ga_KAMEHA_DRAW = 0,
	Ga_KAMEHA_IDLE_01,
	Ga_KAMEHA_IDLE_02,
	Ga_KAMEHA_IDLE_03,
	Ga_KAMEHA_PREPARE,
	Ga_KAMEHA_SHOOTING,
	Ga_KAMEHA_STOP,
	Ga_KAMEHA_HOLSTER
};

#endif
#endif // ARME_KAMEHA_H