/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_kamikaze.cpp			*
*		19022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "generic_arme.h"
#include "arme_kamikaze.h"
#include "gamerules.h"
#include "fx_explode.h"

#ifdef Gd_ARME_KAMIKAZE

LINK_ENTITY_TO_CLASS( weapon_kamikaze, GcKamikaze );

int GcKamikaze::GetItemInfo( ItemInfo *p )
{
	p->pszName = STRING( pev->classname );
	p->pszAmmo1 = "munition_kamikake";
	p->iMaxAmmo1 = Gm_MUNI_MAX;
	p->iSlot = Gm_KAMIKAZE_SLOT;
	p->iPosition = Gm_KAMIKAZE_POSITION;
	p->iId = m_iId = Gm_KAMIKAZE_ID;
	p->iWeight = Gm_KAMIKAZE_POID;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;
	return 1;
}

void GcKamikaze::Spawn( void )
{
	Precache( );

	m_iId = Gm_KAMIKAZE_ID;
	iGvAmmoDefault = Gm_KAMIKAZE_MUNITION;

	GvTempsFDT_f = 0;
	GvTempsExplose_f = 0;
	
	FallInit( );
}

void GcKamikaze::Precache( void )
{
	PRECACHE_MODEL( Gm_KAMIKAZE_FICHIER_MODEL_P );
	PRECACHE_MODEL( Gm_KAMIKAZE_FICHIER_MODEL_V );
	PRECACHE_SOUND( Gm_KAMIKAZE_FICHIER_SON_ATTACK_01 );
}

BOOL GcKamikaze::Deploy( void )
{
	GvTempsAnim_f = gpGlobals->time + 2.0;
	return DefaultDeploy( Gm_KAMIKAZE_FICHIER_MODEL_V, Gm_KAMIKAZE_FICHIER_MODEL_P, Ga_KAMIKAZE_DRAW, "kamikaze" );
}

void GcKamikaze::Holster( void )
{
	if( m_pSpot )
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( GvTempsExplose_f )
		GfTire2( );

	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		//m_pPlayer->iGvArmes &= ~( 1<<Gm_KAMIKAZE_ID );
		m_pPlayer->iGvArmes[Gm_KAMIKAZE_SLOT] &= ~( 1<<Gm_KAMIKAZE_POSITION );
		SetThink( DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}

	GfFinDeTour( &GvTempsFDT_f, 0 );
}

void GcKamikaze::GfAttack1( void )
{
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		GfAttack0( );
		return;
	}

	GfTire1( );
}

void GcKamikaze::GfTire1( void )
{
	if(( GvTempsExplose_f < gpGlobals->time )&& GvTempsExplose_f ||( m_pPlayer->pev->waterlevel > 2 ))
	{
		GfTire2( );
		return;
	}

	if( !GvTempsExplose_f )
	{
		// Groove - 01052002 - Couleur joueur
		m_pPlayer->pev->rendermode = kRenderNormal;
		m_pPlayer->pev->renderfx = kRenderFxGlowShell;
		m_pPlayer->pev->rendercolor.x = 255;		// r
		m_pPlayer->pev->rendercolor.y = 255;		// v
		m_pPlayer->pev->rendercolor.z = 0;			// b
		m_pPlayer->iGvPlayerOutil |= Gm_PLAYER_OUTIL_POWER;

		// Groove - 01052002 - Petite lumire dynamique de la couleur de l'equipe du joueur.
		MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, m_pPlayer->pev->origin );
			WRITE_BYTE( TE_DLIGHT );

			WRITE_COORD( m_pPlayer->pev->origin.x );	// Position
			WRITE_COORD( m_pPlayer->pev->origin.y );
			WRITE_COORD( m_pPlayer->pev->origin.z );
			WRITE_BYTE( 32 );						// Radius, in 10s (therefore, this is 300 units)

			WRITE_BYTE( 255 );			// Color: red
			WRITE_BYTE( 255 );			// Color: green
			WRITE_BYTE(   0 );			// Color: blue
    
			WRITE_BYTE( 128 );						// Life
			WRITE_BYTE( 16 );						// Decay rate
		MESSAGE_END();

		SendWeaponAnim( Ga_KAMIKAZE_TIRE );
		GvTempsAnim_f = gpGlobals->time + Gm_KAMIKAZE_TEMP_EXPLOSE;
		EMIT_SOUND( ENT(m_pPlayer->pev), CHAN_VOICE, Gm_KAMIKAZE_FICHIER_SON_ATTACK_01, 1, 0.9 );
		GvTempsExplose_f = gpGlobals->time + Gm_KAMIKAZE_TEMP_EXPLOSE;
	}
	
	m_pPlayer->pev->velocity = gpGlobals->v_forward * 1024 + gpGlobals->v_up * 256;
	GvTempsFDT_f = gpGlobals->time + 2.0;
}

void GcKamikaze::GfTire2( void )
{
	m_pPlayer->m_rgAmmo[iGvAmmoID]--;
	GvTempsExplose_f = 0;
	m_pPlayer->pev->health = 1;
	ExplosionCreate( m_pPlayer->pev->origin, pev->angles, m_pPlayer->edict( ), Gm_KAMIKAZE_DOMMAGE, true );
}

void GcKamikaze::GfAttack2( void )
{
	GfAttack0( );
	fGvAttack2 = gpGlobals->time + 0.5;
}

void GcKamikaze::GfAttack0( void )
{
	fGvAttack0 = gpGlobals->time + 1.0;
	GfFinDeTour( &GvTempsFDT_f, Gm_KAMIKAZE_TEMPS_DEPLACEMENT );

	if( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE )
		UpdateSpot( );
	else if( m_pSpot &&!( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE ))
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( GvTempsExplose_f )
		GfTire2( );

	if( GvTempsAnim_f ||( GvTempsAnim_f < gpGlobals->time ))
	{
		if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		{
			SendWeaponAnim( Ga_KAMIKAZE_IDLE );
			GvTempsAnim_f = gpGlobals->time + 16.0;
/*
			int GvAnim_i;
			switch( 1 )
			{
			case 1:
				GvAnim_i = Ga_KAMIKAZE_IDLE;
				GvTempsAnim_f = gpGlobals->time + 16.0;
				break;
			}
			SendWeaponAnim( GvAnim_i );
*/
		}
		else
		{
			m_pPlayer->pev->viewmodel = 0; 
			m_pPlayer->pev->weaponmodel = 0;
		}
	}
}

#endif






