/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_mine.cpp				*
*		19022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "generic_arme.h"
#include "arme_mine.h"

#ifdef Gd_ARME_MINE

LINK_ENTITY_TO_CLASS( weapon_mine, GcMine );

int GcMine::GetItemInfo( ItemInfo *p )
{
	p->pszName = STRING( pev->classname );
	p->pszAmmo1 = "munition_mine";
	p->iMaxAmmo1 = Gm_MUNI_MAX;
	p->iSlot = Gm_MINE_SLOT;
	p->iPosition = Gm_MINE_POSITION;
	p->iId = m_iId = Gm_MINE_ID;
	p->iWeight = Gm_MINE_POID;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;
	return 1;
}

void GcMine::Spawn( void )
{
	Precache( );

	m_iId = Gm_MINE_ID;
	iGvAmmoDefault = Gm_MINE_MUNITION;

	GvTempsExplose_f = Gm_MINE_TEMPS_EXPLOSE;
	GvTempsTire_f = 0;
	GvTempsFDT_f = 0;

	FallInit( );
}

void GcMine::Precache( void )
{
	PRECACHE_MODEL( Gm_MINE_FICHIER_MODEL_P );
	PRECACHE_MODEL( Gm_MINE_FICHIER_MODEL_V );
	PRECACHE_MODEL( Gm_MINE_FICHIER_MODEL_W );
}

BOOL GcMine::Deploy( void )
{
	GvTempsAnim_f = gpGlobals->time + 2.0;
	return DefaultDeploy( Gm_MINE_FICHIER_MODEL_V, Gm_MINE_FICHIER_MODEL_P, Ga_MINE_DRAW, "mine" );
}

void GcMine::Holster( void )
{
	if( m_pSpot )
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		//m_pPlayer->iGvArmes &= ~( 1<<Gm_MINE_ID );
		m_pPlayer->iGvArmes[Gm_MINE_SLOT] &= ~( 1<<Gm_MINE_POSITION );
		SetThink( DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}

	GfFinDeTour( &GvTempsFDT_f, 0 );
}

void GcMine::GfAttack1( void )
{
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		GfAttack0( );
		return;
	}

	if( !GvTempsTire_f )
	{
		SendWeaponAnim( Ga_MINE_TIRE );
		m_pPlayer->SetAnimation( PLAYER_ATTACK1 );
		
		GvTempsAnim_f = gpGlobals->time + 2.0;
		GvTempsTire_f = gpGlobals->time + 2.0;
	}

	fGvAttack1 = fGvAttack0 = gpGlobals->time + 0.25;
}

void GcMine::GfTire( void )
{
	GfSonAttack( );
	
	if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		SendWeaponAnim( Ga_MINE_DRAW );
		GvTempsAnim_f = gpGlobals->time + 2.0;
	}
	
	Vector GvOrigin_c = m_pPlayer->pev->origin + gpGlobals->v_forward * 20;

	GcGrenadeGeneric::GfMine( m_pPlayer, GvOrigin_c, Vector( 0,0,0 ), Gm_MINE_AMORCE, GfDommage( Gm_MINE_DOMMAGE ));

	GvTempsTire_f = 0;
	m_pPlayer->m_rgAmmo[iGvAmmoID]--;

	//m_pPlayer->GvPlayerTPT.bAmmo = true;
	m_pPlayer->GvPlayerTPT.bTire = false;
	GvTempsFDT_f = gpGlobals->time;
}

void GcMine::GfAttack2( void )
{
	GfAttack0( );
	fGvAttack2 = gpGlobals->time + 0.5;
}

void GcMine::GfAttack0( void )
{
	fGvAttack0 = gpGlobals->time + 1.0;
	GfFinDeTour( &GvTempsFDT_f, Gm_MINE_TEMPS_DEPLACEMENT );

	if( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE )
		UpdateSpot( );
	else if(( m_pSpot )&&!( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE ))
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( GvTempsTire_f && ( GvTempsTire_f < gpGlobals->time ))
		GfTire( );

	if( GvTempsAnim_f && ( GvTempsAnim_f < gpGlobals->time ))
	{
		if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		{
			int GvAnim_i;
			switch( RANDOM_LONG( 1,4 ))
			{
			default:
			case 1: case 2:
				GvAnim_i = Ga_MINE_IDLE_01;
				GvTempsAnim_f = gpGlobals->time + 3.0;
				break;
			case 3:
				GvAnim_i = Ga_MINE_IDLE_02;
				GvTempsAnim_f = gpGlobals->time + 1.0;
				break;
			case 4:
				GvAnim_i = Ga_MINE_IDLE_03;
				GvTempsAnim_f = gpGlobals->time + 2.0;
				break;
			}
			SendWeaponAnim( GvAnim_i );
		}
		else
		{
			m_pPlayer->pev->viewmodel = 0; 
			m_pPlayer->pev->weaponmodel = 0;
		}
	}
}

#endif
