/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_mine.h					*
*		19122001				*
\*******************************/

#ifndef ARME_MINE_H
#define ARME_MINE_H

#include "define_slot.h"

#ifdef Gd_ARME_MINE

#define Gm_MINE_FICHIER_MODEL_P		"models/armes/p_mine.mdl"
#define Gm_MINE_FICHIER_MODEL_V		"models/armes/v_mine.mdl"
#define Gm_MINE_FICHIER_MODEL_W		"models/armes/w_mine.mdl"

#define Gm_MINE_DOMMAGE				75
#define Gm_MINE_MUNITION			2
#define Gm_MINE_TEMPS_DEPLACEMENT	5.0

#define Gm_MINE_AMORCE				3
#define Gm_MINE_GRAVITE				0.5
#define Gm_MINE_RAYON				1
#define Gm_MINE_REBOND				0.99
#define Gm_MINE_TEMPS_EXPLOSE		5.0
#define Gm_MINE_TEMPS_TIRE_APRES	5.0

class GcMine : public CBasePlayerWeapon
{
public:
	int GetItemInfo( ItemInfo *p );
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );

private:
	void GfTire( void );

	float GvTempsFDT_f;
	float GvTempsAnim_f;
	float GvTempsTire_f;
	short GvTempsExplose_f;
};

enum
{
	Ga_MINE_DRAW = 0,
	Ga_MINE_IDLE_01,
	Ga_MINE_IDLE_02,
	Ga_MINE_IDLE_03,
	Ga_MINE_TIRE
};

#endif
#endif // ARME_MINE_H