/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_minicanon.cpp			*
*		19022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "monsters.h"
#include "player.h"
#include "generic_arme.h"
#include "generic_balle.h"
#include "arme_minicanon.h"
#include "game.h"
#include "gamerules.h"
#include "shake.h"

#ifdef Gd_ARME_MINICANON

LINK_ENTITY_TO_CLASS( weapon_minicanon, GcMinicanon );

int GcMinicanon::GetItemInfo( ItemInfo *p )
{
	p->pszName = STRING( pev->classname );
	p->pszAmmo1 = "munition_minicanon";
	p->iMaxAmmo1 = Gm_MUNI_MAX;
	p->iSlot = Gm_MINICANON_SLOT;
	p->iPosition = Gm_MINICANON_POSITION;
	p->iId = m_iId = Gm_MINICANON_ID;
	p->iWeight = Gm_MINICANON_POID;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;
	return 1;
}

void GcMinicanon::Spawn( void )
{
	Precache( );

	m_iId = Gm_MINICANON_ID;
	iGvAmmoDefault = Gm_MINICANON_MUNITION;

	GvTempsFDT_f = 0;
	GvNbTire_i = 0;
	GvPreci_i = 1;
	GvTempsTire_f = 0;

	FallInit( );
}

void GcMinicanon::Precache( void )
{
	PRECACHE_MODEL( Gm_MINICANON_FICHIER_MODEL_P );
	PRECACHE_MODEL( Gm_MINICANON_FICHIER_MODEL_V );
	PRECACHE_MODEL( Gm_MINICANON_FICHIER_MODEL_R );
	GvShell_i = PRECACHE_MODEL( Gm_MINICANON_FICHIER_MODEL_D );
	PRECACHE_SOUND( Gm_MINICANON_FICHIER_SON_TIRE );
}

BOOL GcMinicanon::Deploy( void )
{
	GvTempsAnim_f = gpGlobals->time + 4.0;
	return DefaultDeploy( Gm_MINICANON_FICHIER_MODEL_V, Gm_MINICANON_FICHIER_MODEL_P, Ga_MINICANON_DRAW, "minicanon" );
}

void GcMinicanon::Holster( void )
{
	if( m_pSpot )
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		//m_pPlayer->iGvArmes &= ~( 1<<Gm_MINICANON_ID );
		m_pPlayer->iGvArmes[Gm_MINICANON_SLOT] &= ~( 1<<Gm_MINICANON_POSITION );
		SetThink( DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}

	if( GvNbTire_i )
	{
		GvTempsFDT_f = gpGlobals->time;
		m_pPlayer->m_rgAmmo[iGvAmmoID]--;
	}

	GfFinDeTour( &GvTempsFDT_f, 0 );
}

void GcMinicanon::GfAttack1( void )
{
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		GvPreci_i = 1;
		GfAttack0( );
		return;
	}

	GfTire( false );

	if( g_pGameRules->GvMortSubite )
		UTIL_ScreenFade( m_pPlayer, Vector( 255, 0, 0 ), 1, 0.5, 64, FFADE_OUT | FFADE_STAYOUT );
	else
		UTIL_ScreenFade( m_pPlayer, Vector( 1,1,1 ), 0.25, 0.25, 64, FFADE_IN );

	fGvAttack0 = fGvAttack2 = fGvAttack1 = gpGlobals->time + Gm_MINICANON_CADANCE_TIRE;
}

void GcMinicanon::GfTire( bool GvTireAutoExec_b )
{
	if( GvPreci_i < Gm_MINICANON_NB_TIRE )
		GvPreci_i++;
	else
		GvPreci_i = 0;

	SendWeaponAnim( Ga_MINICANON_TIRE );
	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

	// Groove - 13022002 - flash en bout de canon du minicanon.
	EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_ITEM, Gm_MINICANON_FICHIER_SON_TIRE, 0.7, ATTN_NORM );

	m_pPlayer->m_iWeaponFlash = BRIGHT_GUN_FLASH;
	m_pPlayer->pev->effects = (int)(m_pPlayer->pev->effects) | EF_MUZZLEFLASH;

	Vector GvOrigin_c = m_pPlayer->GetGunPosition( ) + gpGlobals->v_forward * 16;// + gpGlobals->v_up * 8;

	// Groove - 13022002 - Cration d'une balle.
	short GvTraineCouleur_18i[3][6] = 
	{
		{ 10,  1, 255, 128,   0, 192 },// Life, Width, r, v, b, brightness
		{ 20, 10, 255, 128,   0,  32 },// Life, Width, r, v, b, brightness
		{  0,  0,   0,   0,   0,   0 } // Life, Width, r, v, b, brightness
	};

	int GvBalleOption_i = Gm_BALLE_EXPLOSE | Gm_BALLE_BRIANTE | Gm_BALLE_FUMEE | Gm_BALLE_BRUIT_RICOCHE;

	GcGenericBalle::GfCreateBalle( GvOrigin_c,
								   m_pPlayer->pev->angles, 
								   Gm_MINICANON_PRECISION * ( GvPreci_i + 25 ) / Gm_MINICANON_NB_TIRE, 
								   Gm_MINICANON_BALLE_VITESSE, 
								   Gm_MINICANON_DOMMAGE,
								   0.5,// Duree de vie de la balle si option active.
								   GvTraineCouleur_18i,
								   1,// Nombre de trainees
								   GvBalleOption_i,//short GvOptionCreate, 
								   m_pPlayer, 
								   this, 
								   Gm_MINICANON_ID );
//	GcGenericBalle::GfEssence( pev, entindex( ), GvOrigin_c, gpGlobals->v_forward * 2000, 5 );
/*	GcGenericBalle::GfCreateBalle( GvOrigin_c,
								   m_pPlayer->pev->angles, 
								   0, 
								   500,
								   25, 
								   0,					// Groove - 18032002 - Dure de vie de la balle si option active.
								   GvTraineCouleur_18i,
								   3,					// Groove - 18032002 - Nombre de trainees
								   GvBalleOption_i,		
								   m_pPlayer, 
								   this,
								   Gm_KAMEHA_ID );*/

	// Groove - 13022002 - cration d'une douille
/*
	if( GvQDouilleCMD_i )
	{
		Vector GvShellOrigin_c = pev->origin + m_pPlayer->pev->view_ofs
								+ gpGlobals->v_up * -12 
								+ gpGlobals->v_forward * 20 
								+ gpGlobals->v_right * 4;

		Vector GvShellVelocity_c = m_pPlayer->pev->velocity 
								 + gpGlobals->v_right * RANDOM_FLOAT(50,70) 
								 + gpGlobals->v_up * RANDOM_FLOAT(100,150) 
								 + gpGlobals->v_forward * 25;

		EjectBrass( GvShellOrigin_c, GvShellVelocity_c, pev->angles.y, GvShell_i, TE_BOUNCE_SHELL); 
	}
*/
	if( !GvTireAutoExec_b )
	{
		m_pPlayer->GfSentirDommange( Gm_MINICANON_SENTIR_DOMMAGE * 1, 0 );
		m_pPlayer->pev->velocity -= gpGlobals->v_forward * 128;
		GvTempsTire_f = gpGlobals->time + Gm_MINICANON_CADANCE_TIRE;
	}
	else
	{
		GfMsgStupide( m_pPlayer );
		m_pPlayer->GfSentirDommange( Gm_MINICANON_SENTIR_DOMMAGE * 2, 0 );
		m_pPlayer->pev->velocity -= gpGlobals->v_forward * 128;
		GvTempsTire_f = gpGlobals->time + Gm_MINICANON_CADANCE_TIRE / 2;
	}

	GvNbTire_i++;
	if( GvNbTire_i >= Gm_MINICANON_NB_TIRE )
	{
		if( GvQSmokeCMD_i )
		{
			int GvSprite_i = PRECACHE_MODEL( Gm_BALLE_FUMEE_1 );
				
			Vector GvPosition_c = m_pPlayer->GetGunPosition( ) + gpGlobals->v_forward * 96 + gpGlobals->v_right * 16 + gpGlobals->v_up * -24;

			MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, pev->origin );
				WRITE_BYTE( TE_SMOKE );
				WRITE_COORD( GvPosition_c.x );
				WRITE_COORD( GvPosition_c.y );
				WRITE_COORD( GvPosition_c.z );
				WRITE_SHORT( GvSprite_i );
				WRITE_BYTE( 10 );
				WRITE_BYTE( 12  );
			MESSAGE_END( );
		}

		GvNbTire_i = 0;
		m_pPlayer->m_rgAmmo[iGvAmmoID]--;
		GvTempsTire_f = 0;
		GvTempsAnim_f = gpGlobals->time + 2.0;
		
		m_pPlayer->GvPlayerTPT.bAmmo = true;
		m_pPlayer->GvPlayerTPT.bTire = false;
		GvTempsFDT_f = gpGlobals->time;
	}
}

void GcMinicanon::GfAttack2( void )
{
	GfAttack0( );
	fGvAttack2 = gpGlobals->time + 0.5;
}

void GcMinicanon::GfAttack0( void )
{
	fGvAttack0 = gpGlobals->time + 1.0;
	GfFinDeTour( &GvTempsFDT_f, Gm_MINICANON_TEMPS_DEPLACEMENT );

	if( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE )
		UpdateSpot( );
	else if(( m_pSpot )&&!( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE ))
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( !m_pPlayer->GvPlayerTPT.bTire )
	{
		GvTempsTire_f = 0;
		if( GvNbTire_i )
		{
			GvNbTire_i = 0;
			m_pPlayer->m_rgAmmo[iGvAmmoID]--;
		}
	}
	else if( GvTempsTire_f &&( GvTempsTire_f < gpGlobals->time ))
	{
		GfTire( true );
		return;
	}

	if( GvTempsAnim_f &&( GvTempsAnim_f < gpGlobals->time ))
	{
		if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		{
			SendWeaponAnim( Ga_MINICANON_IDLE );
			GvTempsAnim_f = gpGlobals->time + 3.0;
		}
		else
		{
			m_pPlayer->pev->viewmodel = 0; 
			m_pPlayer->pev->weaponmodel = 0;
		}
	}
}

#endif