/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_minicanon.h			*
*		14122001				*
\*******************************/

#ifndef ARME_MINICANON_H
#define ARME_MINICANON_H

#include "define_slot.h"

#ifdef Gd_ARME_MINICANON

#define Gm_MINICANON_FICHIER_MODEL_R	"models/armes/r_minicanon.mdl"
#define Gm_MINICANON_FICHIER_MODEL_D	"models/armes/d_minicanon.mdl"
#define Gm_MINICANON_FICHIER_MODEL_P	"models/armes/p_minicanon.mdl"
#define Gm_MINICANON_FICHIER_MODEL_V	"models/armes/v_minicanon.mdl"
#define Gm_MINICANON_FICHIER_SON_TIRE	"weapons/minicanon/minicanon2.wav"

#define Gm_MINICANON_DOMMAGE			25
#define Gm_MINICANON_MUNITION			1
#define Gm_MINICANON_TEMPS_DEPLACEMENT	3.0

#define Gm_MINICANON_BALLE_VITESSE		1000
#define Gm_MINICANON_CADANCE_TIRE		0.125
#define Gm_MINICANON_NB_TIRE			25
#define Gm_MINICANON_PRECISION			50 // +25
#define Gm_MINICANON_ROCKET_GRAVITE		1
#define Gm_MINICANON_SENTIR_DOMMAGE		1

class GcMinicanon : public CBasePlayerWeapon
{
public:
	int GetItemInfo( ItemInfo *p );
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );	

private:
	void GfTire( bool GvTireAutoExec_b );
	
	int GvShell_i;
	short GvNbTire_i;
	short GvPreci_i;
	float GvTempsAnim_f;
	float GvTempsFDT_f;
	float GvTempsTire_f;
};

enum
{
	Ga_MINICANON_IDLE = 0,
	Ga_MINICANON_TIRE,
	Ga_MINICANON_DRAW
};

#endif
#endif // ARME_MINICANON_H