/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_molotov.cpp			*
*		08112001				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "fx_sprite.h"
#include "generic_arme.h"
#include "generic_flamme.h"
#include "arme_molotov.h"
#include "gamerules.h"

#ifdef Gd_ARME_MOLOTOV

LINK_ENTITY_TO_CLASS( weapon_molotov, GcMolotov );

int GcMolotov::GetItemInfo( ItemInfo *p )
{
	p->pszName = STRING( pev->classname );
	p->pszAmmo1 = "ammo_molotov";
	p->iMaxAmmo1 = Gm_MUNI_MAX;
	p->iSlot = Gm_MOLOTOV_SLOT;
	p->iPosition = Gm_MOLOTOV_POSITION;
	p->iId = m_iId = Gm_MOLOTOV_ID;
	p->iWeight = Gm_MOLOTOV_POID;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;	
	return 1;
}

void GcMolotov::Spawn( void )
{
	Precache( );
	
	m_iId = Gm_MOLOTOV_ID;
	iGvAmmoDefault = Gm_MOLOTOV_MUNITION;

	GvTempsPuis_f = 0;
	GvTempsFDT_f = 0;
	
	FallInit( );
}

void GcMolotov::Precache( void )
{
	PRECACHE_MODEL( Gm_MOLOTOV_FICHIER_MODEL_P );
	PRECACHE_MODEL( Gm_MOLOTOV_FICHIER_MODEL_V );
	PRECACHE_MODEL( Gm_MOLOTOV_FICHIER_MODEL_W );
	PRECACHE_MODEL( Gm_FLAMME_FICHIER_FEU_1 );
	PRECACHE_MODEL( Gm_FLAMME_FICHIER_FEU_2 );
	PRECACHE_MODEL( Gm_FLAMME_FICHIER_FEU_3 );
}

BOOL GcMolotov::Deploy( void )
{
	GvTempsAnim_f = gpGlobals->time + 2.0;
	return DefaultDeploy( Gm_MOLOTOV_FICHIER_MODEL_V, Gm_MOLOTOV_FICHIER_MODEL_P, Ga_MOLOTOV_DRAW, "molotov" );
}

void GcMolotov::Holster( void )
{
	if( m_pSpot )
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		//m_pPlayer->iGvArmes &= ~( 1<<Gm_MOLOTOV_ID );
		m_pPlayer->iGvArmes[Gm_MOLOTOV_SLOT] &= ~( 1<<Gm_MOLOTOV_POSITION );
		SetThink( DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}

	GfFinDeTour( &GvTempsFDT_f, 0 );
}

void GcMolotov::GfAttack1( void )
{	
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		GfAttack0( );
		return;
	}

	if( !GvTempsPuis_f )
	{
		GvTempsPuis_f = gpGlobals->time;
		SendWeaponAnim( Ga_MOLOTOV_THROW_01 );
		GfSonPuissanceOn();
	}

	if( GfPuissanceProgressive( GvTempsPuis_f ))
		GfTire( Gm_ARME_TEMPS_TIRE_MAX );

	fGvAttack1 = fGvAttack0 = gpGlobals->time + 0.02;
}

void GcMolotov::GfTire( float GvTempsTire )
{
	GfPuissanceAffichage( WEAPON_PUISS_PROG_OFF, Gm_WORM_DEFAUT );
	GfSonAttack( );

	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );
	SendWeaponAnim( Ga_MOLOTOV_THROW_02 );

	Vector GvAngle_c = m_pPlayer->pev->v_angle + m_pPlayer->pev->punchangle;

	if( GvAngle_c.x < 0 )
		GvAngle_c.x = -10 + GvAngle_c.x * ((90 - 10) / 90.0);
	else
		GvAngle_c.x = -10 + GvAngle_c.x * ((90 + 10) / 90.0);

	float GvVelocity_f = (90 - GvAngle_c.x) * 4;
	if( GvVelocity_f > 500 )
		GvVelocity_f = 500;

	UTIL_MakeVectors( GvAngle_c );

	Vector GvOrigin_c = m_pPlayer->GetGunPosition( ) + gpGlobals->v_forward * 16;
	Vector GvVelocity_c = gpGlobals->v_forward * (( GvVelocity_f / Gm_MOLOTOV_COEF_TIRE ) * static_cast<int>( GvTempsTire * 100 )) + m_pPlayer->pev->velocity;
	GvVelocity_c += g_pGameRules->GvVent;

	GcGrenadeGeneric::GfMolotov( m_pPlayer, GvOrigin_c, GvVelocity_c, GfDommage( Gm_MOLOTOV_DOMMAGE ));

	m_pPlayer->m_rgAmmo[iGvAmmoID]--;

	GvTempsAnim_f = gpGlobals->time + 3.0;
	GvTempsPuis_f = 0;
	
	m_pPlayer->GvPlayerTPT.bAmmo = true;
	m_pPlayer->GvPlayerTPT.bTire = false;
	GvTempsFDT_f = gpGlobals->time;
}

void GcMolotov::GfAttack2( void )
{
	GfAttack0( );
	fGvAttack2 = gpGlobals->time + 0.5;
}

void GcMolotov::GfAttack0( void )
{
	fGvAttack0 = gpGlobals->time + 1.0;
	GfFinDeTour( &GvTempsFDT_f, Gm_MOLOTOV_TEMPS_DEPLACEMENT );

	if( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE )
		UpdateSpot( );
	else if( m_pSpot &&!( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE ))
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( GvTempsPuis_f )
	{
		GfTire( gpGlobals->time - GvTempsPuis_f );
		return; // Groove - 15032002 - Peut-etre pas util
	}

	if( GvTempsAnim_f < gpGlobals->time )
	{
		if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		{
			int GvAnim_i;
			switch( RANDOM_LONG( 1,4 ))
			{
			default:
			case 1:	case 2:
				GvAnim_i = Ga_MOLOTOV_IDLE_01;
				GvTempsAnim_f = gpGlobals->time + 8.0;
				break;
			case 3:
				GvAnim_i = Ga_MOLOTOV_IDLE_02;
				GvTempsAnim_f = gpGlobals->time + 2.0;
				break;
			case 4:
				GvAnim_i = Ga_MOLOTOV_IDLE_03;
				GvTempsAnim_f = gpGlobals->time + 2.0;
				break;
			}
			SendWeaponAnim( GvAnim_i );
		}
		else
		{
			m_pPlayer->pev->viewmodel = 0; 
			m_pPlayer->pev->weaponmodel = 0;
		}
	}
}

#endif