/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_molotov.h				*
*		06122001				*
\*******************************/

#ifndef ARME_MOLOTOV_H
#define ARME_MOLOTOV_H

#include "define_slot.h"

#ifdef Gd_ARME_MOLOTOV

#define Gm_MOLOTOV_FICHIER_MODEL_P			"models/armes/p_molotov.mdl"
#define Gm_MOLOTOV_FICHIER_MODEL_V			"models/armes/v_molotov.mdl"
#define Gm_MOLOTOV_FICHIER_MODEL_W			"models/armes/w_molotov.mdl"

#define Gm_MOLOTOV_DOMMAGE					50
#define Gm_MOLOTOV_MUNITION					1
#define Gm_MOLOTOV_TEMPS_DEPLACEMENT		3

#define Gm_MOLOTOV_COEF_TIRE				75  // Plus le nb et petit plus la grenade est puissante
#define Gm_MOLOTOV_GRAVITE					0.6

class GcMolotov : public CBasePlayerWeapon
{
public:
	int GetItemInfo( ItemInfo *p );
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );

private:
	void GfTire( float GvTirePuis_f );

	float GvTempsAnim_f;
	float GvTempsPuis_f;
	float GvTempsFDT_f;
};

enum
{
	Ga_MOLOTOV_IDLE_01 = 0,
	Ga_MOLOTOV_IDLE_02,
	Ga_MOLOTOV_IDLE_03,
	Ga_MOLOTOV_DRAW,
	Ga_MOLOTOV_THROW_01,
	Ga_MOLOTOV_THROW_02
};

#endif
#endif // ARME_MOLOTOV_H