/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_mortier.h				*
*		06122001				*
\*******************************/

#ifndef ARME_MORTIER_H
#define ARME_MORTIER_H

#include "define_slot.h"

#ifdef Gd_ARME_MORTIER

#define Gm_MORTIER_FICHIER_MODEL_P			"models/armes/p_mortier.mdl"
#define Gm_MORTIER_FICHIER_MODEL_R			"models/armes/r_mortier.mdl"
#define Gm_MORTIER_FICHIER_MODEL_V			"models/armes/v_mortier.mdl"
#define Gm_MORTIER_FICHIER_SON_TIRE			"weapons/bazooka/bazooka1.wav"
#define Gm_MORTIER_FICHIER_SON_TRAINE		"weapons/bazooka/bazooka2.wav"

#define Gm_MORTIER_DOMMAGE					25
#define Gm_MORTIER_MUNITION					2
#define Gm_MORTIER_TEMPS_DEPLACEMENT		3.0

#define Gm_MORTIER_RECUL					15

class GcMortier : public CBasePlayerWeapon
{
public:
	int GetItemInfo( ItemInfo *p );
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );	
	
private:
	void GfTire( float GvTirePuis_f );

	float GvTempsPuis_f;
	float GvTempsAnim_f;
	float GvTempsFDT_f;
};

enum
{
	Ga_MORTIER_IDLE = 0,
	Ga_MORTIER_TIRE,
	Ga_MORTIER_DRAW,
	Ga_MORTIER_PREPARE_TIRE,
	Ga_MORTIER_RECHARGE
};

#endif
#endif // ARME_MORTIER_H