/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_morve.cpp				*
*		19022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "generic_arme.h"
#include "generic_balle.h"
#include "arme_morve.h"
#include "gamerules.h"

#ifdef Gd_ARME_MORVE

LINK_ENTITY_TO_CLASS( weapon_morve, GcMorve );

int GcMorve::GetItemInfo( ItemInfo *p )
{
	p->pszName = STRING( pev->classname );
	p->pszAmmo1 = "munition_morve";
	p->iMaxAmmo1 = Gm_MUNI_MAX;
	p->iSlot = Gm_MORVE_SLOT;
	p->iPosition = Gm_MORVE_POSITION;
	p->iId = m_iId = Gm_MORVE_ID;
	p->iWeight = Gm_MORVE_POID;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;
	return 1;
}

void GcMorve::Spawn( void )
{
	Precache( );

	m_iId = Gm_MORVE_ID;
	iGvAmmoDefault = Gm_MORVE_MUNITION;

	GvNbTire_i = 0;
	GvPreci_i = 1;
	GvTempsFDT_f = 0;

	FallInit( );
}

void GcMorve::Precache( void )
{
	PRECACHE_MODEL( Gm_MORVE_FICHIER_MODEL_P );
	PRECACHE_MODEL( Gm_MORVE_FICHIER_MODEL_V );
	PRECACHE_MODEL( Gm_MORVE_FICHIER_MODEL_R );
	PRECACHE_MODEL( Gm_BALLE_MORVE_1 );
	PRECACHE_SOUND( Gm_MORVE_FICHIER_SON_TIRE );
	PRECACHE_SOUND( Gm_MORVE_FICHIER_SON_IMPACT_WALL_1 );
	PRECACHE_SOUND( Gm_MORVE_FICHIER_SON_IMPACT_WALL_2 );
	PRECACHE_SOUND( Gm_MORVE_FICHIER_SON_IMPACT_BODY_1 );
	PRECACHE_SOUND( Gm_MORVE_FICHIER_SON_IMPACT_BODY_2 );
	PRECACHE_MODEL( "sprites/tinyspit.spr" );
}

BOOL GcMorve::Deploy( void )
{
	return DefaultDeploy( Gm_MORVE_FICHIER_MODEL_V, Gm_MORVE_FICHIER_MODEL_P, Ga_MORVE_PREPARE_TIRE, "morve" );
}

void GcMorve::Holster( void )
{
	if( m_pSpot )
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( GvNbTire_i )
	{
		GvNbTire_i = 0;
		m_pPlayer->m_rgAmmo[iGvAmmoID]--;
	}

	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		//m_pPlayer->iGvArmes &= ~( 1<<Gm_MORVE_ID );
		m_pPlayer->iGvArmes[Gm_MORVE_SLOT] &= ~( 1<<Gm_MORVE_POSITION );
		SetThink( DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}
	
	GfFinDeTour( &GvTempsFDT_f, 0 );
}

void GcMorve::GfAttack1( void )
{ 
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		GfAttack0( );
		return;
	}
	GfTire( );
}

void GcMorve::GfAttack2( void )
{
	GfAttack0( );
	fGvAttack2 = gpGlobals->time + 0.5;
}

void GcMorve::GfTire( void )
{
	SendWeaponAnim( Ga_MORVE_TIRE );
	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

	EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_WEAPON, Gm_MORVE_FICHIER_SON_TIRE, 1.0, ATTN_NORM);

	GvPreci_i++;
	if( GvPreci_i > 10 )
		GvPreci_i = 10;

	Vector GvOrigin_c = m_pPlayer->GetGunPosition( ) + gpGlobals->v_forward * 16;// + gpGlobals->v_right * 8 + gpGlobals->v_up * -8;

	short GvTraineCouleur_18i[3][6] = 
	{
		{  5, 10,   0, 255,   0, 255 },// Life, Width, r, v, b, brightness
		{  0,  0,   0,   0,   0,   0 },// Life, Width, r, v, b, brightness
		{  0,  0,   0,   0,   0,   0 } // Life, Width, r, v, b, brightness
	};

	int GvBalleOption_i = Gm_BALLE_AUTO_DESTRUCTION | Gm_BALLE_MORVE | Gm_BALLE_MAKE_DOMMAGE | Gm_BALLE_ANIM;

	GcGenericBalle::GfCreateBalle( GvOrigin_c,
								   m_pPlayer->pev->angles, 
								   Gm_MORVE_PRECISION * GvPreci_i / 10, 
								   Gm_MORVE_BALLE_VITESSE, 
								   Gm_MORVE_DOMMAGE, 
								   1,// Duree de vie de la balle si option active.
								   GvTraineCouleur_18i,
								   0,// Nombre de trainees
								   GvBalleOption_i,//short GvOptionCreate, 
								   m_pPlayer, 
								   this,
								   Gm_MORVE_ID );

	m_pPlayer->GfSentirDommange( Gm_MORVE_SENTIR_DOMMAGE * GvPreci_i / 5, 0 );

	m_pPlayer->GvPlayerTPT.bAmmo = true;
	GvTempsFDT_f = gpGlobals->time;
	GvNbTire_i++;

	fGvAttack0 = fGvAttack1 = gpGlobals->time + 0.5;
}

void GcMorve::GfAttack0( void )
{
	fGvAttack0 = gpGlobals->time + 1.0;
	//GfFinDeTour( &GvTempsFDT_f, Gm_MORVE_TEMPS_DEPLACEMENT );

	if( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE )
		UpdateSpot( );
	else if(( m_pSpot )&&!( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE ))
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( GvNbTire_i && !m_pPlayer->GvPlayerTPT.bTire )
	{
		GvNbTire_i = 0;
		GvPreci_i = 1;
		m_pPlayer->m_rgAmmo[iGvAmmoID]--;
	}

	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		m_pPlayer->pev->viewmodel = 0; 
		m_pPlayer->pev->weaponmodel = 0;
	}
}

#endif