/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_morve.h				*
*		06122001				*
\*******************************/

#ifndef ARME_MORVE_H
#define ARME_MORVE_H

#include "define_slot.h"

#ifdef Gd_ARME_MORVE

#define Gm_MORVE_FICHIER_MODEL_P			"models/armes/p_morve.mdl"
#define Gm_MORVE_FICHIER_MODEL_R			"models/armes/r_morve.mdl"
#define Gm_MORVE_FICHIER_MODEL_V			"models/armes/v_morve.mdl"
#define Gm_MORVE_FICHIER_SON_TIRE			"weapons/morve/morve1.wav"

#define Gm_MORVE_DOMMAGE					5
#define Gm_MORVE_MUNITION					1

#define Gm_MORVE_SENTIR_DOMMAGE				5
#define Gm_MORVE_PRECISION					25
#define Gm_MORVE_BALLE_VITESSE				750

class GcMorve : public CBasePlayerWeapon
{
public:
	int GetItemInfo( ItemInfo *p );
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );

private:
	void GfTire( void );

	float GvTempsFDT_f;
	short GvNbTire_i;
	short GvPreci_i;
};

class GcMorveRocket : public GcGrenadeGeneric
{
public:
	void Spawn( void );
	void Precache( void );
	void EXPORT FollowThink( void );
	void EXPORT IgniteThink( void );
	void EXPORT RocketTouch( CBaseEntity *pEntity );
	static GcMorveRocket *CreateRocket( Vector vecOrigin, Vector vecAngles, CBaseEntity *pOwner, GcMorve *pLauncher );

	GcMorve *m_pLauncher;

private:
	int GvSprite;
};

enum 
{
	Ga_MORVE_IDLE1 = 0,
	Ga_MORVE_IDLE2,
	Ga_MORVE_TIRE,
	Ga_MORVE_PREPARE_TIRE,
	Ga_MORVE_FIN_TIRE,
	Ga_MORVE_AFFICHE
};

#endif
#endif // ARME_MORVE_H