/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_mouton.cpp				*
*		25022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "generic_arme.h"
#include "arme_mouton.h"
#include "gamerules.h"

#ifdef Gd_ARME_MOUTON

LINK_ENTITY_TO_CLASS( weapon_mouton, GcMouton );
LINK_ENTITY_TO_CLASS( monster_mouton, GcMoutonCharge );

int GcMouton::GetItemInfo( ItemInfo *p )
{
	p->pszName = STRING( pev->classname );
	p->pszAmmo1 = "munition_mouton";
	p->iMaxAmmo1 = Gm_MUNI_MAX;
	p->iSlot = Gm_MOUTON_SLOT;
	p->iPosition = Gm_MOUTON_POSITION;
	p->iId = m_iId = Gm_MOUTON_ID;
	p->iWeight = Gm_MOUTON_POID;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;
	return 1;
}

void GcMouton::Spawn( void )
{
	Precache( );

	m_iId = Gm_MOUTON_ID;
	iGvAmmoDefault = Gm_MOUTON_MUNITION;

	GvMoutonDraw_b = false;
	GvNbTire_i = 0;
	GvTempsFDT_f = 0;

	FallInit( );
}

void GcMouton::Precache( void )
{
	PRECACHE_MODEL( Gm_MOUTON_FICHIER_MODEL_V );
	PRECACHE_MODEL("models/armes/v_mouton_radio.mdl");
	PRECACHE_MODEL( Gm_MOUTON_FICHIER_MODEL_R );
	PRECACHE_MODEL( Gm_MOUTON_FICHIER_MODEL_P );
	PRECACHE_MODEL( "models/armes/p_mouton_radio.mdl");
	UTIL_PrecacheOther( "monster_mouton" );
}

BOOL GcMouton::Deploy( void )
{
	if( GvNbTire_i > 0 )
	{
		m_pPlayer->pev->viewmodel = MAKE_STRING( Gm_MOUTON_FICHIER_MODEL_RADIO_V );
		m_pPlayer->pev->weaponmodel = MAKE_STRING( Gm_MOUTON_FICHIER_MODEL_RADIO_P );
		SendWeaponAnim( Ga_MOUTON_RADIO_DRAW );
	}
	else
	{
		m_pPlayer->pev->viewmodel = MAKE_STRING( Gm_MOUTON_FICHIER_MODEL_V );
		m_pPlayer->pev->weaponmodel = MAKE_STRING( Gm_MOUTON_FICHIER_MODEL_P );
		SendWeaponAnim( Ga_MOUTON_DRAW );
	}
	GvTempsAnim_f = gpGlobals->time + 2.0;
	return TRUE;
}

void GcMouton::Holster( void )
{
	if( GvNbTire_i )
		GvTire2( );

	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		//m_pPlayer->iGvArmes &= ~( 1<<Gm_MOUTON_ID );
		m_pPlayer->iGvArmes[Gm_MOUTON_SLOT] &= ~( 1<<Gm_MOUTON_POSITION );
		SetThink( DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}

	GfFinDeTour( &GvTempsFDT_f, 0 );
}

void GcMouton::GfAttack1( void )
{
	if( GvNbTire_i )
		GvTire2( );
	else
		GvTire1( );

	fGvAttack1 = fGvAttack0 = gpGlobals->time + 0.5;
}

void GcMouton::GvTire2( void )
{
	GfFinDeTour( &GvTempsFDT_f, Gm_MOUTON_TEMPS_DEPLACEMENT );

	GfSonAttack( );

	GvTempsAnim_f = gpGlobals->time + 2.0;
	SendWeaponAnim( Ga_MOUTON_RADIO_TIRE );
	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

	GpMouton = NULL;
	while((( GpMouton = UTIL_FindEntityByClassname( GpMouton, "mouton" )) != NULL ))
		if( GpMouton->pev->owner == ENT( m_pPlayer->pev ))
			GpMouton->Use( m_pPlayer, m_pPlayer, USE_ON, 0 );

	if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		GvMoutonDraw_b = true;

	GvNbTire_i = 0;

	m_pPlayer->GvPlayerTPT.bAmmo = false;
	m_pPlayer->GvPlayerTPT.bTire = false;
	GvTempsFDT_f = gpGlobals->time;

	fGvAttack1 = fGvAttack0 = gpGlobals->time + 0.5;
}

void GcMouton::GvTire1( void )
{
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		GfAttack0( );
		return;
	}
	
	m_pPlayer->pev->viewmodel = MAKE_STRING( Gm_MOUTON_FICHIER_MODEL_RADIO_V );
	m_pPlayer->pev->weaponmodel = MAKE_STRING( Gm_MOUTON_FICHIER_MODEL_RADIO_P );

	Vector GvAngle = m_pPlayer->pev->v_angle + m_pPlayer->pev->punchangle;

	if( GvAngle.x < 0 )
		GvAngle.x = -10 + GvAngle.x * ((90 - 10) / 90.0);
	else
		GvAngle.x = -10 + GvAngle.x * ((90 + 10) / 90.0);

	GvAngle.z = 10;
	UTIL_MakeVectors( GvAngle );

	GcMoutonCharge::GfMouton( m_pPlayer, m_pPlayer->pev->origin, m_pPlayer->pev->velocity + gpGlobals->v_forward * 100, GfDommage( Gm_MOUTON_DOMMAGE ));

	GvNbTire_i = 1;

	GvTempsAnim_f = gpGlobals->time + 2.0;
	SendWeaponAnim( Ga_MOUTON_RADIO_DRAW );
	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

	m_pPlayer->m_rgAmmo[iGvAmmoID]--;
	GvNbTire_i++;

	m_pPlayer->GvPlayerTPT.bAmmo = true;
}

void GcMouton::GfAttack2( void )
{
	GfAttack0( );
	fGvAttack2 = gpGlobals->time + 0.5;
}

void GcMouton::GfAttack0( void )
{
	fGvAttack0 = gpGlobals->time + 1.0;
	GfFinDeTour( &GvTempsFDT_f, Gm_MOUTON_TEMPS_DEPLACEMENT );

	if( !m_pPlayer->GvPlayerTPT.bTire && GvNbTire_i )
		GvTire2( );

	if( GvTempsAnim_f < gpGlobals->time )
	{
		if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		{
			if( GvMoutonDraw_b )
			{
				m_pPlayer->pev->viewmodel = MAKE_STRING( Gm_MOUTON_FICHIER_MODEL_V );
				m_pPlayer->pev->weaponmodel = MAKE_STRING( Gm_MOUTON_FICHIER_MODEL_P );
				SendWeaponAnim( Ga_MOUTON_DRAW );
				GvMoutonDraw_b = false;
				GvTempsAnim_f = gpGlobals->time + 2.0;
				return;
			}

			switch( GvNbTire_i )
			{
			case 0:
				int GvAnim_i;
				switch( RANDOM_LONG( 1,4 ))
				{
				case 1:case 2:
					GvAnim_i = Ga_MOUTON_IDLE1;
					GvTempsAnim_f = gpGlobals->time + 4.0;
					break;
				case 3:
					GvAnim_i = Ga_MOUTON_IDLE2;
					GvTempsAnim_f = gpGlobals->time + 1.0;
					break;
				case 4:
					GvAnim_i = Ga_MOUTON_IDLE3;
					GvTempsAnim_f = gpGlobals->time + 1.6;
					break;
				default:
					GvAnim_i = Ga_MOUTON_IDLE1;
					GvTempsAnim_f = gpGlobals->time + 4.0;
					break;
				}
				SendWeaponAnim( GvAnim_i );
				break;
			case 1:
				m_pPlayer->pev->viewmodel = MAKE_STRING( Gm_MOUTON_FICHIER_MODEL_RADIO_V );
				m_pPlayer->pev->weaponmodel = MAKE_STRING( Gm_MOUTON_FICHIER_MODEL_RADIO_P );
				GvTempsAnim_f = gpGlobals->time + 4.0;
				SendWeaponAnim( Ga_MOUTON_RADIO_IDLE1 );
				break;
			}
		}
		else if( !m_pPlayer->GvPlayerTPT.bAmmo )
		{
			m_pPlayer->pev->viewmodel = 0; 
			m_pPlayer->pev->weaponmodel = 0;
		}
	}
}

//////////////////////////////////////////////////////////////

GcMoutonCharge *GcMoutonCharge::GfMouton( CBasePlayer *pGvPlayer, Vector GvOrigin, Vector GvVelocity, int iGvDommage )
{
	GcMoutonCharge *pGvGrenade = GetClassPtr(( GcMoutonCharge * )NULL );

	pGvGrenade->pGvPlayer = pGvPlayer;
	if( pGvGrenade->pGvPlayer )
		pGvGrenade->pev->owner = ENT( pGvPlayer->pev );

	pGvGrenade->pev->classname = MAKE_STRING( "mouton" );
	pGvGrenade->Spawn( );

	UTIL_SetOrigin( pGvGrenade->pev, GvOrigin );
	pGvGrenade->pev->velocity = GvVelocity;
	pGvGrenade->pev->angles = UTIL_VecToAngles( pGvGrenade->pev->velocity );
	pGvGrenade->pev->dmg = iGvDommage;
	
	return pGvGrenade;
}

void GcMoutonCharge::GfDeactivate( void )
{
	if( pGvPlayer )
		pGvPlayer->GvPlayerTPT.bAmmo = false;
	UTIL_Remove( this );
}

void GcMoutonCharge :: Spawn( void )
{
	Precache( );

	pev->movetype = MOVETYPE_BOUNCE;
	pev->solid = SOLID_BBOX;

	SET_MODEL( ENT(pev), Gm_MOUTON_FICHIER_MODEL_R );
	UTIL_SetSize( pev, Vector( -4,-4,-4 ), Vector( 4,4,4 ));
	UTIL_SetOrigin( pev, pev->origin );

	GvPremierBond_b = true;

	SetTouch( GfTouch );
	SetThink( GfThink );
	SetUse( GfMoutonDetonationUse );
	
	pev->gravity = Gm_MOUTON_GRAVITE;
	pev->friction = Gm_MOUTON_REBOND;
	pev->dmg = Gm_MOUTON_DOMMAGE;
	pev->sequence = 1;

	pev->nextthink = gpGlobals->time + 0.02;
}

void GcMoutonCharge::GfTouch( CBaseEntity *pOther )
{
	entvars_t	*pevOther = pOther->pev;

	if ( pOther->edict( ) == pev->owner )
		return;

	pev->gravity = Gm_MOUTON_GRAVITE;
	pev->frame = 0; // Groove - 23072002 - restart anim jump

	TraceResult tr;
	UTIL_TraceLine( pev->origin, pev->origin - Vector( 0,0,10 ), ignore_monsters, edict(), &tr );

	if(( tr.flFraction < 1.0 ) && ( GvPremierBond_b ))
	{
		GvPremierBond_b = false;
		pev->velocity *= Gm_MOUTON_REBOND_MULTI;
	}

	if(!( pev->flags & FL_ONGROUND ) && pev->velocity.Length2D( ) > 10 )
		EMIT_SOUND( ENT( pev ), CHAN_VOICE, Gm_MOUTON_FICHIER_SON_REBOND, 1, ATTN_NORM );

//	StudioFrameAdvance( );
}

void GcMoutonCharge :: GfThink( void )
{
	StudioFrameAdvance( );
	pev->nextthink = gpGlobals->time + 0.02;

	if( pev->frame < 255 )
		pev->frame = ((int)pev->frame + 10 );// % 255;

	pev->velocity.z += 2;

//	pev->velocity += g_pGameRules->GvVent;

	if( pev->velocity.z >= Gm_MOUTON_HAUTEUR_MAX )
		pev->velocity.z = Gm_MOUTON_HAUTEUR_MAX;

	if( UTIL_PointContents( pev->origin ) != CONTENTS_EMPTY )
	{
		pGvPlayer->GvPlayerTPT.bAmmo = false;
		GfDeactivate( );
	}
	else if( pev->waterlevel == 0 )
		pev->movetype = MOVETYPE_BOUNCE;
	
	pev->angles = UTIL_VecToAngles( pev->velocity );
}

void GcMoutonCharge :: Precache( void )
{
	PRECACHE_SOUND( Gm_MOUTON_FICHIER_SON_REBOND );
}

#endif