/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_mouton.h				*
*		19122001				*
\*******************************/

#ifndef ARME_MOUTON_H
#define ARME_MOUTON_H

#include "define_slot.h"

#ifdef Gd_ARME_MOUTON

#define Gm_MOUTON_FICHIER_MODEL_RADIO_P		"models/armes/p_mouton_radio.mdl"
#define Gm_MOUTON_FICHIER_MODEL_RADIO_V		"models/armes/v_mouton_radio.mdl"
#define Gm_MOUTON_FICHIER_MODEL_P			"models/armes/p_mouton.mdl"
#define Gm_MOUTON_FICHIER_MODEL_V			"models/armes/v_mouton.mdl"
#define Gm_MOUTON_FICHIER_MODEL_R			"models/armes/r_mouton.mdl"
#define Gm_MOUTON_FICHIER_SON_REBOND		"weapons/mouton/mouton1.wav"

#define Gm_MOUTON_DOMMAGE					100
#define Gm_MOUTON_MUNITION					1
#define Gm_MOUTON_TEMPS_DEPLACEMENT			0

#define Gm_MOUTON_GRAVITE					0.5
#define Gm_MOUTON_HAUTEUR_MAX				200
#define Gm_MOUTON_REBOND					0.01
#define Gm_MOUTON_REBOND_MULTI				2

class GcMouton : public CBasePlayerWeapon
{
public:
	int GetItemInfo( ItemInfo *p );
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );

private:
	CBaseEntity *GpMouton;

	void GvTire1( void );
	void GvTire2( void );

	bool bGvMoutonActive;
	bool GvMoutonDraw_b;
	short GvNbTire_i;
	float GvTempsFDT_f;
	float GvTempsAnim_f;
};

class GcMoutonCharge : public GcGrenadeGeneric
{
public:
	static GcMoutonCharge *GfMouton( CBasePlayer *pGvPlayer, Vector GvOrigin, Vector GvVelocity, int iGvDommage );

	void Spawn( void );
	void Precache( void );
	void GfDeactivate( void );

private:
	void EXPORT GfTouch( CBaseEntity *pOther );
	void EXPORT GfThink( void );
	void GfBounceSound( void );

	bool GvPremierBond_b;
};

enum
{
	Ga_MOUTON_IDLE1 = 0,
	Ga_MOUTON_IDLE2,
	Ga_MOUTON_IDLE3,
	Ga_MOUTON_TIRE,
	Ga_MOUTON_DRAW
};

enum
{
	Ga_MOUTON_RADIO_IDLE1 = 0,
	Ga_MOUTON_RADIO_TIRE,
	Ga_MOUTON_RADIO_DRAW,
	Ga_MOUTON_RADIO_HOLSTER
};

#endif
#endif // ARME_MOUTON_H