/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_air_strike.h			*
*		19122001				*
\*******************************/

#ifndef Gd_P_ARME_NAPALM
#define Gd_P_ARME_NAPALM

#include "define_slot.h"

#ifdef Gd_ARME_NAPALM

#define Gm_NAPALM_FICHIER_MODEL_P			"models/armes/p_napalm.mdl"
#define Gm_NAPALM_FICHIER_MODEL_R			"models/armes/r_napalm.mdl"
#define Gm_NAPALM_FICHIER_MODEL_V			"models/armes/v_napalm.mdl"
#define Gm_NAPALM_FICHIER_SON_TIRE			"weapons/air_strike/air_strike2.wav"
#define Gm_NAPALM_FICHIER_SON_TRAINE		"weapons/air_strike/air_strike1.wav"
#define Gm_NAPALM_FICHIER_SPRITE_DOT		"sprites/laserdot.spr"
#define Gm_NAPALM_FICHIER_SPRITE_TRAINE		"sprites/smoke.spr"
#define Gm_NAPALM_FICHIER_SPRITE_CIBLE		"sprites/jeu/armes/croix1.spr"
#define Gm_NAPALM_FICHIER_SON_CIBLE			"weapons/commun/cible1.wav"

#define Gm_NAPALM_DOMMAGE					25
#define Gm_NAPALM_TEMPS_DEPLACEMENT			0
#define Gm_NAPALM_MUNITION					1

class GcNapalm : public CBasePlayerWeapon
{
public:
	void Spawn( void );
	void Precache( void );
	int GetItemInfo(ItemInfo *p);
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );

private:
	void GfTire1( void );
	void GfTire2( void );

	CSprite *m_pSprite;
	float GvTempsAnim_f;
	float GvTempsFDT_f;
	short GvChoixTire_i;
};

class GcNapalmRocket : public GcGrenadeGeneric
{
public:
	void Spawn( void );
	void Precache( void );
	static GcNapalmRocket *CreateRocket( CBasePlayer *pGvPlayer, Vector GvOrigin, Vector GvAngles );

private:
	void EXPORT GfActualise( void );
	void EXPORT GfTouch( CBaseEntity *pOther );
	void GfTraine( void );

	int GvTrail_i;
};

enum
{
	Ga_NAPALM_DRAW = 0,
	Ga_NAPALM_IDLE1,
	Ga_NAPALM_IDLE2,
	Ga_NAPALM_ATTACK_PREPA,
	Ga_NAPALM_ATTACK_ILDE,
	Ga_NAPALM_ATTACK
};

#endif
#endif //Gd_P_ARME_NAPALM