/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_pheonix.h				*
*		19122001				*
\*******************************/

#ifndef ARME_PHEONIX_H
#define ARME_PHEONIX_H

#include "define_slot.h"

#ifdef Gd_ARME_PHEONIX

#define Gm_PHEONIX_FICHIER_MODEL_P		"models/armes/p_pigeon.mdl"
#define Gm_PHEONIX_FICHIER_MODEL_R		"models/armes/r_phoenix.mdl"
#define Gm_PHEONIX_FICHIER_MODEL_V		"models/armes/v_pigeon.mdl"
#define Gm_PHEONIX_FICHIER_SON_TIRE		"weapons/pigeon/pigeon1.wav"

#define Gm_PHEONIX_DOMMAGE				50
#define Gm_PHEONIX_MUNITION				1
#define Gm_PHEONIX_TEMPS_DEPLACEMENT	3.0

#define Gm_PHEONIX_COEF_PUISSANCE		350
#define Gm_PHEONIX_RECUL				15
#define Gm_PHEONIX_ROCKET_GRAVITE		1.0

class GcPheonix : public CBasePlayerWeapon
{
public:
	int GetItemInfo( ItemInfo *p );
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );	

private:
	void GfTire( float GvTirePuis_f );

	bool GvAnimOn_b;
	float GvTempsAnim_f;
	float GvTempsFDT_f;
	float GvTempsPuis_f;
};

class GcPheonixRocket : public GcGrenadeGeneric
{
public:
	void Spawn( void );
	void Precache( void );

	static GcPheonixRocket *GfCreatePheonix( CBasePlayer *pGvPlayer, Vector GvOrigin_c, Vector GvAngles_c, int GvVitesse_i );

private:
	void EXPORT GfThink( void );
	void EXPORT GfTouch( CBaseEntity *pOther );
	void GfTraine( void );

	CBaseEntity *pEntity;
	int GvTraine_i;
	float fGvTempsIntervalRecherche;
	float fGvTempsAttack;
};

enum
{
	Ga_PHEONIX_DRAW = 0,
	Ga_PHEONIX_IDLE_01,
	Ga_PHEONIX_IDLE_02,
	Ga_PHEONIX_IDLE_03,
	Ga_PHEONIX_PREPARE_TIRE_01,
	Ga_PHEONIX_PREPARE_TIRE_02,
	Ga_PHEONIX_TIRE
};

#endif
#endif // ARME_PHEONIX_H