/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_pigeon.cpp				*
*		22032002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "generic_arme.h"
#include "arme_pigeon.h"
#include "game.h"
#include "gamerules.h"

#ifdef Gd_ARME_PIGEON

LINK_ENTITY_TO_CLASS( weapon_pigeon, GcPigeon );
LINK_ENTITY_TO_CLASS( rocket_pigeon, GcPigeonRocket );

int GcPigeon::GetItemInfo( ItemInfo *p )
{
	p->pszName = STRING( pev->classname );
	p->pszAmmo1 = "munition_pigeon";
	p->iMaxAmmo1 = Gm_MUNI_MAX;
	p->iSlot = Gm_PIGEON_SLOT;
	p->iPosition = Gm_PIGEON_POSITION;
	p->iId = m_iId = Gm_PIGEON_ID;
	p->iWeight = Gm_PIGEON_POID;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;
	return 1;
}

void GcPigeon::Spawn( void )
{
	Precache( );

	m_iId = Gm_PIGEON_ID;
	iGvAmmoDefault = Gm_PIGEON_MUNITION;

	GvAnimOn_b = false;
	GvTempsPuis_f = 0;
	GvTempsFDT_f = 0;

	FallInit( );
}

void GcPigeon::Precache( void )
{
	PRECACHE_MODEL( Gm_PIGEON_FICHIER_MODEL_P );
	PRECACHE_MODEL( Gm_PIGEON_FICHIER_MODEL_V );
	PRECACHE_MODEL( Gm_PIGEON_FICHIER_MODEL_R );
	PRECACHE_SOUND( Gm_PIGEON_FICHIER_SON_TIRE );
//	UTIL_PrecacheOther( "rocket_pigeon" );
}

BOOL GcPigeon::Deploy( void )
{
	GvTempsAnim_f = gpGlobals->time + 2.0;
	return DefaultDeploy( Gm_PIGEON_FICHIER_MODEL_V, Gm_PIGEON_FICHIER_MODEL_P, Ga_PIGEON_DRAW, "pigeon" );
}

void GcPigeon::Holster( void )
{
	if( m_pSpot )
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		//m_pPlayer->iGvArmes &= ~( 1<<Gm_PIGEON_ID );
		m_pPlayer->iGvArmes[Gm_PIGEON_SLOT] &= ~( 1<<Gm_PIGEON_POSITION );
		SetThink( DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}

	GfFinDeTour( &GvTempsFDT_f, 0 );
}

void GcPigeon::GfAttack1( void )
{
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		GfAttack0( );
		return;
	}

	if( !GvTempsPuis_f )
	{
		GvTempsPuis_f = gpGlobals->time;
		SendWeaponAnim( Ga_PIGEON_PREPARE_TIRE_01 );
		GfSonPuissanceOn( );
	}

	if((( gpGlobals->time - GvTempsPuis_f ) > 0.5 )&& !GvAnimOn_b )
	{
		GvAnimOn_b = true;
		SendWeaponAnim( Ga_PIGEON_PREPARE_TIRE_02 );
	}

	if( GfPuissanceProgressive( GvTempsPuis_f ))
		GfTire( Gm_ARME_TEMPS_TIRE_MAX );

	fGvAttack0 = fGvAttack1 = gpGlobals->time + 0.02;
}

void GcPigeon::GfTire( float GvTirePuis_f )
{
	GfPuissanceAffichage( WEAPON_PUISS_PROG_OFF, Gm_WORM_DEFAUT );
	GfSonAttack( );

	SendWeaponAnim( Ga_PIGEON_TIRE );
	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

	EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_ITEM, Gm_PIGEON_FICHIER_SON_TIRE, 1, ATTN_NORM );
	
	m_pPlayer->m_iWeaponFlash = BRIGHT_GUN_FLASH;
	m_pPlayer->pev->effects = (int)(m_pPlayer->pev->effects) | EF_MUZZLEFLASH;

	Vector GvOrigin_c = m_pPlayer->GetGunPosition( ) + gpGlobals->v_forward * 16;
	
	GcPigeonRocket::GfCreatePigeon( m_pPlayer, GvOrigin_c, m_pPlayer->pev->angles, static_cast<int>( 100 * GvTirePuis_f ));
	
	m_pPlayer->m_rgAmmo[iGvAmmoID]--;

	GvAnimOn_b = false;
	GvTempsPuis_f = 0;
	GvTempsFDT_f = 0;
	GvTempsAnim_f = gpGlobals->time + 3.0;
	
	m_pPlayer->GvPlayerTPT.bAmmo = true;
	m_pPlayer->GvPlayerTPT.bTire = false;
	GvTempsFDT_f = gpGlobals->time;
}

void GcPigeon::GfAttack2( void )
{
	GfAttack0( );
	fGvAttack2 = gpGlobals->time + 0.5;
}

void GcPigeon::GfAttack0( void )
{
	fGvAttack0 = gpGlobals->time + 1.0;
	GfFinDeTour( &GvTempsFDT_f, Gm_PIGEON_TEMPS_DEPLACEMENT );

	if( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE )
		UpdateSpot( );
	else if( m_pSpot &&!( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE ))
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( GvTempsPuis_f )
	{
		if(( gpGlobals->time - GvTempsPuis_f ) < 0.2 )
			GfMsgStupide( m_pPlayer );
		
		if( !m_pPlayer->IsAlive( ))
			GvTempsPuis_f = 0.0;
		else 
			GfTire( gpGlobals->time - GvTempsPuis_f );
	}

	if( GvTempsAnim_f &&( GvTempsAnim_f < gpGlobals->time ))
	{
		if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		{
			int GvAnim_i;
			switch( RANDOM_LONG( 1,2 ))
			{
			default:
			case 1:
				GvAnim_i = Ga_PIGEON_IDLE_01;
				GvTempsAnim_f = gpGlobals->time + 2.0;
				break;
/*
			case 2:
				GvAnim_i = Ga_PIGEON_IDLE_02;
				GvTempsAnim_f = gpGlobals->time + 3.0;
				break;
*/
			case 2:
				GvAnim_i = Ga_PIGEON_IDLE_03;
				GvTempsAnim_f = gpGlobals->time + 2.0;
				break;
			}
			SendWeaponAnim( GvAnim_i );
		}
		else
		{
			m_pPlayer->pev->viewmodel = 0; 
			m_pPlayer->pev->weaponmodel = 0;
		}
	}
}

///////////////////////////////////////////////////////////

GcPigeonRocket *GcPigeonRocket::GfCreatePigeon( CBasePlayer *pGvPlayer, Vector GvOrigin_c, Vector GvAngles_c, int GvVitesse_i )
{
	GcPigeonRocket *pRocket = GetClassPtr(( GcPigeonRocket *)NULL );

	pRocket->pGvPlayer = pGvPlayer;
	pRocket->pev->owner = ENT( pGvPlayer->pev );

	UTIL_SetOrigin( pRocket->pev, GvOrigin_c );
	pRocket->pev->angles = GvAngles_c;
	pRocket->pev->velocity = gpGlobals->v_forward * GvVitesse_i + gpGlobals->v_up * GvVitesse_i;
	pRocket->Spawn( );

	return pRocket;
}

void GcPigeonRocket :: Spawn( void )
{
	Precache( );

	pev->classname = MAKE_STRING( "pigeon" );
	pev->movetype = MOVETYPE_BOUNCE;
	pev->solid = SOLID_BBOX;
	pev->gravity = Gm_PIGEON_ROCKET_GRAVITE;
	pev->dmg = Gm_PIGEON_DOMMAGE;

	SET_MODEL( ENT(pev), Gm_PIGEON_FICHIER_MODEL_R );
	UTIL_SetSize( pev, Vector( -8, -8, -4 ), Vector( 8, 8, 4 ));

	SetThink( GfThink );
	SetTouch( GfTouch );

	if( GvQTrailCMD_i )
		GfTraine( );

	GvTempsIntervalRecherche_f = gpGlobals->time + 0.5;

	pev->nextthink = gpGlobals->time + 0.01;
}

void GcPigeonRocket :: GfThink( void  )
{
	pev->movetype = MOVETYPE_FLY;
	if( GvQDLightCMD_i )
		pev->effects = EF_BRIGHTLIGHT + EF_DIMLIGHT;
	pev->frame = ((int)pev->frame + 10 ) % 255;
	pev->nextthink = gpGlobals->time + 0.01;

	if( GvTempsIntervalRecherche_f < gpGlobals->time )
	{
		GvTempsIntervalRecherche_f = gpGlobals->time + 0.25;
		pEntity = NULL;
		Vector GvTarget_c = Vector( 0,0,0 );
		Vector GvDirection_c;
		float flDist, flMax, flDot;
		TraceResult tr;

		UTIL_MakeAimVectors( pev->angles );

		GvTarget_c = gpGlobals->v_forward;
		// Rayon de recherche d'un joueur par le pigeon
		flMax = 8192;

		while(( pEntity = UTIL_FindEntityByClassname( pEntity, "player" )) != NULL )
		{
			UTIL_TraceLine ( pev->origin, pEntity->pev->origin, dont_ignore_monsters, ENT(pev), &tr );
			if( tr.flFraction >= 0.90 )
			{
				GvDirection_c = pEntity->pev->origin - pev->origin;
				flDist = GvDirection_c.Length( );
				GvDirection_c = GvDirection_c.Normalize( );
				flDot = DotProduct( gpGlobals->v_forward, GvDirection_c );
				if (( flDot > 0 )&&( flDist * ( 1 - flDot ) < flMax ))
				{
					flMax = flDist * (1 - flDot);
					GvTarget_c = GvDirection_c;
				}
			}
		}

		if( GvTarget_c != Vector( 0,0,0 ))
			pev->angles = UTIL_VecToAngles( GvTarget_c );

		pev->angles.x += RANDOM_LONG( - 45, 45 );
		pev->angles.y += RANDOM_LONG( - 45, 45 );
		pev->angles.z += RANDOM_LONG( - 45, 45 );

		pev->velocity = gpGlobals->v_forward * 256;
	}
}

void GcPigeonRocket :: Precache( void )
{
	GvTraine_i = PRECACHE_MODEL("sprites/smoke.spr");
}

void GcPigeonRocket :: GfTouch ( CBaseEntity *pOther )
{
	GfGeneralDetonationTouch( pOther );
	UTIL_Remove( this );
}

void GcPigeonRocket :: GfTraine( void )
{
	MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
		WRITE_BYTE( TE_BEAMFOLLOW );
		WRITE_SHORT( entindex( ));	// entity
		WRITE_SHORT( GvTraine_i );	// model
		WRITE_BYTE( 10 );			// life
		WRITE_BYTE( 20 );			// width
		WRITE_BYTE( 255 );			// r
		WRITE_BYTE( 128 );			// g
		WRITE_BYTE( 128 );			// b
		WRITE_BYTE( 128 );			// brightness
	MESSAGE_END( );					// move PHS/PVS data sending into here (SEND_ALL, SEND_PVS, SEND_PHS)

	MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
		WRITE_BYTE( TE_BEAMFOLLOW );
		WRITE_SHORT( entindex( ));	// entity
		WRITE_SHORT( GvTraine_i );	// model
		WRITE_BYTE( 5 );			// life
		WRITE_BYTE( 5 );			// width
		WRITE_BYTE( 255 );			// r 
		WRITE_BYTE( 128 );			// g
		WRITE_BYTE( 0 );			// b
		WRITE_BYTE( 255 );			// brightness
	MESSAGE_END( );					// move PHS/PVS data sending into here (SEND_ALL, SEND_PVS, SEND_PHS)
}

#endif