/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_pigeon.h				*
*		19122001				*
\*******************************/

#ifndef ARME_PIGEON_H
#define ARME_PIGEON_H

#include "define_slot.h"

#ifdef Gd_ARME_PIGEON

#define Gm_PIGEON_FICHIER_MODEL_P		"models/armes/p_pigeon.mdl"
#define Gm_PIGEON_FICHIER_MODEL_R		"models/armes/r_pigeon.mdl"
#define Gm_PIGEON_FICHIER_MODEL_V		"models/armes/v_pigeon.mdl"
#define Gm_PIGEON_FICHIER_SON_TIRE		"weapons/pigeon/pigeon1.wav"

#define Gm_PIGEON_DOMMAGE				75
#define Gm_PIGEON_MUNITION				1
#define Gm_PIGEON_TEMPS_DEPLACEMENT		3.0

#define Gm_PIGEON_COEF_PUISSANCE		350
#define Gm_PIGEON_RECUL					15
#define Gm_PIGEON_ROCKET_GRAVITE		1.0

class GcPigeon : public CBasePlayerWeapon
{
public:
	int GetItemInfo( ItemInfo *p );
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );	

private:
	void GfTire( float GvTirePuis_f );

	bool GvAnimOn_b;
	float GvTempsAnim_f;
	float GvTempsFDT_f;
	float GvTempsPuis_f;
};

class GcPigeonRocket : public GcGrenadeGeneric
{
public:
	void Spawn( void );
	void Precache( void );

	static GcPigeonRocket *GfCreatePigeon( CBasePlayer *pGvPlayer, Vector GvOrigin_c, Vector GvAngles_c, int GvVitesse_i );

private:
	void EXPORT GfThink( void );
	void EXPORT GfTouch( CBaseEntity *pOther );
	void GfTraine( void );

	CBaseEntity *pEntity;
	int GvTraine_i;
	float GvTempsIntervalRecherche_f;
};

enum
{
	Ga_PIGEON_DRAW = 0,
	Ga_PIGEON_IDLE_01,
	Ga_PIGEON_IDLE_02,
	Ga_PIGEON_IDLE_03,
	Ga_PIGEON_PREPARE_TIRE_01,
	Ga_PIGEON_PREPARE_TIRE_02,
	Ga_PIGEON_TIRE
};

#endif
#endif // ARME_PIGEON_H