/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_sainte.cpp				*
*		19022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "generic_arme.h"
#include "arme_sainte.h"
#include "gamerules.h"

#ifdef Gd_ARME_SAINTE

LINK_ENTITY_TO_CLASS( weapon_sainte, GcSainte );

int GcSainte::GetItemInfo( ItemInfo *p )
{
	p->pszName = STRING( pev->classname );
	p->pszAmmo1 = "munition_sainte";
	p->iMaxAmmo1 = Gm_MUNI_MAX;
	p->iSlot = Gm_SAINTE_SLOT;
	p->iPosition = Gm_SAINTE_POSITION;
	p->iId = m_iId = Gm_SAINTE_ID;
	p->iWeight = Gm_SAINTE_POID;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;
	return 1;
}

void GcSainte::Spawn( void )
{
	Precache( );

	m_iId = Gm_SAINTE_ID;
	iGvAmmoDefault = Gm_SAINTE_MUNITION;

	GvTempsPuis_f = 0;
	GvTempsFDT_f = 0;

	FallInit( );
}

void GcSainte::Precache( void )
{
	PRECACHE_MODEL( Gm_SAINTE_FICHIER_MODEL_P );
	PRECACHE_MODEL( Gm_SAINTE_FICHIER_MODEL_V );
	PRECACHE_MODEL( Gm_SAINTE_FICHIER_MODEL_W );
	PRECACHE_SOUND( Gm_SAINTE_FICHIER_SON_ALLELOUIA );
	PRECACHE_SOUND( Gm_SAINTE_FICHIER_SON_REBOND );
}

BOOL GcSainte::Deploy( void )
{
	GvTempsAnim_f = gpGlobals->time + 2.0;
	return DefaultDeploy( Gm_SAINTE_FICHIER_MODEL_V, Gm_SAINTE_FICHIER_MODEL_P, Ga_SAINTE_DRAW, "crowbar" );
}

void GcSainte::Holster( void )
{
	if( m_pSpot )
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		//m_pPlayer->iGvArmes &= ~( 1<<Gm_SAINTE_ID );
		m_pPlayer->iGvArmes[Gm_SAINTE_SLOT] &= ~( 1<<Gm_SAINTE_POSITION );
		SetThink( DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}

	GfFinDeTour( &GvTempsFDT_f, 0 );
}

void GcSainte::GfAttack1( void )
{
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		GfAttack0( );
		return;
	}

	if( !GvTempsPuis_f )
	{
		GvTempsPuis_f = gpGlobals->time;
		GfSonPuissanceOn( );
	}

	if( GfPuissanceProgressive( GvTempsPuis_f ) )
		GfTire( Gm_ARME_TEMPS_TIRE_MAX );

	fGvAttack1 = fGvAttack0 = gpGlobals->time + 0.02;
}

void GcSainte::GfTire( float GvTirePuis_f )
{
	GfPuissanceAffichage( WEAPON_PUISS_PROG_OFF, Gm_WORM_DEFAUT );
	GfSonAttack( );

	SendWeaponAnim( Ga_SAINTE_TIRE_01 );
	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

	Vector GvAngle_c = m_pPlayer->pev->v_angle + m_pPlayer->pev->punchangle;

	if( GvAngle_c.x < 0 )
		GvAngle_c.x = -10 + GvAngle_c.x * ((90 - 10) / 90.0);
	else
		GvAngle_c.x = -10 + GvAngle_c.x * ((90 + 10) / 90.0);

	float GvVelocity_f = (90 - GvAngle_c.x) * 4;
	if( GvVelocity_f > 500 )
		GvVelocity_f = 500;

	UTIL_MakeVectors( GvAngle_c );

	Vector GvOrigine_c = m_pPlayer->GetGunPosition( ) + gpGlobals->v_forward * 16;
	Vector GvVelocity_c = gpGlobals->v_forward * (( GvVelocity_f / Gm_SAINTE_COEF_TIRE ) * static_cast<int>( GvTirePuis_f * 100 )) + m_pPlayer->pev->velocity;
	GvVelocity_c += g_pGameRules->GvVent;

	GcGrenadeGeneric::GfSainte( m_pPlayer, GvOrigine_c, GvVelocity_c, Gm_SAINTE_EXPLOSE, GfDommage( Gm_SAINTE_DOMMAGE ));

	m_pPlayer->m_rgAmmo[iGvAmmoID]--;
	GvTempsAllelouia_f = gpGlobals->time + 3.0;
	GvTempsAnim_f = gpGlobals->time + 3.0;
	GvTempsPuis_f = 0;

	m_pPlayer->GvPlayerTPT.bAmmo = true;
	m_pPlayer->GvPlayerTPT.bTire = false;
	GvTempsFDT_f = gpGlobals->time;
}

void GcSainte::GfAttack2( void )
{
	GfAttack0( );
	fGvAttack2 = gpGlobals->time + 0.5;
}

void GcSainte::GfAttack0( void )
{
	fGvAttack0 = gpGlobals->time + 1.0;
	GfFinDeTour( &GvTempsFDT_f, Gm_SAINTE_TEMPS_DEPLACEMENT );

	if( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE )
		UpdateSpot( );
	else if( m_pSpot &&!( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE ))
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if(( GvTempsAllelouia_f < gpGlobals->time )&& GvTempsAllelouia_f )
	{
		GvTempsAllelouia_f = 0;
		EMIT_SOUND( ENT( pev ), CHAN_WEAPON, Gm_SAINTE_FICHIER_SON_ALLELOUIA, 1, ATTN_NONE );
	}
	
	if( GvTempsPuis_f )
	{
		// Groove - 12122001 - Un msg inutile
		if(( gpGlobals->time - GvTempsPuis_f ) < 0.2 )
			GfMsgStupide( m_pPlayer );

		if( !m_pPlayer->IsAlive( ))
			GvTempsPuis_f = 0.0;
		else 
			GfTire( gpGlobals->time - GvTempsPuis_f );

		return;
	}

	if( GvTempsAnim_f &&( GvTempsAnim_f < gpGlobals->time ))
	{
		if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		{
			int GvAnim_i;
			switch( RANDOM_LONG( 1,2 ))
			{
			default:
			case 1:
				GvAnim_i = Ga_SAINTE_ILDE_01;
				GvTempsAnim_f = gpGlobals->time + 6.0;
				break;
			case 2:
				GvAnim_i = Ga_SAINTE_ILDE_02;
				GvTempsAnim_f = gpGlobals->time + 2.0;
				break;
			}
			SendWeaponAnim( GvAnim_i );
		}
		else
		{
			m_pPlayer->pev->viewmodel = 0; 
			m_pPlayer->pev->weaponmodel = 0;
		}
	}
}

#endif