/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_sainte.h				*
*		06122001				*
\*******************************/

#ifndef ARME_SAINTE_H
#define ARME_SAINTE_H

#include "define_slot.h"

#ifdef Gd_ARME_SAINTE

#define Gm_SAINTE_FICHIER_MODEL_P			"models/armes/p_sainte.mdl"
#define Gm_SAINTE_FICHIER_MODEL_V			"models/armes/v_sainte.mdl"
#define Gm_SAINTE_FICHIER_MODEL_W			"models/armes/w_sainte.mdl"
#define Gm_SAINTE_FICHIER_SON_ALLELOUIA		"weapons/sainte/sainte1.wav"
#define Gm_SAINTE_FICHIER_SON_REBOND		"weapons/sainte/sainte2.wav"

#define Gm_SAINTE_DOMMAGE					150
#define Gm_SAINTE_MUNITION					1
#define Gm_SAINTE_TEMPS_DEPLACEMENT			0

#define Gm_SAINTE_GRAVITE					0.8
#define Gm_SAINTE_REBOND					0.75
#define Gm_SAINTE_COEF_TIRE					75 // Plus le nb et petit plus la grenade est puissante
#define Gm_SAINTE_EXPLOSE					5.0

class GcSainte : public CBasePlayerWeapon
{
public:
	int GetItemInfo(ItemInfo *p);
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );
	
private:
	void GfTire( float GvTirePuis_f );

	GcGrenadeGeneric* pGrenade;
	float GvTempsAnim_f;
	float GvTempsFDT_f;
	float GvTempsPuis_f;
	float GvTempsAllelouia_f;
};

enum
{
	Ga_SAINTE_ILDE_01 = 0,
	Ga_SAINTE_ILDE_02,
	Ga_SAINTE_DRAW,
	Ga_SAINTE_TIRE_01,
	Ga_SAINTE_TIRE_02
};

#endif
#endif // ARME_SAINTE_H