/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_snipe.cpp				*
*		19022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "monsters.h"
#include "player.h"
#include "generic_arme.h"
#include "generic_balle.h"
#include "arme_snipe.h"
#include "game.h"
#include "gamerules.h"
#include "shake.h"

#ifdef Gd_ARME_SNIPE

LINK_ENTITY_TO_CLASS( weapon_snipe, GcSnipe );
LINK_ENTITY_TO_CLASS( rocket_snipe, GcSnipeRocket );

int GcSnipe::GetItemInfo( ItemInfo *p )
{
	p->pszName = STRING( pev->classname );
	p->pszAmmo1 = "munition_snipe";
	p->iMaxAmmo1 = Gm_MUNI_MAX;
	p->iSlot = Gm_SNIPE_SLOT;
	p->iPosition = Gm_SNIPE_POSITION;
	p->iId = m_iId = Gm_SNIPE_ID;
	p->iWeight = Gm_SNIPE_POID;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;
	return 1;
}

void GcSnipe::Spawn( void )
{
	Precache( );

	m_iId = Gm_SNIPE_ID;
	iGvAmmoDefault = Gm_SNIPE_MUNITION;

	GvTempsFDT_f = 0;
	GvViewSave_b = false;

	iGvZoom = 0;
	bGvZoomRetireForce = false;
	bGvZoomSensMoins = true;

	FallInit( );
}

void GcSnipe::Precache( void )
{
	PRECACHE_MODEL( Gm_SNIPE_FICHIER_MODEL_P );
	PRECACHE_MODEL( Gm_SNIPE_FICHIER_MODEL_V );
	PRECACHE_SOUND( Gm_SNIPE_FICHIER_SON_TIRE );
	PRECACHE_SOUND( Gm_SNIPE_FICHIER_SON_ZOOM );
	GvShell_i = PRECACHE_MODEL( Gm_SNIPE_FICHIER_MODEL_D );
//	UTIL_PrecacheOther( "rocket_snipe" );
}

BOOL GcSnipe::Deploy( void )
{
	GvTempsAnim_f = gpGlobals->time + 2.0;
	return DefaultDeploy( Gm_SNIPE_FICHIER_MODEL_V, Gm_SNIPE_FICHIER_MODEL_P, Ga_SNIPE_DRAW, "snipe" );
}

void GcSnipe::Holster( void )
{
	if( m_pSpot )
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( iGvZoom )
	{
		bGvZoomRetireForce = true;
		GfAttack2( );
	}

	SET_VIEW( m_pPlayer->edict(), m_pPlayer->edict( ));

	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		//m_pPlayer->iGvArmes &= ~( 1<<Gm_SNIPE_ID );
		m_pPlayer->iGvArmes[Gm_SNIPE_SLOT] &= ~( 1<<Gm_SNIPE_POSITION );
		SetThink( DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}

	GfFinDeTour( &GvTempsFDT_f, 0 );
}

void GcSnipe::GfAttack1( void )
{
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		GfAttack0( );
		return;
	}

	GfTire( );

	if( g_pGameRules->GvMortSubite )
		UTIL_ScreenFade( m_pPlayer, Vector( 255, 0, 0 ), 1, 0.5, 64, FFADE_OUT | FFADE_STAYOUT );
	else
		UTIL_ScreenFade( m_pPlayer, Vector( 1,1,1 ), 0.25, 0.25, 64, FFADE_IN );

	fGvAttack1 = fGvAttack0 = gpGlobals->time + 1.0;
}

void GcSnipe::GfTire( void )
{
	g_pGameRules->GvChangeVue = false;
	
	bGvZoomRetireForce = true;
	GfAttack2( );

	SendWeaponAnim( Ga_SNIPE_TIRE );
	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

	EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_ITEM, Gm_SNIPE_FICHIER_SON_TIRE, 1, ATTN_NORM );
	
	// Groove - 13022002 - flash en bout de canon du minicanon.
	m_pPlayer->m_iWeaponFlash = BRIGHT_GUN_FLASH;
	m_pPlayer->pev->effects |= EF_MUZZLEFLASH;

	Vector GvOrigine_c = m_pPlayer->GetGunPosition( ) + gpGlobals->v_forward * 16;// + gpGlobals->v_up * 8;
	
	GcSnipeRocket::CreateRocket( m_pPlayer, GvOrigine_c + gpGlobals->v_forward * 6, m_pPlayer->pev->angles );
	GcSnipeRocketVue *pRocketVue = GcSnipeRocketVue::CreateRocket( m_pPlayer, GvOrigine_c + gpGlobals->v_up * 4, m_pPlayer->pev->angles );

	if( GvQDouilleCMD_i )
	{
		Vector GvShellOrigin_c = pev->origin + m_pPlayer->pev->view_ofs
							   + gpGlobals->v_up * -12 
							   + gpGlobals->v_forward * 20 
							   + gpGlobals->v_right * 4;

		Vector GvShellVelocity_c = m_pPlayer->pev->velocity 
								 + gpGlobals->v_right * RANDOM_LONG( 50,70 ) 
								 + gpGlobals->v_up * RANDOM_LONG( 100,150 ) 
								 + gpGlobals->v_forward * 25;

		EjectBrass( GvShellOrigin_c, GvShellVelocity_c, pev->angles.y, GvShell_i, TE_BOUNCE_SHELL); 
	}

	GvViewSave_b = true;
//	UTIL_SetOrigin( pRocketVue->pev, m_pPlayer->GetGunPosition( ) + gpGlobals->v_up * 8 /*+ gpGlobals->v_forward * 1*/ );
	SET_VIEW( m_pPlayer->edict( ), pRocketVue->edict( ));
	pRocketVue->pev->v_angle = m_pPlayer->pev->v_angle;

	m_pPlayer->m_rgAmmo[iGvAmmoID]--;

	GvTempsAnim_f = gpGlobals->time + 2.0;
	
	m_pPlayer->GvPlayerTPT.bAmmo = true;
	m_pPlayer->GvPlayerTPT.bTire = false;
	GvTempsFDT_f = gpGlobals->time;
}

void GcSnipe::GfAttack2( void )
{
	GfFinDeTour( &GvTempsFDT_f, Gm_SNIPE_TEMPS_DEPLACEMENT );

	EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_ITEM, Gm_SNIPE_FICHIER_SON_ZOOM, 1, ATTN_NORM );		

	GfZoomDynamic( Gm_SNIPE_FICHIER_MODEL_V, Gm_SNIPE_FICHIER_MODEL_P, 50, 1 );
	bGvZoomRetireForce = false;
	
	fGvAttack2 = gpGlobals->time + 0.05;
}

void GcSnipe::GfAttack0( void )
{
	fGvAttack0 = gpGlobals->time + 1.0;
	GfFinDeTour( &GvTempsFDT_f, Gm_SNIPE_TEMPS_DEPLACEMENT );

	bGvZoomSensChange = true;

	if( iGvZoom )
		if(( m_pPlayer->pev->button & ( IN_LEFT|IN_RIGHT|IN_MOVELEFT|IN_MOVERIGHT|IN_JUMP|IN_JUMP2|IN_FORWARD|IN_BACK ))
			&&(!( m_pPlayer->pev->button & IN_DUCK )&&( GfVectorToFloat( m_pPlayer->pev->velocity ) > 100 )))
		{
			bGvZoomRetireForce = true;
			GfAttack2( );
		}

	if( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE )
		UpdateSpot( );
	else if(( m_pSpot )&&!( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE ))
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( GvViewSave_b && ( m_pPlayer->GvPlayerTPT.bAmmo == false ))
	{
		GvViewSave_b = false;
		g_pGameRules->GvChangeVue = true;
		SET_VIEW( m_pPlayer->edict( ), m_pPlayer->edict( ));
	}

	if( GvTempsAnim_f &&( GvTempsAnim_f < gpGlobals->time ))
	{
		if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		{
			SendWeaponAnim( Ga_SNIPE_IDLE );
			GvTempsAnim_f = gpGlobals->time + 2.0;
		}
		else
		{
			m_pPlayer->pev->viewmodel = 0; 
			m_pPlayer->pev->weaponmodel = 0;
		}
	}
}

///////////////////////////////////////////////////////////////////

GcSnipeRocketVue *GcSnipeRocketVue::CreateRocket( CBasePlayer *pGvPlayer, Vector GvOrigin_c, Vector GvAngles_c )
{
	GcSnipeRocketVue *pRocket = GetClassPtr(( GcSnipeRocketVue *)NULL );

	UTIL_SetOrigin( pRocket->pev, GvOrigin_c );
	pRocket->pev->angles = GvAngles_c;
	pRocket->Spawn( );
	pRocket->pev->owner = pGvPlayer->edict( );
	return pRocket;
}

void GcSnipeRocketVue :: GfThink( void  )
{
	if( GvCompteurMax_i <= 8 )
	{
		GvCompteurMax_i++;
		pev->velocity *= 1.5;
	}
	pev->nextthink = gpGlobals->time + 0.1;
}

void GcSnipeRocketVue :: Spawn( void )
{
	pev->movetype = MOVETYPE_FLY;
	pev->solid = SOLID_BBOX;

	SET_MODEL( ENT(pev), Gm_SNIPE_FICHIER_MODEL_VUE );
	UTIL_SetSize( pev, Vector( 0,0,0 ), Vector( 0,0,0 ));	
	UTIL_SetOrigin( pev, pev->origin );

	pev->classname = MAKE_STRING("vue");

	SetThink( GfThink );
	SetTouch( GfGeneralDetonationTouch );

	pev->velocity = gpGlobals->v_forward * 48;// + gpGlobals->v_up * 1;
	pev->gravity = 0.5;
	pev->dmg = 0;

	pev->angles = UTIL_VecToAngles( pev->velocity );
	pev->angles.x = -pev->angles.x; // Groove - 15032002 - Pour regarde la Balle suivant la direction

	GvCompteurMax_i = 0;

	pev->nextthink = gpGlobals->time + 1.0;
}

////////////////////////////////////////////////////////////

GcSnipeRocket *GcSnipeRocket::CreateRocket( CBasePlayer *pGvPlayer, Vector GvOrigin_c, Vector GvAngles_c )
{
	GcSnipeRocket *pRocket = GetClassPtr(( GcSnipeRocket *)NULL );

	UTIL_SetOrigin( pRocket->pev, GvOrigin_c );
	pRocket->pev->angles = GvAngles_c;
	pRocket->Spawn( );
	pRocket->pGvPlayer = pGvPlayer;
	pRocket->pev->owner = pGvPlayer->edict( );

	return pRocket;
}

void GcSnipeRocket :: Spawn( void )
{
	Precache( );

	pev->classname = MAKE_STRING( "snipe" );
	pev->movetype = MOVETYPE_FLY;
	pev->solid = SOLID_BBOX;
	if( GvQDLightCMD_i )
		pev->effects = EF_BRIGHTLIGHT + EF_DIMLIGHT;

	SET_MODEL( ENT(pev), Gm_SNIPE_FICHIER_MODEL_R );
	UTIL_SetSize( pev, Vector( -1,-1,-1 ), Vector( 1,1,1 ));
	UTIL_SetOrigin( pev, pev->origin );

	SetThink( GfThink );
	SetTouch( GfTouch );

	if( GvQTrailCMD_i )
		GfTraine( );

	pev->velocity = gpGlobals->v_forward * 50;
	pev->gravity = 0.5;
	pev->dmg = Gm_SNIPE_DOMMAGE;

	GvCompteurMax_i = 0;

	pev->nextthink = gpGlobals->time + 1.0;
}

void GcSnipeRocket :: Precache( void )
{
	PRECACHE_MODEL( Gm_SNIPE_FICHIER_MODEL_R );
	GvTraine_i = PRECACHE_MODEL( "sprites/smoke.spr" );
}

void GcSnipeRocket :: GfThink( void  )
{
	pev->angles = UTIL_VecToAngles( pev->velocity );

	if( GvCompteurMax_i <= 8 )
	{
		GvCompteurMax_i++;
		pev->velocity *= 1.5;
	}
	pev->nextthink = gpGlobals->time + 0.1;
}

void GcSnipeRocket :: GfTouch ( CBaseEntity *pOther )
{
	pGvPlayer->GvPlayerTPT.bAmmo = false;

	int GvSprite;
	switch( RANDOM_LONG( 1, 4 ))
	{
	default:
	case 1:
		GvSprite = PRECACHE_MODEL( Gm_BALLE_FUMEE_1 );
		break;
	case 2:
		GvSprite = PRECACHE_MODEL( Gm_BALLE_FUMEE_2 );
		break;
	case 3:
		GvSprite = PRECACHE_MODEL( Gm_BALLE_FUMEE_3 );
		break;
	case 4:
		GvSprite = PRECACHE_MODEL( Gm_BALLE_FUMEE_4 );
		break;
	}

	MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, pev->origin );
		WRITE_BYTE( TE_SMOKE );
		WRITE_COORD( pev->origin.x );
		WRITE_COORD( pev->origin.y );
		WRITE_COORD( pev->origin.z );
		WRITE_SHORT( GvSprite );
		WRITE_BYTE( 10 );
		WRITE_BYTE( 12  );
	MESSAGE_END( );

	pEntity = NULL;
	while(( pEntity = UTIL_FindEntityInSphere( pEntity, pev->origin, 100 )) != NULL )
		if( FClassnameIs( pEntity->pev, "vue" ))
			UTIL_Remove( pEntity );

	GcGrenadeGeneric::GfGeneralDetonationTouch( pOther );
}

void GcSnipeRocket :: GfTraine( void )
{
	MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
		WRITE_BYTE( TE_BEAMFOLLOW );
		WRITE_SHORT( entindex( ));	// entity
		WRITE_SHORT( GvTraine_i );	// model
		WRITE_BYTE( 25 );			// life
		WRITE_BYTE( 1 );			// width
		WRITE_BYTE( 255 );			// r
		WRITE_BYTE( 128 );			// g
		WRITE_BYTE( 0 );			// b
		WRITE_BYTE( 192 );			// brightness
	MESSAGE_END( );					// move PHS/PVS data sending into here (SEND_ALL, SEND_PVS, SEND_PHS)
}
#endif