/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_snipe.h				*
*		14122001				*
\*******************************/

#ifndef ARME_SNIPE_H
#define ARME_SNIPE_H

#include "define_slot.h"

#ifdef Gd_ARME_SNIPE

#define Gm_SNIPE_FICHIER_MODEL_D		"models/armes/d_snipe.mdl"
#define Gm_SNIPE_FICHIER_MODEL_P		"models/armes/p_snipe.mdl"
#define Gm_SNIPE_FICHIER_MODEL_V		"models/armes/v_snipe.mdl"
#define Gm_SNIPE_FICHIER_MODEL_VUE		"models/article/null.mdl"
#define Gm_SNIPE_FICHIER_SON_TIRE		"weapons/snipe/snipe1.wav"
#define Gm_SNIPE_FICHIER_SON_ZOOM		"weapons/snipe/snipe2.wav"

#define Gm_SNIPE_DOMMAGE				50
#define Gm_SNIPE_MUNITION				2
#define Gm_SNIPE_TEMPS_DEPLACEMENT		5.0

class GcSnipe : public CBasePlayerWeapon
{
public:
	int GetItemInfo( ItemInfo *p );
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );	

private:
	void GfTire( void );

	bool GvViewSave_b;
	int GvShell_i;
	float GvTempsAnim_f;
	float GvTempsFDT_f;
};

class GcSnipeRocket : public GcGrenadeGeneric
{
public:
	static GcSnipeRocket *CreateRocket( CBasePlayer *pGvPlayer, Vector GvOrigin, Vector GvAngle );

private:
	void Spawn( void );
	void Precache( void );
	void EXPORT GfThink( void );
	void EXPORT GfTouch( CBaseEntity *pOther );
	void GfTraine( void );

	CBasePlayer *pGvPlayer;
	CBaseEntity *pEntity;

	int GvTraine_i;
	int GvCompteurMax_i;
};

class GcSnipeRocketVue : public GcGrenadeGeneric
{
public:
	static GcSnipeRocketVue *CreateRocket( CBasePlayer *pGvPlayer, Vector GvOrigin, Vector GvAngle );

private:
	void Spawn( void );
	void EXPORT GfThink( void );

	int GvCompteurMax_i;
};

enum
{
	Ga_SNIPE_IDLE = 0,
	Ga_SNIPE_DRAW,
	Ga_SNIPE_HOLSTER,
	Ga_SNIPE_TIRE
};

#endif
#endif // ARME_SNIPE_H