/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_super_mouton.cpp		*
*		19122001				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "generic_arme.h"
#include "generic_balle.h"
#include "arme_super_mouton.h"
#include "gamerules.h"
#include "shake.h"

#ifdef Gd_ARME_SUPER_MOUTON

LINK_ENTITY_TO_CLASS( weapon_super_mouton, GcSuperMouton );

int GcSuperMouton::GetItemInfo( ItemInfo *p )
{
	p->pszName = STRING( pev->classname );
	p->pszAmmo1 = "munition_super_mouton";
	p->iMaxAmmo1 = Gm_MUNI_MAX;
	p->iSlot = Gm_SUPER_MOUTON_SLOT;
	p->iPosition = Gm_SUPER_MOUTON_POSITION;
	p->iId = m_iId = Gm_SUPER_MOUTON_ID;
	p->iWeight = Gm_SUPER_MOUTON_POID;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;
	return 1;
}

void GcSuperMouton::Spawn( void )
{
	Precache( );

	m_iId = Gm_SUPER_MOUTON_ID;
	iGvAmmoDefault = Gm_SUPER_MOUTON_MUNITION;

	GvTempsFDT_f = 0;
	GvTireTemps_f = 0;
	GvViewSave_b = false;

	FallInit( );
}

void GcSuperMouton::Precache( void )
{
	PRECACHE_MODEL( Gm_SUPER_MOUTON_FICHIER_MODEL_P );
	PRECACHE_MODEL( Gm_SUPER_MOUTON_FICHIER_MODEL_V );
	PRECACHE_MODEL( Gm_SUPER_MOUTON_FICHIER_MODEL_R );
	PRECACHE_SOUND( Gm_SUPER_MOUTON_FICHIER_SON_TIRE );
}

BOOL GcSuperMouton::Deploy( void )
{
	GvTempsAnim_f = gpGlobals->time + 2.0;
	return DefaultDeploy( Gm_SUPER_MOUTON_FICHIER_MODEL_V, Gm_SUPER_MOUTON_FICHIER_MODEL_P, Ga_SUPER_MOUTON_DRAW, "super_mouton" );
}

void GcSuperMouton::Holster( void )
{
	if( m_pSpot )
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( GvRocketActive_i )
	{
		GvRocketActive_i = 0;

		if( g_pGameRules->GvMortSubite )
			UTIL_ScreenFade( m_pPlayer, Vector( 255, 0, 0 ), 1, 0.5, 64, FFADE_OUT | FFADE_STAYOUT );
		else
			UTIL_ScreenFade( m_pPlayer, Vector( 1,1,1 ), 0.25, 0.25, 64, FFADE_IN );
		
		SET_VIEW( m_pPlayer->edict(), m_pPlayer->edict( ));
	}

	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		//m_pPlayer->iGvArmes &= ~( 1<<Gm_SUPER_MOUTON_ID );
		m_pPlayer->iGvArmes[Gm_SUPER_MOUTON_SLOT] &= ~( 1<<Gm_SUPER_MOUTON_POSITION );
		SetThink( DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}

	GfFinDeTour( &GvTempsFDT_f, 0 );
}

void GcSuperMouton::GfAttack1( void )
{
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] || GvRocketActive_i || GvTireTemps_f )
	{
		GvTireTemps_f = 0;
		GfAttack0( );
		return;
	}

	SendWeaponAnim( Ga_SUPER_MOUTON_TIRE );
	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

	GvTempsAnim_f = gpGlobals->time + 2.0;
	GvTireTemps_f = gpGlobals->time + 1.0;

	fGvAttack1 = gpGlobals->time + 2.0;
	fGvAttack0 = gpGlobals->time + 0.1;
}

void GcSuperMouton::GfTire( void )
{
	if( g_pGameRules->GvMortSubite )
		UTIL_ScreenFade( m_pPlayer, Vector( 255, 0, 0 ), 1, 0.5, 64, FFADE_OUT | FFADE_STAYOUT );
	else
		UTIL_ScreenFade( m_pPlayer, Vector( 1,1,1 ), 0.25, 0.25, 64, FFADE_IN );
	
	Vector vecSrc = m_pPlayer->GetGunPosition( ) + gpGlobals->v_forward * 16;// + gpGlobals->v_up * 8;
	
	short GvTraineCouleur[3][6] = 
	{
		{ 50, 32, 255, 255, 255, 128 },// Life, Width, r, v, b, brightness
		{  0,  0,   0,   0,   0,   0 },// Life, Width, r, v, b, brightness
		{  0,  0,   0,   0,   0,   0 } // Life, Width, r, v, b, brightness
	};

	int GvBalleOption = Gm_BALLE_EXPLOSE | Gm_BALLE_BRIANTE | Gm_BALLE_AUTO_DESTRUCTION | Gm_BALLE_VUE_SUR_NORMAL | Gm_BALLE_VUE_INTERIEUR | Gm_BALLE_ANIM;

	GcGenericBalle::GfCreateBalle( vecSrc,
								   m_pPlayer->pev->angles, 
								   0, 
								   1000,
								   Gm_SUPER_MOUTON_DOMMAGE, 
								   10,// Duree de vie de la balle si option active.
								   GvTraineCouleur,
								   0,// Nombre de trainees
								   GvBalleOption,//short GvOptionCreate, 
								   m_pPlayer, 
								   this,
								   Gm_SUPER_MOUTON_ID );

	EMIT_SOUND( ENT(m_pPlayer->pev), CHAN_ITEM, Gm_SUPER_MOUTON_FICHIER_SON_TIRE, 1, ATTN_NORM );

	GvViewSave_b = true;
	m_pPlayer->m_rgAmmo[iGvAmmoID]--;

	m_pPlayer->GvPlayerTPT.bAmmo = true;
	m_pPlayer->GvPlayerTPT.bTire = false;
	GvTempsFDT_f = gpGlobals->time;
}

void GcSuperMouton::GfAttack2( void )
{
	GfAttack0( );
	fGvAttack2 = gpGlobals->time + 0.5;
}

void GcSuperMouton::GfAttack0( void )
{
	fGvAttack0 = gpGlobals->time + 1.0;
	GfFinDeTour( &GvTempsFDT_f, Gm_SUPER_MOUTON_TEMPS_DEPLACEMENT );

	if( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE )
		UpdateSpot( );
	else if(( m_pSpot )&&!( m_pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_VISEE ))
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( GvTireTemps_f &&( GvTireTemps_f < gpGlobals->time ))
	{
		GvTireTemps_f = 0;
		GfTire( );
	}
	
	if( !GvRocketActive_i && GvViewSave_b )
	{
		GvViewSave_b = false;

		if( g_pGameRules->GvMortSubite )
			UTIL_ScreenFade( m_pPlayer, Vector( 255, 0, 0 ), 1, 0.5, 64, FFADE_OUT | FFADE_STAYOUT );
		else
			UTIL_ScreenFade( m_pPlayer, Vector( 1,1,1 ), 0.25, 0.25, 64, FFADE_IN );

		SET_VIEW( m_pPlayer->edict( ), m_pPlayer->edict() );
	}

	if( GvTempsAnim_f && ( GvTempsAnim_f < gpGlobals->time ))
	{
		if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		{
			SendWeaponAnim( Ga_SUPER_MOUTON_IDLE );
			GvTempsAnim_f = gpGlobals->time + 6.0;
		}
		else
		{
			m_pPlayer->pev->viewmodel = 0; 
			m_pPlayer->pev->weaponmodel = 0;
		}
	}
}

#endif