/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_teleporteur.h			*
*		16112001				*
\*******************************/

#ifndef ARME_TELEPORTEUR_H
#define ARME_TELEPORTEUR_H

#include "define_slot.h"

#ifdef Gd_ARME_TELEPORTEUR

#define Gm_TELEPORTEUR_FICHIER_MODEL_P			"models/armes/p_teleporteur.mdl"
#define Gm_TELEPORTEUR_FICHIER_MODEL_V			"models/armes/v_teleporteur.mdl"
#define Gm_TELEPORTEUR_FICHIER_SON_TELEPORT		"weapons/teleporteur/teleporteur1.wav"
#define Gm_TELEPORTEUR_FICHIER_SON_ZAP			"weapons/teleporteur/teleporteur2.wav"
#define Gm_TELEPORTEUR_FICHIER_SPRITE_TELEPORT	"sprites/jeu/teleport.spr"
#define Gm_TELEPORTEUR_FICHIER_SPRITE_ZAP		"sprites/xbeam1.spr"

#define Gm_TELEPORTEUR_DOMMAGE					0
#define Gm_TELEPORTEUR_MUNITION					2
#define Gm_TELEPORTEUR_TEMPS_DEPLACEMENT		0

class GcTeleporteur : public CBasePlayerWeapon
{
public:
	int GetItemInfo(ItemInfo *p);
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );

private:
	void GfTire( const Vector &GvOrigin_c, const Vector &GvDirection_c );
	void UpdateEffect( const Vector &GvOrigin_c, const Vector &GvFin_c, float timeBlend );
	void CreateEffect( void );
	void DestroyEffect( void );
	CBeam *pEffect;

	float GvTempsFDT_f;
	float GvTempsVieEffect_f;
};

enum
{
	Ga_TELEPORTEUR_IDLE1 = 0,
	Ga_TELEPORTEUR_TIRE,
	Ga_TELEPORTEUR_DRAW
};

#endif
#endif // ARME_TELEPORTEUR_H