/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_trident.cpp			*
*		19022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "fx_sprite.h"
#include "generic_arme.h"
#include "generic_flamme.h"
#include "arme_trident.h"

#ifdef Gd_ARME_TRIDENT

LINK_ENTITY_TO_CLASS( weapon_trident, GcTrident );

int GcTrident::GetItemInfo( ItemInfo *p )
{
	p->pszName = STRING( pev->classname );
	p->pszAmmo1 = "munition_trident";
	p->iMaxAmmo1 = Gm_MUNI_MAX;
	p->iSlot = Gm_TRIDENT_SLOT;
	p->iPosition = Gm_TRIDENT_POSITION;
	p->iId = m_iId = Gm_TRIDENT_ID;
	p->iWeight = Gm_TRIDENT_POID;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;
	return 1;
}

void GcTrident::Spawn( void )
{
	Precache( );

	m_iId = Gm_TRIDENT_ID;
	iGvAmmoDefault = Gm_TRIDENT_MUNITION;

	GvTempsFDT_f = 0;
	GvTempsAttack_f = 0;
	GvMerciDieu_i = 0;

	FallInit( );
}

void GcTrident::Precache( void )
{
	PRECACHE_MODEL( Gm_TRIDENT_FICHIER_MODEL_V );
	PRECACHE_MODEL( Gm_TRIDENT_FICHIER_MODEL_P );

	PRECACHE_SOUND( Gm_TRIDENT_FICHIER_SON_TIRE_APPEL );
	PRECACHE_SOUND( Gm_TRIDENT_FICHIER_SON_TIRE_FIN );
	PRECACHE_SOUND( Gm_TRIDENT_FICHIER_SON_APARTE );
	PRECACHE_SOUND( Gm_TRIDENT_FICHIER_SON_PLEURE );
	PRECACHE_SOUND( Gm_TRIDENT_FICHIER_SON_FLAMME );
}

BOOL GcTrident::Deploy( void )
{
	GvTempsAnim_f = gpGlobals->time + 2.0;
	return DefaultDeploy( Gm_TRIDENT_FICHIER_MODEL_V, Gm_TRIDENT_FICHIER_MODEL_P, Ga_TRIDENT_DRAW, "trident" );
}

void GcTrident::Holster( void )
{
	if( m_pSpot )
	{
		m_pSpot->Killed( NULL, GIB_NEVER );
		m_pSpot = NULL;
	}

	if( !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		//m_pPlayer->iGvArmes &= ~( 1<<Gm_TRIDENT_ID );
		m_pPlayer->iGvArmes[Gm_TRIDENT_SLOT] &= ~( 1<<Gm_TRIDENT_POSITION );
		SetThink( DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}

	GfFinDeTour( &GvTempsFDT_f, 0 );
}

void GcTrident::GfAttack1( void )
{
	if( !m_pPlayer->GvPlayerTPT.bTire || !m_pPlayer->m_rgAmmo[iGvAmmoID] )
	{
		GfAttack0( );
		return;
	}

	GvOriginSpot_c = UpdateSpot( );

	SendWeaponAnim( Ga_TRIDENT_ATTACK_CALL );
	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

	EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_WEAPON, Gm_TRIDENT_FICHIER_SON_TIRE_APPEL, 0.9, ATTN_NORM );

	m_pSprite = CSprite::SpriteCreate( Gm_TRIDENT_FICHIER_SPRITE_CIBLE, GvPosition_c, FALSE );
	m_pSprite->pev->scale = 2.0;
	m_pSprite->SetTransparency( kRenderGlow, 255, 255, 255, 255,kRenderFxNoDissipation );
	
//	EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_WEAPON, Gm_AIR_STRIKE_FICHIER_SON_CIBLE, 0.7, ATTN_NORM );

	GvTempsAttack_f = gpGlobals->time + 5.0;
	m_pPlayer->m_rgAmmo[iGvAmmoID]--;
	
	m_pPlayer->GvPlayerTPT.bTire = false;
	GvTempsFDT_f = gpGlobals->time;
}

void GcTrident::GfTire( void )
{
	m_pPlayer->sGvProfil.iGvSatan++;
	
	GvCompte = 0;
	pEntity = NULL;
	while(( pEntity = UTIL_FindEntityInSphere( pEntity, GvOriginSpot_c, 250 )) != NULL )
	{
		if( FClassnameIs( pEntity->pev, "player" ))
		{
			GcFlamme::GfCreateFlamme( pEntity->pev->origin );
			EMIT_SOUND( ENT( pEntity->pev ), CHAN_WEAPON, Gm_TRIDENT_FICHIER_SON_FLAMME, 1, ATTN_NORM );
			GvCompte++;
		}
	}
	if( !GvCompte )
	{
		GcFlamme::GfCreateFlamme( m_pPlayer->pev->origin );
		EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_WEAPON, Gm_TRIDENT_FICHIER_SON_PLEURE, 0.9, ATTN_NORM );
	}
	else
	{
		GvMerciDieu_i = 1;
	}

	GvTempsAnim_f = gpGlobals->time + 2.5;
}

void GcTrident::GfAttack2( void )
{
	GfAttack0( );
	fGvAttack2 = gpGlobals->time + 0.5;
}

void GcTrident::GfAttack0( void )
{
	fGvAttack0 = gpGlobals->time + 1.0;
	GfFinDeTour( &GvTempsFDT_f, Gm_TRIDENT_TEMPS_DEPLACEMENT );

	UpdateSpot( );

	if( GvTempsAttack_f != 0 )
	{
		if( GvTempsAttack_f < gpGlobals->time )
		{
			GfTire( );
			GvTempsAttack_f = 0;
		}
		return;
	}

	if( m_pSprite &&( !m_pPlayer->GvPlayerTPT.bTire ))
	{
		UTIL_Remove( m_pSprite );
		m_pSprite = NULL;
	}

	if( GvTempsAnim_f < gpGlobals->time )
	{
		if( GvMerciDieu_i == 1 )
		{
			EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_WEAPON, Gm_TRIDENT_FICHIER_SON_TIRE_FIN, 0.9, ATTN_NORM );
			GvMerciDieu_i = 2;
			GvTempsAnim_f = gpGlobals->time + 2.5;
			return;
		}
		else if( GvMerciDieu_i == 2 )
		{
			EMIT_SOUND( ENT( m_pPlayer->pev ), CHAN_WEAPON, Gm_TRIDENT_FICHIER_SON_APARTE, 0.9, ATTN_NORM );
			m_pPlayer->pev->punchangle.x -= 15;
			SendWeaponAnim( Ga_TRIDENT_ATTACK_FIN );
			GvTempsAnim_f = gpGlobals->time + 2.5;
			GvMerciDieu_i = 0;
			return;
		}
		else if( GvMerciDieu_i == 3 )
		{
			SendWeaponAnim( Ga_TRIDENT_ATTACK_FIN );
			GvTempsAnim_f = gpGlobals->time + 2.5;
			GvMerciDieu_i = 0;
		}

		if( m_pPlayer->m_rgAmmo[iGvAmmoID] )
		{
			int GvAnim_i;
			switch( RANDOM_LONG( 1,4 ))
			{
			case 1:	case 2:
				GvAnim_i = Ga_TRIDENT_IDLE_01;
				GvTempsAnim_f = gpGlobals->time + 10.0;
				break;
			case 3:
				GvAnim_i = Ga_TRIDENT_IDLE_02;
				GvTempsAnim_f = gpGlobals->time + 2.0;
				break;
			case 4:
				GvAnim_i = Ga_TRIDENT_IDLE_03;
				GvTempsAnim_f = gpGlobals->time + 2.0;
				break;
			default:
				GvAnim_i = Ga_TRIDENT_IDLE_01;
				GvTempsAnim_f = gpGlobals->time + 2.0;
				break;
			}
			SendWeaponAnim( GvAnim_i );
		}
		else
		{
			m_pPlayer->pev->viewmodel = 0; 
			m_pPlayer->pev->weaponmodel = 0;
		}
	}
}

#endif
