/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	arme_trident.h				*
*		23042002				*
\*******************************/

#ifndef ARME_TRIDENT_H
#define ARME_TRIDENT_H

#include "define_slot.h"

#ifdef Gd_ARME_TRIDENT

#define Gm_TRIDENT_FICHIER_MODEL_P				"models/armes/p_trident.mdl"
#define Gm_TRIDENT_FICHIER_MODEL_V				"models/armes/v_trident.mdl"
#define Gm_TRIDENT_FICHIER_SON_TIRE_APPEL		"weapons/trident/trident1.wav"
#define Gm_TRIDENT_FICHIER_SON_TIRE_FIN			"weapons/trident/trident2.wav"
#define Gm_TRIDENT_FICHIER_SON_APARTE			"weapons/trident/trident3.wav"
#define Gm_TRIDENT_FICHIER_SON_PLEURE			"weapons/trident/trident4.wav"
#define Gm_TRIDENT_FICHIER_SON_FLAMME			"weapons/trident/trident5.wav"
#define Gm_TRIDENT_FICHIER_SPRITE_TRAINE		"sprites/smoke.spr"
#define Gm_TRIDENT_FICHIER_SPRITE_CIBLE			"sprites/jeu/armes/croix1.spr"

#define Gm_TRIDENT_DOMMAGE						3
#define Gm_TRIDENT_MUNITION						1
#define Gm_TRIDENT_TEMPS_DEPLACEMENT			10.0

class GcTrident : public CBasePlayerWeapon
{
public:
	int GetItemInfo( ItemInfo *p );
	void Spawn( void );
	void Precache( void );
	BOOL Deploy( void );
	void Holster( void );
	void GfAttack1( void );
	void GfAttack2( void );
	void GfAttack0( void );

private:
	void GfTire( void );

	CSprite *m_pSprite;
	CBaseEntity *pEntity;
	float GvTempsAnim_f;
	float GvTempsAttack_f;
	float GvTempsFDT_f;
	short GvMerciDieu_i;
	short GvCompte;
	Vector GvOriginSpot_c;
};

enum
{
	Ga_TRIDENT_IDLE_01 = 0,
	Ga_TRIDENT_IDLE_02,
	Ga_TRIDENT_IDLE_03,
	Ga_TRIDENT_DRAW,
	Ga_TRIDENT_ATTACK_CALL,
	Ga_TRIDENT_ATTACK_WAIT,
	Ga_TRIDENT_ATTACK_FIN
};

#endif
#endif // ARME_TRIDENT_H