/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	gamerules.cpp				*
*		28022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "generic_arme.h"
#include "generic_balle.h"
#include "gamerules.h"
#include "gamerules_teamplay.h"
#include "gamerules_mode_action.h"
#include "gamerules_mode_baril.h"
#include "gamerules_mode_batte.h"
#include "gamerules_mode_controle.h"
#include "gamerules_mode_group.h"
#include "gamerules_mode_normal.h"
#include "gamerules_mode_zone.h"
#include "arme_mine.h"
#include "items.h"
#include "item_baril.h"

// Groove - 03122001 - Point de Spwan Collectif
extern edict_t *EntSelectSpawnPoint( CBaseEntity *pPlayer );
// Groove - 03122001 - Point de Spwan Indpendant
extern edict_t *EntSelectTeamSpawnPoint( CBaseEntity *pPlayer );

DLL_GLOBAL CGameRules*	g_pGameRules = NULL;
extern DLL_GLOBAL BOOL	g_fGameOver;

void CGameRules::GfScoreAdd( GeScore GvScore )
{
	switch( GvScore )
	{
	default:
	case Gm_SCORE_INI :
		iGvScoreBleuPoint = 0;
		iGvScoreRougePoint = 0;
		break;
	case Gm_SCORE_INI_FULL :
		iGvScoreBleuPoint = 0;
		iGvScoreRougePoint = 0;
		iGvScoreBleuManche = 0;
		iGvScoreRougeManche = 0;
		break;
	case Gm_SCORE_BLEU_1 :
		iGvScoreBleuPoint++;
		break;
	case Gm_SCORE_BLEU_2 :
		iGvScoreBleuPoint += 2;
		break;
	case Gm_SCORE_BLEU_3 :
		iGvScoreBleuPoint += 3;
		break;
	case Gm_SCORE_ROUGE_1 :
		iGvScoreRougePoint++;
		break;
	case Gm_SCORE_ROUGE_2 :
		iGvScoreRougePoint += 2;
		break;
	case Gm_SCORE_ROUGE_3 :
		iGvScoreRougePoint += 3;
		break;
	}

	GfGestionScore( );
}

// Groove - 28022002 - Spawn d'entit dans les zones ddis.
void CGameRules::GfEntitySpawn_i( int GvChoixEntity_i )
{
	ALERT( at_console, "Zglu debut\n" );
	/*CBaseEntity **/pEntity = NULL;
	// Groove - 12022002 - Comptage des barils, mines.
	int GvCompteEntity_i = 0;

	switch( GvChoixEntity_i )
	{
	case Gm_ENTITY_BARIL:
		while( pEntity = UTIL_FindEntityByClassname( pEntity, "item_baril" ))
			GvCompteEntity_i++;
		break;
	case Gm_ENTITY_BARIL_ROUGE:
		while( pEntity = UTIL_FindEntityByClassname( pEntity, "item_baril_rouge" ))
			GvCompteEntity_i++;
		break;
	case Gm_ENTITY_BARIL_BLEU:
		while( pEntity = UTIL_FindEntityByClassname( pEntity, "item_baril_bleu" ))
			GvCompteEntity_i++;
		break;
	case Gm_ENTITY_MINE:
		while( pEntity = UTIL_FindEntityByClassname( pEntity, "item_mine" ))
			GvCompteEntity_i++;
		break;
	case Gm_ENTITY_COMETE:
		break;
	default:
		return;
	}

	// Groove - 10032002 - Limite du nombre d'entit d'un type a 12.
	if( GvCompteEntity_i > 12 )
	{
		ALERT( at_console, "Max d'entites atteind !" );
		return;
	}

	pEntity = NULL;

	int GvNbZone016_i = 0;
	int GvNbZone032_i = 0;
	int GvNbZone064_i = 0;
	int GvNbZone128_i = 0;
	int GvNbZone256_i = 0;

	while((( pEntity = UTIL_FindEntityByClassname ( pEntity, "info_caisse_16" )) != NULL ))
		GvNbZone016_i++;

	while((( pEntity = UTIL_FindEntityByClassname ( pEntity, "info_caisse_32" )) != NULL ))
		GvNbZone032_i++;

	while((( pEntity = UTIL_FindEntityByClassname ( pEntity, "info_caisse_64" )) != NULL ))
		GvNbZone064_i++;

	while((( pEntity = UTIL_FindEntityByClassname ( pEntity, "info_caisse_128" )) != NULL ))
		GvNbZone128_i++;

	while((( pEntity = UTIL_FindEntityByClassname ( pEntity, "info_caisse_256" )) != NULL ))
		GvNbZone256_i++;

	double GvNbUnites_d = (( GvNbZone256_i * 16 )
						 + ( GvNbZone128_i * 8  )
						 + ( GvNbZone064_i * 4  )
						 + ( GvNbZone032_i * 2  )
						 + ( GvNbZone016_i * 1  ));
/*
	ALERT( at_console, "Caisses : %f : 256 : %f 128 : %f 64 : %f 32 : %f 16 : %f\n", 
						GvNbUnitCaisses,
						GvNbZone256_d,
						GvNbZone128_d,
						GvNbZone064_d,
						GvNbZone032_d,
						GvNbZone016_d );
*/
	Vector GvPosition_c = Vector( 0,0,0 );

	// Groove - 17012002 - Equiprobabilit de spawn des caisses siuvant les zones
	if( GvNbUnites_d == 0 )
	{
		#ifdef Gm_BETA_TEST
			ALERT( at_console, "Pas de zones de spawns des caisses.\n" );
		#endif
		return;
	}
	else
	{
		float GvProba_f[5][2];

		GvProba_f[0][0] = (( static_cast<float>( GvNbZone016_i * 1  )) / GvNbUnites_d );
		GvProba_f[1][0] = (( static_cast<float>( GvNbZone032_i * 2  )) / GvNbUnites_d );
		GvProba_f[2][0] = (( static_cast<float>( GvNbZone064_i * 4  )) / GvNbUnites_d );
		GvProba_f[3][0] = (( static_cast<float>( GvNbZone128_i * 8  )) / GvNbUnites_d );
		GvProba_f[4][0] = (( static_cast<float>( GvNbZone256_i * 16 )) / GvNbUnites_d );
/*
		ALERT( at_console, "Proba : %f : 256 : %f 128 : %f 64 : %f 32 : %f 16 : %f\n", 
							GvNbUnites_d,
							GvProba_f[0][0],
							GvProba_f[1][0],
							GvProba_f[2][0],
							GvProba_f[3][0],
							GvProba_f[4][0] );
*/
		for( short I = 0; I <= 4; I++ )
			GvProba_f[I][1] = 0;

		for( short J = 0; J <= 4; J++ )
			for( short K = 0; K <= J; K++ )
				GvProba_f[J][1] += GvProba_f[K][0];

		float GvChoixZone_f = RANDOM_FLOAT( 0, 1 );

		if(( GvChoixZone_f <= GvProba_f[0][1] ) && ( GvProba_f[0][0] > 0 ))
		{
			for ( int i = RANDOM_LONG( 1,GvNbZone016_i ); i > 0; i-- )
				pEntity = UTIL_FindEntityByClassname( pEntity, "info_caisse_16" );

			GvPosition_c = pEntity->pev->origin;
		}
		else if(( GvChoixZone_f <= GvProba_f[1][1] ) && ( GvProba_f[1][0] > 0 ))
		{
			for ( int i = RANDOM_LONG( 1,GvNbZone032_i ); i > 0; i-- )
				pEntity = UTIL_FindEntityByClassname( pEntity, "info_caisse_32" );

			GvPosition_c = pEntity->pev->origin + Vector( RANDOM_LONG( -16,16 ), RANDOM_LONG( -16,16 ), 0 );
		}
		else if(( GvChoixZone_f <= GvProba_f[2][1] ) && ( GvProba_f[2][0] > 0 ))
		{
			for ( int i = RANDOM_LONG( 1,GvNbZone064_i ); i > 0; i-- )
				pEntity = UTIL_FindEntityByClassname( pEntity, "info_caisse_64" );

			GvPosition_c = pEntity->pev->origin + Vector( RANDOM_LONG( -32,32 ), RANDOM_LONG( -32,32 ), 0 );
		}
		else if(( GvChoixZone_f <= GvProba_f[3][1] ) && ( GvProba_f[3][0] > 0 ))
		{
			for ( int i = RANDOM_LONG( 1,GvNbZone128_i ); i > 0; i-- )
				pEntity = UTIL_FindEntityByClassname( pEntity, "info_caisse_128" );

			GvPosition_c = pEntity->pev->origin + Vector( RANDOM_LONG( -96,96 ), RANDOM_LONG( -96,96 ), 0 );
		}
		else if(( GvChoixZone_f <= GvProba_f[4][1] ) && ( GvProba_f[4][0] > 0 ))
		{
			for ( int i = RANDOM_LONG( 1,GvNbZone256_i ); i > 0; i-- )
				pEntity = UTIL_FindEntityByClassname( pEntity, "info_caisse_256" );

			GvPosition_c = pEntity->pev->origin + Vector( RANDOM_LONG( -224,224 ), RANDOM_LONG( -224,224 ), 0 );
		}
		else
		{
			ALERT( at_console, "ERREUR dans GfEntitySpawn( )" );
			return;
		}

		switch( GvChoixEntity_i )
		{
		case Gm_ENTITY_BARIL_ROUGE:
			pEntity = CBaseEntity::Create( "item_baril_rouge", GvPosition_c, Vector( 0,0,0 ), pEntity->edict( ));
			break;
		case Gm_ENTITY_BARIL_BLEU:
			pEntity = CBaseEntity::Create( "item_baril_bleu", GvPosition_c, Vector( 0,0,0 ), pEntity->edict( ));
			break;
		case Gm_ENTITY_BARIL:
			pEntity = CBaseEntity::Create( "item_baril", GvPosition_c, Vector( 0,0,0 ), pEntity->edict( ));			
			break;
		case Gm_ENTITY_MINE:
			pEntity = GcGrenadeGeneric::GfMine( NULL, GvPosition_c, Vector( 0,0,0 ), Gm_MINE_AMORCE, Gm_MINE_DOMMAGE );
//			pEntity = CBaseEntity::Create( "item_mine", GvPosition_c, Vector( 0,0,0 ), pEntity->edict( ));			
			break;
		default:
			return;
		}

		pEntity->pev->velocity.z = -1;
		EMIT_SOUND( ENT( pEntity->pev ), CHAN_ITEM, Gf_SOUND_JEU_CAISSE_SPAWN_01, 0.75, ATTN_NORM);

	}
	ALERT( at_console, "Zglu fin\n" );
}

BOOL CGameRules::CanHaveAmmo( CBasePlayer *pPlayer, const char *pszAmmoName, int iMaxCarry )
{
	int iAmmoIndex;

	if( pszAmmoName )
	{
		iAmmoIndex = pPlayer->GetAmmoIndex( pszAmmoName );

		if( iAmmoIndex > -1 )
			if( pPlayer->AmmoInventory( iAmmoIndex ) < iMaxCarry )
				// player has room for more of this type of ammo
				return TRUE;
	}
	return FALSE;
}

//=========================================================
//=========================================================
edict_t *CGameRules :: GetPlayerSpawnSpot( CBasePlayer *pPlayer )
{
//	extern edict_t *EntSelectTeamSpawnPoint( CBaseEntity *pPlayer );
	edict_t *pentSpawnSpot = NULL;

	// Groove - 03122001 - Si le mode de jeu actif est Gm_GAMERULES_NORMAL
	// les pts de spwan sont commun aux equipes
	if( g_pGameRules->bGfSpawnGroup( ))
		pentSpawnSpot = EntSelectTeamSpawnPoint( pPlayer );
	else
		pentSpawnSpot = EntSelectSpawnPoint( pPlayer );

	pPlayer->pev->origin = VARS( pentSpawnSpot )->origin + Vector(0,0,1);
	pPlayer->pev->v_angle  = g_vecZero;
	pPlayer->pev->velocity = g_vecZero;
	pPlayer->pev->angles = VARS( pentSpawnSpot )->angles;
	pPlayer->pev->punchangle = g_vecZero;
	pPlayer->pev->fixangle = TRUE;
	
	return pentSpawnSpot;
}

// Groove - 21112001 - Choix du type de jeu
CGameRules *InstallGameRules( void )
{
	SERVER_COMMAND( "exec game.cfg\n" );
	SERVER_EXECUTE( );

	if(( strstr( STRING(gpGlobals->mapname ), "ac_" )) != NULL )
		return new GcGamerulesAction;

	else if(( strstr( STRING(gpGlobals->mapname ), "bt_" )) != NULL )
		return new GcGamerulesBatte;

	else if(( strstr( STRING(gpGlobals->mapname ), "db_" )) != NULL )
		return new GcGamerulesBaril;

	else if(( strstr( STRING(gpGlobals->mapname ), "fun_" )) != NULL )
		return new GcGamerulesNormal;

	else if(( strstr( STRING(gpGlobals->mapname ), "gp_" )) != NULL )
		return new GcGamerulesGroup;

	else if(( strstr( STRING(gpGlobals->mapname ), "pc_" )) != NULL )
		return new GcGamerulesControle;

	else if(( strstr( STRING( gpGlobals->mapname ), "wm_" )) != NULL )
		return new GcGamerulesNormal;

	else if(( strstr( STRING(gpGlobals->mapname ), "zn_" )) != NULL )
		return new GcGamerulesZone;
	
	else
		return new GcGamerulesNormal;
}



