/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	gamerules_mode_batte.cpp	*
*		17042002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "generic_arme.h"
#include "gamerules.h"
#include "gamerules_teamplay.h"
#include "gamerules_mode_baril.h"
#include "define_slot.h"
#include "map_triggers.h"
#include "game.h"

// Groove - 21112001 - Pr effet couleur sur HUD
#include "shake.h"

void GcGamerulesBaril::GfTempsTPT( CBasePlayer *pPlayer )
{ 
    if( !fGvTempsTPT || fGvTempsTPT <= gpGlobals->time ) // si il s'est pass 1 seconde depuis qu'on a assign temps2
	{
		short GvCompteBarilBleu_i = 0;
		short GvCompteBarilRouge_i = 0;
		
		CBaseEntity *pGvEntityBaril = NULL;
		while( pGvEntityBaril = UTIL_FindEntityByClassname( pGvEntityBaril, "item_baril_bleu" ))
			GvCompteBarilBleu_i++;
		if( GvCompteBarilBleu_i < 5 )
			GfEntitySpawn_i( Gm_ENTITY_BARIL_BLEU );
		
		pGvEntityBaril = NULL;
		while( pGvEntityBaril = UTIL_FindEntityByClassname( pGvEntityBaril, "item_baril_rouge" ))
			GvCompteBarilRouge_i++;
		if( GvCompteBarilRouge_i < 5 )
			GfEntitySpawn_i( Gm_ENTITY_BARIL_ROUGE );

		UTIL_Remove( pGvEntityBaril );

		// Les scores sont mise a jour toutes les secondes ...
		GfFinDeTourAutoTPT( pPlayer );

		MESSAGE_BEGIN( MSG_ALL, gmsgTime );
			WRITE_BYTE( iGvTempsTPT );
		MESSAGE_END( );

		fGvTempsTPT++;
		iGvTempsTPT--;

		if(( iGvTempsTPT == 5 ) &&  pPlayer->GvPlayerTPT.bTire )
			EMIT_SOUND( ENT( pPlayer->pev ), CHAN_VOICE, Gf_SOUND_JEU_VITE_01, 0.7, ATTN_STATIC);
		if(( iGvTempsTPT < 3 ) &&  pPlayer->GvPlayerTPT.bTire )
			EMIT_SOUND( ENT( pPlayer->pev ), CHAN_ITEM, Gf_SOUND_JEU_BELL_01, 0.7, ATTN_STATIC );
	}

    if( iGvTempsTPT < 0 )
	{
		pPlayer->GvPlayerTPT.bMove = false;
		pPlayer->GvPlayerTPT.bTire = false;

		if( iGvTempsTPT == -Gm_TPT_TEMPS_FIN_TOUR )
		{
			if( GvWormsBleuTPT )
				GfWormsRougesTPT( pPlayer );
			else
				GfWormsBleuxTPT( pPlayer );
		}
	}

	if( FStrEq( pPlayer->m_szTeamName,"Wormsblue" ))
		pPlayer->pev->iuser4 = Gm_WORM_BLEU;
	else
		pPlayer->pev->iuser4 = Gm_WORM_ROUGE;

	pPlayer->pev->iuser3 = pPlayer->GvPlayerTPT.bMove;

	// EurOPiUM - 03032002 - pyramide
	pPlayer->pev->fuser1 = pPlayer->pev->health;
}

// Groove - 22112001 - PlayerSpawn pour le mode de jeu normale
void GcGamerulesBaril::PlayerSpawn( CBasePlayer *pPlayer )
{
	BOOL		addDefault = TRUE;
	CBaseEntity	*pWeaponEntity = NULL;

	if( FStrEq( pPlayer->m_szTeamName,"Wormsblue" ))
		pPlayer->pev->iuser4 = Gm_WORM_BLEU;
	else
		pPlayer->pev->iuser4 = Gm_WORM_ROUGE;

	pPlayer->pev->fuser1 = pPlayer->pev->health;		
	pPlayer->pev->iuser3 = pPlayer->GvPlayerTPT.bMove = false;
	pPlayer->GvPlayerTPT.bAmmo = false;
	pPlayer->GvPlayerTPT.bTire = false;
	pPlayer->pev->maxspeed = 1;
	
	if( GvMortSubite )
	{
		UTIL_ScreenFade( pPlayer, Vector( 255, 0, 0 ), 1, 0.5, 64, FFADE_OUT | FFADE_STAYOUT );
		pPlayer->GfSentirDommange( 20, 255 );
		pPlayer->pev->health = 1;
	}
	else
	{
		UTIL_ScreenFade( pPlayer, Vector( 1,1,1 ), 0, 1, 255, FFADE_IN );
	}

	while ( pWeaponEntity = UTIL_FindEntityByClassname( pWeaponEntity, "game_player_equip" ))
	{
		pWeaponEntity->Touch( pPlayer );
		addDefault = FALSE;
	}

	if( pPlayer->iGvConnection == Gm_CLIENT_CONNECTION_RESPAWN )
	{
		for (int i=0; i < MAX_AMMO_SLOTS;i++)
			pPlayer->m_rgAmmo[i] = pPlayer->m_rgAmmodonne[i];

		pPlayer->pev->rendermode = kRenderNormal;
		pPlayer->pev->renderamt = 255;
		pPlayer->pev->renderfx = kRenderFxNone;
		pPlayer->pev->rendercolor.x = 0;
		pPlayer->pev->rendercolor.y = 0;
		pPlayer->pev->rendercolor.z = 0;
	}

	if( pPlayer->iGvConnection == Gm_CLIENT_CONNECTION_SPAWN )
	{ 
		#ifdef Gd_ARME_FUSIL
			if( GvFusilOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_fusil" );
		#endif
		#ifdef Gd_ARME_AIR_STRIKE
			if(( GvAirStrikeOnCMD.value == 1 )&& bGvAirAttack )
				pPlayer->GiveNamedItem( "weapon_air_strike" );
		#endif
		#ifdef Gd_ARME_BANANE
//			#ifdef Gm_BETA_TEST
				if( GvBananeOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_banane" );
//			#endif
		#endif
		#ifdef Gd_ARME_BATTE
			if( GvBatteOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_batte" );
		#endif
		#ifdef Gd_ARME_BAZOOKA
			if( GvBazookaOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_bazooka" );
		#endif
		#ifdef Gd_ARME_CAMERA
			if( GvCameraOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_camera" );
		#endif
		#ifdef Gd_ARME_CLUSTER
			if( GvClusterOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_cluster" );
		#endif
		#ifdef Gd_ARME_CROIX
			#ifdef Gm_BETA_TEST
				if( GvCroixOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_croix" );
			#endif
		#endif
		#ifdef Gd_ARME_DYNAMITE
			if( GvDynamiteOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_dynamite" );
		#endif
		#ifdef Gd_ARME_GRAPPIN
			if( GvGrappinOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_grappin" );
		#endif
		#ifdef Gd_ARME_GRENADE
			if( GvGrenadeOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_grenade" );
		#endif
		#ifdef Gd_ARME_HACHE
			if( GvHacheOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_hache" );
		#endif
		#ifdef Gd_ARME_HELICO
			if( GvHacheOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_helico" );
		#endif
		#ifdef Gd_ARME_JETPACK
			if( GvJetpackOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_jetpack" );
		#endif
		#ifdef Gd_ARME_KAMEHA
			if( GvKameaOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_kameha" );
		#endif
		#ifdef Gd_ARME_KAMIKAZE
			if( GvKamikazeOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_kamikaze" );
		#endif
		#ifdef Gd_ARME_MINE
			if( GvMineOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_mine" );
		#endif
		#ifdef Gd_ARME_MINICANON
			if( GvMinicanonOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_minicanon" );
		#endif
		#ifdef Gd_ARME_LASER
//			if( GvMinicanonOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_laser" );
		#endif
		#ifdef Gd_ARME_MOLOTOV
			if( GvMolotovOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_molotov" );
		#endif
		#ifdef Gd_ARME_MORTIER
			if( GvMortierOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_mortier" );
		#endif
		#ifdef Gd_ARME_MORVE
//			#ifdef Gm_BETA_TEST
				if( GvMorveOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_morve" );
//			#endif
		#endif
		#ifdef Gd_ARME_MOUTON
			if( GvMoutonOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_mouton" );
		#endif
		#ifdef Gd_ARME_NAPALM
			#ifdef Gm_BETA_TEST
				if(( GvNapalmOnCMD.value == 1 )&& bGvAirAttack )
					pPlayer->GiveNamedItem( "weapon_napalm" );
			#endif
		#endif
		#ifdef Gd_ARME_PHEONIX
			#ifdef Gm_BETA_TEST
				if( GvPheonixOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_pheonix" );
			#endif
		#endif
		#ifdef Gd_ARME_PIGEON
//			#ifdef Gm_BETA_TEST
				if( GvPigeonOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_pigeon" );
//			#endif
		#endif
		#ifdef Gd_ARME_SAINTE
//			#ifdef Gm_BETA_TEST
				if( GvSainteOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_sainte" );
//			#endif
		#endif
		#ifdef Gd_ARME_SNIPE
			if( GvSnipeOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_snipe" );
		#endif
		#ifdef Gd_ARME_SUPER_MOUTON
			#ifdef Gm_BETA_TEST
				if( GvSuperMoutonOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_super_mouton" );
			#endif
		#endif
		#ifdef Gd_ARME_TELEPORTEUR
			if( GvTeleporteurOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_teleporteur" );

		#endif
		#ifdef Gd_ARME_TRIDENT
			#ifdef Gm_BETA_TEST
				if( GvTridentOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_trident" );
			#endif
		#endif
		#ifdef Gd_ARME_UZI
			#ifdef Gm_BETA_TEST
				if( GvUziOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_uzi" );
			#endif
		#endif
		pPlayer->iGvConnection = Gm_CLIENT_CONNECTION_RESPAWN;
	}

	// Groove - 28032002 - Donne une arme spcial a l'equipe qui gagne une manche.
	if( pPlayer->iGvConnection == Gm_CLIENT_CONNECTION_WIN )
	{ 
		for( int i = 0; i < MAX_AMMO_SLOTS; i++ )
			pPlayer->m_rgAmmo[i] = pPlayer->m_rgAmmodonne[i];

		switch( RANDOM_LONG( 1, 6 ))
		{
		case 1:
			#ifdef Gd_ARME_TRIDENT
				if( GvTridentOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_trident" );
			break;
			#endif
		case 2:			
			#ifdef Gd_ARME_SAINTE
				if( GvSainteOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_sainte" );
			break;
			#endif
		case 3:
			#ifdef Gm_ARME_MORVE
				if( GvMorveOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_morve" );
			break;
			#endif
		case 4:
			#ifdef Gm_ARME_MINICANON
			if( GvMinicanonOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_minicanon" );
			break;
			#endif
		case 5:
			#ifdef Gm_ARME_CROIX
			if( GvCroixOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_croix" );
			break;
			#endif
		case 6:
			#ifdef Gm_ARME_BANANE
			if( GvBananeOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_banane" );
			break;
			#endif
		default:
			break;
		}

		pPlayer->iGvConnection = Gm_CLIENT_CONNECTION_RESPAWN;
	}
}