/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	gamerules_mode_batte.cpp	*
*		19022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "generic_arme.h"
#include "game.h"
#include "gamerules.h"
#include "gamerules_teamplay.h"
#include "gamerules_mode_batte.h"
#include "define_slot.h"
#include "map_triggers.h"

// Groove - 21112001 - Pr effet couleur sur HUD
#include "shake.h"

// Groove - 22112001 - PlayerSpawn pour le mode de jeu normale
void GcGamerulesBatte::PlayerSpawn( CBasePlayer *pPlayer )
{
	BOOL		addDefault = TRUE;
	CBaseEntity	*pWeaponEntity = NULL;

	if( FStrEq( pPlayer->m_szTeamName,"Wormsblue" ))
		pPlayer->pev->iuser4 = Gm_WORM_BLEU;
	else
		pPlayer->pev->iuser4 = Gm_WORM_ROUGE;

	pPlayer->pev->fuser1 = pPlayer->pev->health;		
	pPlayer->pev->iuser3 = pPlayer->GvPlayerTPT.bMove = false;
	pPlayer->GvPlayerTPT.bAmmo = false;
	pPlayer->GvPlayerTPT.bTire = false;
	pPlayer->pev->maxspeed = 1;

	if( GvMortSubite )
	{
		UTIL_ScreenFade( pPlayer, Vector( 255, 0, 0 ), 1, 0.5, 64, FFADE_OUT | FFADE_STAYOUT );
		pPlayer->GfSentirDommange( 20, 255 );
		pPlayer->pev->health = 1;
	}
	else
	{
		UTIL_ScreenFade( pPlayer, Vector( 1,1,1 ), 0, 1, 255, FFADE_IN );
	}

	while ( pWeaponEntity = UTIL_FindEntityByClassname( pWeaponEntity, "game_player_equip" ))
	{
		pWeaponEntity->Touch( pPlayer );
		addDefault = FALSE;
	}

	if( pPlayer->iGvConnection == Gm_CLIENT_CONNECTION_RESPAWN )
	{
		for( int i=0; i < MAX_AMMO_SLOTS;i++ )
			pPlayer->m_rgAmmo[i] = pPlayer->m_rgAmmodonne[i];

		pPlayer->pev->rendermode = kRenderNormal;
		pPlayer->pev->renderamt = 255;
		pPlayer->pev->renderfx = kRenderFxNone;
		pPlayer->pev->rendercolor.x = 0;
		pPlayer->pev->rendercolor.y = 0;
		pPlayer->pev->rendercolor.z = 0;
	}

	if( pPlayer->iGvConnection == Gm_CLIENT_CONNECTION_SPAWN )
	{ 
		#ifdef Gd_ARME_BATTE
//			if( GvBatteOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_batte" );
		#endif
		#ifdef Gd_ARME_CAMERA
			if( GvCameraOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_camera" );
		#endif
		#ifdef Gd_ARME_GRAPPIN
			if( GvGrappinOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_grappin" );
		#endif
		#ifdef Gd_ARME_JETPACK
			if( GvJetpackOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_jetpack" );
		#endif
		#ifdef Gd_ARME_TELEPORTEUR
			if( GvTeleporteurOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_teleporteur" );
		#endif
		pPlayer->iGvConnection = Gm_CLIENT_CONNECTION_RESPAWN;
	}

	// Groove - 28032002 - Donne une arme spcial a l'equipe qui gagne une manche.
	if( pPlayer->iGvConnection == Gm_CLIENT_CONNECTION_WIN )
	{ 
		switch( RANDOM_LONG( 1, 3 ))
		{
		case 1:
			#ifdef Gd_ARME_GRAPPIN
				if( GvGrappinOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_grappin" );
			#endif
			break;
		case 2:
			#ifdef Gd_ARME_JETPACK
				if( GvJetpackOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_jetpack" );
			#endif
			break;
		case 3:
			#ifdef Gd_ARME_TELEPORTEUR
				if( GvTeleporteurOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_teleporteur" );
			#endif
			break;
		}

		pPlayer->iGvConnection = Gm_CLIENT_CONNECTION_RESPAWN;
	}

	pPlayer->GvPlayerTPT.bMove = false;
	pPlayer->GvPlayerTPT.bTire = false;
}
