/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	gamerules_multiplay			*
*		27022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "generic_arme.h"
#include "gamerules.h"
#include "game.h"
#include "items.h"
#include "client.h"

#include "map_triggers.h"
#include "define_slot.h"
#include "shake.h"
#include "arme_mouton.h"

extern DLL_GLOBAL CGameRules *g_pGameRules;
extern DLL_GLOBAL BOOL	g_fGameOver;

CHalfLifeMultiplay::CHalfLifeMultiplay( )
{
	GvMortSubite = false;
	GvActiveBaril_b = false;
	GvActiveMine_b = false;
	GvActiveZoneBleu_b = false;
	GvActiveZoneRouge_b = false;

	// Groove - 11122001 - Init des scores
	GfScoreAdd( Gm_SCORE_INI_FULL );
	
	fGvChangementDeCarte = 0.0;

	if( IS_DEDICATED_SERVER( ))
	{
		// dedicated server
		char *servercfgfile = (char *)CVAR_GET_STRING( "servercfgfile" );

		if( servercfgfile && servercfgfile[0] )
		{
			char szCommand[256];
			
			ALERT( at_console, "Executing dedicated server config file\n" );
			sprintf( szCommand, "exec %s\n", servercfgfile );
			SERVER_COMMAND( szCommand );
		}
	}
	else
	{
		// listen server
		char *lservercfgfile = (char *)CVAR_GET_STRING( "lservercfgfile" );

		if( lservercfgfile && lservercfgfile[0] )
		{
			char szCommand[256];
			
			ALERT( at_console, "Executing listen server config file\n" );
			sprintf( szCommand, "exec %s\n", lservercfgfile );
			SERVER_COMMAND( szCommand );
		}
	}
}

// longest the intermission can last, in seconds
#define MAX_INTERMISSION_TIME		120

void CHalfLifeMultiplay::PlayerSpawn( CBasePlayer *pPlayer )
{
	BOOL		addDefault = TRUE;
	CBaseEntity	*pWeaponEntity = NULL;

	if( FStrEq( pPlayer->m_szTeamName,"Wormsblue" ))
		pPlayer->pev->iuser4 = Gm_WORM_BLEU;
	else
		pPlayer->pev->iuser4 = Gm_WORM_ROUGE;

	pPlayer->pev->fuser1 = pPlayer->pev->health;		
	pPlayer->pev->iuser3 = pPlayer->GvPlayerTPT.bMove = false;
	pPlayer->GvPlayerTPT.bAmmo = false;
	pPlayer->GvPlayerTPT.bTire = false;
	pPlayer->pev->maxspeed = 1;

	if( GvMortSubite )
	{
		UTIL_ScreenFade( pPlayer, Vector( 255, 0, 0 ), 1, 0.5, 64, FFADE_OUT | FFADE_STAYOUT );
		pPlayer->GfSentirDommange( 20, 255 );
		pPlayer->pev->health = 1;
	}
	else
	{
		UTIL_ScreenFade( pPlayer, Vector( 1,1,1 ), 0, 1, 255, FFADE_IN );
	}

	while ( pWeaponEntity = UTIL_FindEntityByClassname( pWeaponEntity, "game_player_equip" ))
	{
		pWeaponEntity->Touch( pPlayer );
		addDefault = FALSE;
	}

	if( pPlayer->iGvConnection == Gm_CLIENT_CONNECTION_RESPAWN )
	{
		for( int i = 0; i < MAX_AMMO_SLOTS; i++ )
			pPlayer->m_rgAmmo[i] = pPlayer->m_rgAmmodonne[i];

		pPlayer->pev->rendermode = kRenderNormal;
		pPlayer->pev->renderamt = 255;
		pPlayer->pev->renderfx = kRenderFxNone;
		pPlayer->pev->rendercolor.x = 0;
		pPlayer->pev->rendercolor.y = 0;
		pPlayer->pev->rendercolor.z = 0;
	}

	if( pPlayer->iGvConnection == Gm_CLIENT_CONNECTION_SPAWN )
	{
		#ifdef Gd_ARME_FUSIL
			if( GvFusilOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_fusil" );
		#endif
		#ifdef Gd_ARME_AIR_STRIKE
			if(( GvAirStrikeOnCMD.value == 1 )&& bGvAirAttack )
				pPlayer->GiveNamedItem( "weapon_air_strike" );
		#endif
		#ifdef Gd_ARME_BANANE
			#ifdef Gm_BETA_TEST
				if( GvBananeOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_banane" );
			#endif
		#endif
		#ifdef Gd_ARME_BATTE
			if( GvBatteOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_batte" );
		#endif
		#ifdef Gd_ARME_BAZOOKA
			if( GvBazookaOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_bazooka" );
		#endif
		#ifdef Gd_ARME_CAMERA
			if( GvCameraOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_camera" );
		#endif
		#ifdef Gd_ARME_CLUSTER
			if( GvClusterOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_cluster" );
		#endif
		#ifdef Gd_ARME_CROIX
			#ifdef Gm_BETA_TEST
				if( GvCroixOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_croix" );
			#endif
		#endif
		#ifdef Gd_ARME_DYNAMITE
			if( GvDynamiteOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_dynamite" );
		#endif
		#ifdef Gd_ARME_GRAPPIN
			if( GvGrappinOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_grappin" );
		#endif
		#ifdef Gd_ARME_GRENADE
			if( GvGrenadeOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_grenade" );
		#endif
		#ifdef Gd_ARME_HACHE
			#ifdef Gm_BETA_TEST
				if( GvHacheOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_hache" );
			#endif
		#endif
		#ifdef Gd_ARME_HELICO
			#ifdef Gm_BETA_TEST
				if( GvHacheOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_helico" );
			#endif
		#endif
		#ifdef Gd_ARME_JETPACK
			#ifdef Gm_BETA_TEST
				if( GvJetpackOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_jetpack" );
			#endif
		#endif
		#ifdef Gd_ARME_KAMEHA
			#ifdef Gm_BETA_TEST
				if( GvKameaOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_kameha" );
			#endif
		#endif
		#ifdef Gd_ARME_KAMIKAZE
			if( GvKamikazeOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_kamikaze" );
		#endif
		#ifdef Gd_ARME_MINE
			if( GvMineOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_mine" );
		#endif
		#ifdef Gd_ARME_MINICANON
			#ifdef Gm_BETA_TEST
				if( GvMinicanonOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_minicanon" );
			#endif
		#endif
		#ifdef Gd_ARME_LASER
//			if( GvLaserOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_laser" );
		#endif
		#ifdef Gd_ARME_MOLOTOV
			#ifdef Gm_BETA_TEST
				if( GvMolotovOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_molotov" );
			#endif
		#endif
		#ifdef Gd_ARME_MORTIER
			if( GvMortierOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_mortier" );
		#endif
		#ifdef Gd_ARME_MORVE
			#ifdef Gm_BETA_TEST
				if( GvMorveOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_morve" );
			#endif
		#endif
		#ifdef Gd_ARME_MOUTON
			if( GvMoutonOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_mouton" );
		#endif
		#ifdef Gd_ARME_NAPALM
			#ifdef Gm_BETA_TEST
				if(( GvNapalmOnCMD.value == 1 )&& bGvAirAttack )
					pPlayer->GiveNamedItem( "weapon_napalm" );
			#endif
		#endif
		#ifdef Gd_ARME_PIGEON
			#ifdef Gm_BETA_TEST
				if( GvPigeonOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_pigeon" );
			#endif
		#endif
		#ifdef Gd_ARME_PHEONIX
			#ifdef Gm_BETA_TEST
				if( GvPheonixOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_pheonix" );
			#endif
		#endif
		#ifdef Gd_ARME_SAINTE
			#ifdef Gm_BETA_TEST
				if( GvSainteOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_sainte" );
			#endif
		#endif
		#ifdef Gd_ARME_SNIPE
			#ifdef Gm_BETA_TEST
				if( GvSnipeOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_snipe" );
			#endif
		#endif
		#ifdef Gd_ARME_SUPER_MOUTON
			#ifdef Gm_BETA_TEST
				if( GvSuperMoutonOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_super_mouton" );
			#endif
		#endif
		#ifdef Gd_ARME_TELEPORTEUR
			if( GvTeleporteurOnCMD.value == 1 )
				pPlayer->GiveNamedItem( "weapon_teleporteur" );

		#endif
		#ifdef Gd_ARME_TRIDENT
			#ifdef Gm_BETA_TEST
				if( GvTridentOnCMD.value == 1 )
					pPlayer->GiveNamedItem( "weapon_trident" );
			#endif
		#endif
		pPlayer->iGvConnection = Gm_CLIENT_CONNECTION_RESPAWN;
	}
}
//=========================================================
//=========================================================
void CHalfLifeMultiplay::Think( void )
{
	static int last_frags;
	static int last_time;

	int frags_remaining = 0;
	int time_remaining = 0;

	if( g_fGameOver )   // someone else quit the game already
	{
		g_fGameOver = false;
		if( fGvChangementDeCarte < gpGlobals->time )
			if( m_iEndIntermissionButtonHit || (( fGvChangementDeCarte + MAX_INTERMISSION_TIME ) < gpGlobals->time )) 
				ChangeLevel( ); // intermission is over
		return;
	}

	float flTimeLimit = timelimit.value * 60;
	float flFragLimit = fraglimit.value;
	
	time_remaining = (int)( flTimeLimit ? ( flTimeLimit - gpGlobals->time ) : 0 );

	if( flTimeLimit != 0 && gpGlobals->time >= flTimeLimit )
	{
		GoToIntermission( );
		return;
	}

	if( flFragLimit )
	{
		int bestfrags = 9999;
		int remain;

		// check if any player is over the frag limit
		for( int i = 1; i <= gpGlobals->maxClients; i++ )
		{
			CBaseEntity *pPlayer = UTIL_PlayerByIndex( i );

			if( pPlayer && pPlayer->pev->frags >= flFragLimit )
			{
				GoToIntermission( );
				return;
			}


			if( pPlayer )
			{
				remain = flFragLimit - pPlayer->pev->frags;
				if( remain < bestfrags )
					bestfrags = remain;
			}

		}
		frags_remaining = bestfrags;
	}

	// Updates when frags change
	if( frags_remaining != last_frags )
		g_engfuncs.pfnCvar_DirectSet( &fragsleft, UTIL_VarArgs( "%i", frags_remaining ) );

	// Updates once per second
	if( GvTimeLeftCMD.value != last_time )
		g_engfuncs.pfnCvar_DirectSet( &GvTimeLeftCMD, UTIL_VarArgs( "%i", time_remaining ) );

	last_frags = frags_remaining;
	last_time  = time_remaining;
}

//=========================================================
//=========================================================
BOOL CHalfLifeMultiplay::IsMultiplayer( void )
{
	return TRUE;
}

//=========================================================
//=========================================================
BOOL CHalfLifeMultiplay::IsDeathmatch( void )
{
	return TRUE;
}

//=========================================================
//=========================================================
BOOL CHalfLifeMultiplay::FShouldSwitchWeapon( CBasePlayer *pPlayer, CBasePlayerItem *pWeapon )
{
	if( !pWeapon->CanDeploy( ))
		return FALSE;

	if( !pPlayer->m_pActiveItem )
		return TRUE;

	if( !pPlayer->m_pActiveItem->CanHolster( ))
		return FALSE;

	if( pWeapon->ItemInfoArray[pWeapon->m_iId].iWeight > pPlayer->m_pActiveItem->ItemInfoArray[pPlayer->m_pActiveItem->m_iId].iWeight )
		return TRUE;

	return FALSE;
}

BOOL CHalfLifeMultiplay :: ClientConnected( edict_t *pEntity, const char *pszName, const char *pszAddress, char szRejectReason[ 128 ] )
{
	return TRUE;
}

void CHalfLifeMultiplay::UpdateGameMode( CBasePlayer *pPlayer )
{
	MESSAGE_BEGIN( MSG_ONE, gmsgGameMode, NULL, pPlayer->edict() );
		WRITE_BYTE( 0 );  // game mode none
	MESSAGE_END();
}

// Groove - 27102001 - Ini HUD
void CHalfLifeMultiplay::InitHUD( CBasePlayer *pl )
{
	UTIL_ClientPrintAll( HUD_PRINTNOTIFY, UTIL_VarArgs( "%s has joined the game\n", 		( pl->pev->netname && STRING(pl->pev->netname)[0] != 0 ) ? STRING(pl->pev->netname) : "unconnected" ));
	UTIL_LogPrintf( "\"%s<%i>\" has entered the game\n",  STRING( pl->pev->netname ), GETPLAYERUSERID( pl->edict() ) );

	UpdateGameMode( pl );

	iGvTempsTPT = 0;
	fGvTempsTPT = 0;

	MESSAGE_BEGIN( MSG_ONE, gmsgScoreInfo, NULL, pl->edict() );
		WRITE_BYTE( ENTINDEX(pl->edict()) );
		WRITE_SHORT( pl->ietoiles );
		WRITE_SHORT( 0 );
	MESSAGE_END();

	GfScoreAdd( Gm_SCORE_INI );

	SendMOTDToClient( pl->edict() );

	for( int i = 1; i <= gpGlobals->maxClients; i++ )
	{
		// FIXME:  Probably don't need to cast this just to read m_iDeaths
		CBasePlayer *plr = (CBasePlayer *)UTIL_PlayerByIndex( i );

		if( plr )
		{
			MESSAGE_BEGIN( MSG_ONE, gmsgScoreInfo, NULL, pl->edict() );
				WRITE_BYTE( i );	// client number
				WRITE_SHORT( plr->ietoiles );
				WRITE_SHORT( plr->m_iDeaths );
			MESSAGE_END();
		}
	}

	if( g_fGameOver )
	{
		MESSAGE_BEGIN( MSG_ONE, SVC_INTERMISSION, NULL, pl->edict() );
		MESSAGE_END();
	}
	
	// Groove - 06032002 - Affichage du menu de changment d'equipe ...
	pl->PfShowVGUI_i( MENU_TEAM );
}

//=========================================================
//=========================================================
void CHalfLifeMultiplay :: ClientDisconnected( edict_t *pClient )
{
	if( pClient )
	{
		CBasePlayer *pPlayer = (CBasePlayer *)CBaseEntity::Instance( pClient );

		if( pPlayer )
		{
			FireTargets( "game_playerleave", pPlayer, pPlayer, USE_TOGGLE, 0 );
			UTIL_LogPrintf( "\"%s<%i>\" disconnected\n", STRING( pPlayer->pev->netname ), GETPLAYERUSERID( pPlayer->edict( )));
			pPlayer->RemoveAllItems( TRUE );// destroy all of the players weapons and items
		}
	}
}

// Groove - 03122001 - Dommage lors d'une chute 
float CHalfLifeMultiplay :: FlPlayerFallDamage( CBasePlayer *pPlayer )
{
//	Groove - 08042002 - Fin de tour lors d'une chute.
//	pPlayer->GvMoveTPT_b = false;
//	pPlayer->GvPlayerTPT.bTire = false;
	pPlayer->m_flFallVelocity -= PLAYER_MAX_SAFE_FALL_SPEED;
	return pPlayer->m_flFallVelocity * DAMAGE_FOR_FALL_SPEED;
} 

// Groove - 17082002 - Gestion des scores et victoires
void CHalfLifeMultiplay::GfGestionScore( void )
{
	bool bGvVictoire = false;
	int iGvMsg = 0;

	if( GvPointsCMD.value < 2 )
		GvPointsCMD.value = 2;

	if( GvPointsCMD.value > 20 )
		GvPointsCMD.value = 20;

	if( GvRoundsCMD.value != -1 )
	{
		if(( GvRoundsCMD.value <= iGvScoreBleuManche )||( GvRoundsCMD.value <= iGvScoreRougePoint ))
			g_fGameOver = true;
		if( GvRoundsCMD.value < 1 )
			GvRoundsCMD.value = 1;
		if( GvRoundsCMD.value > 5 )
			GvRoundsCMD.value = 5;
	}

	if( iGvScoreRougePoint >= GvPointsCMD.value )
	{
		iGvScoreRougeManche++;

		for( int iGvIndex = 0; iGvIndex <= gpGlobals->maxClients; iGvIndex++ )
		{	
			CBasePlayer *pGvPlayerX = (CBasePlayer*) UTIL_PlayerByIndex( iGvIndex );
			if( pGvPlayerX && ( FStrEq( pGvPlayerX->m_szTeamName,"Wormsred" )))
			{
				pGvPlayerX->m_iRespawnFrames = 0;
				respawn( pGvPlayerX->pev, false );

				switch( RANDOM_LONG( 1,3 ))
				{
				case 1 : EMIT_SOUND( ENT( pGvPlayerX->pev ), CHAN_VOICE, Gf_SOUND_VICTOIRE_01, 1, ATTN_NORM ); break;
				case 2 : EMIT_SOUND( ENT( pGvPlayerX->pev ), CHAN_VOICE, Gf_SOUND_VICTOIRE_02, 1, ATTN_NORM ); break;
				case 3 : EMIT_SOUND( ENT( pGvPlayerX->pev ), CHAN_VOICE, Gf_SOUND_VICTOIRE_03, 1, ATTN_NORM ); break;
				}
				
				CBaseEntity::Create( "item_caisse_arme", pGvPlayerX->pev->origin + Vector( 0,0,64), Vector( 0,0,0 ), pGvPlayerX->edict( ));
			}
		}

		iGvMsg = Gm_WORM_ROUGE;
		bGvVictoire = true;
	}

	if( iGvScoreBleuPoint >= GvPointsCMD.value )
	{
		iGvScoreBleuManche++;

		for( int iGvIndex = 0; iGvIndex <= gpGlobals->maxClients; iGvIndex++ )
		{	
			CBasePlayer *pGvPlayerX = (CBasePlayer*) UTIL_PlayerByIndex( iGvIndex );
			if( pGvPlayerX && ( FStrEq( pGvPlayerX->m_szTeamName,"Wormsblue" )))
			{
				pGvPlayerX->m_iRespawnFrames = 0;
				respawn( pGvPlayerX->pev, false );

				switch( RANDOM_LONG( 1,3 ))
				{
				case 1 : EMIT_SOUND( ENT( pGvPlayerX->pev ), CHAN_VOICE, Gf_SOUND_VICTOIRE_01, 1, ATTN_NORM ); break;
				case 2 : EMIT_SOUND( ENT( pGvPlayerX->pev ), CHAN_VOICE, Gf_SOUND_VICTOIRE_02, 1, ATTN_NORM ); break;
				case 3 : EMIT_SOUND( ENT( pGvPlayerX->pev ), CHAN_VOICE, Gf_SOUND_VICTOIRE_03, 1, ATTN_NORM ); break;
				}
			
				CBaseEntity::Create( "item_caisse_arme", pGvPlayerX->pev->origin + Vector( 0,0,64), Vector( 0,0,0 ), pGvPlayerX->edict( ));
			}
		}

		iGvMsg = Gm_WORM_BLEU;
		bGvVictoire = true;
	}

	if( bGvVictoire )
		GfScoreAdd( Gm_SCORE_INI );

	if( gmsgBarreMsg && iGvMsg )
	{
		MESSAGE_BEGIN( MSG_ALL, gmsgBarreMsg );
			WRITE_BYTE( iGvMsg );
		MESSAGE_END( );
	}

	if( gmsgScore )
	{
		MESSAGE_BEGIN( MSG_ALL, gmsgScore );
			WRITE_BYTE( iGvScoreRougePoint );
			WRITE_BYTE( iGvScoreBleuPoint );
			WRITE_BYTE( iGvScoreRougeManche );
			WRITE_BYTE( iGvScoreBleuManche );
		MESSAGE_END( );
	}
}

void CHalfLifeMultiplay::PlayerThink( CBasePlayer *pGvPlayer )
{
	GfTempsTPT( pGvPlayer );

	if( g_fGameOver )
	{
		// check for button presses
		if( pGvPlayer->m_afButtonPressed & ( IN_DUCK | IN_ATTACK | IN_ATTACK2 | IN_USE | IN_JUMP | IN_JUMP2 ))
			m_iEndIntermissionButtonHit = TRUE;

		// clear attack/use commands from player
		pGvPlayer->m_afButtonPressed = 0;
		pGvPlayer->pev->button = 0;
		pGvPlayer->m_afButtonReleased = 0;
	}
}

//=========================================================
// IPointsForKill - how many points awarded to anyone
// that kills this player?
//=========================================================
int CHalfLifeMultiplay::IPointsForKill( CBasePlayer *pAttacker, CBasePlayer *pKilled )
{
	return 1;
}

//=========================================================
// PlayerKilled - someone/something killed this player
//=========================================================
void CHalfLifeMultiplay::PlayerKilled( CBasePlayer *pVictim, entvars_t *pKiller, entvars_t *pInflictor )
{
	for( int i=0; i < MAX_AMMO_SLOTS;i++ )
		pVictim->m_rgAmmodonne[i] =pVictim->m_rgAmmo[i];

	if( g_pGameRules->bGfScoreKill( ))
		if ( FStrEq(pVictim->m_szTeamName,"Wormsred"))
			GfScoreAdd( Gm_SCORE_BLEU_1 );
		else 
			GfScoreAdd( Gm_SCORE_ROUGE_1 );

	DeathNotice( pVictim, pKiller, pInflictor );

	pVictim->m_iDeaths += 1;

	FireTargets( "game_playerdie", pVictim, pVictim, USE_TOGGLE, 0 );
	CBasePlayer *peKiller = NULL;
	CBaseEntity *ktmp = CBaseEntity::Instance( pKiller );
	if( ktmp &&( ktmp->Classify( ) == CLASS_PLAYER ))
		peKiller = (CBasePlayer*)ktmp;

	if( pVictim->pev == pKiller )  
		 // killed self
		pKiller->frags -= 1;
	else if( ktmp && ktmp->IsPlayer( ))
	{
		// Groove - 08052002 - Le joueur marque 1 point
		pKiller->frags += 1;		
		FireTargets( "game_playerkill", ktmp, ktmp, USE_TOGGLE, 0 );
	}
	else
	  // killed by the world
		pKiller->frags -= 1;
	

	// update the scores
	// killed scores

	MESSAGE_BEGIN( MSG_ALL, gmsgScoreInfo );
		WRITE_BYTE( ENTINDEX( pVictim->edict( )));
		WRITE_SHORT( pVictim->ietoiles );
		WRITE_SHORT( pVictim->m_iDeaths );
	MESSAGE_END();

	CBaseEntity *ep = CBaseEntity::Instance( pKiller );
	if( ep && ep->Classify() == CLASS_PLAYER )
	{
		CBasePlayer *PK = (CBasePlayer*)ep;

		MESSAGE_BEGIN( MSG_ALL, gmsgScoreInfo );
			WRITE_BYTE( ENTINDEX( PK->edict( )));
			// WRITE_SHORT( PK->pev->frags );
			// EurOPiuM - 18032002 - fichier profil
			WRITE_SHORT( PK->ietoiles );
			WRITE_SHORT( PK->m_iDeaths );
		MESSAGE_END( );

		PK->m_flNextDecalTime = gpGlobals->time;
	}

	if(( pVictim->HasNamedPlayerItem( "weapon_mouton" )) || ( pVictim->HasNamedPlayerItem( "weapon_lance_mouton" )))
		GfDeactivateMouton( pVictim );
}

void CHalfLifeMultiplay::GfDeactivateMouton( CBasePlayer *pOwner )
{
	edict_t *pFind; 

	pFind = FIND_ENTITY_BY_CLASSNAME( NULL, "monster_mouton" );

	while( !FNullEnt( pFind ))
	{
		CBaseEntity *pEnt = CBaseEntity::Instance( pFind );
		GcMoutonCharge *pGvMouton = (GcMoutonCharge *)pEnt;

		if( pGvMouton )
			if ( pGvMouton->pev->owner == pOwner->edict( ))
				pGvMouton->GfDeactivate( );

		pFind = FIND_ENTITY_BY_CLASSNAME( pFind, "monster_mouton" );
	}
}


//=========================================================
// Deathnotice. 
//=========================================================
// Groove - 04102001 - A voir
void CHalfLifeMultiplay::DeathNotice( CBasePlayer *pVictim, entvars_t *pKiller, entvars_t *pevInflictor )
{
	// Work out what killed the player, and send a message to all clients about it
	CBaseEntity *Killer = CBaseEntity::Instance( pKiller );

	const char *killer_weapon_name = "world";		// by default, the player is killed by the world
	int killer_index = 0;
	
	// Hack to fix name change
	char *tau = "tau_cannon";
	char *gluon = "gluon gun";

	if( pKiller->flags & FL_CLIENT )
	{
		killer_index = ENTINDEX( ENT( pKiller ));
		
		if( pevInflictor )
			if( pevInflictor == pKiller )
			{
				// If the inflictor is the killer,  then it must be their current weapon doing the damage
				CBasePlayer *pPlayer = (CBasePlayer*)CBaseEntity::Instance( pKiller );
				
				if( pPlayer->m_pActiveItem )
					killer_weapon_name = pPlayer->m_pActiveItem->ItemInfoArray[pPlayer->m_pActiveItem->m_iId].pszName;
			}
			else
				killer_weapon_name = STRING( pevInflictor->classname );  // it's just that easy
	}
	else
		killer_weapon_name = STRING( pevInflictor->classname );

	// strip the monster_* or weapon_* from the inflictor's classname
	if ( strncmp( killer_weapon_name, "weapon_", 7 ) == 0 )
		killer_weapon_name += 7;
	else if ( strncmp( killer_weapon_name, "monster_", 8 ) == 0 )
		killer_weapon_name += 8;
	else if ( strncmp( killer_weapon_name, "func_", 5 ) == 0 )
		killer_weapon_name += 5;

	if( killer_weapon_name == "worldspawn" )
		killer_weapon_name =  "world     ";     

	MESSAGE_BEGIN( MSG_ALL, gmsgDeathMsg );
		WRITE_BYTE( killer_index );						// the killer
		WRITE_BYTE( ENTINDEX( pVictim->edict( )));		// the victim
		WRITE_STRING( killer_weapon_name );				// what they were killed by (should this be a string?)
	MESSAGE_END( );

/*	if( pVictim->pev == pKiller )
		UTIL_LogPrintf( "\"%s<%i>\" killed self with %s\n", STRING( pVictim->pev->netname ), GETPLAYERUSERID( pVictim->edict( )), killer_weapon_name );
	else if( pKiller->flags & FL_CLIENT )
		UTIL_LogPrintf( "\"%s<%i>\" killed \"%s<%i>\" with %s\n",  STRING( pKiller->netname ),
			GETPLAYERUSERID( ENT( pKiller )),
			STRING( pVictim->pev->netname ),
			GETPLAYERUSERID( pVictim->edict( )),
			killer_weapon_name );
	else
		UTIL_LogPrintf( "\"%s<%i>\" killed by world with %s\n",  STRING( pVictim->pev->netname ), GETPLAYERUSERID( pVictim->edict() ), killer_weapon_name );*/
	
//  Print a standard message
	// TODO: make this go direct to console
	return; // just remove for now

/*	char	szText[ 128 ];

	if ( pKiller->flags & FL_MONSTER )
	{
		// killed by a monster
		strcpy ( szText, STRING( pVictim->pev->netname ) );
		strcat ( szText, " was killed by a monster.\n" );
		return;
	}

	if ( pKiller == pVictim->pev )
	{
		strcpy ( szText, STRING( pVictim->pev->netname ) );
		strcat ( szText, " commited suicide.\n" );
	}
	else if ( pKiller->flags & FL_CLIENT )
	{
		strcpy ( szText, STRING( pKiller->netname ) );

		strcat( szText, " : " );
		strcat( szText, killer_weapon_name );
		strcat( szText, " : " );

		strcat ( szText, STRING( pVictim->pev->netname ) );
		strcat ( szText, "\n" );
	}
	else if ( FClassnameIs ( pKiller, "worldspawn" ) )
	{
		strcpy ( szText, STRING( pVictim->pev->netname ) );
		strcat ( szText, " fell or drowned or something.\n" );
	}
	else if ( pKiller->solid == SOLID_BSP )
	{
		strcpy ( szText, STRING( pVictim->pev->netname ) );
		strcat ( szText, " was mooshed.\n" );
	}
	else
	{
		strcpy ( szText, STRING( pVictim->pev->netname ) );
		strcat ( szText, " died mysteriously.\n" );
	}

	UTIL_ClientPrintAll( HUD_PRINTNOTIFY, szText );*/

}

edict_t *CHalfLifeMultiplay::GetPlayerSpawnSpot( CBasePlayer *pPlayer )
{
	edict_t *pentSpawnSpot = CGameRules::GetPlayerSpawnSpot( pPlayer );	
	if( IsMultiplayer( ) && pentSpawnSpot->v.target )
		FireTargets( STRING(pentSpawnSpot->v.target), pPlayer, pPlayer, USE_TOGGLE, 0 );

	return pentSpawnSpot;
}


//=========================================================
//=========================================================
int CHalfLifeMultiplay::PlayerRelationship( CBaseEntity *pPlayer, CBaseEntity *pTarget )
{
	// half life deathmatch has only enemies
	return GR_NOTTEAMMATE;
}

BOOL CHalfLifeMultiplay :: PlayFootstepSounds( CBasePlayer *pl, float fvol )
{
	if( g_footsteps && g_footsteps->value == 0 )
		return FALSE;

	if( pl->IsOnLadder( ) || pl->pev->velocity.Length2D() > 220 )
		return TRUE;  // only make step sounds in multiplayer if the player is moving fast enough

	return FALSE;
}


//=========================================================
//======== CHalfLifeMultiplay private functions ===========
#define INTERMISSION_TIME		3

void CHalfLifeMultiplay::GoToIntermission( void )
{
	if ( g_fGameOver )
		return;  // intermission has already been triggered, so ignore.

	MESSAGE_BEGIN(MSG_ALL, SVC_INTERMISSION);
	MESSAGE_END();

	fGvChangementDeCarte = gpGlobals->time + INTERMISSION_TIME;
	g_fGameOver = TRUE;
	m_iEndIntermissionButtonHit = FALSE;
}

#define MAX_RULE_BUFFER 1024

typedef struct mapcycle_item_s
{
	struct mapcycle_item_s *next;

	char mapname[ 32 ];
	int  minplayers, maxplayers;
	char rulebuffer[ MAX_RULE_BUFFER ];
} mapcycle_item_t;

typedef struct mapcycle_s
{
	struct mapcycle_item_s *items;
	struct mapcycle_item_s *next_item;
} mapcycle_t;

/*
==============
DestroyMapCycle

Clean up memory used by mapcycle when switching it
==============
*/
void DestroyMapCycle( mapcycle_t *cycle )
{
	mapcycle_item_t *p, *n, *start;
	p = cycle->items;
	if ( p )
	{
		start = p;
		p = p->next;
		while ( p != start )
		{
			n = p->next;
			delete p;
			p = n;
		}
		
		delete cycle->items;
	}
	cycle->items = NULL;
	cycle->next_item = NULL;
}

static char com_token[ 1500 ];

/*
==============
COM_Parse

Parse a token out of a string
==============
*/
char *COM_Parse (char *data)
{
	int             c;
	int             len;
	
	len = 0;
	com_token[0] = 0;
	
	if (!data)
		return NULL;
		
// skip whitespace
skipwhite:
	while ( (c = *data) <= ' ')
	{
		if (c == 0)
			return NULL;                    // end of file;
		data++;
	}
	
// skip // comments
	if (c=='/' && data[1] == '/')
	{
		while (*data && *data != '\n')
			data++;
		goto skipwhite;
	}
	

// handle quoted strings specially
	if (c == '\"')
	{
		data++;
		while (1)
		{
			c = *data++;
			if (c=='\"' || !c)
			{
				com_token[len] = 0;
				return data;
			}
			com_token[len] = c;
			len++;
		}
	}

// parse single characters
	if (c=='{' || c=='}'|| c==')'|| c=='(' || c=='\'' || c == ',' )
	{
		com_token[len] = c;
		len++;
		com_token[len] = 0;
		return data+1;
	}

// parse a regular word
	do
	{
		com_token[len] = c;
		data++;
		len++;
		c = *data;
	if (c=='{' || c=='}'|| c==')'|| c=='(' || c=='\'' || c == ',' )
			break;
	} while (c>32);
	
	com_token[len] = 0;
	return data;
}

/*
==============
COM_TokenWaiting

Returns 1 if additional data is waiting to be processed on this line
==============
*/
int COM_TokenWaiting( char *buffer )
{
	char *p;

	p = buffer;
	while ( *p && *p!='\n')
	{
		if ( !isspace( *p ) || isalnum( *p ) )
			return 1;

		p++;
	}

	return 0;
}

/*
==============
ReloadMapCycleFile


Parses mapcycle.txt file into mapcycle_t structure
==============
*/
int ReloadMapCycleFile( char *filename, mapcycle_t *cycle )
{
	char szBuffer[ MAX_RULE_BUFFER ];
	char szMap[ 32 ];
	int length;
	char *pFileList;
	char *aFileList = pFileList = (char*)LOAD_FILE_FOR_ME( filename, &length );
	int hasbuffer;
	mapcycle_item_s *item, *newlist = NULL, *next;

	if ( pFileList && length )
	{
		// the first map name in the file becomes the default
		while ( 1 )
		{
			hasbuffer = 0;
			memset( szBuffer, 0, MAX_RULE_BUFFER );

			pFileList = COM_Parse( pFileList );
			if ( strlen( com_token ) <= 0 )
				break;

			strcpy( szMap, com_token );

			// Any more tokens on this line?
			if ( COM_TokenWaiting( pFileList ) )
			{
				pFileList = COM_Parse( pFileList );
				if ( strlen( com_token ) > 0 )
				{
					hasbuffer = 1;
					strcpy( szBuffer, com_token );
				}
			}

			// Check map
			if ( IS_MAP_VALID( szMap ) )
			{
				// Create entry
				char *s;

				item = new mapcycle_item_s;

				strcpy( item->mapname, szMap );

				item->minplayers = 0;
				item->maxplayers = 0;

				memset( item->rulebuffer, 0, MAX_RULE_BUFFER );

				if ( hasbuffer )
				{
					s = g_engfuncs.pfnInfoKeyValue( szBuffer, "minplayers" );
					if ( s && s[0] )
					{
						item->minplayers = atoi( s );
						item->minplayers = max( item->minplayers, 0 );
						item->minplayers = min( item->minplayers, gpGlobals->maxClients );
					}
					s = g_engfuncs.pfnInfoKeyValue( szBuffer, "maxplayers" );
					if ( s && s[0] )
					{
						item->maxplayers = atoi( s );
						item->maxplayers = max( item->maxplayers, 0 );
						item->maxplayers = min( item->maxplayers, gpGlobals->maxClients );
					}

					// Remove keys
					//
					g_engfuncs.pfnInfo_RemoveKey( szBuffer, "minplayers" );
					g_engfuncs.pfnInfo_RemoveKey( szBuffer, "maxplayers" );

					strcpy( item->rulebuffer, szBuffer );
				}

				item->next = cycle->items;
				cycle->items = item;
			}
			else
				ALERT( at_console, "Skipping %s from mapcycle, not a valid map\n", szMap );
		}

		FREE_FILE( aFileList );
	}

	// Fixup circular list pointer
	item = cycle->items;

	// Reverse it to get original order
	while ( item )
	{
		next = item->next;
		item->next = newlist;
		newlist = item;
		item = next;
	}
	cycle->items = newlist;
	item = cycle->items;

	// Didn't parse anything
	if( !item )
		return 0;

	while ( item->next )
		item = item->next;

	item->next = cycle->items;
	
	cycle->next_item = item->next;

	return 1;
}

/*
==============
CountPlayers

Determine the current # of active players on the server for map cycling logic
==============
*/
int CountPlayers( void )
{
	int	num = 0;

	for ( int i = 1; i <= gpGlobals->maxClients; i++ )
	{
		CBaseEntity *pEnt = UTIL_PlayerByIndex( i );

		if( pEnt )
			num = num + 1;
	}

	return num;
}

/*
==============
ExtractCommandString

Parse commands/key value pairs to issue right after map xxx command is issued on server
 level transition
==============
*/
void ExtractCommandString( char *s, char *szCommand )
{
	// Now make rules happen
	char	pkey[512];
	char	value[512];	// use two buffers so compares
								// work without stomping on each other
	char	*o;
	
	if ( *s == '\\' )
		s++;

	while (1)
	{
		o = pkey;
		while ( *s != '\\' )
		{
			if ( !*s )
				return;
			*o++ = *s++;
		}
		*o = 0;
		s++;

		o = value;

		while (*s != '\\' && *s)
		{
			if (!*s)
				return;
			*o++ = *s++;
		}
		*o = 0;

		strcat( szCommand, pkey );
		if ( strlen( value ) > 0 )
		{
			strcat( szCommand, " " );
			strcat( szCommand, value );
		}
		strcat( szCommand, "\n" );

		if (!*s)
			return;
		s++;
	}
}

/*
==============
ChangeLevel

Server is changing to a new level, check mapcycle.txt for map name and setup info
==============
*/
void CHalfLifeMultiplay :: ChangeLevel( void )
{
	static char szPreviousMapCycleFile[ 256 ];
	static mapcycle_t mapcycle;

	char szNextMap[32];
	char szFirstMapInList[32];
	char szCommands[ 1500 ];
	char szRules[ 1500 ];
	int minplayers = 0, maxplayers = 0;
	strcpy( szFirstMapInList, "hldm1" );  // the absolute default level is hldm1

	int	curplayers;
	BOOL do_cycle = TRUE;

	// Groove - ini temps
	iGvTempsTPT = 0;
	fGvTempsTPT = 0;

	// find the map to change to
	char *mapcfile = (char*)CVAR_GET_STRING( "mapcyclefile" );
	ASSERT( mapcfile != NULL );

	szCommands[ 0 ] = '\0';
	szRules[ 0 ] = '\0';

	curplayers = CountPlayers();

	// Has the map cycle filename changed?
	if ( stricmp( mapcfile, szPreviousMapCycleFile ) )
	{
		strcpy( szPreviousMapCycleFile, mapcfile );

		DestroyMapCycle( &mapcycle );

		if ( !ReloadMapCycleFile( mapcfile, &mapcycle ) || ( !mapcycle.items ) )
		{
			ALERT( at_console, "Unable to load map cycle file %s\n", mapcfile );
			do_cycle = FALSE;
		}
	}

	if ( do_cycle && mapcycle.items )
	{
		BOOL keeplooking = FALSE;
		BOOL found = FALSE;
		mapcycle_item_s *item;

		// Assume current map
		strcpy( szNextMap, STRING(gpGlobals->mapname) );
		strcpy( szFirstMapInList, STRING(gpGlobals->mapname) );

		// Traverse list
		for ( item = mapcycle.next_item; item->next != mapcycle.next_item; item = item->next )
		{
			keeplooking = FALSE;

			ASSERT( item != NULL );

			if ( item->minplayers != 0 )
			{
				if ( curplayers >= item->minplayers )
				{
					found = TRUE;
					minplayers = item->minplayers;
				}
				else
					keeplooking = TRUE;
			}

			if ( item->maxplayers != 0 )
			{
				if ( curplayers <= item->maxplayers )
				{
					found = TRUE;
					maxplayers = item->maxplayers;
				}
				else
					keeplooking = TRUE;
			}

			if ( keeplooking )
				continue;

			found = TRUE;
			break;
		}

		if( !found )
			item = mapcycle.next_item;
		
		// Increment next item pointer
		mapcycle.next_item = item->next;

		// Perform logic on current item
		strcpy( szNextMap, item->mapname );

		ExtractCommandString( item->rulebuffer, szCommands );
		strcpy( szRules, item->rulebuffer );
	}

	if( !IS_MAP_VALID(szNextMap) )
		strcpy( szNextMap, szFirstMapInList );

	g_fGameOver = TRUE;

	ALERT( at_console, "CHANGE LEVEL: %s\n", szNextMap );
	if( minplayers || maxplayers )
		ALERT( at_console, "PLAYER COUNT:  min %i max %i current %i\n", minplayers, maxplayers, curplayers );

	if( strlen( szRules ) > 0 )
		ALERT( at_console, "RULES:  %s\n", szRules );
	
	CHANGE_LEVEL( szNextMap, NULL );
	
	if( strlen( szCommands ) > 0 )
		SERVER_COMMAND( szCommands );
}

#define MAX_MOTD_CHUNK	  60
#define MAX_MOTD_LENGTH   (MAX_MOTD_CHUNK * 4)

void CHalfLifeMultiplay :: SendMOTDToClient( edict_t *client )
{
	// read from the MOTD.txt file
	int length, char_count = 0,compteur = 0;
	char *pFileList;
	char *aFileList = pFileList = (char*)LOAD_FILE_FOR_ME( "motd.txt", &length );

	// Send the message of the day
	// read it chunk-by-chunk,  and send it in parts

	while ( pFileList && *pFileList && char_count < MAX_MOTD_LENGTH )
	{
		compteur++;
		char chunk[MAX_MOTD_CHUNK+1];
		
		if( strlen( pFileList ) < MAX_MOTD_CHUNK )
			strcpy( chunk, pFileList );
		else
		{
			strncpy( chunk, pFileList, MAX_MOTD_CHUNK );
			chunk[MAX_MOTD_CHUNK] = 0;		// strncpy doesn't always append the null terminator
		}

		char_count += strlen( chunk );
		if( char_count < MAX_MOTD_LENGTH )
			pFileList = aFileList + char_count; 
		else
			*pFileList = 0;

		MESSAGE_BEGIN( MSG_ONE, gmsgMOTD, NULL, client );
			WRITE_BYTE( *pFileList ? FALSE : TRUE );	// FALSE means there is still more message to come
			WRITE_STRING( chunk );
		MESSAGE_END( );
	}
	if( !compteur )
	{
		MESSAGE_BEGIN( MSG_ONE, gmsgMOTD, NULL, client );
			WRITE_BYTE( TRUE );	// FALSE means there is still more message to come
			WRITE_STRING("#no motd");
		MESSAGE_END();
	}

	FREE_FILE( aFileList );
}