/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	TPT							*
*		24042002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "client.h"
#include "cbase.h"
#include "player.h"
#include "gamerules.h"
#include "fx_explode.h"
#include "map_triggers.h"
#include "shake.h"
#include "game.h"

void CGameRules::GfTempsTPT( CBasePlayer *pPlayer )
{ 
	if( GvMortSubite )
		GfWaterUpdate( );

    if( !fGvTempsTPT || fGvTempsTPT <= gpGlobals->time )
	{
		GfFinDeTourAutoTPT( pPlayer );
		
		MESSAGE_BEGIN( MSG_ALL, gmsgTime );
			WRITE_BYTE( iGvTempsTPT );
		MESSAGE_END( );

		fGvTempsTPT++;
		iGvTempsTPT--;

		if( GvWormsRougeTPT )
		{
			for( int iGvIndex = 0; iGvIndex <= gpGlobals->maxClients; iGvIndex++ )
			{	
				CBasePlayer *pGvPlayerX = (CBasePlayer*) UTIL_PlayerByIndex( iGvIndex );
				if( pGvPlayerX && ( FStrEq( pGvPlayerX->m_szTeamName,"Wormsblue" )))
				{
					pGvPlayerX->GvPlayerTPT.bMove = false;
					pGvPlayerX->GvPlayerTPT.bTire = false;
					pGvPlayerX->pev->maxspeed = 1;
				}
			}
		}
		else
		{
			for( int iGvIndex = 0; iGvIndex <= gpGlobals->maxClients; iGvIndex++ )
			{	
				CBasePlayer *pGvPlayerX = (CBasePlayer*) UTIL_PlayerByIndex( iGvIndex );
				if( pGvPlayerX && ( FStrEq( pGvPlayerX->m_szTeamName,"Wormsred" )))
				{
					pGvPlayerX->GvPlayerTPT.bMove = false;
					pGvPlayerX->GvPlayerTPT.bTire = false;
					pGvPlayerX->pev->maxspeed = 1;
				}
			}		
		}

		if(( iGvTempsTPT == 5 ) && pPlayer->GvPlayerTPT.bTire )
			EMIT_SOUND( ENT( pPlayer->pev ), CHAN_VOICE, Gf_SOUND_JEU_VITE_01, 0.7, ATTN_STATIC);
		if(( iGvTempsTPT < 3 ) &&  pPlayer->GvPlayerTPT.bTire )
			EMIT_SOUND( ENT( pPlayer->pev ), CHAN_ITEM, Gf_SOUND_JEU_BELL_01, 0.7, ATTN_STATIC );
	}

    if( iGvTempsTPT < 0 )
	{
		iGvTempsTPT = 0;

		for( int iGvIndex = 0; iGvIndex <= gpGlobals->maxClients; iGvIndex++ )
		{	
			CBasePlayer *pGvPlayerX = (CBasePlayer*) UTIL_PlayerByIndex( iGvIndex );
			if( pGvPlayerX )
			{
				pGvPlayerX->GvPlayerTPT.bMove = false;
				pGvPlayerX->GvPlayerTPT.bTire = false;
				pGvPlayerX->pev->maxspeed = 1;
			}
		}

		if( !fGvTempsChangeTourTPT )
			fGvTempsChangeTourTPT = gpGlobals->time + Gm_TPT_TEMPS_FIN_TOUR;
	}

	if( fGvTempsChangeTourTPT && fGvTempsChangeTourTPT < gpGlobals->time )
	{
		bool bGvAmmoActive = false;
		bool bGvPlayerDeath = false;

		for( int iGvIndex = 0; iGvIndex <= gpGlobals->maxClients; iGvIndex++ )
		{	
			CBasePlayer *pGvPlayerX = (CBasePlayer*) UTIL_PlayerByIndex( iGvIndex );
			if( pGvPlayerX )
			{
				if( pGvPlayerX->GvPlayerTPT.bAmmo )
					bGvAmmoActive = true;
				if( !pGvPlayerX->IsAlive( ))
					bGvPlayerDeath = true;
			}
		}

		if( bGvAmmoActive || bGvPlayerDeath )
		{
			fGvTempsChangeTourTPT = gpGlobals->time + Gm_TPT_TEMPS_FIN_TOUR;
			return;
		}

		fGvTempsChangeTourTPT = 0;

		if( GvWormsBleuTPT )
			GfWormsRougesTPT( pPlayer );
		else
			GfWormsBleuxTPT( pPlayer );
	}

	if( FStrEq( pPlayer->m_szTeamName,"Wormsblue" ))
		pPlayer->pev->iuser4 = Gm_WORM_BLEU;
	else
		pPlayer->pev->iuser4 = Gm_WORM_ROUGE;

	// EurOPiUM - 03032002 - pyramide
	if( pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_INVISIBLE )
		pPlayer->pev->fuser1 = 255;
	else
		pPlayer->pev->fuser1 = pPlayer->pev->health;		

	pPlayer->pev->iuser3 = pPlayer->GvPlayerTPT.bMove;
}

short CGameRules::GfCompteWormsTPT( void )
{
	CBasePlayer *pPlayer = NULL;
	short GvNbJoueursPeutBouger = 0;

	// Recherche de TOUS les joueurs
	while((( pPlayer = ( CBasePlayer * ) UTIL_FindEntityByClassname ( pPlayer, "player" )) != NULL ) && ( !FNullEnt ( pPlayer->edict( ))))
		if( pPlayer->IsPlayer( ) && pPlayer->GvPlayerTPT.bMove ) 
			GvNbJoueursPeutBouger++;

	UTIL_Remove( pPlayer );

	if( GvNbJoueurTPT != GvNbJoueursPeutBouger )
	{
		MESSAGE_BEGIN( MSG_ALL, gmsgReste );
			WRITE_BYTE( GvNbJoueursPeutBouger );
		MESSAGE_END( );

		GvNbJoueurTPT = GvNbJoueursPeutBouger;
	}

	return GvNbJoueursPeutBouger;
}

void CGameRules::GfFinDeTourAutoTPT( CBasePlayer *pPlayer )
{
	bool bGvAmmoActive = false;
	bool bGvPlayerDeath = false;
	
	if( GfCompteWormsTPT( ) || iGvTempsTPT > 20 )
		return;
	else
	{
		for( int iGvIndex = 0; iGvIndex <= gpGlobals->maxClients; iGvIndex++ )
		{	
			CBasePlayer *pGvPlayerX = (CBasePlayer*) UTIL_PlayerByIndex( iGvIndex );
			if( pGvPlayerX )
			{
				if( pGvPlayerX->GvPlayerTPT.bAmmo )
					bGvAmmoActive = true;
				if( !pGvPlayerX->IsAlive( ))
					bGvPlayerDeath = true;
				pGvPlayerX->GvPlayerTPT.bMove = false;
				pGvPlayerX->GvPlayerTPT.bTire = false;
				pGvPlayerX->pev->maxspeed = 1;
			}
		}
	}

	if( bGvAmmoActive || bGvPlayerDeath )
	{
		iGvTempsTPT = 0;
		return;
	}

	EMIT_SOUND( ENT( pPlayer->pev ), CHAN_ITEM, Gf_SOUND_JEU_GONG_01, 1.0, ATTN_STATIC );
	
	fGvTempsChangeTourTPT = 0;

	if( GvWormsRougeTPT )
		GfWormsBleuxTPT( pPlayer );
	else
		GfWormsRougesTPT( pPlayer );
}

// Groove - 25102001 - Worms blaiss ...
void CGameRules::GfMaladieGestion( CBasePlayer *pPlayer )
{
	if(( pPlayer->pev->health <= ( GvWormVieCMD.value / 4 )))
	{
		switch( RANDOM_LONG( 1,2 )) 
		{
		case 1: 
			EMIT_SOUND( ENT( pPlayer->pev ), CHAN_VOICE, Gf_SOUND_DOMMAGE_EXPLOSE_01, 1, ATTN_NORM );
			break;
		case 2: 
			EMIT_SOUND( ENT( pPlayer->pev ), CHAN_VOICE, Gf_SOUND_DOMMAGE_EXPLOSE_02, 1, ATTN_NORM );
			break;
		}

		if( !pPlayer->pev->health )
			return;
		else if( pPlayer->pev->health == 1 )
			pPlayer->GfSentirDommange( Gm_SENTIR_DOMMAGE_MALADIE, 255 );
		else
			pPlayer->GfSentirDommange( Gm_SENTIR_DOMMAGE_MALADIE, 255 - pPlayer->pev->health );

		// Le Worm perd 5 pts de vie mais ne meurt jamais.
		if( pPlayer->pev->health > 5 )
			pPlayer->pev->health -= 5;
		else
			pPlayer->pev->health = 1;
	}
}

void CGameRules::GfWormsRougesTPT( CBasePlayer *pGvPlayer )
{
	iGvTempsTPT = GvTempsTourCMD.value;
	GvWormsRougeTPT = true;
	GvWormsBleuTPT = false;

	GfCompteWormsTPT( );
	GfVentUpdate( );

	if( GvMortSubite )
	{
		iGvWaterUp = GvWaterCMD.value;
		fGvTempsWaterUp = gpGlobals->time + 0.5;
		GfWaterUpdate( );
	}

	for( int iGvIndex = 0; iGvIndex <= gpGlobals->maxClients; iGvIndex++ )
	{	
		CBasePlayer *pGvPlayerX = (CBasePlayer*) UTIL_PlayerByIndex( iGvIndex );
		if( pGvPlayerX && ( FStrEq( pGvPlayerX->m_szTeamName,"Wormsred" )))
		{
			pGvPlayerX->GvPlayerTPT.bMove = true;
			pGvPlayerX->GvPlayerTPT.bTire = true;
			pGvPlayerX->GvPlayerTPT.bAmmo = false;
			pGvPlayerX->pev->maxspeed = Gm_WORM_VITESSE;
		}
		else if( pGvPlayerX && ( FStrEq( pGvPlayerX->m_szTeamName,"Wormsblue" )))
		{
			pGvPlayerX->GvPlayerTPT.bMove = false;
			pGvPlayerX->GvPlayerTPT.bTire = false;
			pGvPlayerX->GvPlayerTPT.bAmmo = false;
			pGvPlayerX->pev->maxspeed = 1;
		}
	}

	GfMortSubiteControle( pGvPlayer );
	GfIniTPT( );
	GfMaladieGestion( pGvPlayer );

	if( bGfCaisseCanSpawn( ) && ( RANDOM_LONG( 1, GvBoxCMD.value ) == 1 ))
			GfCaisseGestion( );
}

void CGameRules::GfWormsBleuxTPT( CBasePlayer *pGvPlayer )
{ 
	iGvTempsTPT = GvTempsTourCMD.value;
	GvWormsBleuTPT = true;	
	GvWormsRougeTPT = false;	

	GfCompteWormsTPT( );
	GfVentUpdate( );

	if( GvMortSubite )
	{
		iGvWaterUp = GvWaterCMD.value;
		fGvTempsWaterUp = gpGlobals->time + 0.5;
		GfWaterUpdate( );
	}

	for( int iGvIndex = 0; iGvIndex <= gpGlobals->maxClients; iGvIndex++ )
	{
		CBasePlayer *pGvPlayerX = (CBasePlayer*) UTIL_PlayerByIndex( iGvIndex );
		if( pGvPlayerX &&( FStrEq( pGvPlayerX->m_szTeamName,"Wormsblue" )))
		{
			pGvPlayerX->GvPlayerTPT.bMove = true;
			pGvPlayerX->GvPlayerTPT.bTire = true;
			pGvPlayerX->GvPlayerTPT.bAmmo = false;
			pGvPlayerX->pev->maxspeed = Gm_WORM_VITESSE;
		}
		else if( pGvPlayerX &&( FStrEq( pGvPlayerX->m_szTeamName,"Wormsred" )))
		{
			pGvPlayerX->GvPlayerTPT.bMove = false;
			pGvPlayerX->GvPlayerTPT.bTire = false;
			pGvPlayerX->GvPlayerTPT.bAmmo = false;
			pGvPlayerX->pev->maxspeed = 1;
		}
	}

	GfMortSubiteControle( pGvPlayer );
	GfIniTPT( );
	GfMaladieGestion( pGvPlayer );

	if( bGfCaisseCanSpawn( ) && ( RANDOM_LONG( 1, GvBoxCMD.value ) == 1 ))
			GfCaisseGestion( );
}

void CGameRules::GfIniTPT( void )
{        
	for( int iGvIndex = 0; iGvIndex <= gpGlobals->maxClients; iGvIndex++ )
	{
		CBasePlayer *pGvPlayerX = (CBasePlayer*) UTIL_PlayerByIndex( iGvIndex );
		if( pGvPlayerX )
		{
			if( !pGvPlayerX->GvPlayerTPT.bMove )
			{
				// Groove - 14032002 - Ini gravite du joueur
		//		if(( pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_GRAVITE )
		//			||( pPlayer->iGvPlayerOutil & Gm_PLAYER_OUTIL_GRAVITE_S ))
					pGvPlayerX->pev->gravity = Gm_WORM_GRAVITE;

				// Groove - 14032002 - Ini invisibilit
				if( pGvPlayerX->iGvInvisible )
					pGvPlayerX->iGvInvisible++;
				
				if(( pGvPlayerX->iGvPlayerOutil & Gm_PLAYER_OUTIL_INVISIBLE ) && pGvPlayerX->iGvInvisible > 3 )
				{
					pGvPlayerX->iGvInvisible = 0;
					pGvPlayerX->pev->rendermode = kRenderNormal;
					pGvPlayerX->pev->renderamt = 255;
					pGvPlayerX->pev->renderfx = kRenderFxNone;
				}

				// Groove - 01052002 - Ini des effect sur le joueur
				if(( pGvPlayerX->iGvPlayerOutil & Gm_PLAYER_OUTIL_POWER ) && !( pGvPlayerX->iGvPlayerOutil & Gm_PLAYER_OUTIL_INVISIBLE ))
				{
					pGvPlayerX->pev->rendermode = kRenderNormal;
					pGvPlayerX->pev->renderamt = 255;
					pGvPlayerX->pev->renderfx = kRenderFxNone;
					pGvPlayerX->pev->rendercolor.x = 0;
					pGvPlayerX->pev->rendercolor.y = 0;
					pGvPlayerX->pev->rendercolor.z = 0;
				}

				// Groove - 23042002 - Annule les outils
				pGvPlayerX->iGvPlayerOutil = 0;
			}
			/*else
			{
				// Rinicialise les bonus fournis par les caisses d'outils
				if(!( pGvPlayerX->iGvPlayerOutil & Gm_PLAYER_OUTIL_VITESSE ) && !( pGvPlayerX->iGvPlayerOutil & Gm_PLAYER_OUTIL_VITESSE_S ))
					pGvPlayerX->pev->maxspeed = Gm_WORM_VITESSE;
			}*/

//			pGvPlayerX->GvPlayerTPT.bMove = false;
//			pGvPlayerX->pev->maxspeed = 1;
		}
	}
}

void CGameRules::GfCaisseGestion( void )
{
	pGvCaisse = NULL;

	// Groove - 12022002 - Comptage des caisses.
	int GvCompteCaisseArme = 0;
	int GvCompteCaisseOutil = 0;
	int GvCompteCaisseVie = 0;
	int GvCompteCaisseMega = 0;

	while( pGvCaisse = UTIL_FindEntityByClassname( pGvCaisse, "item_caisse_arme" ))
		GvCompteCaisseArme++;
	while( pGvCaisse = UTIL_FindEntityByClassname( pGvCaisse, "item_caisse_outil" ))
		GvCompteCaisseOutil++;
	while( pGvCaisse = UTIL_FindEntityByClassname( pGvCaisse, "item_caisse_vie" ))
		GvCompteCaisseVie++;
	while( pGvCaisse = UTIL_FindEntityByClassname( pGvCaisse, "item_caisse_mega" ))
		GvCompteCaisseMega++;

	if( GvCompteCaisseMega + GvCompteCaisseVie + GvCompteCaisseOutil + GvCompteCaisseArme > 16 )
	{
		ALERT( at_console, "Max de caisses sur la carte atteind !" );
		return;
	}

	pGvCaisse = NULL;

	double GvCompteZoneCaisse016 = 0;
	double GvCompteZoneCaisse032 = 0;
	double GvCompteZoneCaisse064 = 0;
	double GvCompteZoneCaisse128 = 0;
	double GvCompteZoneCaisse256 = 0;

	while((( pGvCaisse = UTIL_FindEntityByClassname ( pGvCaisse, "info_caisse_16" )) != NULL ))
		GvCompteZoneCaisse016++;

	while((( pGvCaisse = UTIL_FindEntityByClassname ( pGvCaisse, "info_caisse_32" )) != NULL ))
		GvCompteZoneCaisse032++;

	while((( pGvCaisse = UTIL_FindEntityByClassname ( pGvCaisse, "info_caisse_64" )) != NULL ))
		GvCompteZoneCaisse064++;

	while((( pGvCaisse = UTIL_FindEntityByClassname ( pGvCaisse, "info_caisse_128" )) != NULL ))
		GvCompteZoneCaisse128++;

	while((( pGvCaisse = UTIL_FindEntityByClassname ( pGvCaisse, "info_caisse_256" )) != NULL ))
		GvCompteZoneCaisse256++;

	double GvNbUnitCaisses = (( GvCompteZoneCaisse256 * 16 )
							+ ( GvCompteZoneCaisse128 * 8  )
							+ ( GvCompteZoneCaisse064 * 4  )
							+ ( GvCompteZoneCaisse032 * 2  )
							+ ( GvCompteZoneCaisse016 * 1  ));

	Vector GvPosition_c;
	
	if( GvNbUnitCaisses == 0 )
	{
		#ifdef Gm_BETA_TEST
			ALERT( at_console, "Pas de zones de spawns des caisses.\n" );
		#endif
		return;
	}
	else
	{
		float GvCaisseProba[5][2];

		GvCaisseProba[0][0] = (((float)GvCompteZoneCaisse016 * 1  ) / GvNbUnitCaisses );
		GvCaisseProba[1][0] = (((float)GvCompteZoneCaisse032 * 2  ) / GvNbUnitCaisses );
		GvCaisseProba[2][0] = (((float)GvCompteZoneCaisse064 * 4  ) / GvNbUnitCaisses );
		GvCaisseProba[3][0] = (((float)GvCompteZoneCaisse128 * 8  ) / GvNbUnitCaisses );
		GvCaisseProba[4][0] = (((float)GvCompteZoneCaisse256 * 16 ) / GvNbUnitCaisses );

		ALERT( at_console, "Proba : %f : 256 : %f 128 : %f 64 : %f 32 : %f 16 : %f\n", 
							GvNbUnitCaisses,
							GvCaisseProba[0][0],
							GvCaisseProba[1][0],
							GvCaisseProba[2][0],
							GvCaisseProba[3][0],
							GvCaisseProba[4][0] );

		for( short I = 0; I <= 4; I++ )
			GvCaisseProba[I][1] = 0;

		for( short J = 0; J <= 4; J++ )
			for( short K = 0; K <= J; K++ )
				GvCaisseProba[J][1] += GvCaisseProba[K][0];

		float GvChoixZoneCaisse = RANDOM_FLOAT( 0, 1 );

		// Groove - 22052002 - Slection d'une zone pour le spawn
		if(( GvChoixZoneCaisse <= GvCaisseProba[0][1] ) && ( GvCaisseProba[0][0] > 0 ))
		{
			for ( int i = RANDOM_LONG( 1,GvCompteZoneCaisse016 ); i > 0; i-- )
				pGvCaisse = UTIL_FindEntityByClassname( pGvCaisse, "info_caisse_16" );

			GvPosition_c = pGvCaisse->pev->origin;
		}
		else if(( GvChoixZoneCaisse <= GvCaisseProba[1][1] ) && ( GvCaisseProba[1][0] > 0 ))
		{
			for ( int i = RANDOM_LONG( 1,GvCompteZoneCaisse032 ); i > 0; i-- )
				pGvCaisse = UTIL_FindEntityByClassname( pGvCaisse, "info_caisse_32" );

			GvPosition_c = pGvCaisse->pev->origin;
		}
		else if(( GvChoixZoneCaisse <= GvCaisseProba[2][1] ) && ( GvCaisseProba[2][0] > 0 ))
		{
			for ( int i = RANDOM_LONG( 1,GvCompteZoneCaisse064 ); i > 0; i-- )
				pGvCaisse = UTIL_FindEntityByClassname( pGvCaisse, "info_caisse_64" );

			GvPosition_c = pGvCaisse->pev->origin + Vector( RANDOM_LONG( -32,32 ), RANDOM_LONG( -32,32 ), 0 );;
		}
		else if(( GvChoixZoneCaisse <= GvCaisseProba[3][1] ) && ( GvCaisseProba[3][0] > 0 ))
		{
			for ( int i = RANDOM_LONG( 1,GvCompteZoneCaisse128 ); i > 0; i-- )
				pGvCaisse = UTIL_FindEntityByClassname( pGvCaisse, "info_caisse_128" );

			GvPosition_c = pGvCaisse->pev->origin + Vector( RANDOM_LONG( -96,96 ), RANDOM_LONG( -96,96 ), 0 );
		}
		else if(( GvChoixZoneCaisse <= GvCaisseProba[4][1] ) && ( GvCaisseProba[4][0] > 0 ))
		{
			for ( int i = RANDOM_LONG( 2,GvCompteZoneCaisse256 ); i > 0; i-- )
				pGvCaisse = UTIL_FindEntityByClassname( pGvCaisse, "info_caisse_256" );

			GvPosition_c = pGvCaisse->pev->origin + Vector( RANDOM_LONG( -224,224 ), RANDOM_LONG( -224,224 ), 0 );;
		}
		
		// Groove - 22052002 - Choix du type de caisse a spawner
		switch( RANDOM_LONG( 0, 36 ))
		{
		case  0: case  1: case  2: case  3: 
		case  4: case  5: case  6: case  7: 
		case  8: case  9: case 10: case 11:
		case 12: case 13: case 14: case 15:
			pGvCaisse = CBaseEntity::Create( "item_caisse_arme", GvPosition_c, Vector( 0,0,0 ), pGvCaisse->edict( ));
			break;
		case 16: case 17: case 18: case 19: 
		case 20: case 21: case 22: case 23:
		case 24: case 25: case 26: case 27: 
			pGvCaisse = CBaseEntity::Create( "item_caisse_outil", GvPosition_c, Vector( 0,0,0 ), pGvCaisse->edict( ));
			break;
		case 28: case 29: case 30: case 31: 
		case 32: case 33: case 34: case 35:
			pGvCaisse = CBaseEntity::Create( "item_caisse_vie", GvPosition_c, Vector( 0,0,0 ), pGvCaisse->edict( ));
			break;
		case 36:
			pGvCaisse = CBaseEntity::Create( "item_caisse_mega", GvPosition_c, Vector( 0,0,0 ), pGvCaisse->edict( ));
			break;
		}

		pGvCaisse->pev->velocity.z = -1;
		EMIT_SOUND( ENT( pGvCaisse->pev ), CHAN_ITEM, Gf_SOUND_JEU_CAISSE_SPAWN_01, 0.75, ATTN_STATIC );
	}
}

void CGameRules::GfWaterUpdate( void )
{
	if( fGvTempsWaterUp &&( fGvTempsWaterUp < gpGlobals->time ))
	{
		iGvWaterUp--;
		if( iGvWaterUp )
			fGvTempsWaterUp = gpGlobals->time + 0.1;
		else
			fGvTempsWaterUp = 0;

		while((( pGvWater = UTIL_FindEntityByClassname ( pGvWater, "func_water_up" )) != NULL ))
			UTIL_SetOrigin( pGvWater->pev, ( pGvWater->pev->origin + Vector( 0, 0, 1 )));
	}
}

void CGameRules::GfVentUpdate( void )
{
	GvVent = Vector( RANDOM_FLOAT( -GvWormVentCMD.value, GvWormVentCMD.value ), RANDOM_LONG( -GvWormVentCMD.value, GvWormVentCMD.value ), RANDOM_LONG( -2.0*GvWormVentCMD.value, 0.0 ));
}

void CGameRules::GfMortSubiteControle( CBasePlayer *pGvPlayer ) 
{
	// Groove - 14032002 - Quand il reste que 3 mins a joueur passage en mode "mort subite"
	if( GvTimeLeftCMD.value && GvTimeLeftCMD.value < GvMortSubiteCMD.value )///*180*/ && !GvMortSubite )//( GvMortSubiteCMD.value * 60 ))&& !GvMortSubite )
	{
		GvMortSubite = true;
		MESSAGE_BEGIN( MSG_ALL, gmsgBarreMsg );
			WRITE_BYTE( Gm_MSG_CAISSE_MEGA_MORT_SUBITE );
		MESSAGE_END( );

		UTIL_ScreenFade( pGvPlayer, Vector( 255, 0, 0 ), 1, 0.5, 64, FFADE_OUT | FFADE_STAYOUT );
/*		EMIT_SOUND( ENT( pGvPlayer->pev ), CHAN_ITEM, Gf_SOUND_JEU_GONG_01, 0.5, ATTN_STATIC );

		pGvPlayer->GfSentirDommange( 20, 255 );
		pGvPlayer->pev->health = 1;*/
	}
}