/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	generic_balle.cpp			*
*		17032002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "fx_sprite.h"
#include "fx_explode.h"
#include "fx_decals.h"
#include "shake.h"
#include "generic_arme.h"
#include "arme_kameha.h"
#include "player.h"
#include "game.h"
#include "gamerules.h"
#include "generic_balle.h"
#include "define_slot.h"

LINK_ENTITY_TO_CLASS( balle, GcGenericBalle );

GcGenericBalle *GcGenericBalle::GfCreateBalle( Vector GvOrigin_c,
											   Vector GvAngles_c, 
											   int GvPrecision_i, 
											   int GvVitesse_i, 
											   int GvDommage_i,
											   float GvTempsVie_f,
											   short GvTraineCouleur_i[][6],
											   short GvTraineNb_i,
											   int GvOption_i, 
											   CBasePlayer *pGvPlayer,
											   CBasePlayerWeapon *pLauncher, 
											   short GvArmeID_i )
{
	GcGenericBalle *pBalle = GetClassPtr(( GcGenericBalle * ) NULL );

	UTIL_SetOrigin( pBalle->pev, GvOrigin_c );
	pBalle->pev->angles = GvAngles_c;
	pBalle->GvPrecision_i = GvPrecision_i;
	pBalle->GvVitesse_i = GvVitesse_i;
	pBalle->GvDommage_i = GvDommage_i;
	pBalle->GvTempsVie_f = GvTempsVie_f;
	for( short I = 0; I < 3; I++ )
		for( short J = 0; J < 6; J++ )
			pBalle->GvTraineCouleur_18i[I][J] = GvTraineCouleur_i[I][J];
	pBalle->GvTraineNb_i = GvTraineNb_i;
	pBalle->GvOption_i = GvOption_i;
	pBalle->GvArmeID_i = GvArmeID_i;
	pBalle->Spawn( );
	pBalle->m_pLauncher = pLauncher;
	if( pBalle->m_pLauncher )
		pBalle->m_pLauncher->GvRocketActive_i++;
	
	pBalle->pGvPlayer = pGvPlayer;
	if( pBalle->pGvPlayer )
		pBalle->pev->owner = ENT( pGvPlayer->pev );

	return pBalle;
}

void GcGenericBalle::Spawn( void )
{
	Precache( );

	pev->movetype = MOVETYPE_FLY;
	pev->solid = SOLID_BBOX;

	UTIL_SetOrigin( pev, pev->origin );

	GfClassName( );

	SetThink( GfThink );
	SetTouch( GfTouch );

	if( GvOption_i & Gm_BALLE_CHUTE )
	{
		GvTempsChute_f = gpGlobals->time;
		GvDeg_f = 0;
	}
	
	if(( GvOption_i & Gm_BALLE_BRIANTE )&& GvQDLightCMD_i )
		pev->effects = EF_BRIGHTLIGHT + EF_DIMLIGHT;

	if( GvOption_i & Gm_BALLE_SON )
		GfSonOn( );

	if( GvQTrailCMD_i )
		GfTraine( );

	if( GvOption_i & Gm_BALLE_ACCELERATION )
	{
		GvCompteurMax_i = 0;
		GvTempsAcc_f = gpGlobals->time + 0.25;
		pev->velocity = gpGlobals->v_forward/* * 32*/;
	}
	else if( GvVitesse_i )
	{
		pev->velocity = gpGlobals->v_forward * GvVitesse_i 
					  + gpGlobals->v_right * RANDOM_LONG( -GvPrecision_i, GvPrecision_i )
					  + gpGlobals->v_up * RANDOM_LONG( 0, 2 * GvPrecision_i );
	}
	
	if( GvOption_i & Gm_BALLE_AUTO_DESTRUCTION )
		GvTempsDestruction_f = gpGlobals->time + GvTempsVie_f;
	else
		GvTempsDestruction_f = 0;

	pev->gravity = 0.5;
	pev->dmg = GvDommage_i;
	pev->nextthink = gpGlobals->time + 0.01;
}

void GcGenericBalle :: Precache( void )
{
	PRECACHE_MODEL( Gm_MINICANON_FICHIER_MODEL_R );
	PRECACHE_MODEL( Gm_MORVE_FICHIER_MODEL_R );
	PRECACHE_MODEL( Gm_SNIPE_FICHIER_MODEL_R );
	PRECACHE_MODEL( Gm_FUSIL_FICHIER_MODEL_R );
	GvMorveSPR_i = PRECACHE_MODEL( "sprites/tinyspit.spr" );
	GvFilSPR_i = PRECACHE_MODEL( "sprites/xbeam1.spr" );
	GvFumeeSPR_i = PRECACHE_MODEL( "sprites/smoke.spr" );
}

void GcGenericBalle::GfClassName( void )
{
	switch( GvArmeID_i )
	{
/*	case Gm_CAMERA_ID:
		pev->classname = MAKE_STRING( "camera" );
		SET_MODEL( ENT( pev ), Gm_CAMERA_FICHIER_MODEL_R );
		UTIL_SetSize( pev, Vector( -2,-2,-2 ), Vector( 2,2,2 ));
		GvTraineSPR_i = GvFumeeSPR_i;
		break;*/
	case Gm_GRAPPIN_ID:
		pev->classname = MAKE_STRING( "grappin" );
		SET_MODEL( ENT( pev ), Gm_GRAPPIN_FICHIER_MODEL_R );
		UTIL_SetSize( pev, Vector( -2,-2,-2 ), Vector( 2,2,2 ));
		GvTraineSPR_i = GvFilSPR_i;
		break;
	case Gm_FUSIL_ID:
		pev->classname = MAKE_STRING( "fusil" );
		SET_MODEL( ENT( pev ), Gm_FUSIL_FICHIER_MODEL_R );
		UTIL_SetSize( pev, Vector( -2,-2,-2 ), Vector( 2,2,2 ));
		GvTraineSPR_i = GvFumeeSPR_i;
		break;
	case Gm_KAMEHA_ID:
		pev->classname = MAKE_STRING( "kameha" );
		SET_MODEL( ENT( pev ), Gm_KAMEHA_FICHIER_SPRITE_R );
		pev->scale = 0.5;
		pev->rendermode = kRenderGlow;
		pev->rendercolor.x = 255;
		pev->rendercolor.y = 255;
		pev->rendercolor.z = 255;
		pev->renderamt = 255;
		pev->renderfx = kRenderFxNoDissipation;
		pev->frame = 0.8;
		pev->effects = EF_BRIGHTLIGHT;
		UTIL_SetSize( pev, Vector( -2,-2,-2 ), Vector( 2,2,2 ));
		GvTraineSPR_i = GvFumeeSPR_i;
		break;
	case Gm_MINICANON_ID:
		pev->classname = MAKE_STRING( "minicanon" );
		UTIL_SetSize( pev, Vector( -2,-2,-2 ), Vector( 2,2,2 ));
		SET_MODEL( ENT( pev ), Gm_MINICANON_FICHIER_MODEL_R );
		GvTraineSPR_i = GvFumeeSPR_i;
		break;
	case Gm_SNIPE_ID:
		pev->classname = MAKE_STRING( "snipe" );
		UTIL_SetSize( pev, Vector( -1,-1,-1 ), Vector( 1,1,1 ));
		SET_MODEL( ENT( pev ), Gm_SNIPE_FICHIER_MODEL_R );
		GvTraineSPR_i = GvFumeeSPR_i;
		break;
	case Gm_MORVE_ID:
		pev->classname = MAKE_STRING( "morve" );
		UTIL_SetSize( pev, Vector( -2,-2,-2 ), Vector( 2,2,2 ));
		SET_MODEL( ENT( pev ), Gm_MORVE_FICHIER_MODEL_R );
		GvTraineSPR_i = GvMorveSPR_i;
		break;
	case Gm_BAZOOKA_ID:
		pev->classname = MAKE_STRING( "bazooka" );
		SET_MODEL( ENT( pev ), Gm_BAZOOKA_FICHIER_MODEL_R );
		UTIL_SetSize( pev, Vector( -2,-2,-2 ), Vector( 2,2,2 ));
		GvTraineSPR_i = GvFumeeSPR_i;
		break;
	case Gm_MORTIER_ID:
		pev->classname = MAKE_STRING( "mortier" );
		SET_MODEL( ENT( pev ), Gm_MORTIER_FICHIER_MODEL_R );
		UTIL_SetSize( pev, Vector( -2,-2,-2 ), Vector( 2,2,2 ));
		GvTraineSPR_i = GvFumeeSPR_i;
		break;
	case Gm_SUPER_MOUTON_ID:
		pev->classname = MAKE_STRING( "super mouton" );
		UTIL_SetSize( pev, Vector( -24,-24, 0 ), Vector( 24,24,64 ));
		SET_MODEL( ENT( pev ), Gm_SUPER_MOUTON_FICHIER_MODEL_R );
		GvTraineSPR_i = GvFumeeSPR_i;
		break;
	case Gm_COMETTE_ID:
		pev->classname = MAKE_STRING( "comette" );
		SET_MODEL( ENT( pev ), Gm_KAMEHA_FICHIER_SPRITE_R );
		pev->scale = 0.5;
		pev->rendermode = kRenderGlow;
		pev->rendercolor.x = 255;
		pev->rendercolor.y = 255;
		pev->rendercolor.z = 255;
		pev->renderamt = 255;
		pev->renderfx = kRenderFxNoDissipation;
		pev->frame = 0.8;
		pev->effects = EF_BRIGHTLIGHT;
		pev->velocity.z -= 1;
		pev->gravity = 0.2;
		UTIL_SetSize( pev, Vector( -2,-2,-2 ), Vector( 2,2,2 ));
		GvTraineSPR_i = GvKameaSPR_i;
		break;
	default:
		pev->classname = MAKE_STRING( "balle" );
		UTIL_SetSize( pev, Vector( -0,-0,-0 ), Vector( 0,0,0 ));
		SET_MODEL( ENT( pev ), Gm_MINICANON_FICHIER_MODEL_R );
		GvTraineSPR_i = GvFumeeSPR_i;
		break;
	}
}

void GcGenericBalle::GfThink( void  )
{
	pev->movetype = MOVETYPE_FLY;

	if( GfTouchEau( ))
	{
		if( m_pLauncher )
			if( m_pLauncher->GvRocketActive_i )
				m_pLauncher->GvRocketActive_i--;

		if( GvOption_i & Gm_BALLE_VUE_INTERIEUR )
			SET_VIEW( pGvPlayer->edict( ), pGvPlayer->edict( ));

		if( GvOption_i & Gm_BALLE_SON )
			GfSonOff( );
	
		pGvPlayer->GvPlayerTPT.bAmmo = false;
//		UTIL_Remove( this );
	}

	if( GvOption_i & Gm_BALLE_ROCKET )
		if( GvTireRocket_b )
			GfCreateRocket( );

	if( GvOption_i & Gm_BALLE_VUE_SUR_HELICOP )
	{
		UTIL_MakeVectors( pGvPlayer->pev->v_angle );
		pev->angles = pGvPlayer->pev->angles;
		pev->v_angle = pGvPlayer->pev->v_angle;
		if(!( GvOption_i & Gm_BALLE_CONTROLE_VITESSE ))
			pev->velocity = gpGlobals->v_forward * GvVitesse_i;
	}
	else if( GvOption_i & Gm_BALLE_VUE_SUR_NORMAL )
	{
		UTIL_MakeVectors( pGvPlayer->pev->angles );
		pev->angles = pGvPlayer->pev->angles;
		pev->v_angle = pGvPlayer->pev->v_angle;
		if(!( GvOption_i & Gm_BALLE_CONTROLE_VITESSE ))
			pev->velocity = gpGlobals->v_forward * GvVitesse_i;
	}
	else
		pev->angles = UTIL_VecToAngles( pev->velocity );

	if(( GvOption_i & Gm_BALLE_ACCELERATION )&&( GvCompteurMax_i <= 8 )&&( GvTempsAcc_f < gpGlobals->time ))
	{
		GvTempsAcc_f = gpGlobals->time + 0.25;
//		pev->velocity = gpGlobals->v_forward * 32;
		GvCompteurMax_i++;
	}
	else if(( GvOption_i & Gm_BALLE_ACCELERATION )&&( GvCompteurMax_i <= 24 )&&( GvTempsAcc_f < gpGlobals->time ))
	{
		GvTempsAcc_f = gpGlobals->time + 0.05;
		GvCompteurMax_i++;
		pev->angles = UTIL_VecToAngles( pev->velocity + ( Vector( GvPrecision_i,GvPrecision_i,GvPrecision_i )/10 ));
		pev->velocity *= 1.5;
	}

	if( GvOption_i & Gm_BALLE_CHUTE )
	{
		if(( GvTempsChute_f < gpGlobals->time ) && GvTempsChute_f )
		{
			GvTempsChute_f = gpGlobals->time + 0.02;
			if( GvDeg_f >= 90 )
				GvDeg_f = 90;
			else
				GvDeg_f += 0.02;

			pev->velocity.z -= ( 500 * sinl( GfUtilDegRad_f( GvDeg_f ))) ;// Groove - 04042002 - 500 => Chute max
		}
	}

	if( GvOption_i & Gm_BALLE_VUE_INTERIEUR )
		SET_VIEW( pGvPlayer->edict( ), edict( ));

	if( GvOption_i & Gm_BALLE_ANIM )
		pev->frame = ((int)pev->frame + 10 ) % 255;

	if( GvOption_i & Gm_BALLE_ANIM_SPRITE )
		pev->frame = ((int)pev->frame + 1 ) % 15;

	if( GvOption_i & Gm_BALLE_SCALE_PLUS )
	{
		pev->scale += 0.01;	
		if( GvArmeID_i == Gm_COMETTE_ID )
			pev->velocity.z -= 0.02;
	}

	if( GvQTrailCMD_i )
	{
		if(( GvOption_i & Gm_BALLE_MORVE )&&( GvMorveTraineTemps_f < gpGlobals->time ))
		{
			GvMorveTraineTemps_f = gpGlobals->time + 0.1;
			MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, pev->origin );
				WRITE_BYTE( TE_SPRITE_SPRAY );
				WRITE_COORD( pev->origin.x );	// position
				WRITE_COORD( pev->origin.y );	
				WRITE_COORD( pev->origin.z );	
				WRITE_COORD( 0 );				// direction
				WRITE_COORD( 0 );	
				WRITE_COORD( -1 );	
				WRITE_SHORT( GvMorveSPR_i );		// model
				WRITE_BYTE ( 5 );				// count
				WRITE_BYTE ( 16 );				// speed
				WRITE_BYTE ( 200 );				// noise ( client will divide by 100 )
			MESSAGE_END();
		}
	}

	if(( GvTempsDestruction_f < gpGlobals->time )&&( GvTempsDestruction_f > 0 )&&( pev->velocity != Vector( 0,0,0 )))
	{
		if( GvOption_i & Gm_BALLE_MORVE )
		{
			MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, pev->origin );
				WRITE_BYTE( TE_SPRITE_SPRAY );
				WRITE_COORD( pev->origin.x );	// pos
				WRITE_COORD( pev->origin.y );	
				WRITE_COORD( pev->origin.z );	
				WRITE_COORD( 0 );				// dir
				WRITE_COORD( 0 );	
				WRITE_COORD( 4 );	
				WRITE_SHORT( GvMorveSPR_i );	// model
				WRITE_BYTE ( 50 );				// count
				WRITE_BYTE ( 30 );				// speed
				WRITE_BYTE ( 200 );				// noise ( client will divide by 100 )
			MESSAGE_END();

			if( RANDOM_LONG( 0, 1 ))
				EMIT_SOUND( ENT(pev), CHAN_WEAPON, Gm_MORVE_FICHIER_SON_IMPACT_WALL_1, 1.0, ATTN_NORM );
			else
				EMIT_SOUND( ENT(pev), CHAN_WEAPON, Gm_MORVE_FICHIER_SON_IMPACT_WALL_2, 1.0, ATTN_NORM );
		}

		if( GvOption_i & Gm_BALLE_VUE_INTERIEUR )
			SET_VIEW( pGvPlayer->edict( ), pGvPlayer->edict( ));

		if( GvOption_i & Gm_BALLE_EXPLOSE )
			ExplosionCreate( pev->origin, pev->angles, edict(), GvDommage_i, true );

		if( m_pLauncher )
		{
			m_pLauncher->GvRocketActive_i--;
			m_pLauncher->GvPosition_c = Vector( 0,0,0 );
		}
		UTIL_Remove( this );
	}

	if( GfTouchEau( ) && GvOption_i & Gm_BALLE_VUE_INTERIEUR )
	{
		if( g_pGameRules->GvMortSubite )
			UTIL_ScreenFade( pGvPlayer, Vector( 255, 0, 0 ), 1, 0.5, 64, FFADE_OUT | FFADE_STAYOUT );
		else
			UTIL_ScreenFade( pGvPlayer, Vector( 0, 0, 0 ), 0.25, 0.5, 255, FFADE_IN );
		
		SET_VIEW( pGvPlayer->edict( ), pGvPlayer->edict( ));
	}

	if( GvOption_i & Gm_BALLE_VENT )
	{
		pev->velocity += g_pGameRules->GvVent;
		pev->nextthink = gpGlobals->time + 0.05;
		return;
	}

	pev->nextthink = gpGlobals->time + 0.01;
}

void GcGenericBalle :: GfTouch ( CBaseEntity *pOther )
{
	pGvPlayer->GvPlayerTPT.bAmmo = false;

	if( GvOption_i & Gm_BALLE_VUE_INTERIEUR )
	{
		if( g_pGameRules->GvMortSubite )
			UTIL_ScreenFade( pGvPlayer, Vector( 255, 0, 0 ), 1, 0.5, 64, FFADE_OUT | FFADE_STAYOUT );
		else
			UTIL_ScreenFade( pGvPlayer, Vector( 0, 0, 0 ), 0.25, 0.5, 255, FFADE_IN );

		SET_VIEW( pGvPlayer->edict( ), pGvPlayer->edict( ));
	}

	if( m_pLauncher )
	{
		if( m_pLauncher->GvRocketActive_i )
			m_pLauncher->GvRocketActive_i--;
		m_pLauncher->GvPosition_c = pev->origin;
	}

	if( GvOption_i & Gm_BALLE_EJECT )
	{
		pev->angles = UTIL_VecToAngles( pev->velocity );
		if( !FClassnameIs( pOther->pev, "info_bananier" ) && !FClassnameIs( pOther->pev, "info_sapin" ))
//			pOther->pev->velocity -= gpGlobals->v_forward * 512;
//		else
			pOther->pev->velocity += gpGlobals->v_forward * 512 + gpGlobals->v_up * 128;
	}

	if( GvOption_i & Gm_BALLE_SON )
		GfSonOff( );

	if( GvOption_i & Gm_BALLE_EXPLOSE )
		GfGeneralDetonationTouch( pOther );

	if( GvOption_i & Gm_BALLE_MORVE )
		GfMorveSplash( pOther );

	if( GvOption_i & Gm_BALLE_MAKE_DOMMAGE )
	{
		GfEject( );

		if( GvOption_i & Gm_BALLE_MORVE )
			pOther->TakeDamage( pev, pev, GvDommage_i, Gm_DMG_RADIOACTIF );
		else
			pOther->TakeDamage( pev, pev, GvDommage_i, Gm_DMG_EXPLOSION );
	}

	if( GvQSmokeCMD_i )
		if( GvOption_i & Gm_BALLE_FUMEE )
			GfBalleFumee( );

	if( GvOption_i & Gm_BALLE_BRUIT_RICOCHE )
		GfBalleBruitRiche( pOther );

	if( GvOption_i & Gm_BALLE_CLUSTER )
	{
		for( short I = 1; I <= 5; I++ )
		{
			Vector GvOriginModifier_c = ( pev->origin - gpGlobals->v_forward * RANDOM_LONG( 48,64 ) + gpGlobals->v_up * RANDOM_LONG( 48,64 ) + gpGlobals->v_right * RANDOM_LONG( -64,64 ));
			GcGrenadeGeneric::GfClusterFrag( NULL, GvOriginModifier_c, -( pev->velocity * RANDOM_FLOAT( 0.1,0.25 )) + gpGlobals->v_up * RANDOM_LONG( -32,32 ) + gpGlobals->v_right * RANDOM_LONG( -32,32 ) + gpGlobals->v_forward * -RANDOM_LONG( 32,64 ), pev->dmg );
		}
	}

	if( GvOption_i & Gm_BALLE_ALLREADY_LIFE )
	{
		pev->velocity = Vector( 0,0,0 );
		UTIL_SetOrigin( pev, pev->origin );
	}
	else
		UTIL_Remove( this );
}

void GcGenericBalle::GfCreateRocket( void )
{
	Vector GvOrigin_c = pev->origin + gpGlobals->v_forward * 16 + gpGlobals->v_right * 16;
	
	short GvTraine_18i[3][6] = 
	{
		{  5,  1, 255, 255,   0, 192 },// Life, Width, r, v, b, brightness
		{ 10,  5, 255, 128,   0, 192 },// Life, Width, r, v, b, brightness
		{ 15, 10, 255,   0,   0, 128 } // Life, Width, r, v, b, brightness
	};

	int GvBalleOption_i = Gm_BALLE_EXPLOSE | Gm_BALLE_FUMEE | Gm_BALLE_SON;

	GcGenericBalle::GfCreateBalle( GvOrigin_c,
								   pev->angles, 
								   0, 
								   500,
								   50,//Gm_HELICO_DOMMAGE, 
								   0,					// Groove - 18032002 - Dure de vie de la balle si option active.
								   GvTraineCouleur_18i,
								   3,					// Groove - 18032002 - Nombre de trainees
								   GvBalleOption_i,		
								   pGvPlayer, 
								   m_pLauncher,
								   Gm_BAZOOKA_ID );
}

void GcGenericBalle::GfBalleBruitRiche( CBaseEntity *pOther )
{
	if( pOther->IsPlayer( ))
	{
		switch( RANDOM_LONG( 1, 5 ))
		{
		case 1:
			EMIT_SOUND( ENT(pev), CHAN_WEAPON, Gm_BALLE_HIT_1, 1.0, ATTN_NORM );
			break;
		case 2:
			EMIT_SOUND( ENT(pev), CHAN_WEAPON, Gm_BALLE_HIT_2, 1.0, ATTN_NORM );
			break;
		case 3:
			EMIT_SOUND( ENT(pev), CHAN_WEAPON, Gm_BALLE_HIT_3, 1.0, ATTN_NORM );
			break;
		case 4:
			EMIT_SOUND( ENT(pev), CHAN_WEAPON, Gm_BALLE_HIT_4, 1.0, ATTN_NORM );
			break;
		case 5:
			EMIT_SOUND( ENT(pev), CHAN_WEAPON, Gm_BALLE_HIT_5, 1.0, ATTN_NORM );
			break;
		default:
			EMIT_SOUND( ENT(pev), CHAN_WEAPON, Gm_BALLE_HIT_1, 1.0, ATTN_NORM );
		}
	}
	else
	{
		switch( RANDOM_LONG( 1, 6 ) )
		{
		case 1:
			EMIT_SOUND( ENT(pev), CHAN_WEAPON, Gm_BALLE_RICOCHET_1, 1.0, ATTN_NORM );
			break;
		case 2:
			EMIT_SOUND( ENT(pev), CHAN_WEAPON, Gm_BALLE_RICOCHET_2, 1.0, ATTN_NORM );
			break;
		case 3:
			EMIT_SOUND( ENT(pev), CHAN_WEAPON, Gm_BALLE_RICOCHET_3, 1.0, ATTN_NORM );
			break;
		case 4:
			EMIT_SOUND( ENT(pev), CHAN_WEAPON, Gm_BALLE_RICOCHET_4, 1.0, ATTN_NORM );
			break;
		case 5:
			EMIT_SOUND( ENT(pev), CHAN_WEAPON, Gm_BALLE_RICOCHET_5, 1.0, ATTN_NORM );
			break;
		case 6:
			EMIT_SOUND( ENT(pev), CHAN_WEAPON, Gm_BALLE_RICOCHET_6, 1.0, ATTN_NORM );
			break;
		default:
			EMIT_SOUND( ENT(pev), CHAN_WEAPON, Gm_BALLE_RICOCHET_1, 1.0, ATTN_NORM );
		}
	}
}

void GcGenericBalle::GfBalleFumee( void )
{
	int GvSprite;
	switch( RANDOM_LONG( 0, 3 ))
	{
	case 0:
		GvSprite = PRECACHE_MODEL( Gm_BALLE_FUMEE_1 );
		break;
	case 1:
		GvSprite = PRECACHE_MODEL( Gm_BALLE_FUMEE_2 );
		break;
	case 2:
		GvSprite = PRECACHE_MODEL( Gm_BALLE_FUMEE_3 );
		break;
	case 3:
		GvSprite = PRECACHE_MODEL( Gm_BALLE_FUMEE_4 );
		break;
	default:
		GvSprite = PRECACHE_MODEL( Gm_BALLE_FUMEE_1 );
	}

	MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, pev->origin );
		WRITE_BYTE( TE_SMOKE );
		WRITE_COORD( pev->origin.x );
		WRITE_COORD( pev->origin.y );
		WRITE_COORD( pev->origin.z );
		WRITE_SHORT( GvSprite );
		WRITE_BYTE( 10 );
		WRITE_BYTE( 12  );
	MESSAGE_END( );
}

void GcGenericBalle::GfMorveSplash( CBaseEntity *pOther )
{
	TraceResult tr;

	UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );
	UTIL_DecalTrace( &tr, DECAL_SPLASH_1 + RANDOM_LONG( 0,1 ));

	MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, tr.vecEndPos );
		WRITE_BYTE( TE_SPRITE_SPRAY );
		WRITE_COORD( tr.vecEndPos.x);	// pos
		WRITE_COORD( tr.vecEndPos.y);	
		WRITE_COORD( tr.vecEndPos.z);	
		WRITE_COORD( tr.vecPlaneNormal.x);	// dir
		WRITE_COORD( tr.vecPlaneNormal.y);	
		WRITE_COORD( tr.vecPlaneNormal.z);	
		WRITE_SHORT( GvMorveSPR_i );	// model
		WRITE_BYTE ( 50 );			// count
		WRITE_BYTE ( 30 );			// speed
		WRITE_BYTE ( 200 );			// noise ( client will divide by 100 )
	MESSAGE_END();

	if( pOther->IsPlayer( ))
		if( RANDOM_LONG( 0, 1 ))
			EMIT_SOUND( ENT( pev ), CHAN_WEAPON, Gm_MORVE_FICHIER_SON_IMPACT_BODY_1, 1.0, ATTN_NORM );
		else
			EMIT_SOUND( ENT( pev ), CHAN_WEAPON, Gm_MORVE_FICHIER_SON_IMPACT_BODY_2, 1.0, ATTN_NORM );
	else
		if( RANDOM_LONG( 0, 1 ))
			EMIT_SOUND( ENT( pev ), CHAN_WEAPON, Gm_MORVE_FICHIER_SON_IMPACT_WALL_1, 1.0, ATTN_NORM );
		else
			EMIT_SOUND( ENT( pev ), CHAN_WEAPON, Gm_MORVE_FICHIER_SON_IMPACT_WALL_2, 1.0, ATTN_NORM );
}

void GcGenericBalle :: GfTraine( void )
{
	if( GvTraineNb_i > 0 )
	{
		MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
			WRITE_BYTE( TE_BEAMFOLLOW );
			WRITE_SHORT( entindex( ));			 // entity
			WRITE_SHORT( GvTraineSPR_i );			 // model
			WRITE_BYTE( GvTraineCouleur_18i[0][0] ); // life
			WRITE_BYTE( GvTraineCouleur_18i[0][1] ); // width
			WRITE_BYTE( GvTraineCouleur_18i[0][2] ); // r, g, b 
			WRITE_BYTE( GvTraineCouleur_18i[0][3] ); // r, g, b
			WRITE_BYTE( GvTraineCouleur_18i[0][4] ); // r, g, b
			WRITE_BYTE( GvTraineCouleur_18i[0][5] ); // brightness
		MESSAGE_END( );  // move PHS/PVS data sending into here (SEND_ALL, SEND_PVS, SEND_PHS)
	}
	if( GvTraineNb_i > 1 )
	{
		MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
			WRITE_BYTE( TE_BEAMFOLLOW );
			WRITE_SHORT( entindex( ));	// entity
			WRITE_SHORT( GvTraineSPR_i );	// model
			WRITE_BYTE( GvTraineCouleur_18i[1][0] ); // life
			WRITE_BYTE( GvTraineCouleur_18i[1][1] ); // width
			WRITE_BYTE( GvTraineCouleur_18i[1][2] ); // r, g, b 
			WRITE_BYTE( GvTraineCouleur_18i[1][3] ); // r, g, b
			WRITE_BYTE( GvTraineCouleur_18i[1][4] ); // r, g, b
			WRITE_BYTE( GvTraineCouleur_18i[1][5] ); // brightness
		MESSAGE_END( );  // move PHS/PVS data sending into here (SEND_ALL, SEND_PVS, SEND_PHS)
	}
	if( GvTraineNb_i > 2 )
	{
		MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
			WRITE_BYTE( TE_BEAMFOLLOW );
			WRITE_SHORT( entindex( ));	// entity
			WRITE_SHORT( GvTraineSPR_i );	// model
			WRITE_BYTE( GvTraineCouleur_18i[2][0] ); // life
			WRITE_BYTE( GvTraineCouleur_18i[2][1] ); // width
			WRITE_BYTE( GvTraineCouleur_18i[2][2] ); // r, g, b 
			WRITE_BYTE( GvTraineCouleur_18i[2][3] ); // r, g, b
			WRITE_BYTE( GvTraineCouleur_18i[2][4] ); // r, g, b
			WRITE_BYTE( GvTraineCouleur_18i[2][5] ); // brightness
		MESSAGE_END( );  // move PHS/PVS data sending into here (SEND_ALL, SEND_PVS, SEND_PHS)
	}
}

void GcGenericBalle::GfSonOff( void )
{
	switch( GvArmeID_i )
	{
	case Gm_BAZOOKA_ID:
	case Gm_MORTIER_ID:
		STOP_SOUND( edict( ), CHAN_ITEM, Gm_BAZOOKA_FICHIER_SON_TRAINE );
		break;
//	case Gm_KAMEHA_ID:
	case Gm_COMETTE_ID:
		break;
	default:
		break;
	}
}

void GcGenericBalle::GfSonOn( void )
{
	switch( GvArmeID_i )
	{
	case Gm_BAZOOKA_ID:
	case Gm_MORTIER_ID:
		EMIT_SOUND( ENT( pev ), CHAN_ITEM, Gm_BAZOOKA_FICHIER_SON_TRAINE, 0.7, 0.5 );
		break;
//	case Gm_KAMEA_ID:
//		EMIT_SOUND( ENT( pev ), CHAN_ITEM, Gm_KAMEHA_FICHIER_SON_TRAINE, 1.0, 0.5 );
//		break;
	case Gm_COMETTE_ID:
		break;
	default:
		break;
	}
}