/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	generic_balle.h				*
*		30012002				*
\*******************************/

#ifndef GENERIC_BALLE_H
#define GENERIC_BALLE_H

#define Gm_MINICANON_FICHIER_MODEL_R	"models/armes/r_minicanon.mdl"
#define Gm_MORVE_FICHIER_MODEL_R		"models/armes/r_morve.mdl"
#define Gm_GRAPPIN_FICHIER_MODEL_R		"models/armes/r_grappin.mdl"
#define Gm_SUPER_MOUTON_FICHIER_MODEL_R "models/armes/r_super_mouton.mdl"
#define Gm_SNIPE_FICHIER_MODEL_R		"models/armes/r_minicanon.mdl"
#define Gm_FUSIL_FICHIER_MODEL_R		"models/armes/r_fusil.mdl"
#define Gm_BAZOOKA_FICHIER_MODEL_R		"models/armes/r_bazooka.mdl"
#define Gm_CAMERA_FICHIER_MODEL_R		"models/armes/w_camera.mdl"
#define Gm_MORTIER_FICHIER_MODEL_R		"models/armes/r_mortier.mdl"

#define Gm_MORVE_FICHIER_SON_IMPACT_WALL_1	"weapons/morve/morve2.wav"
#define Gm_MORVE_FICHIER_SON_IMPACT_WALL_2	"weapons/morve/morve3.wav"
#define Gm_MORVE_FICHIER_SON_IMPACT_BODY_1	"weapons/morve/morve4.wav"
#define Gm_MORVE_FICHIER_SON_IMPACT_BODY_2	"weapons/morve/morve5.wav"

#define Gm_BALLE_FUMEE_1 "sprites/jeu/armes/balle_fumee1.spr"
#define Gm_BALLE_FUMEE_2 "sprites/jeu/armes/balle_fumee2.spr"
#define Gm_BALLE_FUMEE_3 "sprites/jeu/armes/balle_fumee3.spr"
#define Gm_BALLE_FUMEE_4 "sprites/jeu/armes/balle_fumee4.spr"
#define Gm_BALLE_MORVE_1 "sprites/jeu/armes/morve1.spr"

#define Gm_BALLE_RICOCHET_1 "weapons/commun/ricochet1.wav"
#define Gm_BALLE_RICOCHET_2 "weapons/commun/ricochet2.wav"
#define Gm_BALLE_RICOCHET_3 "weapons/commun/ricochet3.wav"
#define Gm_BALLE_RICOCHET_4 "weapons/commun/ricochet4.wav"
#define Gm_BALLE_RICOCHET_5 "weapons/commun/ricochet5.wav"
#define Gm_BALLE_RICOCHET_6 "weapons/commun/ricochet6.wav"

#define Gm_BALLE_HIT_1 "weapons/commun/balle_hit1.wav"
#define Gm_BALLE_HIT_2 "weapons/commun/balle_hit2.wav"
#define Gm_BALLE_HIT_3 "weapons/commun/balle_hit3.wav"
#define Gm_BALLE_HIT_4 "weapons/commun/balle_hit4.wav"
#define Gm_BALLE_HIT_5 "weapons/commun/balle_hit5.wav"

#define Gm_BAZOOKA_FICHIER_SON_TRAINE "weapons/bazooka/bazooka2.wav"

#define Gm_BALLE_DEBRIS				( 1<<0 )
#define Gm_BALLE_ACCELERATION		( 1<<1 )
#define Gm_BALLE_VUE_INTERIEUR		( 1<<2 )
#define Gm_BALLE_EXPLOSE			( 1<<3 )
#define Gm_BALLE_MAKE_DOMMAGE		( 1<<4 )
#define Gm_BALLE_AUTO_DESTRUCTION	( 1<<5 )
#define Gm_BALLE_SON				( 1<<6 )
#define Gm_BALLE_MORVE				( 1<<7 )
#define Gm_BALLE_BRIANTE			( 1<<8 )
#define Gm_BALLE_VUE_SUR_HELICOP	( 1<<9 )
#define Gm_BALLE_VUE_SUR_NORMAL		( 1<<10 )
#define Gm_BALLE_FUMEE				( 1<<11 )
#define Gm_BALLE_BRUIT_RICOCHE		( 1<<12 )
#define Gm_BALLE_ALLREADY_LIFE		( 1<<13 )
#define Gm_BALLE_ANIM				( 1<<14 )
#define Gm_BALLE_CHUTE				( 1<<15 )
#define Gm_BALLE_CLUSTER			( 1<<16 )
#define Gm_BALLE_EJECT				( 1<<17 )
#define Gm_BALLE_ROCKET				( 1<<18 )
#define Gm_BALLE_ANIM_SPRITE		( 1<<19 )
#define Gm_BALLE_CONTROLE_VITESSE	( 1<<20 )
#define Gm_BALLE_SCALE_PLUS			( 1<<21 )
#define Gm_BALLE_VENT				( 1<<22 )


class GcGenericBalle : public GcGrenadeGeneric
{
public:
	void Spawn( void );
	void Precache( void );
	static GcGenericBalle *GfCreateBalle( Vector GvOrigin_c,
										  Vector GvAngles_c, 
										  int GvPrecision_i, 
										  int GvVitesse_i, 
										  int GvDommage_i, 
										  float GvTempsVie_f,
										  short GvTraineCouleur_i[][6],
										  short GvTraineNb_i,
										  int GvOption_i, 
										  CBasePlayer *pOwner, 
										  CBasePlayerWeapon *pLauncher, 
										  short GvArmeID_i );
	bool GvTireRocket_b;

private:
	void EXPORT GfThink( void );
	void EXPORT GfTouch( CBaseEntity *pOther );
	void GfClassName( void );
	void GfTraine( void );
	void GfMorveSplash( CBaseEntity *pOther );
	void GfBalleBruitRiche( CBaseEntity *pOther );
	void GfBalleFumee( void );
	void GfCreateRocket( void );
	void GfSonOn( void );
	void GfSonOff( void );

	CBasePlayerWeapon *m_pLauncher;

	int GvTraineSPR_i;
	int GvMorveSPR_i;
	int GvFilSPR_i;
	int GvFumeeSPR_i;
	int GvKameaSPR_i;

	int GvPrecision_i;
	int GvVitesse_i;
	int GvDommage_i;
	float GvTempsVie_f;
	short GvTraineCouleur_18i[3][6];
	short GvTraineNb_i;
	short GvCompteurMax_i;
	int GvOption_i;
	short GvArmeID_i;
	float GvTempsDestruction_f;
	float GvTempsAcc_f;
	float GvMorveTraineTemps_f;
	float GvTempsChute_f; 
	float GvDeg_f;
};

#endif //GENERIC_BALLE_H