/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	generic_flamme.cpp			*
*		22032002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "fx_explode.h"
#include "fx_sprite.h"
#include "generic_arme.h"
#include "generic_flamme.h"
#include "game.h"

LINK_ENTITY_TO_CLASS( flamme, GcFlamme );

GcFlamme *GcFlamme::GfCreateFlamme( Vector GvOrigin )
{
	GcFlamme *pFlamme = GetClassPtr(( GcFlamme * )NULL );
	UTIL_SetOrigin( pFlamme->pev, GvOrigin );
	pFlamme->Spawn( );

	return pFlamme;
}

void GcFlamme::Spawn( void )
{
	Precache( );

	pev->classname = MAKE_STRING( "feu" );
	pev->gravity = 0.5;
//	if( GvQDLightCMD_i )
		pev->effects = EF_BRIGHTLIGHT;

	EMIT_SOUND_DYN( ENT( pev ), CHAN_ITEM, Gm_FLAMME_FICHIER_SON, 1.0, ATTN_NORM, 0, 100 );

	iGvTempsVie = RANDOM_LONG( 25, 35 );
	fGvTempsDmg = gpGlobals->time + 0.1;

	UTIL_SetSize( pev, Vector( -8,-8,0 ), Vector( 8,8,32 ));

	MESSAGE_BEGIN( MSG_ALL, gmsgFlamme );
		WRITE_BYTE( iGvTempsVie ); //duree en secondes que la flamme brulera
		WRITE_COORD( pev->origin.x ); // coordonne x de l'emplacement de la flamme
		WRITE_COORD( pev->origin.y ); // coordonne y de l'emplacement de la flamme
		WRITE_COORD( pev->origin.z + 4 ); // coordonne z de l'emplacement de la flamme
	MESSAGE_END( );

	fGvTempsVie = gpGlobals->time + static_cast<float>( iGvTempsVie );

	SetThink( GfVie );
	pev->nextthink = gpGlobals->time;
}

void GcFlamme::Precache( void )
{
	PRECACHE_MODEL( Gm_FLAMME_FICHIER_FEU_1 );
	PRECACHE_MODEL( Gm_FLAMME_FICHIER_FEU_2 );
	PRECACHE_MODEL( Gm_FLAMME_FICHIER_FEU_3 );
	PRECACHE_SOUND( Gm_FLAMME_FICHIER_SON );
}

void GcFlamme :: GfVie( void )
{
	pev->nextthink = gpGlobals->time + 0.5;
	pev->effects = EF_BRIGHTLIGHT;

	if( fGvTempsVie &&( fGvTempsVie < gpGlobals->time ))
		UTIL_Remove( this );
	
	if( fGvTempsDmg && fGvTempsDmg < gpGlobals->time )
	{
		fGvTempsDmg = gpGlobals->time + 0.1;
		pGvEntity = NULL;
		while(( pGvEntity = UTIL_FindEntityInSphere( pGvEntity, pev->origin, 64 )) != NULL )
		{
			bool bGvExplose = false;
			if(( FClassnameIs( pGvEntity->pev, "player" ))&&( pGvEntity->pev->health >= 0 ))
			{
				// Groove - 14012002 - mettre un son pour Worm qui se brule.
				if(( pGvEntity->pev->health <= ( Gm_FLAMME_DOMMAGE + 1 ))&&( pGvEntity->pev->health > 0 ))
				{
					if( bGvExplose == false )
					{
						ExplosionCreate( pGvEntity->pev->origin, pev->angles, pGvEntity->edict( ), 25, true );
						bGvExplose = true;
					}
				}
				else
				{
					pGvEntity->TakeDamage( VARS( eoNullEntity ), VARS( eoNullEntity ), Gm_FLAMME_DOMMAGE, Gm_DMG_CHAUD );
					pGvEntity->pev->velocity.z += 250;
					pGvEntity->pev->velocity += gpGlobals->v_forward * 16 ;
				}
			}
		}
	}
}
