/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	generic_grenade.cpp			*
*		22032002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "monsters.h"
#include "player.h"
#include "soundent.h"
#include "fx_decals.h"
#include "shake.h"
#include "customentity.h"
#include "fx_beam.h"
#include "fx_explode.h"
#include "fx_sprite.h"
#include "generic_arme.h"
#include "generic_flamme.h"
#include "gamerules.h"
#include "game.h"
#include "define_slot.h"

#include "arme_grenade.h"
#include "arme_cluster.h"
#include "arme_sainte.h"
#include "arme_banane.h"
#include "arme_molotov.h"
#include "arme_dynamite.h"
#include "arme_mine.h"

#include "items.h"
#include "item_sapin.h"

LINK_ENTITY_TO_CLASS( grenade, GcGrenadeGeneric );

void GcGrenadeGeneric::GfCommunExplosion( TraceResult *pTrace, int iGvTypeDommage )
{
	pev->takedamage = DAMAGE_NO;
/*	
	MESSAGE_BEGIN( MSG_PAS, SVC_TEMPENTITY, pev->origin );
		WRITE_BYTE( TE_EXPLOSION );		// This makes a dynamic light and the explosion sprites/sound
		WRITE_COORD( pev->origin.x );	// Send to PAS because of the sound
		WRITE_COORD( pev->origin.y );
		WRITE_COORD( pev->origin.z );
		WRITE_SHORT( g_sModelIndexFireball );
		WRITE_BYTE( pev->dmg / Gm_SPRITE_EXPLOSE_DIV + Gm_SPRITE_EXPLOSE_PLUS );
		WRITE_BYTE( 15  ); // framerate
		WRITE_BYTE( TE_EXPLFLAG_NONE );
	MESSAGE_END();*/

	MESSAGE_BEGIN( MSG_ALL, gmsgExplosion);
		WRITE_BYTE( RANDOM_LONG( 1, 9 ) ); //puissance
		WRITE_BYTE( RANDOM_LONG( 1, 6 )); //couleur
		WRITE_COORD( pev->origin.x ); // coordonne x
		WRITE_COORD( pev->origin.y ); // coordonne y
		WRITE_COORD( pev->origin.z ); // coordonne z
	MESSAGE_END( );

	entvars_t *pevOwner;
	if ( pev->owner )
		pevOwner = VARS( pev->owner );
	else
		pevOwner = NULL;

	pev->owner = NULL; // can't traceline attack owner if this is set

	RadiusDamage( pev, pevOwner, pev->dmg, CLASS_NONE, iGvTypeDommage );

	int iGvDecalChoix;

	// Groove - 08052002 - Affiche la trace.
	if( pev->dmg <= 5 )
		iGvDecalChoix = DECAL_EXPLOSE_005;
	else if( pev->dmg <= 10 )
		iGvDecalChoix = DECAL_EXPLOSE_010;
	else if( pev->dmg <= 25 )
		iGvDecalChoix = DECAL_EXPLOSE_025;
	else if( pev->dmg <= 50 )
		iGvDecalChoix = DECAL_EXPLOSE_050;
	else if( pev->dmg <= 75 )
		iGvDecalChoix = DECAL_EXPLOSE_075;
	else if( pev->dmg <= 100 )
		iGvDecalChoix = DECAL_EXPLOSE_100;
	else if( pev->dmg <= 150 )
		iGvDecalChoix = DECAL_EXPLOSE_150;
	else if( pev->dmg <= 200 )
		iGvDecalChoix = DECAL_EXPLOSE_200;
	else if( pev->dmg <= 300 )
		iGvDecalChoix = DECAL_EXPLOSE_300;

	UTIL_DecalTrace( pTrace, iGvDecalChoix );

	if( UTIL_PointContents( pev->origin ) == CONTENTS_WATER )
		UTIL_Bubbles( pev->origin - Vector( 64, 64, 64 ), pev->origin + Vector( 64, 64, 64 ), 100 );

	if( pGvPlayer )
		pGvPlayer->GvPlayerTPT.bAmmo = false;

	UTIL_Remove( this );
}

void GcGrenadeGeneric::GfMoutonDetonationUse( CBaseEntity *pActivator, CBaseEntity *pCaller, USE_TYPE useType, float value )
{
	SetThink( GfCommunDetonation );
	pev->nextthink = gpGlobals->time;
}

bool GcGrenadeGeneric::GfTouchEau( void )
{
	// Groove - 03122001 - Si les grenades tombent a l'eau elle n'explose pas et disparaissent.
	if( pev->waterlevel > 1 )
	{
		// Groove - 03122001 - Enfin il faudra jouer d'autre sons ;-)
		switch ( RANDOM_LONG( 0, 2 ) )
		{
			case 0:	EMIT_SOUND(ENT(pev), CHAN_VOICE, "weapons/debris1.wav", 0.55, ATTN_NORM);	break;
			case 1:	EMIT_SOUND(ENT(pev), CHAN_VOICE, "weapons/debris2.wav", 0.55, ATTN_NORM);	break;
			case 2:	EMIT_SOUND(ENT(pev), CHAN_VOICE, "weapons/debris3.wav", 0.55, ATTN_NORM);	break;
		}
		
		if( pGvPlayer )
			pGvPlayer->GvPlayerTPT.bAmmo = false;

		return true;
	}
	else
	{
		return false;
	}
}

void GcGrenadeGeneric::GfGeneralDetonationTouch( CBaseEntity *pOther )
{
	TraceResult tr;
	Vector		vecSpot;// trace starts here!

	pev->enemy = pOther->edict();

	vecSpot = pev->origin - pev->velocity.Normalize( ) * 32;
	UTIL_TraceLine( vecSpot, vecSpot + pev->velocity.Normalize( ) * 64, ignore_monsters, ENT( pev ), &tr );

	GfEject( );

	GfCommunExplosion( &tr, Gm_DMG_EXPLOSION );
}

void GcGrenadeGeneric::GfEssenceDetonationTouch( CBaseEntity *pOther )
{
	TraceResult tr;

	pev->enemy = pOther->edict();

	Vector vecSpot = pev->origin - pev->velocity.Normalize( ) * 32;
	UTIL_TraceLine( vecSpot, vecSpot + pev->velocity.Normalize( ) * 64, ignore_monsters, ENT( pev ), &tr );

	UTIL_MakeVectors( pev->v_angle );

	EMIT_SOUND(ENT(pev), CHAN_WEAPON, Gm_FLAMME_FICHIER_SON, 1.0, ATTN_NORM);

	GcFlamme::GfCreateFlamme( pev->origin );

//	GfEject( );

	GfCommunExplosion( &tr, Gm_DMG_CHAUD );
}

void GcGrenadeGeneric::GfMortierDetonationTouch( CBaseEntity *pOther )
{
	TraceResult tr;

	pev->enemy = pOther->edict();

	Vector vecSpot = pev->origin - pev->velocity.Normalize( ) * 32;

	UTIL_TraceLine( vecSpot, vecSpot - pev->velocity.Normalize( ) * 64, ignore_monsters, ENT(pev), &tr );

	GfEject( );

	GfCommunExplosion( &tr, Gm_DMG_EXPLOSION );
}

void GcGrenadeGeneric::GfMolotovDetonationTouch( CBaseEntity *pOther )
{
	TraceResult tr;
	Vector		vecSpot;

	pev->enemy = pOther->edict();

	vecSpot = pev->origin - pev->velocity.Normalize() * 32;
	UTIL_TraceLine( vecSpot, vecSpot + pev->velocity.Normalize() * 64, ignore_monsters, ENT(pev), &tr );

	GfCommunExplosion( &tr, Gm_DMG_CHAUD );

	GcGrenadeGeneric::GfEssence( pGvPlayer, pev->origin + Vector(   0,  0, 20 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
	GcGrenadeGeneric::GfEssence( pGvPlayer, pev->origin + Vector(  20, 20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
	GcGrenadeGeneric::GfEssence( pGvPlayer, pev->origin + Vector(  20,-20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
	GcGrenadeGeneric::GfEssence( pGvPlayer, pev->origin + Vector( -20, 20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
	GcGrenadeGeneric::GfEssence( pGvPlayer, pev->origin + Vector( -20,-20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
	GcGrenadeGeneric::GfEssence( pGvPlayer, pev->origin + Vector(   0,  0, 10 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
	GcGrenadeGeneric::GfEssence( pGvPlayer, pev->origin + Vector(  10, 10,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
	GcGrenadeGeneric::GfEssence( pGvPlayer, pev->origin + Vector(  10,-10,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
	GcGrenadeGeneric::GfEssence( pGvPlayer, pev->origin + Vector( -10, 10,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
	GcGrenadeGeneric::GfEssence( pGvPlayer, pev->origin + Vector( -10,-10,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
}

void GcGrenadeGeneric::GfBananeDetonation( void )
{
	GfCommunDetonation( );
	
	GcGrenadeGeneric::GfBananeFrag( pGvPlayer, pev->origin + Vector(   0,  0, 10 ), Gm_RANDOM_VECTOR( Gm_BANANE_PRECISION, Gm_BANANE_HAUTEUR_MINI, Gm_BANANE_HAUTEUR_MAX ), pev->dmg );
	GcGrenadeGeneric::GfBananeFrag( pGvPlayer, pev->origin + Vector(  10, 10,  5 ), Gm_RANDOM_VECTOR( Gm_BANANE_PRECISION, Gm_BANANE_HAUTEUR_MINI, Gm_BANANE_HAUTEUR_MAX ), pev->dmg );
	GcGrenadeGeneric::GfBananeFrag( pGvPlayer, pev->origin + Vector(  10,-10,  5 ), Gm_RANDOM_VECTOR( Gm_BANANE_PRECISION, Gm_BANANE_HAUTEUR_MINI, Gm_BANANE_HAUTEUR_MAX ), pev->dmg );
	GcGrenadeGeneric::GfBananeFrag( pGvPlayer, pev->origin + Vector( -10, 10,  5 ), Gm_RANDOM_VECTOR( Gm_BANANE_PRECISION, Gm_BANANE_HAUTEUR_MINI, Gm_BANANE_HAUTEUR_MAX ), pev->dmg );
	GcGrenadeGeneric::GfBananeFrag( pGvPlayer, pev->origin + Vector( -10,-10,  5 ), Gm_RANDOM_VECTOR( Gm_BANANE_PRECISION, Gm_BANANE_HAUTEUR_MINI, Gm_BANANE_HAUTEUR_MAX ), pev->dmg );
}

void GcGrenadeGeneric::GfClusterDetonation( void )
{
	GfCommunDetonation( );
	
	GcGrenadeGeneric::GfClusterFrag( pGvPlayer, pev->origin + Vector(  10, 10,  5 ), Gm_RANDOM_VECTOR( Gm_CLUSTER_PRECISION, Gm_CLUSTER_HAUTEUR_MINI, Gm_CLUSTER_HAUTEUR_MAX ), pev->dmg );
	GcGrenadeGeneric::GfClusterFrag( pGvPlayer, pev->origin + Vector(  10,-10,  5 ), Gm_RANDOM_VECTOR( Gm_CLUSTER_PRECISION, Gm_CLUSTER_HAUTEUR_MINI, Gm_CLUSTER_HAUTEUR_MAX ), pev->dmg );
	GcGrenadeGeneric::GfClusterFrag( pGvPlayer, pev->origin + Vector( -10, 10,  5 ), Gm_RANDOM_VECTOR( Gm_CLUSTER_PRECISION, Gm_CLUSTER_HAUTEUR_MINI, Gm_CLUSTER_HAUTEUR_MAX ), pev->dmg );
	GcGrenadeGeneric::GfClusterFrag( pGvPlayer, pev->origin + Vector( -10,-10,  5 ), Gm_RANDOM_VECTOR( Gm_CLUSTER_PRECISION, Gm_CLUSTER_HAUTEUR_MINI, Gm_CLUSTER_HAUTEUR_MAX ), pev->dmg );
}

void GcGrenadeGeneric::GfCommunDetonation( void )
{
	TraceResult tr;
	Vector		vecSpot;// trace starts here!

	vecSpot = pev->origin + Vector ( 0 , 0 , 8 );
	UTIL_TraceLine ( vecSpot, vecSpot + Vector ( 0, 0, -40 ),  ignore_monsters, ENT(pev), & tr);

//	if( GvQDLightCMD_i )
		pev->effects = EF_BRIGHTLIGHT;

	GfCommunExplosion( &tr, Gm_DMG_EXPLOSION );

	GfEject( );
}

//////////////////////////////////////////////////////////////

void GcGrenadeGeneric::GfBananeRebond( CBaseEntity *pOther )
{
	if( pev->flags & FL_ONGROUND )
	{
		pev->velocity *= 0.8;
		pev->sequence = 0;
	}
	else
	{
		pev->avelocity.x = RANDOM_FLOAT ( -50, -800 );
		GfBananeRebondSon( );
	}
}

void GcGrenadeGeneric::GfSainteRebond( CBaseEntity *pOther )
{
	if( pev->flags & FL_ONGROUND )
	{
		pev->velocity *= 0.8;
		pev->sequence = 0;
	}
	else
	{
		// EurOPiuM - 24/07/02 - Particles Sainte
		MESSAGE_BEGIN( MSG_ALL, gmsgSainte);
			WRITE_BYTE( PARTICLES_SAINTE_REBOND ); // type de fume
			WRITE_COORD( pev->origin.x ); // coordonne x
			WRITE_COORD( pev->origin.y ); // coordonne y
			WRITE_COORD( pev->origin.z ); // coordonne z
		MESSAGE_END( );

		GfSainteRebondSon( );
	}
}
void GcGrenadeGeneric::GfGeneralRebond( CBaseEntity *pOther )
{
	if( pev->flags & FL_ONGROUND )
	{
		pev->velocity *= 0.8;
		pev->sequence = 0;
	}
	else
	{
		GfGeneralRebondSon( );
	}
}

void GcGrenadeGeneric::GfBananeRebondSon( void )
{
	EMIT_SOUND( ENT(pev), CHAN_VOICE, Gm_BANANE_FICHIER_SON_REBOND, 1.0, ATTN_NORM);
}

void GcGrenadeGeneric::GfSainteRebondSon( void )
{
#ifdef Gd_ARME_SAINTE
	EMIT_SOUND( ENT(pev), CHAN_VOICE, Gm_SAINTE_FICHIER_SON_REBOND, 1.0, ATTN_NORM);
#endif
}

void GcGrenadeGeneric::GfGeneralRebondSon( void )
{
	switch( RANDOM_LONG( 0, 2 ))
	{
	case 0:	EMIT_SOUND( ENT(pev), CHAN_VOICE, "weapons/grenade_hit1.wav", 0.25, ATTN_NORM);	break;
	case 1:	EMIT_SOUND( ENT(pev), CHAN_VOICE, "weapons/grenade_hit2.wav", 0.25, ATTN_NORM);	break;
	case 2:	EMIT_SOUND( ENT(pev), CHAN_VOICE, "weapons/grenade_hit3.wav", 0.25, ATTN_NORM);	break;
	}
}

//////////////////////////////////////////////////////////////

void GcGrenadeGeneric::GfBananeChute( void )
{
	if( pev->dmgtime <= gpGlobals->time )
		SetThink( GfBananeDetonation );

	GfCommunChute( );
}

void GcGrenadeGeneric::GfClusterChute( void )
{
	if( pev->dmgtime <= gpGlobals->time )
		SetThink( GfClusterDetonation );

	GfCommunChute( );
}

void GcGrenadeGeneric::GfDynamiteChute( void )
{
	if( pev->dmgtime <= gpGlobals->time )
		SetThink( GfCommunDetonation );
	else
		EMIT_SOUND(ENT(pev), CHAN_VOICE, "weapons/mine/mine1.wav", 0.75, ATTN_NORM);

	GfCommunChute( );
}

void GcGrenadeGeneric::GfMineChute( void )
{
	pev->nextthink = gpGlobals->time + 0.1;
	if( GvTempsAmorce > gpGlobals->time )
	{
		EMIT_SOUND( ENT(pev), CHAN_VOICE, "weapons/mine/mine1.wav", 0.75, ATTN_NORM);
		return;
	}

	short GvNbJoueur = 0;
	m_pEntity = NULL;
	while(( m_pEntity = UTIL_FindEntityInSphere( m_pEntity, pev->origin, pev->dmg * Gm_MINE_RAYON )) != NULL )
	{
		if( FClassnameIs( m_pEntity->pev, "player" ))
		{
			GvNbJoueur++;
		}
	}

	if(( GvNbJoueur > 0 ) && ( pev->dmgtime == 0 ) && ( GvTempsReactive < gpGlobals->time ))
	{
		GvTempsReactive = gpGlobals->time + 3;
		EMIT_SOUND(ENT(pev), CHAN_VOICE, "weapons/mine/mine1.wav", 0.75, ATTN_NORM );
		switch( RANDOM_LONG( 1,8 ))
		{
		case 1:
			pev->dmgtime = 0;
			break;
		case 2:	case 3:
			pev->dmgtime = gpGlobals->time + 1.0;
			break;
		default:
		case 4:	case 5:	case 6:
			pev->dmgtime = gpGlobals->time + 1.5;
			break;
		case 7:	case 8:
			pev->dmgtime = gpGlobals->time + 2.0;
			break;
		}
	}

	if(( pev->dmgtime <= gpGlobals->time ) && ( pev->dmgtime != 0 ))
		SetThink( GfCommunDetonation );
}

void GcGrenadeGeneric::GfSainteChute( void )
{
/*	MESSAGE_BEGIN( MSG_ALL, gmsgSainte );
		WRITE_BYTE( PARTICLES_SAINTE_ATTENTE );
		WRITE_COORD( pev->origin.x ); // coordonne x
		WRITE_COORD( pev->origin.y ); // coordonne y
		WRITE_COORD( pev->origin.z ); // coordonne z
	MESSAGE_END( );*/
	
	if( pev->dmgtime <= gpGlobals->time )
	{
/*		MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
			WRITE_BYTE( TE_LARGEFUNNEL );
			WRITE_COORD( pev->origin.x );
			WRITE_COORD( pev->origin.y );
			WRITE_COORD( pev->origin.z );
			// Groove - 14032002 - Pas model
			WRITE_SHORT( 0 );
			WRITE_SHORT( 1 );
		MESSAGE_END( );
*/
		// EurOPiuM - 24/07/02 - Particles Sainte
		// nouvel effet
		MESSAGE_BEGIN( MSG_ALL, gmsgSainte );
			WRITE_BYTE( PARTICLES_SAINTE_EXPLOSION );
			WRITE_COORD( pev->origin.x );	// coordonne x
			WRITE_COORD( pev->origin.y );	// coordonne y
			WRITE_COORD( pev->origin.z );	// coordonne z
		MESSAGE_END( );
		
		MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, pev->origin );
			WRITE_BYTE( TE_DLIGHT );

			WRITE_COORD( pev->origin.x );    // Position...
			WRITE_COORD( pev->origin.y );
			WRITE_COORD( pev->origin.z );
			WRITE_BYTE( 32 );     // Radius, in 10s (therefore, this is 300 units)
    
			WRITE_BYTE( 255 );    // Color: red
			WRITE_BYTE( 128 );    // Color: green
			WRITE_BYTE( 128 );    // Color: blue
        
			WRITE_BYTE( 64 );      // Life
			WRITE_BYTE( 10 );     // Decay rate
		MESSAGE_END();
		SetThink( GfCommunDetonation );
	}

	GfCommunChute( );
}

void GcGrenadeGeneric::GfGeneralChute( void )
{
	if( pev->dmgtime <= gpGlobals->time )
		SetThink( GfCommunDetonation );

	GfCommunChute( );
}

void GcGrenadeGeneric::GfCommunChute( void )
{
	if( !IsInWorld( ))
	{
		UTIL_Remove( this );
		return;
	}

	pev->velocity += g_pGameRules->GvVent;

	StudioFrameAdvance( );

//	if( pev->dmgtime - 1 < gpGlobals->time )
//		CSoundEnt::InsertSound ( bits_SOUND_DANGER, pev->origin + pev->velocity * (pev->dmgtime - gpGlobals->time), 400, 0.1 );

	if (pev->waterlevel != 0)
	{
		pev->velocity *= 0.5;
		pev->framerate = 0.2;
	}

	pev->nextthink = gpGlobals->time + 0.1;
}

///////////////////////////////////////////////////////////

void GcGrenadeGeneric:: Spawn( void )
{
	pev->movetype = MOVETYPE_BOUNCE;
	pev->solid = SOLID_BBOX;
	
	SET_MODEL( ENT(pev), "models/grenade.mdl");
	UTIL_SetSize( pev, Vector( -2,-2,-2), Vector( 2,2,2 ));
}

// Groove - 04112001 - Eject le joueur quand il se mange une explosion.
void GcGrenadeGeneric::GfEject( void )
{
	m_pEntity = NULL;
	while(( m_pEntity = UTIL_FindEntityInSphere( m_pEntity, pev->origin, ( pev->dmg * Gm_EJECT_RAYON ))) != NULL )
	{
		Vector GvDebut = pev->origin;
		Vector GvFin = m_pEntity->pev->origin;
		Vector GvDistance = GvFin - GvDebut;

		// Eject les joueurs
		if( FClassnameIs( m_pEntity->pev, "player" ))
		{
			int GvPuisFacteur_i = ( pev->dmg * static_cast<int>(( pev->dmg * Gm_EJECT_RAYON ) / ( GfUtilLongueur_c( GvDistance ) + 16 ))) / 4;
			
			#ifdef Gm_BETA_TEST
				ClientPrint( m_pEntity->pev, HUD_PRINTTALK, UTIL_VarArgs( "%d\n",GvPuisFacteur_i ));
			#endif

			// Groove - 01052002 - Pour le VGUI des scores.
			CBasePlayer *GpPlayer = (CBasePlayer *)m_pEntity;
			
			if( GpPlayer->sGvProfil.iGvBilleBocketMax < GvPuisFacteur_i )
				GpPlayer->sGvProfil.iGvBilleBocketMax = GvPuisFacteur_i;

			if( pGvPlayer )
			if( GvPuisFacteur_i >= 800 )
			{
				GvPuisFacteur_i *= 4;
				MESSAGE_BEGIN( MSG_BROADCAST, gmsgBilleBocket );
					WRITE_BYTE( 2 ); //bille bocket geant
					WRITE_BYTE( m_pEntity->entindex( ));// receveur
					WRITE_BYTE( pGvPlayer->entindex( ));// attaquant
				MESSAGE_END( );
//				ClientPrint( m_pEntity->pev, HUD_PRINTTALK, UTIL_VarArgs( "\"%s is a bilboquet geant\" by %s\n", STRING( m_pEntity->pev->netname ), pev->netname ));
				GpPlayer->sGvProfil.iGvBilleBocketNb++;
				TakeDamage( m_pEntity->pev, pGvPlayer->pev, 200, Gm_DMG_CONTACT );
			}
			else if( GvPuisFacteur_i >= 400 )
			{
				GvPuisFacteur_i *= 2;
				MESSAGE_BEGIN( MSG_BROADCAST, gmsgBilleBocket );
					WRITE_BYTE( 1 ); //bille bocket normal
					WRITE_BYTE( m_pEntity->entindex( ));// receveur
					WRITE_BYTE( pGvPlayer->entindex( ));// attaquant
				MESSAGE_END( );
//				ClientPrint( m_pEntity->pev, HUD_PRINTTALK, UTIL_VarArgs( "\"%s is a bilboquet\" by %s\n", STRING( m_pEntity->pev->netname ), pev->netname ));
				GpPlayer->sGvProfil.iGvBilleBocketNb++;
				TakeDamage( m_pEntity->pev, pGvPlayer->pev, 200, Gm_DMG_CONTACT );
			}

			// Groove - 03122001 - Le Worm resent le dommage
			m_pEntity->pev->punchangle.x += RANDOM_LONG( -GvPuisFacteur_i,GvPuisFacteur_i );
			m_pEntity->pev->punchangle.y += RANDOM_LONG( -GvPuisFacteur_i,GvPuisFacteur_i );
			m_pEntity->pev->punchangle.z += RANDOM_LONG( -GvPuisFacteur_i,GvPuisFacteur_i );

			m_pEntity->pev->velocity += GvDistance / Gm_EJECT_PUISSANCE;
			m_pEntity->pev->velocity.z = m_pEntity->pev->velocity.z + ( pev->dmg * Gm_EJECT_HAUTEUR );

			if( g_pGameRules->GvMortSubite )
				UTIL_ScreenFade( m_pEntity, Vector( 128, 0, 0 ), 1, 0.5, 64, FFADE_IN );
			else
				UTIL_ScreenFade( m_pEntity, Vector(( pev->dmg * 2 ), 0, 0 ), 1, 0.5, 128, FFADE_IN );
			
			switch( RANDOM_LONG( 1,2 ))
			{
			case 1 : 
				EMIT_SOUND( ENT(m_pEntity->pev), CHAN_VOICE, Gf_SOUND_DOMMAGE_EXPLOSE_01, 1, ATTN_NORM );
				break;
			case 2 :
				EMIT_SOUND( ENT(m_pEntity->pev), CHAN_VOICE, Gf_SOUND_DOMMAGE_EXPLOSE_02, 1, ATTN_NORM );
				break;
			}
		}
		// Agite les caisses
		else if(( FClassnameIs( m_pEntity->pev, "item_caisse_arme" )) 
			|| ( FClassnameIs( m_pEntity->pev, "item_caisse_outil" )) 
			|| ( FClassnameIs( m_pEntity->pev, "item_caisse_vie" )) 
			|| ( FClassnameIs( m_pEntity->pev, "item_caisse_mega" ))
			|| ( FClassnameIs( m_pEntity->pev, "item_baril" ))
			|| ( FClassnameIs( m_pEntity->pev, "item_baril_rouge" ))
			|| ( FClassnameIs( m_pEntity->pev, "item_baril_bleu" ))
			|| ( FClassnameIs( m_pEntity->pev, "mine" )))
//			|| ( FClassnameIs( m_pEntity->pev, "info_bananier" )))
		{
			m_pEntity->pev->velocity.z = m_pEntity->pev->velocity.z + pev->dmg * static_cast<int>(( pev->dmg * Gm_EJECT_RAYON ) / ( GfUtilLongueur_c( GvDistance ) + 1 )) + pev->dmg;
//			m_pEntity->pev->velocity.z = m_pEntity->pev->velocity.z + 128 + pev->dmg;
			GfDetruitCaisse( m_pEntity );
		}
		else if( FClassnameIs( m_pEntity->pev, "info_bananier" )|| FClassnameIs( m_pEntity->pev, "info_sapin" ))
			GfDetruitCaisse( m_pEntity );
	}
}

void GcGrenadeGeneric::GfDetruitCaisse( CBaseEntity *pEntity )
{
	Vector GvDistance_c = pev->origin - pEntity->pev->origin;
	int GvDistance_i = GfUtilLongueur_c( GvDistance_c );
	if( GvDistance_i < 1 )
		GvDistance_i = 1;

	pEntity->GvNiveauVie_i -= ( pev->dmg / ( GvDistance_i / 20 ));
}

///////////////////////////////////////////////////////////////////////////////////////////////////////

/*******************************\
* Groove - 09112001 - Grenade	*
\*******************************/
#ifdef Gd_ARME_GRENADE
GcGrenadeGeneric *GcGrenadeGeneric::GfGrenade( CBasePlayer *pGvPlayer, Vector vecStart, Vector vecVelocity, float GvTempsExplose_f, int GvDommage_i )
{
	GcGrenadeGeneric *pGvGrenade = GetClassPtr(( GcGrenadeGeneric * )NULL );
	pGvGrenade->pev->classname = MAKE_STRING("grenade");
	pGvGrenade->Spawn( );

	pGvGrenade->pGvPlayer = pGvPlayer;
	if( pGvGrenade->pGvPlayer )
		pGvGrenade->pev->owner = ENT( pGvPlayer->pev );

	UTIL_SetOrigin( pGvGrenade->pev, vecStart );
	pGvGrenade->pev->velocity = vecVelocity;
	pGvGrenade->pev->angles = UTIL_VecToAngles( pGvGrenade->pev->velocity );
	
	pGvGrenade->SetTouch( GfGeneralRebond );

	pGvGrenade->pev->dmgtime = gpGlobals->time + GvTempsExplose_f;
	pGvGrenade->SetThink( GfGeneralChute );
	pGvGrenade->pev->nextthink = gpGlobals->time + 0.1;

	if( GvTempsExplose_f < 0.1 )
	{
		pGvGrenade->pev->nextthink = gpGlobals->time;
		pGvGrenade->pev->velocity = Vector( 0, 0, 0 );
	}
		
	pGvGrenade->pev->sequence = 0;
	pGvGrenade->pev->framerate = 1.0;
	pGvGrenade->pev->gravity = Gm_GRENADE_GRAVITE;
	pGvGrenade->pev->friction = Gm_GRENADE_REBOND;
	pGvGrenade->pev->avelocity = Vector( -40,-30,-20 );
	pGvGrenade->pev->dmg = GvDommage_i;

	SET_MODEL( ENT( pGvGrenade->pev ), Gm_GRENADE_FICHIER_MODEL_W );

	return pGvGrenade;
}
#endif

/***************************************\
* Groove - 09112001 - Cluster			*
\***************************************/
#ifdef Gd_ARME_CLUSTER
GcGrenadeGeneric * GcGrenadeGeneric::GfCluster( CBasePlayer *pGvPlayer, Vector vecStart, Vector vecVelocity, float GvTempsExplose_f, int GvDommage_i )
{
	GcGrenadeGeneric *pGvGrenade = GetClassPtr(( GcGrenadeGeneric *)NULL );
	pGvGrenade->pev->classname = MAKE_STRING( "cluster" );
	pGvGrenade->Spawn( );

	pGvGrenade->pGvPlayer = pGvPlayer;
	if( pGvGrenade->pGvPlayer )
		pGvGrenade->pev->owner = ENT( pGvPlayer->pev );

	UTIL_SetOrigin( pGvGrenade->pev, vecStart );
	pGvGrenade->pev->velocity = vecVelocity;
	pGvGrenade->pev->angles = UTIL_VecToAngles( pGvGrenade->pev->velocity );

	pGvGrenade->pev->dmgtime = gpGlobals->time + GvTempsExplose_f;
	pGvGrenade->pev->nextthink = gpGlobals->time + 0.1;

	pGvGrenade->SetTouch( GfGeneralRebond );
	pGvGrenade->SetThink( GfClusterChute );

	if( GvTempsExplose_f < 0.1 )
	{
		pGvGrenade->pev->nextthink = gpGlobals->time;
		pGvGrenade->pev->velocity = Vector( 0, 0, 0 );
	}

	pGvGrenade->pev->sequence = 0;
	pGvGrenade->pev->framerate = 1.0;
	pGvGrenade->pev->gravity = Gm_CLUSTER_GRAVITE;
	pGvGrenade->pev->friction = Gm_CLUSTER_REBOND;
	pGvGrenade->pev->avelocity.x = -30;
	pGvGrenade->pev->avelocity.y = -20;
	pGvGrenade->pev->avelocity.z = -10;

	SET_MODEL( ENT( pGvGrenade->pev ), Gm_CLUSTER_FICHIER_MODEL_W );
	pGvGrenade->pev->dmg = GvDommage_i;

	return pGvGrenade;
}
#endif

/***************************************\
* Groove - 09112001 - Cluster fragement	*
\***************************************/
GcGrenadeGeneric *GcGrenadeGeneric::GfClusterFrag( CBasePlayer *pGvPlayer, Vector vecStart, Vector vecVelocity, int GvDommage_i )
{
	GcGrenadeGeneric *pGvGrenade = GetClassPtr(( GcGrenadeGeneric* )NULL );
	
	pGvGrenade->pev->classname = MAKE_STRING( "cluster_frag" );
	pGvGrenade->Spawn( );

	pGvGrenade->pGvPlayer = pGvPlayer;
	if( pGvGrenade->pGvPlayer )
		pGvGrenade->pev->owner = ENT( pGvPlayer->pev );

	UTIL_SetOrigin( pGvGrenade->pev, vecStart );
	pGvGrenade->pev->velocity = vecVelocity;
	pGvGrenade->pev->angles = UTIL_VecToAngles( pGvGrenade->pev->velocity );
	
	pGvGrenade->pev->gravity = Gm_CLUSTER_GRAVITE_FRAGMENT;
	pGvGrenade->pev->avelocity = Vector( RANDOM_FLOAT ( -100, -500 ),RANDOM_FLOAT ( -100, -500 ),RANDOM_FLOAT ( -100, -500 ));
	pGvGrenade->pev->dmg = Gm_CLUSTER_DOMMAGE;

	pGvGrenade->SetThink( GfCommunChute );
	pGvGrenade->pev->nextthink = gpGlobals->time + 0.1;
	pGvGrenade->SetTouch( GfGeneralDetonationTouch );
	
	SET_MODEL( ENT( pGvGrenade->pev ), Gm_CLUSTER_FICHIER_MODEL_R );
	return pGvGrenade;
}

/*******************************\
* Groove - 09112001 - Sainte	*
\*******************************/
#ifdef Gd_ARME_SAINTE
GcGrenadeGeneric *GcGrenadeGeneric::GfSainte( CBasePlayer *pGvPlayer, Vector vecStart, Vector vecVelocity, float GvTempsExplose_f, int GvDommage_i )
{
	GcGrenadeGeneric *pGvGrenade = GetClassPtr(( GcGrenadeGeneric * )NULL );

	pGvGrenade->pev->classname = MAKE_STRING( "sainte" );
	pGvGrenade->Spawn( );

	pGvGrenade->pGvPlayer = pGvPlayer;
	if( pGvGrenade->pGvPlayer )
		pGvGrenade->pev->owner = ENT( pGvPlayer->pev );

	UTIL_SetOrigin( pGvGrenade->pev, vecStart );
	pGvGrenade->pev->velocity = vecVelocity;
	pGvGrenade->pev->angles = UTIL_VecToAngles( pGvGrenade->pev->velocity );
	pGvGrenade->pev->effects |= EF_DIMLIGHT;

	pGvGrenade->SetTouch( GfSainteRebond );

	pGvGrenade->pev->dmgtime = gpGlobals->time + GvTempsExplose_f;
	pGvGrenade->SetThink( GfSainteChute );
	pGvGrenade->pev->nextthink = gpGlobals->time + 0.001;

	if( GvQDLightCMD_i )
		pGvGrenade->pev->effects = EF_DIMLIGHT;


	if( GvTempsExplose_f < 0.1 )
	{
		pGvGrenade->pev->nextthink = gpGlobals->time;
		pGvGrenade->pev->velocity = Vector( 0, 0, 0 );
	}
		
	pGvGrenade->pev->sequence = 0;
	pGvGrenade->pev->framerate = 1.0;
	pGvGrenade->pev->gravity = Gm_SAINTE_GRAVITE;
	pGvGrenade->pev->friction = Gm_SAINTE_REBOND;
	pGvGrenade->pev->avelocity.x = -40;
	pGvGrenade->pev->avelocity.y = -30;
	pGvGrenade->pev->avelocity.z = -20;

	SET_MODEL( ENT( pGvGrenade->pev ), Gm_SAINTE_FICHIER_MODEL_W );
	pGvGrenade->pev->dmg = GvDommage_i;

	return pGvGrenade;
}
#endif

/*******************************\
* Groove - 09112001 - Banane	*
\*******************************/
#ifdef Gd_ARME_BANANE
GcGrenadeGeneric *GcGrenadeGeneric::GfBanane( CBasePlayer *pGvPlayer, Vector vecStart, Vector vecVelocity, float GvTempsExplose_f, int GvDommage_i )
{
	GcGrenadeGeneric *pGvGrenade = GetClassPtr(( GcGrenadeGeneric * )NULL );

	pGvGrenade->pev->classname = MAKE_STRING( "banane" );
	pGvGrenade->Spawn( );

	pGvGrenade->pGvPlayer = pGvPlayer;
	if( pGvGrenade->pGvPlayer )
		pGvGrenade->pev->owner = ENT( pGvPlayer->pev );

	UTIL_SetOrigin( pGvGrenade->pev, vecStart );
	pGvGrenade->pev->velocity = vecVelocity;
	pGvGrenade->pev->angles = UTIL_VecToAngles( pGvGrenade->pev->velocity );
	
	pGvGrenade->SetTouch( GfBananeRebond );

	pGvGrenade->pev->dmgtime = gpGlobals->time + GvTempsExplose_f;
	pGvGrenade->SetThink( GfBananeChute );
	pGvGrenade->pev->nextthink = gpGlobals->time + 0.1;

	if( GvTempsExplose_f < 0.1 )
	{
		pGvGrenade->pev->nextthink = gpGlobals->time;
		pGvGrenade->pev->velocity = Vector( 0, 0, 0 );
	}
		
	pGvGrenade->pev->sequence = 0;
	pGvGrenade->pev->framerate = 1.0;
	pGvGrenade->pev->gravity = Gm_BANANE_GRAVITE;
	pGvGrenade->pev->friction = Gm_BANANE_REBOND;
	pGvGrenade->pev->avelocity.x = -40;

	SET_MODEL( ENT( pGvGrenade->pev ), Gm_BANANE_FICHIER_MODEL_R );
	pGvGrenade->pev->dmg = GvDommage_i;

	return pGvGrenade;
}
#endif

/***************************************\
* Groove - 09112001 - Banane fragement	*
\***************************************/

GcGrenadeGeneric *GcGrenadeGeneric::GfBananeFrag( CBasePlayer *pGvPlayer, Vector vecStart, Vector vecVelocity, int GvDommage_i )
{
	GcGrenadeGeneric *pGvGrenade = GetClassPtr(( GcGrenadeGeneric *)NULL );

	pGvGrenade->pev->classname = MAKE_STRING("banane_frag");
	pGvGrenade->Spawn( );

	pGvGrenade->pGvPlayer = pGvPlayer;
	if( pGvGrenade->pGvPlayer )
		pGvGrenade->pev->owner = ENT( pGvPlayer->pev );

	UTIL_SetOrigin( pGvGrenade->pev, vecStart );
	pGvGrenade->pev->velocity = vecVelocity;
	pGvGrenade->pev->angles = UTIL_VecToAngles( pGvGrenade->pev->velocity );
	
	pGvGrenade->pev->nextthink = gpGlobals->time;
	
	pGvGrenade->pev->gravity = Gm_BANANE_GRAVITE;
	pGvGrenade->pev->avelocity.x = RANDOM_FLOAT ( -100, -500 );
	
	pGvGrenade->SetThink( GfCommunChute );
	pGvGrenade->pev->nextthink = gpGlobals->time + 0.1;
	pGvGrenade->SetTouch( GfGeneralDetonationTouch );

	pGvGrenade->pev->dmg = Gm_BANANE_DOMMAGE;
	
	SET_MODEL( ENT( pGvGrenade->pev ), Gm_BANANE_FICHIER_MODEL_R );
	return pGvGrenade;
}

/***************************************\
* Groove - 09112001 - Molotov			*
\***************************************/
#ifdef Gd_ARME_MOLOTOV
GcGrenadeGeneric *GcGrenadeGeneric::GfMolotov( CBasePlayer *pGvPlayer, Vector vecStart, Vector vecVelocity, int GvDommage_i )
{
	GcGrenadeGeneric *pGvGrenade = GetClassPtr(( GcGrenadeGeneric* )NULL );

	pGvGrenade->pev->classname = MAKE_STRING( "molotov" );
	pGvGrenade->Spawn( );

	pGvGrenade->pGvPlayer = pGvPlayer;
	if( pGvGrenade->pGvPlayer )
		pGvGrenade->pev->owner = ENT( pGvPlayer->pev );

	UTIL_SetOrigin( pGvGrenade->pev, vecStart );
	pGvGrenade->pev->velocity = vecVelocity;
	pGvGrenade->pev->angles = UTIL_VecToAngles( pGvGrenade->pev->velocity );
	
	pGvGrenade->pev->gravity = Gm_MOLOTOV_GRAVITE;
	pGvGrenade->pev->avelocity.x = RANDOM_FLOAT ( -100, -500 );
	
	pGvGrenade->SetThink( GfCommunChute );
	pGvGrenade->pev->nextthink = gpGlobals->time + 0.1;
	pGvGrenade->SetTouch( GfMolotovDetonationTouch );

	pGvGrenade->pev->dmg = GvDommage_i;
	SET_MODEL( ENT( pGvGrenade->pev ), Gm_MOLOTOV_FICHIER_MODEL_W );

	return pGvGrenade;
}
#endif

/***************************************\
* Groove - 18122001 - Mine				*
\***************************************/
#ifdef Gd_ARME_MINE
GcGrenadeGeneric * GcGrenadeGeneric::GfMine( CBasePlayer *pGvPlayer, Vector GvOrigin_c, Vector GvAngle_c, float GvTempsDeclanche_f, int GvDommage_i )
{
	GcGrenadeGeneric *pGvGrenade = GetClassPtr(( GcGrenadeGeneric *)NULL );

	pGvGrenade->pev->classname = MAKE_STRING( "mine" );
	pGvGrenade->Spawn( );

	pGvGrenade->pGvPlayer = pGvPlayer;
	if( pGvGrenade->pGvPlayer )
		pGvGrenade->pev->owner = ENT( pGvPlayer->pev );

	UTIL_SetOrigin( pGvGrenade->pev, GvOrigin_c );
	pGvGrenade->pev->velocity = Vector( 0,0,-256 );
	pGvGrenade->pev->angles = GvAngle_c;

	pGvGrenade->pev->sequence = 0;
	pGvGrenade->pev->framerate = 1.0;
	pGvGrenade->pev->movetype = MOVETYPE_TOSS;
	pGvGrenade->pev->gravity = Gm_MINE_GRAVITE;
	pGvGrenade->pev->friction = Gm_MINE_REBOND;

	pGvGrenade->GvTempsAmorce = gpGlobals->time + GvTempsDeclanche_f;
	pGvGrenade->GvTempsReactive = 0;
	pGvGrenade->pev->dmgtime = 0;
	pGvGrenade->pev->nextthink = gpGlobals->time + 0.1;
	pGvGrenade->SetThink( GfMineChute );

	SET_MODEL( ENT( pGvGrenade->pev ), Gm_MINE_FICHIER_MODEL_W );
	pGvGrenade->pev->dmg = GvDommage_i;

	return pGvGrenade;
}
#endif
/***************************************\
* Groove - 09112001 - Dynamite			*
\***************************************/
#ifdef Gd_ARME_DYNAMITE
GcGrenadeGeneric * GcGrenadeGeneric::GfDynamite( CBasePlayer *pGvPlayer, Vector vecStart, Vector vecVelocity, float GvTempsExplose_f, int GvDommage_i )
{
	GcGrenadeGeneric *pGvGrenade = GetClassPtr( (GcGrenadeGeneric *)NULL );

	pGvGrenade->pev->classname = MAKE_STRING( "dynamite" );
	pGvGrenade->Spawn();
	
	pGvGrenade->pGvPlayer = pGvPlayer;
	if( pGvGrenade->pGvPlayer )
		pGvGrenade->pev->owner = ENT( pGvPlayer->pev );

	UTIL_SetOrigin( pGvGrenade->pev, vecStart );
	pGvGrenade->pev->velocity = Vector( 0,0,-256 );
	pGvGrenade->pev->angles = UTIL_VecToAngles( pGvGrenade->pev->velocity );

	pGvGrenade->pev->sequence = 0;
	pGvGrenade->pev->framerate = 1.0;
	pGvGrenade->pev->gravity = Gm_DYNAMITE_GRAVITE;
	pGvGrenade->pev->movetype = MOVETYPE_TOSS;
	pGvGrenade->pev->friction = Gm_DYNAMITE_REBOND;

	pGvGrenade->pev->dmgtime = gpGlobals->time + GvTempsExplose_f;
	pGvGrenade->SetThink( GfDynamiteChute );
	pGvGrenade->pev->nextthink = gpGlobals->time + 0.1;

	if( GvTempsExplose_f < 0.1 )
	{
		pGvGrenade->pev->nextthink = gpGlobals->time;
		pGvGrenade->pev->velocity = Vector( 0, 0, 0 );
	}

	SET_MODEL( ENT( pGvGrenade->pev ), Gm_DYNAMITE_FICHIER_MODEL_W );
	pGvGrenade->pev->dmg = GvDommage_i;

	return pGvGrenade;
}
#endif

/***************************************\
* Groove - 09112001 - Goute d'essence	*
\***************************************/
GcGrenadeGeneric *GcGrenadeGeneric::GfEssence( CBasePlayer *pGvPlayer, Vector vecStart, Vector vecVelocity, int GvDommage_i )
{
	GcGrenadeGeneric *pGvGrenade = GetClassPtr(( GcGrenadeGeneric* )NULL );

	pGvGrenade->pev->solid = SOLID_NOT;
	UTIL_SetSize( pGvGrenade->pev, Vector(0,0,0), Vector(0,0,0));
	
	pGvGrenade->pGvPlayer = pGvPlayer;
	if( pGvGrenade->pGvPlayer )
		pGvGrenade->pev->owner = ENT( pGvPlayer->pev );

	pGvGrenade->pev->classname = MAKE_STRING("essence");
	pGvGrenade->Spawn( );
	
	UTIL_SetOrigin( pGvGrenade->pev, vecStart );
	pGvGrenade->pev->velocity = vecVelocity;
	pGvGrenade->pev->angles = UTIL_VecToAngles( pGvGrenade->pev->velocity );

	pGvGrenade->pev->gravity = Gm_CLUSTER_GRAVITE_FRAGMENT;
	pGvGrenade->pev->avelocity.x = RANDOM_FLOAT ( -500, 500 );
	pGvGrenade->pev->avelocity.x = RANDOM_FLOAT ( -500, 500 );
	
	pGvGrenade->SetThink( GfCommunChute );
	pGvGrenade->pev->nextthink = gpGlobals->time + 0.1;
	pGvGrenade->SetTouch( GfEssenceDetonationTouch );
	pGvGrenade->pev->dmg = GvDommage_i;
	
	SET_MODEL( ENT( pGvGrenade->pev ), Gm_CLUSTER_FICHIER_MODEL_R );
	return pGvGrenade;
}

/***************************************\
* Groove - 09112001 - Sapin				*
\***************************************/
GcGrenadeGeneric *GcGrenadeGeneric::GfSapinFrag( CBasePlayer *pGvPlayer, Vector vecStart, Vector vecVelocity, int iGvDommage )
{
	GcGrenadeGeneric *pGvGrenade = GetClassPtr(( GcGrenadeGeneric *)NULL );

	pGvGrenade->pev->classname = MAKE_STRING( "boule" );
	pGvGrenade->Spawn( );

	pGvGrenade->pGvPlayer = pGvPlayer;
	if( pGvGrenade->pGvPlayer )
		pGvGrenade->pev->owner = ENT( pGvPlayer->pev );

	UTIL_SetOrigin( pGvGrenade->pev, vecStart );
	pGvGrenade->pev->velocity = vecVelocity;
	pGvGrenade->pev->angles = UTIL_VecToAngles( pGvGrenade->pev->velocity );
	
	pGvGrenade->pev->gravity = 0.5;
	pGvGrenade->pev->avelocity = Vector( RANDOM_FLOAT ( -256, 256 ),RANDOM_FLOAT ( -256, 256 ),RANDOM_FLOAT ( -256, 256 ));
	
	pGvGrenade->SetThink( GfCommunChute );
	pGvGrenade->pev->nextthink = gpGlobals->time + 0.1;
	pGvGrenade->SetTouch( GfGeneralDetonationTouch );
	pGvGrenade->pev->dmg = Gm_SAPIN_DOMMAGE;
	
	SET_MODEL( ENT( pGvGrenade->pev ), Gm_SAPIN_BOULE );
	return pGvGrenade;
}
