/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	generic_grenade.h			*
*		22032002				*
\*******************************/

#ifndef GENERIC_GRENADE_H
#define GENERIC_GRENADE_H

class CBasePlayerWeapon;

class GcGrenadeGeneric : public CBaseMonster
{
public:
	void Spawn( void );

	static GcGrenadeGeneric *GfGrenade( CBasePlayer *pGvPlayer, Vector GvOrigin, Vector GvVelocity, float fGvTempsExplose, int iGvDommage );
	static GcGrenadeGeneric *GfCluster( CBasePlayer *pGvPlayer, Vector GvOrigin, Vector GvVelocity, float fGvTempsExplose, int iGvDommage );
	static GcGrenadeGeneric *GfClusterFrag( CBasePlayer *pGvPlayer, Vector GvOrigin, Vector GvVelocity, int iGvDommage );
	static GcGrenadeGeneric *GfSainte( CBasePlayer *pGvPlayer, Vector GvOrigin, Vector GvVelocity, float fGvTempsExplose, int iGvDommage );
	static GcGrenadeGeneric *GfBanane( CBasePlayer *pGvPlayer, Vector GvOrigin, Vector GvVelocity, float fGvTempsExplose, int iGvDommage );
	static GcGrenadeGeneric *GfBananeFrag( CBasePlayer *pGvPlayer, Vector GvOrigin, Vector GvVelocity, int iGvDommage );
	static GcGrenadeGeneric *GfMolotov( CBasePlayer *pGvPlayer, Vector GvOrigin, Vector GvVelocity, int iGvDommage );
	static GcGrenadeGeneric *GfDynamite( CBasePlayer *pGvPlayer, Vector GvOrigin, Vector GvVelocity, float fGvTempsExplose, int iGvDommage );
	static GcGrenadeGeneric *GfMine( CBasePlayer *pGvPlayer, Vector GvOrigin, Vector GvVelocity, float fGvTempsAmorce, int iGvDommage );
	static GcGrenadeGeneric *GfEssence( CBasePlayer *pGvPlayer, Vector GvOrigin, Vector GvVelocity, int iGvDommage );
	static GcGrenadeGeneric *GfSapinFrag( CBasePlayer *pGvPlayer, Vector GvOrigin, Vector GvVelocity, int iGvDommage );

	void EXPORT GfCommunDetonation( void );
	void EXPORT GfClusterDetonation( void );
	void EXPORT GfBananeDetonation( void );

	void EXPORT GfGeneralDetonationTouch( CBaseEntity *pOther );
	void EXPORT GfMortierDetonationTouch( CBaseEntity *pOther );
	void EXPORT GfMolotovDetonationTouch( CBaseEntity *pOther );
	void EXPORT GfEssenceDetonationTouch( CBaseEntity *pOther );

	bool GfTouchEau( void );

	void EXPORT GfMoutonDetonationUse( CBaseEntity *pActivator, CBaseEntity *pCaller, USE_TYPE useType, float value );

	void GfCommunExplosion( TraceResult *pTrace, int bitsDamageType );

	void EXPORT GfCommunChute( void );
	void EXPORT GfGeneralChute( void );
	void EXPORT GfClusterChute( void );
	void EXPORT GfBananeChute( void );
	void EXPORT GfMineChute( void );
	void EXPORT GfDynamiteChute( void );
	void EXPORT GfSainteChute( void );

	void GfGeneralRebondSon( void );
	void GfBananeRebondSon( void );
	void GfSainteRebondSon( void );

	void EXPORT GfGeneralRebond( CBaseEntity *pOther );
	void EXPORT GfBananeRebond( CBaseEntity *pOther );
	void EXPORT GfSainteRebond( CBaseEntity *pOther );

	void GfEject( void );
	void GfDetruitCaisse( CBaseEntity *pEntity );

	float GvTempsAmorce;
	float GvTempsReactive;

	bool GvSainteSon;

	CBasePlayer *pGvPlayer;

private:
	CBaseEntity *m_pEntity;
};

#endif //GENERIC_GRENADE_H
