/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	item_bananier				*	
*		06062002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "monsters.h"
#include "player.h"
#include "fx_explode.h"
#include "fx_sprite.h"
#include "generic_flamme.h"
#include "arme_banane.h"
#include "gamerules.h"
#include "items.h"
#include "item_bananier.h"

LINK_ENTITY_TO_CLASS( info_bananier, GcItemBananier );

void GcItemBananier::Spawn( void )
{ 
	Precache( );
	SET_MODEL( ENT( pev ), Gm_BANANIER_MODEL );
	pev->gravity = 0.75;
	GvNiveauVie_i = Gm_CAISSE_HEALTH;
	CItem::Spawn( );
//	pev->classname = MAKE_STRING( "baril" );
	pev->solid = SOLID_BBOX;
	UTIL_SetSize( pev, Vector( -24,-24,0 ), Vector( 24,24,128 ));
	pev->takedamage = DAMAGE_NO;
	pev->friction = 0.5;
	pev->scale = 1.0;
	pev->movetype = MOVETYPE_TOSS;
	pev->sequence = Ga_BANANIER_GRANDI_1;
	pev->nextthink = gpGlobals->time + 0.1;
	SetThink( GfBananeEject );
}

void GcItemBananier::Precache( void )
{ 
	PRECACHE_MODEL ( Gm_BANANIER_MODEL );
}

void GcItemBananier::GfBananeEject( void )
{
	CBaseEntity *pGvEntity = NULL;
	short iGvItemNb = 0;

	if( pev->frame < 255 && pev->sequence == Ga_BANANIER_GRANDI_1 )
	{
		pev->frame = ((int)pev->frame + 1 );// % 255;
		if( pev->frame >= 255 )
		{
			pev->frame = 1;
			pev->sequence = Ga_BANANIER_IDLE_1;
		}
		pev->nextthink = gpGlobals->time + 0.1;
	}
	
	if( pev->sequence == Ga_BANANIER_IDLE_1 )
	{
		pev->frame = ((int)pev->frame + 2 ) % 255;
		pev->nextthink = gpGlobals->time + 0.02;
	}

	if( pev->waterlevel > 2 )
	{
		ExplosionCreate( Center( ), pev->angles, edict( ), Gm_BANANIER_DOMMAGE, TRUE );
		UTIL_Remove( this );
	}

	if( GvNiveauVie_i != Gm_CAISSE_HEALTH )
	{
		GvNiveauVie_i = Gm_CAISSE_HEALTH;
		GcGrenadeGeneric::GfBananeFrag( NULL, pev->origin + Vector( 0, 0, 160 ), Gm_RANDOM_VECTOR( Gm_BANANE_PRECISION, Gm_BANANE_HAUTEUR_MINI, Gm_BANANE_HAUTEUR_MAX ), Gm_BANANE_DOMMAGE );
	}

	while(( pGvEntity = UTIL_FindEntityInSphere( pGvEntity, pev->origin, 32 )) != NULL )
	{
		if(( FClassnameIs( pGvEntity->pev, "item_caisse_arme" ))
			||( FClassnameIs( pGvEntity->pev, "item_caisse_outil" ))
			||( FClassnameIs( pGvEntity->pev, "item_caisse_vie" ))
			||( FClassnameIs( pGvEntity->pev, "item_caisse_mega" )))
			iGvItemNb++;
		if( iGvItemNb )
			UTIL_Remove( pGvEntity );
			break;
	}
}