/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	item_baril.cpp				*
*		31012002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "monsters.h"
#include "player.h"
#include "fx_explode.h"
#include "fx_sprite.h"
#include "generic_flamme.h"
#include "gamerules.h"
#include "items.h"
#include "item_baril.h"

LINK_ENTITY_TO_CLASS( item_baril, GcItemBaril );

void GcItemBaril::Spawn( void )
{ 
	Precache( );
	SET_MODEL( ENT( pev ), Gm_BARIL_MODEL );
	pev->gravity = 0.75;
	GvNiveauVie_i = Gm_CAISSE_HEALTH;
	CItem::Spawn( );
//	pev->classname = MAKE_STRING( "baril" );
	pev->solid = SOLID_BBOX;
	UTIL_SetSize( pev, Vector( -24,-24,0 ), Vector( 24,24,48 ));
	pev->takedamage = DAMAGE_NO;
	pev->friction = 0.5;
	pev->movetype = MOVETYPE_BOUNCE;
	pev->sequence = 0;
	pev->nextthink = gpGlobals->time + 0.025;
	SetThink( GfDestruction );
}

void GcItemBaril::Precache( void )
{ 
	PRECACHE_MODEL ( Gm_BARIL_MODEL );
}

void GcItemBaril::GfDestruction( void )
{
	CBaseEntity *pGvEntity = NULL;
	short iGvItemNb = 0;

	pev->frame = ((int)pev->frame + 10 ) % 255;
	pev->nextthink = gpGlobals->time + 0.025;

	if( pev->waterlevel > 2 )
	{
		ExplosionCreate( Center( ), pev->angles, edict( ), Gm_BARIL_DOMMAGE, TRUE );
		UTIL_Remove( this );
	}

	if( GvNiveauVie_i <= 0 )
	{
		ExplosionCreate( Center( ), pev->angles, edict( ), Gm_BARIL_DOMMAGE, TRUE );

		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector(   0,  0, 20 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector(  20, 20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector(  20,-20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector( -20, 20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector( -20,-20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );

		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector(   0,  0, 10 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector(  10, 10,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector(  10,-10,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector( -10, 10,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector( -10,-10,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );

		UTIL_Remove( this );
	}

	while(( pGvEntity = UTIL_FindEntityInSphere( pGvEntity, pev->origin, 32 )) != NULL )
	{
		if(( FClassnameIs( pGvEntity->pev, "item_caisse_arme" ))
			||( FClassnameIs( pGvEntity->pev, "item_caisse_outil" ))
			||( FClassnameIs( pGvEntity->pev, "item_caisse_vie" ))
			||( FClassnameIs( pGvEntity->pev, "item_caisse_mega" )))
			iGvItemNb++;
		if( iGvItemNb )
			UTIL_Remove( pGvEntity );
			break;
	}
}
