/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	item_caisse_arme.cpp		*
*		19022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "fx_explode.h"
#include "fx_sprite.h"
#include "generic_flamme.h"
#include "game.h"
#include "items.h"
#include "item_caisse_arme.h"
#include "define_slot.h"

void GcItemCaisseArmes::Spawn( void )
{ 
	Precache( );
	SET_MODEL( ENT( pev ), Gm_CAISSE_ARME_MODEL );
	pev->gravity = 0.75;
	GvNiveauVie_i = Gm_CAISSE_HEALTH;
	CItem::Spawn( );
	UTIL_SetSize( pev, Vector( -16,-16,0 ), Vector( 16,16,32 ));
	pev->takedamage = DAMAGE_NO;
	pev->nextthink = gpGlobals->time + 0.25;
	SetThink( GfDestruction );
}

void GcItemCaisseArmes::GfDestruction( void )
{
/*	CBaseEntity *pGvEntity = NULL;
	short iGvItemNb = 0;
	
	while(( pGvEntity = UTIL_FindEntityInSphere( pGvEntity, pev->origin, 32 )) != NULL )
	{
		if(( FClassnameIs( pGvEntity->pev, "item_caisse_arme" ))
			||( FClassnameIs( pGvEntity->pev, "item_caisse_outil" ))
			||( FClassnameIs( pGvEntity->pev, "item_caisse_vie" ))
			||( FClassnameIs( pGvEntity->pev, "item_caisse_mega" ))
			||( FClassnameIs( pGvEntity->pev, "item_baril" ))
			||( FClassnameIs( pGvEntity->pev, "item_baril_rouge" ))
			||( FClassnameIs( pGvEntity->pev, "item_baril_bleu" ))
			||( FClassnameIs( pGvEntity->pev, "info_bananier" ))
			||( FClassnameIs( pGvEntity->pev, "info_sapin" )))
			iGvItemNb++;
		if( iGvItemNb )
			break;
	}
*/

	if( pev->waterlevel > 2 )
	{
		ExplosionCreate( Center( ), pev->angles, edict( ), Gm_CAISSE_DEGAT, TRUE );
		UTIL_Remove( this );
	}

	// Groove - 23042002 - Supprieur a 1 car self compris
	if( GvNiveauVie_i <= 0 )//|| iGvItemNb > 1 )
	{
		ExplosionCreate( Center( ), pev->angles, edict( ), Gm_CAISSE_DEGAT, TRUE );

		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector(  20, 20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector(  20,-20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector( -20, 20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector( -20,-20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );

		UTIL_Remove( this );
	}

	pev->nextthink = gpGlobals->time + 0.25;
}

void GcItemCaisseArmes::Precache( void ) 
{ 
	PRECACHE_MODEL ( Gm_CAISSE_ARME_MODEL );
	PRECACHE_SOUND ( Gf_SOUND_JEU_CAISSE_ARME_01 );
}

BOOL GcItemCaisseArmes::MyTouch( CBasePlayer *pPlayer )
{
	int iGvArmeID = -1;

	AffichageHUD( Gm_ITEM_CAISSE_ARME, pPlayer );
	GfTouchPlayerEffect( pPlayer, false );
	pPlayer->sGvProfil.iGvCaissesNb++;

	switch( RANDOM_LONG( 1,28 ))
	{
		default:
		case 1 : 
			if( bGvAirAttack )
				pPlayer->GiveNamedItem( "weapon_air_strike" ); iGvArmeID = Gm_AIR_STRIKE_ID; 
			break;
		case 2 : pPlayer->GiveNamedItem( "weapon_banane" ); iGvArmeID = Gm_BANANE_ID; break;
		case 3 : pPlayer->GiveNamedItem( "weapon_batte" ); iGvArmeID = Gm_BATTE_ID; break;
		case 4 : pPlayer->GiveNamedItem( "weapon_bazooka" ); iGvArmeID = Gm_BAZOOKA_ID; break;
		case 5 : pPlayer->GiveNamedItem( "weapon_cluster" ); iGvArmeID = Gm_CLUSTER_ID; break;
		case 6 : pPlayer->GiveNamedItem( "weapon_croix" ); iGvArmeID = Gm_CROIX_ID; break;
		case 7 : pPlayer->GiveNamedItem( "weapon_dynamite" ); iGvArmeID = Gm_DYNAMITE_ID; break;
		case 8 : pPlayer->GiveNamedItem( "weapon_fusil" ); iGvArmeID = Gm_FUSIL_ID; break;
		case 9 : pPlayer->GiveNamedItem( "weapon_grappin" ); iGvArmeID = Gm_GRAPPIN_ID; break;
		case 10: pPlayer->GiveNamedItem( "weapon_grenade" ); iGvArmeID = Gm_GRENADE_ID; break;
		case 11: pPlayer->GiveNamedItem( "weapon_hache" ); iGvArmeID = Gm_HACHE_ID; break;
		case 12: pPlayer->GiveNamedItem( "weapon_jetpack" ); iGvArmeID = Gm_JETPACK_ID; break;
		case 13: pPlayer->GiveNamedItem( "weapon_kameha" ); iGvArmeID = Gm_KAMEHA_ID; break;
		case 14: pPlayer->GiveNamedItem( "weapon_kamikaze" ); iGvArmeID = Gm_KAMIKAZE_ID; break;
		case 15: pPlayer->GiveNamedItem( "weapon_mine" ); iGvArmeID = Gm_MINE_ID; break;
		case 16: pPlayer->GiveNamedItem( "weapon_minicanon" ); iGvArmeID = Gm_MINICANON_ID; break;
		case 17: pPlayer->GiveNamedItem( "weapon_molotov" ); iGvArmeID = Gm_MOLOTOV_ID; break;
		case 18: pPlayer->GiveNamedItem( "weapon_mortier" ); iGvArmeID = Gm_MORTIER_ID; break;
		case 19: pPlayer->GiveNamedItem( "weapon_morve" ); iGvArmeID = Gm_MORVE_ID; break;
		case 20: pPlayer->GiveNamedItem( "weapon_mouton" ); iGvArmeID = Gm_MOUTON_ID; break;
		case 21: 
			if( bGvAirAttack )
				pPlayer->GiveNamedItem( "weapon_napalm" ); iGvArmeID = Gm_NAPALM_ID; 
			break;
		case 22: pPlayer->GiveNamedItem( "weapon_pigeon" ); iGvArmeID = Gm_PIGEON_ID; break;
		case 23: pPlayer->GiveNamedItem( "weapon_pheonix" ); iGvArmeID = Gm_PHEONIX_ID; break;
		case 24: pPlayer->GiveNamedItem( "weapon_sainte" ); iGvArmeID = Gm_SAINTE_ID; break;
		case 25: pPlayer->GiveNamedItem( "weapon_snipe" ); iGvArmeID = Gm_SNIPE_ID; break;
		case 26: pPlayer->GiveNamedItem( "weapon_super_mouton" ); iGvArmeID = Gm_SUPER_MOUTON_ID; break;
		case 27: pPlayer->GiveNamedItem( "weapon_teleporteur" ); iGvArmeID = Gm_TELEPORTEUR_ID; break;
		case 28: pPlayer->GiveNamedItem( "weapon_trident" ); iGvArmeID = Gm_TRIDENT_ID; break;
	}

	if( iGvArmeID >= 0 )
	{
		MESSAGE_BEGIN( MSG_ONE, gmsgWeapPickup, NULL, pPlayer->pev );
			WRITE_BYTE( iGvArmeID );
		MESSAGE_END( );
	}

	EMIT_SOUND( ENT( pPlayer->pev ), CHAN_ITEM, Gf_SOUND_JEU_CAISSE_ARME_01 , 0.8, ATTN_NORM );

	return TRUE;
}
