/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	item_caisse_mega.cpp		*
*		19022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "fx_explode.h"
#include "fx_sprite.h"
#include "define_slot.h"
#include "generic_balle.h"
#include "generic_flamme.h"
#include "gamerules.h"
#include "game.h"
#include "items.h"
#include "item_caisse_mega.h"

void GcItemCaisseMega::Spawn( void )
{ 
	Precache( );
	SET_MODEL( ENT( pev ), Gm_CAISSE_MEGA_MODEL );
	pev->gravity = 0.8;
	GvNiveauVie_i = Gm_CAISSE_HEALTH;
	CItem::Spawn( );
	UTIL_SetSize( pev, Vector( -16,-16,0 ), Vector( 16,16,32 ));
	pev->takedamage = DAMAGE_NO;
	pev->nextthink = gpGlobals->time + 0.25;
	SetThink( GfDestruction );
}

void GcItemCaisseMega::GfDestruction( void )
{
/*	CBaseEntity *pGvEntity = NULL;
	short iGvItemNb = 0;
	
	while(( pGvEntity = UTIL_FindEntityInSphere( pGvEntity, pev->origin, 32 )) != NULL )
	{
		if(( FClassnameIs( pGvEntity->pev, "item_caisse_arme" ))
			||( FClassnameIs( pGvEntity->pev, "item_caisse_outil" ))
			||( FClassnameIs( pGvEntity->pev, "item_caisse_vie" ))
			||( FClassnameIs( pGvEntity->pev, "item_caisse_mega" ))
			||( FClassnameIs( pGvEntity->pev, "item_baril_rouge" ))
			||( FClassnameIs( pGvEntity->pev, "item_baril_bleu" ))
			||( FClassnameIs( pGvEntity->pev, "item_baril" ))
			||( FClassnameIs( pGvEntity->pev, "info_bananier" ))
			||( FClassnameIs( pGvEntity->pev, "info_sapin" )))
			iGvItemNb++;
		if( iGvItemNb )
			break;
	}*/

	if( pev->waterlevel > 2 )
	{
		ExplosionCreate( Center( ), pev->angles, edict( ), Gm_CAISSE_DEGAT, TRUE );
		UTIL_Remove( this );
	}
	
	// Groove - 23042002 - Supprieur a 1 car self compris
	if( GvNiveauVie_i <= 0 )//|| iGvItemNb > 1 )
	{
		ExplosionCreate( Center( ), pev->angles, edict( ), Gm_CAISSE_DEGAT, TRUE );

//		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector(   0,  0, 20 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector(  20, 20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector(  20,-20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector( -20, 20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector( -20,-20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );

		UTIL_Remove( this );
	}

	pev->nextthink = gpGlobals->time + 0.25;
}

void GcItemCaisseMega::Precache( void ) 
{ 
	PRECACHE_MODEL ( Gm_CAISSE_MEGA_MODEL );
	PRECACHE_SOUND ( Gf_SOUND_JEU_CAISSE_MEGA_01 );
}

BOOL GcItemCaisseMega::MyTouch( CBasePlayer *pPlayer )
{
	AffichageHUD( Gm_ITEM_CAISSE_MEGA, pPlayer );
	GfTouchPlayerEffect( pPlayer, false );
	pPlayer->sGvProfil.iGvCaissesNb++;

	short GvMsgHUD = 0;

	switch( RANDOM_LONG( 0,24 ))
	{
		case 0 :
		case 1 :
		case 2 :
		case 3 :
		case 4 :
			g_pGameRules->GfEntitySpawn_i( Gm_ENTITY_BARIL );
			GvMsgHUD = Gm_MSG_CAISSE_MEGA_BARIL_1;
			break;
		case 5 :
		case 6 :
		case 7 :
			g_pGameRules->GfEntitySpawn_i( Gm_ENTITY_BARIL );
			g_pGameRules->GfEntitySpawn_i( Gm_ENTITY_BARIL );
			g_pGameRules->GfEntitySpawn_i( Gm_ENTITY_BARIL );
			GvMsgHUD = Gm_MSG_CAISSE_MEGA_BARIL_3;
			break;
		case 8 :
			g_pGameRules->GfEntitySpawn_i( Gm_ENTITY_BARIL );
			g_pGameRules->GfEntitySpawn_i( Gm_ENTITY_BARIL );
			g_pGameRules->GfEntitySpawn_i( Gm_ENTITY_BARIL );
			g_pGameRules->GfEntitySpawn_i( Gm_ENTITY_BARIL );
			g_pGameRules->GfEntitySpawn_i( Gm_ENTITY_BARIL );
			GvMsgHUD = Gm_MSG_CAISSE_MEGA_BARIL_5;
			break;
		case 9 :
		case 10 :
		case 11 :
		case 12 :
		case 13 :
			g_pGameRules->GfEntitySpawn_i( Gm_ENTITY_MINE );
			GvMsgHUD = Gm_MSG_CAISSE_MEGA_MINE_1;
			break;
		case 14 :
		case 15 :
		case 16 :
			g_pGameRules->GfEntitySpawn_i( Gm_ENTITY_MINE );
			g_pGameRules->GfEntitySpawn_i( Gm_ENTITY_MINE );
			g_pGameRules->GfEntitySpawn_i( Gm_ENTITY_MINE );
			GvMsgHUD = Gm_MSG_CAISSE_MEGA_MINE_3;
			break;
		case 17 :
			g_pGameRules->GfEntitySpawn_i( Gm_ENTITY_MINE );
			g_pGameRules->GfEntitySpawn_i( Gm_ENTITY_MINE );
			g_pGameRules->GfEntitySpawn_i( Gm_ENTITY_MINE );
			g_pGameRules->GfEntitySpawn_i( Gm_ENTITY_MINE );
			g_pGameRules->GfEntitySpawn_i( Gm_ENTITY_MINE );
			GvMsgHUD = Gm_MSG_CAISSE_MEGA_MINE_5;
			break;
		case 18 :
		case 19 :
			GfBonusDivin( pPlayer );
			GvMsgHUD = Gm_MSG_CAISSE_MEGA_BENEDICTION;
			break;
		case 20 :
			GfBonusTeamDivin( );
			GvMsgHUD = Gm_MSG_CAISSE_MEGA_BENEDICTION_TEAM;
			break;
		case 21 :
		case 22 :
			GfMalusMortSubite( pPlayer );
			GvMsgHUD = Gm_MSG_CAISSE_MEGA_MORT_SUBITE;
			break;
		case 23 :
			GfMalusTeamMortSubite( );
			GvMsgHUD = Gm_MSG_CAISSE_MEGA_MORT_SUBITE_TEAM;
			break;
		case 24 :
			GvMsgHUD = Gm_MSG_CAISSE_MEGA_COMETTE;
			pPlayer->sGvProfil.iGvApocalipse++;
			GfComette( pPlayer );
	}
	
	MESSAGE_BEGIN( MSG_ALL, gmsgBarreMsg );
		WRITE_BYTE( GvMsgHUD );
	MESSAGE_END( );

	EMIT_SOUND( ENT( pPlayer->pev ), CHAN_ITEM, Gf_SOUND_JEU_CAISSE_MEGA_01 , 0.8, ATTN_NORM );

	return TRUE;
}

// Groove - 24042002 - Apocalipse now.
void GcItemCaisseMega::GfComette( CBasePlayer *pPlayer )
{
	short GvTraineCouleur_18i[3][6] = 
	{
		{  64,  96, 255, 255, 255, 255 },// Life, Width, r, v, b, brightness
		{  96, 128, 128, 128, 255,  96 },// Life, Width, r, v, b, brightness
		{ 128, 255,   0,   0, 255,  32 } // Life, Width, r, v, b, brightness
	};

	int GvBalleOption_i = Gm_BALLE_SON | Gm_BALLE_BRIANTE | Gm_BALLE_EJECT | Gm_BALLE_EXPLOSE | Gm_BALLE_SCALE_PLUS;

	GcGenericBalle::GfCreateBalle( pPlayer->pev->origin + Vector( 0,0, 2000 ),
								   Vector( 0,0,0 ), 
								   0, 
								   0,
								   1500, 
								   0,					// Groove - 18032002 - Dure de vie de la balle si option active.
								   GvTraineCouleur_18i,
								   0,					// Groove - 18032002 - Nombre de trainees
								   GvBalleOption_i,		
								   pPlayer,
								   NULL,
								   Gm_COMETTE_ID );
}

// Groove - 14032002 - Benediction divine
void GcItemCaisseMega::GfBonusDivin( CBasePlayer *pPlayer )
{
	pPlayer->pev->health = GvWormVieCMD.value;
	pPlayer->pev->gravity = ( Gm_WORM_GRAVITE / 3 );
	pPlayer->pev->maxspeed = ( Gm_WORM_VITESSE * 3 );
}

void GcItemCaisseMega::GfBonusTeamDivin( void )
{
	CBasePlayer *pPlayer = NULL;
	while((( pPlayer = ( CBasePlayer * ) UTIL_FindEntityByClassname ( pPlayer, "player" )) != NULL ) && ( !FNullEnt ( pPlayer->edict( ))))
	{	
		MESSAGE_BEGIN( MSG_ONE, gmsgBarreMsg, NULL, pPlayer->pev );
			WRITE_BYTE( Gm_MSG_CAISSE_MEGA_BENEDICTION );
		MESSAGE_END( );

		pPlayer->pev->health = GvWormVieCMD.value;
		pPlayer->pev->gravity = ( Gm_WORM_GRAVITE / 2 );
		pPlayer->pev->maxspeed = ( Gm_WORM_VITESSE * 2 );
	}
	UTIL_Remove( pPlayer );
}

void GcItemCaisseMega::GfMalusMortSubite( CBasePlayer *pPlayer )
{
	EMIT_SOUND( ENT( pPlayer->pev ), CHAN_ITEM, Gf_SOUND_JEU_GONG_01, 0.5, ATTN_STATIC );

	pPlayer->GfSentirDommange( 20, 255 );
	pPlayer->pev->health = 1;
	pPlayer->pev->gravity = ( Gm_WORM_GRAVITE * 2 );
	pPlayer->pev->maxspeed = ( Gm_WORM_VITESSE / 2 );
}

void GcItemCaisseMega::GfMalusTeamMortSubite( void )
{
	CBasePlayer *pPlayer = NULL;
	while((( pPlayer = ( CBasePlayer * ) UTIL_FindEntityByClassname ( pPlayer, "player" )) != NULL ) && ( !FNullEnt ( pPlayer->edict( ))))
	{	
		EMIT_SOUND( ENT( pPlayer->pev ), CHAN_ITEM, Gf_SOUND_JEU_GONG_01, 0.5, ATTN_STATIC );

		pPlayer->GfSentirDommange( 20, 255 );
		pPlayer->pev->health = 1;
	}
	UTIL_Remove( pPlayer );
}
