/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	item_caisse_outil.cpp		*
*		19022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "fx_explode.h"
#include "fx_sprite.h"
#include "generic_flamme.h"
#include "game.h"
#include "items.h"
#include "item_caisse_outil.h"

void GcItemCaisseOutil::Spawn( void )
{ 
	Precache( );
	SET_MODEL( ENT( pev ), Gm_CAISSE_OUTIL_MODEL );
	pev->gravity = 0.7;
	GvNiveauVie_i = Gm_CAISSE_HEALTH;
	CItem::Spawn( );
	UTIL_SetSize( pev, Vector( -16,-16,0 ), Vector( 16,16,32 ));
	pev->takedamage = DAMAGE_NO;
	pev->nextthink = gpGlobals->time + 0.25;
	SetThink( GfDestruction );
}

void GcItemCaisseOutil::GfDestruction( void )
{
/*	CBaseEntity *pGvEntity = NULL;
	short iGvItemNb = 0;
	
	while(( pGvEntity = UTIL_FindEntityInSphere( pGvEntity, pev->origin, 32 )) != NULL )
	{
		if(( FClassnameIs( pGvEntity->pev, "item_caisse_arme" ))
			||( FClassnameIs( pGvEntity->pev, "item_caisse_outil" ))
			||( FClassnameIs( pGvEntity->pev, "item_caisse_vie" ))
			||( FClassnameIs( pGvEntity->pev, "item_caisse_mega" ))
			||( FClassnameIs( pGvEntity->pev, "item_baril_rouge" ))
			||( FClassnameIs( pGvEntity->pev, "item_baril_bleu" ))
			||( FClassnameIs( pGvEntity->pev, "item_baril" ))
			||( FClassnameIs( pGvEntity->pev, "info_bananier" ))
			||( FClassnameIs( pGvEntity->pev, "info_sapin" )))
			iGvItemNb++;
		if( iGvItemNb )
			break;
	}*/
	if( pev->waterlevel > 2 )
	{
		ExplosionCreate( Center( ), pev->angles, edict( ), Gm_CAISSE_DEGAT, TRUE );
		UTIL_Remove( this );
	}

	// Groove - 23042002 - Supprieur a 1 car self compris
	if( GvNiveauVie_i <= 0 )//|| iGvItemNb > 1 )
	{
		ExplosionCreate( Center( ), pev->angles, edict( ), Gm_CAISSE_DEGAT, TRUE );

//		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector(   0,  0, 20 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector(  20, 20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector(  20,-20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector( -20, 20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector( -20,-20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );

		UTIL_Remove( this );
	}

	pev->nextthink = gpGlobals->time + 0.25;
}

void GcItemCaisseOutil::Precache( void ) 
{ 
	PRECACHE_MODEL ( Gm_CAISSE_OUTIL_MODEL );
	PRECACHE_SOUND ( Gf_SOUND_JEU_CAISSE_OUTIL_01 );
}

BOOL GcItemCaisseOutil::MyTouch( CBasePlayer *pPlayer )
{
	AffichageHUD( Gm_ITEM_CAISSE_OUTIL, pPlayer );
	GfTouchPlayerEffect( pPlayer, true );
	pPlayer->sGvProfil.iGvCaissesNb++;

	short GvMsgHUD = 0;
	
	switch( RANDOM_LONG( 1,16 ))
	{
		case 1: 
		case 2:
		case 3: 
			pPlayer->iGvPlayerOutil |= Gm_PLAYER_OUTIL_GRAVITE;
			pPlayer->pev->gravity = ( Gm_WORM_GRAVITE / 2 ); 
			GvMsgHUD = Gm_MSG_CAISSE_OUTIL_GRAVITE_1; 
			break;
		case 4: 
			pPlayer->iGvPlayerOutil |= Gm_PLAYER_OUTIL_GRAVITE_S;
			pPlayer->pev->gravity = ( Gm_WORM_GRAVITE / 3 ); 
			GvMsgHUD = Gm_MSG_CAISSE_OUTIL_GRAVITE_2; 
			break;
		case 5: 
		case 6: 
		case 7: 
			pPlayer->iGvPlayerOutil |= Gm_PLAYER_OUTIL_VITESSE;
			pPlayer->pev->maxspeed = ( Gm_WORM_VITESSE * 2 ); 
			GvMsgHUD = Gm_MSG_CAISSE_OUTIL_VITESSE_1; 
			break;
		case 8: 
			pPlayer->iGvPlayerOutil |= Gm_PLAYER_OUTIL_VITESSE_S;
			pPlayer->pev->maxspeed = ( Gm_WORM_VITESSE * 3 ); 
			GvMsgHUD = Gm_MSG_CAISSE_OUTIL_VITESSE_2; 
			break;
		case 9:
		case 10:
		case 11:
			pPlayer->iGvPlayerOutil |= Gm_PLAYER_OUTIL_VISEE;
			GvMsgHUD = Gm_MSG_CAISSE_OUTIL_LASER;
			break;
		case 12:
		case 13:
			pPlayer->iGvPlayerOutil |= Gm_PLAYER_OUTIL_INVISIBLE;
			pPlayer->pev->rendermode = kRenderTransAdd;
			pPlayer->pev->renderamt = 1;
			pPlayer->pev->renderfx = kRenderFxPulseSlow;
			GvMsgHUD = Gm_MSG_CAISSE_OUTIL_INVISIBLE;
			break;
		case 14: 
		case 15:
			pPlayer->iGvPlayerOutil |= Gm_PLAYER_OUTIL_DOMMAGE_2X;
			GvMsgHUD = Gm_MSG_CAISSE_OUTIL_DOMMAGE_2X;
			break;
		case 16:
			pPlayer->iGvPlayerOutil |= Gm_PLAYER_OUTIL_DOMMAGE_3X;
			GvMsgHUD = Gm_MSG_CAISSE_OUTIL_DOMMAGE_3X;
			break;
	}

	MESSAGE_BEGIN( MSG_ONE, gmsgBarreMsg, NULL, pPlayer->pev );
		WRITE_BYTE( GvMsgHUD );
	MESSAGE_END( );

	EMIT_SOUND( ENT( pPlayer->pev ), CHAN_ITEM, Gf_SOUND_JEU_CAISSE_OUTIL_01, 0.8, ATTN_NORM );

	return TRUE;
}
