/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	item_caisse_vie.cpp			*
*		23042002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "fx_explode.h"
#include "fx_sprite.h"
#include "generic_flamme.h"
#include "game.h"
#include "items.h"
#include "item_caisse_vie.h"

void GcItemCaisseVie::Spawn( void )
{ 
	Precache( );
	SET_MODEL( ENT( pev ), Gm_CAISSE_VIE_MODEL );
	pev->gravity = 0.6;
	GvNiveauVie_i = Gm_CAISSE_HEALTH;
	CItem::Spawn( );
	UTIL_SetSize( pev, Vector( -16,-16,0 ), Vector( 16,16,32 ));
	pev->takedamage = DAMAGE_NO;
	pev->nextthink = gpGlobals->time + 0.25;
	SetThink( GfDestruction );
}

void GcItemCaisseVie::GfDestruction( void )
{
/*	CBaseEntity *pGvEntity = NULL;
	short iGvItemNb = 0;

	while(( pGvEntity = UTIL_FindEntityInSphere( pGvEntity, pev->origin, 32 )) != NULL )
	{
		if(( FClassnameIs( pGvEntity->pev, "item_caisse_arme" ))
			||( FClassnameIs( pGvEntity->pev, "item_caisse_outil" ))
			||( FClassnameIs( pGvEntity->pev, "item_caisse_vie" ))
			||( FClassnameIs( pGvEntity->pev, "item_caisse_mega" ))
			||( FClassnameIs( pGvEntity->pev, "item_baril_rouge" ))
			||( FClassnameIs( pGvEntity->pev, "item_baril_bleu" ))
			||( FClassnameIs( pGvEntity->pev, "item_baril" ))
			||( FClassnameIs( pGvEntity->pev, "info_bananier" ))
			||( FClassnameIs( pGvEntity->pev, "info_sapin" )))
			iGvItemNb++;
		if( iGvItemNb )
			break;
	}*/
	if( pev->waterlevel > 2 )
	{
		ExplosionCreate( Center( ), pev->angles, edict( ), Gm_CAISSE_DEGAT, TRUE );
		UTIL_Remove( this );
	}

	// Groove - 23042002 - Supprieur a 1 car self compris
	if( GvNiveauVie_i <= 0 )//|| iGvItemNb > 1 )
	{
		ExplosionCreate( Center( ), pev->angles, edict( ), Gm_CAISSE_DEGAT, TRUE );

//		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector(   0,  0, 20 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector(  20, 20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector(  20,-20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector( -20, 20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );
		GcGrenadeGeneric::GfEssence( NULL, pev->origin + Vector( -20,-20,  5 ), Gm_RANDOM_VECTOR( Gm_FLAMME_PRECISION, Gm_FLAMME_HAUTEUR_MINI, Gm_FLAMME_HAUTEUR_MAX ), Gm_ESSENCE_DOMMAGE );

		UTIL_Remove( this );
	}

	pev->nextthink = gpGlobals->time + 0.25;
}

void GcItemCaisseVie::Precache( void ) 
{ 
	PRECACHE_MODEL( Gm_CAISSE_VIE_MODEL );
	PRECACHE_SOUND( Gf_SOUND_JEU_CAISSE_VIE_01 );
}

BOOL GcItemCaisseVie::MyTouch( CBasePlayer *pPlayer )
{
	short GvCombienDeVie;
	short GvMsgHUD;

	AffichageHUD( Gm_ITEM_CAISSE_VIE, pPlayer );
	GfTouchPlayerEffect( pPlayer, false );
	pPlayer->sGvProfil.iGvCaissesNb++;

	switch( RANDOM_LONG( 1,8 ))
	{
		case 1: 
		case 2:
		case 3: 
		case 4: GvCombienDeVie = 25;	GvMsgHUD = Gm_MSG_CAISSE_VIE_025 ; break;
		case 5:
		case 6: 
		case 7: GvCombienDeVie = 50;	GvMsgHUD = Gm_MSG_CAISSE_VIE_050 ; break;
		case 8: GvCombienDeVie = 100;	GvMsgHUD = Gm_MSG_CAISSE_VIE_100 ; break;
	}

	pPlayer->pev->health += GvCombienDeVie ;

	if( pPlayer->pev->health >= GvWormVieCMD.value )
		pPlayer->pev->health = GvWormVieCMD.value;

	MESSAGE_BEGIN( MSG_ONE, gmsgBarreMsg, NULL, pPlayer->pev );
		WRITE_BYTE( GvMsgHUD );
	MESSAGE_END( );

	EMIT_SOUND( ENT( pPlayer->pev ), CHAN_ITEM, Gf_SOUND_JEU_CAISSE_VIE_01 , 0.8, ATTN_NORM );

	return TRUE;
}
