/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	item_bananier				*	
*		06062002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "monsters.h"
#include "player.h"
#include "fx_explode.h"
#include "fx_sprite.h"
#include "generic_flamme.h"
#include "arme_banane.h"
#include "gamerules.h"
#include "items.h"
#include "item_sapin.h"

LINK_ENTITY_TO_CLASS( info_sapin, GcItemSapin );

void GcItemSapin::Spawn( void )
{ 
	Precache( );
	SET_MODEL( ENT( pev ), Gm_SAPIN_SAPIN );
	pev->gravity = 0.25;
	GvNiveauVie_i = Gm_CAISSE_HEALTH;
	CItem::Spawn( );
//	pev->classname = MAKE_STRING( "baril" );
	pev->solid = SOLID_BBOX;
	UTIL_SetSize( pev, Vector( -24,-24,0 ), Vector( 24,24,128 ));
	pev->takedamage = DAMAGE_NO;
	pev->friction = 0.5;
	pev->scale = 1.0;
	pev->movetype = MOVETYPE_TOSS;
	pev->sequence = 0;
	pev->nextthink = gpGlobals->time + 0.1;
	SetThink( GfSapinEject );
}

void GcItemSapin::Precache( void )
{ 
	PRECACHE_MODEL ( Gm_SAPIN_SAPIN );
	PRECACHE_MODEL ( Gm_SAPIN_BOULE );
}

void GcItemSapin::GfSapinEject( void )
{
	CBaseEntity *pGvEntity = NULL;
	short iGvItemNb = 0;

	pev->frame = ((int)pev->frame + 2 ) % 255;
	pev->nextthink = gpGlobals->time + 0.02;

	if( GvNiveauVie_i != Gm_CAISSE_HEALTH )
	{
		GvNiveauVie_i = Gm_CAISSE_HEALTH;
		GcGrenadeGeneric::GfSapinFrag( NULL, pev->origin + Vector( 0, 128, 192 ), pev->velocity		+ Vector( 0 + RANDOM_LONG( -64,64 ),	256 + RANDOM_LONG( -64,64 ), 256 + RANDOM_LONG( 0,256 )),	Gm_SAPIN_DOMMAGE );
		GcGrenadeGeneric::GfSapinFrag( NULL, pev->origin + Vector( 96, 96, 192 ), pev->velocity		+ Vector( 256 + RANDOM_LONG( -64,64 ),	256 + RANDOM_LONG( -64,64 ), 256 + RANDOM_LONG( 0,256 )),	Gm_SAPIN_DOMMAGE );
		GcGrenadeGeneric::GfSapinFrag( NULL, pev->origin + Vector( 128, 0, 192 ), pev->velocity		+ Vector( 256 + RANDOM_LONG( -64,64 ),	0 + RANDOM_LONG( -64,64 ), 256 + RANDOM_LONG( 0,256 )),		Gm_SAPIN_DOMMAGE );
		GcGrenadeGeneric::GfSapinFrag( NULL, pev->origin + Vector( 96, -96, 192 ), pev->velocity	+ Vector( 256 + RANDOM_LONG( -64,64 ),	-256 + RANDOM_LONG( -64,64 ), 256 + RANDOM_LONG( 0,256 )),	Gm_SAPIN_DOMMAGE );
		GcGrenadeGeneric::GfSapinFrag( NULL, pev->origin + Vector( 0, -128, 192 ), pev->velocity	+ Vector( 0 + RANDOM_LONG( -64,64 ),	-256 + RANDOM_LONG( -64,64 ), 256 + RANDOM_LONG( 0,256 )),	Gm_SAPIN_DOMMAGE );
		GcGrenadeGeneric::GfSapinFrag( NULL, pev->origin + Vector( -96, -96, 192 ), pev->velocity	+ Vector( -256 + RANDOM_LONG( -64,64 ),	-256 + RANDOM_LONG( -64,64 ), 256 + RANDOM_LONG( 0,256 )),	Gm_SAPIN_DOMMAGE );
		GcGrenadeGeneric::GfSapinFrag( NULL, pev->origin + Vector( -128, 0, 192 ), pev->velocity	+ Vector( -256 + RANDOM_LONG( -64,64 ),	0 + RANDOM_LONG( -64,64 ), 256 + RANDOM_LONG( 0,256 )),		Gm_SAPIN_DOMMAGE );
		GcGrenadeGeneric::GfSapinFrag( NULL, pev->origin + Vector( -96, 96, 192 ), pev->velocity	+ Vector( -256 + RANDOM_LONG( -64,64 ), 256 + RANDOM_LONG( -64,64 ), 256 + RANDOM_LONG( 0,256 )),	Gm_SAPIN_DOMMAGE );
	}

	if( pev->waterlevel > 2 )
	{
		ExplosionCreate( Center( ), pev->angles, edict( ), Gm_SAPIN_DOMMAGE, TRUE );
		UTIL_Remove( this );
	}
	
	while(( pGvEntity = UTIL_FindEntityInSphere( pGvEntity, pev->origin, 32 )) != NULL )
	{
		if(( FClassnameIs( pGvEntity->pev, "item_caisse_arme" ))
			||( FClassnameIs( pGvEntity->pev, "item_caisse_outil" ))
			||( FClassnameIs( pGvEntity->pev, "item_caisse_vie" ))
			||( FClassnameIs( pGvEntity->pev, "item_caisse_mega" )))
			iGvItemNb++;
		if( iGvItemNb )
			UTIL_Remove( pGvEntity );
			break;
	}
}