/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	item_tombe_bleu.cpp			*
*		19022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "items.h"
#include "gamerules.h"
#include "item_tombe_bleu.h"

#ifdef Gd_ITEM_TOMBE_BLEU

LINK_ENTITY_TO_CLASS( item_tombe_bleu, GcItemTombeBleu );

void GcItemTombeBleu::Spawn( void )
{ 
	Precache( );
	SET_MODEL( ENT( pev ), Gm_TOMBE_BLEU_MODEL );
	pev->gravity = 0.5;
	pev->velocity.z = -1;
	EMIT_SOUND(ENT( pev ), CHAN_ITEM, Gm_TOMBE_SON_TAKE, 0.75, ATTN_NORM);
	CItem::Spawn( );
	pev->sequence = 0;
	pev->nextthink = gpGlobals->time + 0.02;
	SetThink( GfThink );
}

void GcItemTombeBleu::Precache( void ) 
{ 
	PRECACHE_MODEL( Gm_TOMBE_BLEU_MODEL );
	PRECACHE_SOUND( Gm_TOMBE_SON_TAKE );
}

void GcItemTombeBleu::GfThink( void ) 
{ 
	pev->nextthink = gpGlobals->time + 0.02;
	pev->frame = ((int)pev->frame + 5 ) % 255;
}

// Groove - 13122001 - Gestion de la rcupration des tombe.
void GcItemTombeBleu::GfTombeRecup( CBasePlayer *pPlayer )
{
	short GvMsgHUD;
	if( pPlayer && ( FStrEq( pPlayer->m_szTeamName,"Wormsred" )))
	{
		pPlayer->sGvProfil.iGvTombeEnnemie++;
		GvMsgHUD = Gm_MSG_ROUGE_TOMBE_BLEU_01;
		g_pGameRules->GfScoreAdd( Gm_SCORE_ROUGE_1 );
	}
	else
	{
		pPlayer->sGvProfil.iGvToucheCollegue++;
		GvMsgHUD = Gm_MSG_BLEU_TOMBE_BLEU_01;
	}

	MESSAGE_BEGIN( MSG_ONE, gmsgBarreMsg, NULL, pPlayer->pev );
		WRITE_BYTE( GvMsgHUD );
	MESSAGE_END( );
}

BOOL GcItemTombeBleu::MyTouch( CBasePlayer *pPlayer )
{
	AffichageHUD( Gm_ITEM_TOMBE_BLEU, pPlayer );
	GfTouchPlayerEffect( pPlayer, false );
	GfTombeRecup( pPlayer );
/*
	MESSAGE_BEGIN( MSG_ONE, gmsgItemPickup, NULL, pPlayer->pev );
		WRITE_STRING( STRING( pev->classname ));
	MESSAGE_END( );
*/
	EMIT_SOUND( ENT( pPlayer->pev ), CHAN_ITEM, Gm_TOMBE_SON_TAKE , 0.8, ATTN_NORM );

	return TRUE;
}
#endif