/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	items.cpp					*
*		08052002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "items.h"
#include "gamerules.h"

void CItem::Spawn( void )
{
	pev->movetype = MOVETYPE_TOSS;
	pev->solid = SOLID_TRIGGER;
	UTIL_SetOrigin( pev, pev->origin );
	UTIL_SetSize( pev, Vector(-16, -16, 0), Vector( 16,16,16 ));
	SetTouch( ItemTouch );
}

void CItem::ItemTouch( CBaseEntity *pOther )
{
	if( !pOther->IsPlayer( ))
	{
		if( pOther->pev->solid != SOLID_BSP )
			UTIL_Remove( this );

		return;
	}

	CBasePlayer *pPlayer = (CBasePlayer *)pOther;

	if( MyTouch( pPlayer ))
	{
		SUB_UseTargets( pOther, USE_TOGGLE, 0 );
		SetTouch( NULL );
		UTIL_Remove( this );
	}
}

void CItem::Materialize( void )
{
	if( pev->effects & EF_NODRAW )
	{
		pev->effects &= ~EF_NODRAW;
		pev->effects |= EF_MUZZLEFLASH;
	}

	SetTouch( ItemTouch );
}

//EurOPiuM - 21042002 - Item HUD
void CItem::AffichageHUD( int QuelleItem, CBasePlayer *pPlayer )
{
	MESSAGE_BEGIN( MSG_ONE, gmsgPrise, NULL, pPlayer->pev );
		WRITE_BYTE( QuelleItem );
	MESSAGE_END( );
}

// Groove - 01052002 - Effect quand un joueur recupre un item.
void CItem::GfTouchPlayerEffect( CBasePlayer *pPlayer, bool bGvEffect )
{
	int iGvCouleur[3] = { 0,255,0 };
	if( pPlayer && ( FStrEq( pPlayer->m_szTeamName,"Wormsblue" )))
	{
		iGvCouleur[0] = 0;
		iGvCouleur[1] = 0;
		iGvCouleur[2] = 255;
	}
	else if( pPlayer && ( FStrEq( pPlayer->m_szTeamName,"Wormsred" )))
	{
		iGvCouleur[0] = 255;
		iGvCouleur[1] = 0;
		iGvCouleur[2] = 0;
	}

	if( bGvEffect )
	{
		// Groove - 01052002 - Couleur joueur
		pPlayer->pev->rendermode = kRenderNormal;
		pPlayer->pev->renderfx = kRenderFxGlowShell;
		pPlayer->pev->rendercolor.x = iGvCouleur[0];		// r
		pPlayer->pev->rendercolor.y = iGvCouleur[1];		// v
		pPlayer->pev->rendercolor.z = iGvCouleur[2];		// b
		pPlayer->iGvPlayerOutil |= Gm_PLAYER_OUTIL_POWER;
	}

	// Groove - 01052002 - Petite lumire dynamique de la couleur de l'equipe du joueur.
	MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, pev->origin );
		WRITE_BYTE( TE_DLIGHT );

		WRITE_COORD( pPlayer->pev->origin.x );	// Position
		WRITE_COORD( pPlayer->pev->origin.y );
		WRITE_COORD( pPlayer->pev->origin.z );
		WRITE_BYTE( 32 );						// Radius, in 10s (therefore, this is 300 units)

		WRITE_BYTE( iGvCouleur[0] );			// Color: red
		WRITE_BYTE( iGvCouleur[1] );			// Color: green
		WRITE_BYTE( iGvCouleur[2] );			// Color: blue
    
		WRITE_BYTE( 128 );						// Life
		WRITE_BYTE( 16 );						// Decay rate
	MESSAGE_END();
}