/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	triggers.h					*
*		31012002				*
\*******************************/

#ifndef Gd_TRIGGER
#define Gd_TRIGGER

// Groove - 18122001 - Point de Spawn des mines
class GcTriggerMine : public CPointEntity
{
public:
	void Spawn( void );
	void KeyValue( KeyValueData *pkvd );
	BOOL IsTriggered( CBaseEntity *pEntity );
};

// Groove - 31012002 - Point de Spawn des barils
class GcTriggerBaril : public CPointEntity
{
public:
	void Spawn( void );
	void KeyValue( KeyValueData *pkvd );
	BOOL IsTriggered( CBaseEntity *pEntity );
};

// Groove - 04122001 - Class trigger generic
class CBaseTrigger : public CBaseToggle
{
public:
	void EXPORT TeleportTouch ( CBaseEntity *pOther );
	void KeyValue( KeyValueData *pkvd );
	void EXPORT MultiTouch( CBaseEntity *pOther );
	void EXPORT HurtTouch ( CBaseEntity *pOther );
	void EXPORT CDAudioTouch ( CBaseEntity *pOther );
	void ActivateMultiTrigger( CBaseEntity *pActivator );
	void EXPORT MultiWaitOver( void );
	void EXPORT CounterUse( CBaseEntity *pActivator, CBaseEntity *pCaller, USE_TYPE useType, float value );
	void EXPORT ToggleUse ( CBaseEntity *pActivator, CBaseEntity *pCaller, USE_TYPE useType, float value );
	void InitTrigger( void );

	virtual int	ObjectCaps( void ) { return CBaseToggle :: ObjectCaps() & ~FCAP_ACROSS_TRANSITION; }
};

/*
// Groove - 04122001 - zone bleu
class GcZoneBleu: public CBaseTrigger 
{ 
public: 
	void Spawn( void ); 
	void EXPORT WhoIsInEntityThink( void );
}; 
// Groove - 04122001 - zone rouge
class GcZoneRouge: public CBaseTrigger 
{ 
public: 
	void Spawn( void ); 
	void EXPORT WhoIsInEntityThink( void );
}; 
*/

// Groove - 17042002 - Zone rouge pour le mode de jeu Zone
class GcTriggerZoneBleu : public CBaseTrigger
{
public:
	void Spawn( void );
private:
	void EXPORT RadiationThink( void );
	void HurtTouch ( CBaseEntity *pOther );
	float GvActualise_f;
};

// Groove - 17042002 - Zone rouge pour le mode de jeu Zone
class GcTriggerZoneRouge : public CBaseTrigger
{
public:
	void Spawn( void );
private:
	void EXPORT RadiationThink( void );
	void HurtTouch ( CBaseEntity *pOther );
	float GvActualise_f;
};

// Groove - 17042002 - Zone rouge pour le mode de jeu Zone
class GcTriggerControle : public CBaseTrigger
{
public:
	void Spawn( void );
private:
	void EXPORT RadiationThink( void );
	void HurtTouch ( CBaseEntity *pOther );
	float GvActualise_f;
};

//////////////////////////////////////////////////////////////

// Groove - 07042002 - Trigger hurt
class CTriggerHurt : public CBaseTrigger
{
public:
	void Spawn( void );
	void EXPORT RadiationThink( void );
};

// Groove - 03122001 - Trigger hurt pour l'equipe Rouge
class GcTriggerHurtBleu : public CBaseTrigger
{
public:
	void Spawn( void );
	void EXPORT RadiationThink( void );
	void HurtTouch ( CBaseEntity *pOther );
};
// Groove - 03122001 - Trigger hurt pour l'equipe Bleu
class GcTriggerHurtRouge : public CBaseTrigger
{
public:
	void Spawn( void );
	void EXPORT RadiationThink( void );
	void HurtTouch ( CBaseEntity *pOther );
};

////////////////////////////////////////////////////////

// Groove - 17012002 - Zone de Spawn des caisses
class GcInfoCaisse016 : public CPointEntity
{
public:
	void		KeyValue( KeyValueData *pkvd );
	BOOL		IsTriggered( CBaseEntity *pEntity );
};

// Groove - 17012002 - Zone de Spawn des caisses
class GcInfoCaisse032 : public CPointEntity
{
public:
	void		KeyValue( KeyValueData *pkvd );
	BOOL		IsTriggered( CBaseEntity *pEntity );
};

// Groove - 17012002 - Zone de Spawn des caisses
class GcInfoCaisse064 : public CPointEntity
{
public:
	void		KeyValue( KeyValueData *pkvd );
	BOOL		IsTriggered( CBaseEntity *pEntity );
};

// Groove - 17012002 - Zone de Spawn des caisses
class GcInfoCaisse128 : public CPointEntity
{
public:
	void		KeyValue( KeyValueData *pkvd );
	BOOL		IsTriggered( CBaseEntity *pEntity );
};

// Groove - 17012002 - Zone de Spawn des caisses
class GcInfoCaisse256 : public CPointEntity
{
public:
	void		KeyValue( KeyValueData *pkvd );
	BOOL		IsTriggered( CBaseEntity *pEntity );
};

#endif //Gd_TRIGGER
