/*******************************\
*	WormsHL						*
*		www.wormshl.fr.st		*
*								*
*	Groove						*
*		groove@wormshl.net		*
*								*
*	player.cpp					*
*		28022002				*
\*******************************/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "map_trains.h"
#include "nodes.h"
#include "generic_arme.h"
#include "player.h"
#include "soundent.h"
#include "monsters.h"
#include "shake.h"
#include "fx_decals.h"
#include "game.h"
#include "gamerules.h"
#include "arme_batte.h"
#include "fx_explode.h"

extern DLL_GLOBAL ULONG		g_ulModelIndexPlayer;
extern DLL_GLOBAL BOOL		g_fGameOver;
extern DLL_GLOBAL BOOL		g_fDrawLines;
extern DLL_GLOBAL int		gDisplayTitle;

BOOL gInitHUD = TRUE;

extern void respawn( entvars_t *pev, BOOL fCopyCorpse );
extern Vector VecBModelOrigin( entvars_t *pevBModel );

// Groove - 03122001 - Point de Spwan Collectif
extern edict_t *EntSelectSpawnPoint( CBaseEntity *pPlayer );
// Groove - 03122001 - Point de Spwan Indpendant
extern edict_t *EntSelectTeamSpawnPoint( CBaseEntity *pPlayer );

int MapTextureTypeStepType(char chTextureType);
CBaseEntity *FindEntityForward(CBaseEntity*); 
// the world node graph
extern CGraph	WorldGraph;

#define TRAIN_ACTIVE	0x80 
#define TRAIN_NEW		0xc0
#define TRAIN_OFF		0x00
#define TRAIN_NEUTRAL	0x01
#define TRAIN_SLOW		0x02
#define TRAIN_MEDIUM	0x03
#define TRAIN_FAST		0x04 
#define TRAIN_BACK		0x05

int gmsgScoreInfo = 0;
int gmsgCroise = 0;
int gmsgShake = 0;
int gmsgFade = 0;
int gmsgSelAmmo = 0;
int gmsgResetHUD = 0;
int gmsgInitHUD = 0;
int gmsgShowGameTitle = 0;
int gmsgCurWeapon = 0;
int gmsgHealth = 0;
int gmsgDamage = 0;
int gmsgTrain = 0;
int gmsgLogo = 0;
int gmsgWeaponList = 0;
int gmsgAmmoX = 0;
int gmsgHudText = 0;
int gmsgDeathMsg = 0;
int gmsgTeamInfo = 0;
int gmsgTeamScore = 0;
int gmsgGameMode = 0;
int gmsgMOTD = 0;
int gmsgAmmoPickup = 0;
int gmsgWeapPickup = 0;
int gmsgHideWeapon = 0;
int gmsgSetCurWeap = 0;
int gmsgSayText = 0;
int gmsgTextMsg = 0;
int gmsgSetFOV = 0;
int gmsgShowMenu = 0;
int gmsgGeigerRange = 0;
// Piv - 14112001 - Pr changement d'equipe
int gmsgVGUIMenu = 0;
// Groove - 19022002 - Puissance progressive
int gmsgPuissance = 0;
// Groove - 19022002 - Nombre de joueurs qui non pas fini leur tour
int gmsgReste = 0;
// Groove - 19022002 - Affichage du temps
int gmsgTime = 0;
// Groove - 19022002 - Affichage des scores
int gmsgScore = 0;
// Groove - 19022002 - Barre des msgs
int gmsgBarreMsg = 0;
// EurOPiuM - 21042002 - Msg du bille boket.
int gmsgBilleBocket = 0;
// EurOPiuM - Item HUD - 16/04/02
int gmsgPrise = 0;
// Groove - 22042002 - Communition
int gmsgCommunication = 0;
// EurOPiuM - 16/06/02 - Profil
int gmsgProfil = 0;
// EurOPiuM - 26/06/02 - Particles Lanceflamme
int gmsgLanceflamme = 0;
// EurOPiuM - 26/06/02 - Particles Flamme
int gmsgFlamme = 0;
// EurOPiuM - 26/07/02 - Particles Saintes
int gmsgSainte = 0;
// EurOPiUM - 06/07/02 - Radar
int gmsgRadar = 0;
// EurOPiuM - 22/08/02 - Particles Explosion standards
int gmsgExplosion;

void LinkUserMessages( void )
{
	// Already taken care of?
	if( gmsgSelAmmo )
		return;

	gmsgSelAmmo = REG_USER_MSG("SelAmmo", sizeof(SelAmmo));
	gmsgCurWeapon = REG_USER_MSG("CurWeapon", 2 );
	gmsgGeigerRange = REG_USER_MSG("Geiger", 1 );
	gmsgHealth = REG_USER_MSG( "Health", 1 );
	gmsgDamage = REG_USER_MSG( "Damage", 4 );
	gmsgTrain = REG_USER_MSG( "Train", 1);
	gmsgHudText = REG_USER_MSG( "HudText", -1 );
	gmsgSayText = REG_USER_MSG( "SayText", -1 );
	gmsgTextMsg = REG_USER_MSG( "TextMsg", -1 );
	gmsgWeaponList = REG_USER_MSG("WeaponList", -1);
	gmsgResetHUD = REG_USER_MSG("ResetHUD", 1);		// called every respawn
	gmsgInitHUD = REG_USER_MSG("InitHUD", 0 );		// called every time a new player joins the server
	gmsgShowGameTitle = REG_USER_MSG("GameTitle", 1);
	gmsgDeathMsg = REG_USER_MSG( "DeathMsg", -1 );
	gmsgScoreInfo = REG_USER_MSG( "ScoreInfo", 5 );
	gmsgTeamInfo = REG_USER_MSG( "TeamInfo", -1 );  // sets the name of a player's team
	gmsgTeamScore = REG_USER_MSG( "TeamScore", -1 );  // sets the score of a team on the scoreboard
	gmsgGameMode = REG_USER_MSG( "GameMode", 1 );
	gmsgMOTD = REG_USER_MSG( "MOTD", -1 );
	gmsgAmmoPickup = REG_USER_MSG( "AmmoPickup", 2 );
	gmsgWeapPickup = REG_USER_MSG( "WeapPickup", 1 );
	gmsgHideWeapon = REG_USER_MSG( "HideWeapon", 1 );
	gmsgSetFOV = REG_USER_MSG( "SetFOV", 1 );
	gmsgShowMenu = REG_USER_MSG( "ShowMenu", -1 );
	gmsgShake = REG_USER_MSG("ScreenShake", sizeof(ScreenShake));
	gmsgFade = REG_USER_MSG("ScreenFade", sizeof(ScreenFade));
	gmsgAmmoX = REG_USER_MSG("AmmoX", 2);
	// Groove - 19022002 - Nom du joueur que l'on croise
	gmsgCroise = REG_USER_MSG( "Croise", 1 );
	// Groove - 19022002 - Puissance progressive
	gmsgPuissance = REG_USER_MSG( "Puissance", 2 );
	// Groove - 19022002 - Nombre de joueurs qui non pas fini leur tour
	gmsgReste = REG_USER_MSG( "Reste", 1 );
	// Groove - 19022002 - Affichage du temps
	gmsgTime = REG_USER_MSG( "Time", 1 );	
	// Groove - 19022002 - Affichage des scores
	gmsgScore = REG_USER_MSG( "Score", 4 );
	// Groove - 19022002 - Barre des msgs
	gmsgBarreMsg = REG_USER_MSG( "Victoire", 1 );
	// Piv - 14112001 - Pr changement d'equipe
	gmsgVGUIMenu = REG_USER_MSG( "VGUIMenu", 1 );
	// EurOPiuM - 21042002 - Msg du bille boket.
	gmsgBilleBocket = REG_USER_MSG( "BilleBocket", 3 );
	// EurOPiuM - 21042002 - Quand on recupre un item
	gmsgPrise = REG_USER_MSG("Prise", 1);
	// Groove - 22042002 - Communition
	gmsgCommunication = REG_USER_MSG( "Communication", 2 );
	// EurOPiuM - 16/06/02 - Profil
	gmsgProfil = REG_USER_MSG( "Profil", 15 );
	// EurOPiuM - 26/06/02 - Particles Lanceflamme
	gmsgLanceflamme = REG_USER_MSG( "Lanceflamme", 1 );
	// EurOPiuM - 26/06/02 - Particles Flamme
	gmsgFlamme = REG_USER_MSG( "Flamme", 7 );
	// EurOPiuM - 27/07/02 - Particles Sainte
	gmsgSainte = REG_USER_MSG( "Sainte", 7 );
	// EurOPiuM - 06/07/02 - Radar
	gmsgRadar = REG_USER_MSG( "Radar", -1 );
	// EurOPiuM - 22/08/02 - Particles Explosion standards
	gmsgExplosion = REG_USER_MSG( "Explosion", 8 );
}

LINK_ENTITY_TO_CLASS( player, CBasePlayer );

// Groove 27102001 Sentir dommage
void CBasePlayer::GfSentirDommange( unsigned short iGvPuissance, unsigned short iGvHUDRouge )
{
	if(( pev->waterlevel == 3 ) || ( pev->health < 1 ))
		return;

	if(( pev->punchangle.x < 30 )&&( pev->punchangle.x > -30 ))
		pev->punchangle.x += RANDOM_LONG( -iGvPuissance,iGvPuissance );
	if(( pev->punchangle.y < 30 )&&( pev->punchangle.y > -30 ))
		pev->punchangle.y += RANDOM_LONG( -iGvPuissance,iGvPuissance );
	if(( pev->punchangle.z < 30 )&&( pev->punchangle.z > -30 ))
		pev->punchangle.z += RANDOM_LONG( -iGvPuissance,iGvPuissance );

	if( iGvHUDRouge > 0 )
	{
		if( g_pGameRules->GvMortSubite )
			UTIL_ScreenFade( this, Vector( 255, 0, 0 ), 1, 0.5, 64, FFADE_OUT | FFADE_STAYOUT );
		else
			UTIL_ScreenFade( this, Vector(( iGvHUDRouge ), 0, 0 ), 1, 0.5, 128, FFADE_IN);
	}
}

void CBasePlayer :: Pain( void )
{
	float	flRndSound;//sound randomizer

	flRndSound = RANDOM_FLOAT ( 0 , 1 ); 
	
	if ( flRndSound <= 0.33 )
		EMIT_SOUND(ENT(pev), CHAN_VOICE, "player/pl_pain5.wav", 1, ATTN_NORM);
	else if ( flRndSound <= 0.66 )	
		EMIT_SOUND(ENT(pev), CHAN_VOICE, "player/pl_pain6.wav", 1, ATTN_NORM);
	else
		EMIT_SOUND(ENT(pev), CHAN_VOICE, "player/pl_pain7.wav", 1, ATTN_NORM);
}

/* 
 *
 */
Vector VecVelocityForDamage(float flDamage)
{
	Vector vec(RANDOM_FLOAT(-100,100), RANDOM_FLOAT(-100,100), RANDOM_FLOAT(200,300));

	if (flDamage > -50)
		vec = vec * 0.7;
	else if (flDamage > -200)
		vec = vec * 2;
	else
		vec = vec * 10;
	
	return vec;
}

int TrainSpeed(int iSpeed, int iMax)
{
	float fSpeed, fMax;
	int iRet = 0;

	fMax = (float)iMax;
	fSpeed = iSpeed;

	fSpeed = fSpeed/fMax;

	if (iSpeed < 0)
		iRet = TRAIN_BACK;
	else if (iSpeed == 0)
		iRet = TRAIN_NEUTRAL;
	else if (fSpeed < 0.33)
		iRet = TRAIN_SLOW;
	else if (fSpeed < 0.66)
		iRet = TRAIN_MEDIUM;
	else
		iRet = TRAIN_FAST;

	return iRet;
}

void CBasePlayer :: DeathSound( void )
{
	// temporarily using pain sounds for death sounds
	switch (RANDOM_LONG(1,5)) 
	{
	case 1: 
		EMIT_SOUND( ENT( pev ), CHAN_VOICE, "player/pl_pain5.wav", 1, ATTN_NORM );
		break;
	case 2: 
		EMIT_SOUND( ENT( pev ), CHAN_VOICE, "player/pl_pain6.wav", 1, ATTN_NORM );
		break;
	case 3: 
		EMIT_SOUND( ENT( pev ), CHAN_VOICE, "player/pl_pain7.wav", 1, ATTN_NORM );
		break;
	}
}

int CBasePlayer :: TakeHealth( float flHealth, int bitsDamageType )
{
	return CBaseMonster :: TakeHealth (flHealth, bitsDamageType);
}

// Groove - 29012002 - Position de la cible suivant la position de la camra du joueur
Vector CBasePlayer :: GetGunPosition( void )
{
	return pev->origin + pev->view_ofs;
/*
	Vector GvOrigin;
	if( GvViewCMD == 0 )	
		GvOrigin = pev->origin + pev->view_ofs;
	else
		GvOrigin = pev->origin + pev->view_ofs + gpGlobals->v_right * GvSideCMD * 16;
	return GvOrigin;
*/
}

//=========================================================
// TraceAttack
//=========================================================
// Groove - 25112001 - Degat egaux pour chaque partie du corps
void CBasePlayer :: TraceAttack( entvars_t *pevAttacker, float flDamage, Vector vecDir, TraceResult *ptr, int bitsDamageType)
{
	if( pev->takedamage )
	{
		m_LastHitGroup = ptr->iHitgroup;

		AddMultiDamage( pevAttacker, this, flDamage, bitsDamageType );

		switch( RANDOM_LONG( 1,2 ))
		{
		case 1 : 
			EMIT_SOUND( ENT( pev ), CHAN_VOICE, Gf_SOUND_DOMMAGE_EXPLOSE_01, 1, ATTN_NORM );
			break;
		case 2 :
			EMIT_SOUND( ENT( pev ), CHAN_VOICE, Gf_SOUND_DOMMAGE_EXPLOSE_02, 1, ATTN_NORM );
			break;
		}
	}
}

int CBasePlayer :: TakeDamage( entvars_t *pevInflictor, entvars_t *pevAttacker, float flDamage, int bitsDamageType )
{
	// have suit diagnose the problem - ie: report damage type
	int bitsDamage = bitsDamageType;
	int ffound = TRUE;
	int fTookDamage;
	float flHealthPrev = pev->health;

	if ( !IsAlive() )
		return 0;
	
	CBaseEntity *pAttacker = CBaseEntity::Instance(pevAttacker);

	// Groove - 02052002 - Son traitre
	if(( pAttacker && g_pGameRules->PlayerRelationship( this, pAttacker ) == GR_TEAMMATE )&&( pAttacker != this ))
	{
		switch( RANDOM_LONG( 1,2 ))
		{
		case 1 : 
			EMIT_SOUND( ENT( pev ), CHAN_VOICE, Gf_SOUND_AMBIANCE_TRAITRE_01, 1, ATTN_NORM );
			break;
		case 2 :
			EMIT_SOUND( ENT( pev ), CHAN_VOICE, Gf_SOUND_AMBIANCE_TRAITRE_02, 1, ATTN_NORM );
			break;
		}
	}

	// this cast to INT is critical!!! If a player ends up with 0.5 health, the engine will get that
	// as an int (zero) and think the player is dead! (this will incite a clientside screentilt, etc)
	fTookDamage = CBaseMonster::TakeDamage(pevInflictor, pevAttacker, (int)flDamage, bitsDamageType);

	// reset damage time countdown for each type of time based damage player just sustained

	for( int i = 0; i < CDMG_TIMEBASED; i++ )
		if (bitsDamageType & ( DMG_PARALYZE << i ))
			m_rgbTimeBasedDamage[i] = 0;

	m_bitsDamageType |= bitsDamage; // Save this so we can report it to the client
	m_bitsHUDDamage = -1;  // make sure the damage bits get resent

	while( fTookDamage && ( bitsDamage & DMG_TIMEBASED ) && ffound && bitsDamage )
	{
		ffound = FALSE;

		if( bitsDamage & ( Gm_DMG_CHAUD | Gm_DMG_CONTACT | Gm_DMG_EAU | Gm_DMG_ECLAIR | Gm_DMG_EXPLOSION | Gm_DMG_FROID	| Gm_DMG_RADIOACTIF	))
		{
			bitsDamage &= ~( Gm_DMG_CHAUD | Gm_DMG_CONTACT | Gm_DMG_EAU | Gm_DMG_ECLAIR | Gm_DMG_EXPLOSION | Gm_DMG_FROID	| Gm_DMG_RADIOACTIF	);
			ffound = TRUE;
		}
		
	}

	pev->punchangle.x = -2;

	return fTookDamage;
}

void CBasePlayer::RemoveAllItems( BOOL removeSuit )
{
	if (m_pActiveItem)
	{
		m_pActiveItem->Holster( );
		m_pActiveItem = NULL;
	}

	m_pLastItem = NULL;

	int i;
	CBasePlayerItem *pPendingItem;
	for (i = 0; i < MAX_ITEM_TYPES; i++)
	{
		m_pActiveItem = m_rgpPlayerItems[i];
		while (m_pActiveItem)
		{
			pPendingItem = m_pActiveItem->m_pNext; 
			m_pActiveItem->Drop( );
			m_pActiveItem = pPendingItem;
		}
		m_rgpPlayerItems[i] = NULL;
	}
	m_pActiveItem = NULL;

	pev->viewmodel		= 0;
	pev->weaponmodel	= 0;
	
	// Groove - 08052002 - Gestion des armes de WormsHL
	for( i = 0; i < MAX_WEAPON_SLOTS; i++ )
		iGvArmes[i] = 0;

/*	if ( removeSuit )
		iGvArmes = 0;
	else
		iGvArmes &= ~WEAPON_ALLWEAPONS;
*/
	for ( i = 0; i < MAX_AMMO_SLOTS;i++)
		m_rgAmmo[i] = 0;

	UpdateClientData();
	// send Selected Weapon Message to our client
	MESSAGE_BEGIN( MSG_ONE, gmsgCurWeapon, NULL, pev );
		WRITE_BYTE(0);
		WRITE_BYTE(0);
//		WRITE_BYTE(0);
	MESSAGE_END();
}

/*
 * GLOBALS ASSUMED SET:  g_ulModelIndexPlayer
 *
 * ENTITY_METHOD(PlayerDie)
 */
entvars_t *g_pevLastInflictor;  // Set in combat.cpp.  Used to pass the damage inflictor for death messages.
								// Better solution:  Add as parameter to all Killed() functions.

void CBasePlayer::Killed( entvars_t *pevAttacker, int iGib )
{
	if( IsAlive( ))
		return;

	CSound *pSound;
	
	g_pGameRules->PlayerKilled( this, pevAttacker, g_pevLastInflictor );

	if( m_pTank != NULL )
	{
		m_pTank->Use( this, this, USE_OFF, 0 );
		m_pTank = NULL;
	}

	// this client isn't going to be thinking for a while, so reset the sound until they respawn
	pSound = CSoundEnt::SoundPointerForIndex( CSoundEnt::ClientSoundIndex( edict( )));

	if( pSound )
		pSound->Reset( );

	SetAnimation( PLAYER_DIE );
	
	pev->modelindex = g_ulModelIndexPlayer;    // don't use eyes

	pev->deadflag		= DEAD_DYING;
	pev->movetype		= MOVETYPE_TOSS;
	ClearBits(pev->flags, FL_ONGROUND);
	if (pev->velocity.z < 10)
		pev->velocity.z += RANDOM_FLOAT(0,300);

	// send "health" update message to zero
	m_iClientHealth = 0;
	MESSAGE_BEGIN( MSG_ONE, gmsgHealth, NULL, pev );
		WRITE_BYTE( m_iClientHealth );
	MESSAGE_END();

	// Tell Ammo Hud that the player is dead
	MESSAGE_BEGIN( MSG_ONE, gmsgCurWeapon, NULL, pev );
		WRITE_BYTE(0);
		WRITE_BYTE(0XFF);
//		WRITE_BYTE(0xFF);
	MESSAGE_END();

	// reset FOV
	m_iFOV = m_iClientFOV = 0;

	MESSAGE_BEGIN( MSG_ONE, gmsgSetFOV, NULL, pev );
		WRITE_BYTE(0);
	MESSAGE_END();


	// UNDONE: Put this in, but add FFADE_PERMANENT and make fade time 8.8 instead of 4.12
	// UTIL_ScreenFade( edict(), Vector(128,0,0), 6, 15, 255, FFADE_OUT | FFADE_MODULATE );

	if(( pev->health < -40 && iGib != GIB_NEVER ) || iGib == GIB_ALWAYS )
	{
		pev->solid			= SOLID_NOT;

		GibMonster();	// This clears pev->model
		pev->effects |= EF_NODRAW;
		return;
	}

	DeathSound();
	
	pev->angles.x = 0;
	pev->angles.z = 0;

	SetThink( PlayerDeathThink );
	pev->nextthink = gpGlobals->time + 0.1;
}


// Set the activity based on an event or current state
void CBasePlayer::SetAnimation( PLAYER_ANIM playerAnim )
{
	int animDesired;
	float speed;
	char szAnim[64];

	speed = pev->velocity.Length2D();

	if( !GvPlayerTPT.bMove )
		playerAnim = PLAYER_IDLE;

	if (pev->flags & FL_FROZEN)
	{
		speed = 0;
		playerAnim = PLAYER_IDLE;
	}

	switch (playerAnim) 
	{
	case PLAYER_JUMP:
		m_IdealActivity = ACT_HOP;
		break;
	
	case PLAYER_SUPERJUMP:
		m_IdealActivity = ACT_LEAP;
		break;
	
	case PLAYER_DIE:
		m_IdealActivity = ACT_DIESIMPLE;
		m_IdealActivity = GetDeathActivity( );
		break;

	case PLAYER_ATTACK1:	
		switch( m_Activity )
		{
		case ACT_HOVER:
		case ACT_SWIM:
		case ACT_HOP:
		case ACT_LEAP:
		case ACT_DIESIMPLE:
			m_IdealActivity = m_Activity;
			break;
		default:
			m_IdealActivity = ACT_RANGE_ATTACK1;
			break;
		}
		break;
	case PLAYER_IDLE:
	case PLAYER_WALK:
		if( !FBitSet( pev->flags, FL_ONGROUND ) && (m_Activity == ACT_HOP || m_Activity == ACT_LEAP) )	// Still jumping
			m_IdealActivity = m_Activity;
		else if( pev->waterlevel > 1 )
			if ( speed == 0 )
				m_IdealActivity = ACT_HOVER;
			else
				m_IdealActivity = ACT_SWIM;
		else
			m_IdealActivity = ACT_WALK;
		break;
	}

	switch (m_IdealActivity)
	{
	case ACT_HOVER:
	case ACT_LEAP:
	case ACT_SWIM:
	case ACT_HOP:
	case ACT_DIESIMPLE:
	default:
		if ( m_Activity == m_IdealActivity)
			return;
		m_Activity = m_IdealActivity;

		animDesired = LookupActivity( m_Activity );
		// Already using the desired animation?
		if (pev->sequence == animDesired)
			return;

		pev->gaitsequence = 0;
		pev->sequence		= animDesired;
		pev->frame			= 0;
		ResetSequenceInfo( );
		return;

	case ACT_RANGE_ATTACK1:
		if ( FBitSet( pev->flags, FL_DUCKING ) )	// crouching
			strcpy( szAnim, "crouch_shoot_" );
		else
			strcpy( szAnim, "ref_shoot_" );
		strcat( szAnim, m_szAnimExtention );
		animDesired = LookupSequence( szAnim );
		if (animDesired == -1)
			animDesired = 0;

		if ( pev->sequence != animDesired || !m_fSequenceLoops )
		{
			pev->frame = 0;
		}

		if (!m_fSequenceLoops)
		{
			pev->effects |= EF_NOINTERP;
		}

		m_Activity = m_IdealActivity;

		pev->sequence		= animDesired;
		ResetSequenceInfo( );
		break;

	case ACT_WALK:
		if (m_Activity != ACT_RANGE_ATTACK1 || m_fSequenceFinished)
		{
			if ( FBitSet( pev->flags, FL_DUCKING ) )	// crouching
				strcpy( szAnim, "crouch_aim_" );
			else
				strcpy( szAnim, "ref_aim_" );
			strcat( szAnim, m_szAnimExtention );
			animDesired = LookupSequence( szAnim );
			if (animDesired == -1)
				animDesired = 0;
			m_Activity = ACT_WALK;
		}
		else
		{
			animDesired = pev->sequence;
		}
	}

	if ( FBitSet( pev->flags, FL_DUCKING ) )
	{
		if ( speed == 0)
		{
			pev->gaitsequence	= LookupActivity( ACT_CROUCHIDLE );
			// pev->gaitsequence	= LookupActivity( ACT_CROUCH );
		}
		else
		{
			pev->gaitsequence	= LookupActivity( ACT_CROUCH );
		}
	}
	else if ( speed > 220 )
	{
		pev->gaitsequence	= LookupActivity( ACT_RUN );
	}
	else if (speed > 0)
	{
		pev->gaitsequence	= LookupActivity( ACT_WALK );
	}
	else
	{
		// pev->gaitsequence	= LookupActivity( ACT_WALK );
		pev->gaitsequence	= LookupSequence( "deep_idle" );
	}


	// Already using the desired animation?
	if (pev->sequence == animDesired)
		return;

	//ALERT( at_console, "Set animation to %d\n", animDesired );
	// Reset to first frame of desired animation
	pev->sequence		= animDesired;
	pev->frame			= 0;
	ResetSequenceInfo( );
}


/*
===========
WaterMove
============
*/
#define AIRTIME	12		// lung full of air lasts this many seconds

// Groove - Gestion de la mort des Worms 100% coding !
void CBasePlayer::GfWormsDansEau( void )
{
	// waterlevel 0 - hors de l'eau
	// waterlevel 1 - les pieds dans l'eau
	// waterlevel 2 - le corps dans l'eau
	// waterlevel 3 - la tete dans l'eau

	if(( pev->movetype == MOVETYPE_NOCLIP ) || !pev->waterlevel || !IsAlive( ))
		return;

	// Dans la lave
	if( pev->watertype == CONTENT_LAVA )
	{
		if( pev->waterlevel == 1 )
			TakeDamage( VARS( eoNullEntity ), VARS( eoNullEntity ), 5 * pev->waterlevel, Gm_DMG_CHAUD );
		else if( pev->waterlevel == 2 )
			TakeDamage( VARS( eoNullEntity ), VARS( eoNullEntity ), 10 * pev->waterlevel, Gm_DMG_CHAUD );
		else if( pev->waterlevel == 3 )
		{
			TakeDamage( VARS(eoNullEntity), VARS(eoNullEntity), 50 * pev->waterlevel, Gm_DMG_CHAUD );
			sGvProfil.iGvNoyer++;
#ifdef Gm_BETA_TEST
			EMIT_SOUND( ENT(pev), CHAN_WEAPON, Gm_BATTE_FICHIER_SON_PLOUF, 1, ATTN_NONE );
#else
			if( !GvMoveTPT_b )
			// Groove - 19112001 - Pour exe de son pour chaque joueur
				EMIT_SOUND( ENT( pev ), CHAN_WEAPON, Gm_BATTE_FICHIER_SON_PLOUF, 1, ATTN_NONE );
#endif
		}
		pev->dmgtime = gpGlobals->time + 0.1;
		if( GvWormsDansEauTemps_f < gpGlobals->time )
		{
			GvWormsDansEauTemps_f = gpGlobals->time + 2.0;
			switch( RANDOM_LONG( 1,2 ))
			{
			case 1: EMIT_SOUND( ENT(pev), CHAN_BODY, Gf_SOUND_DOMMAGE_LAVE_01, 1, ATTN_NORM ); break;
			case 2: EMIT_SOUND( ENT(pev), CHAN_BODY, Gf_SOUND_DOMMAGE_LAVE_02, 1, ATTN_NORM ); break;
			}
		}
	}
	// Dans produit toxique
	else if( pev->watertype == CONTENT_SLIME )
	{
		if( pev->waterlevel == 1 )
			TakeDamage( VARS( eoNullEntity ), VARS( eoNullEntity ), 2 * pev->waterlevel, Gm_DMG_RADIOACTIF );
		else if( pev->waterlevel == 2 )
			TakeDamage( VARS( eoNullEntity ), VARS( eoNullEntity ), 4 * pev->waterlevel, Gm_DMG_RADIOACTIF );
		else if( pev->waterlevel == 3 )
		{
			TakeDamage( VARS(eoNullEntity), VARS(eoNullEntity), 50 * pev->waterlevel, Gm_DMG_RADIOACTIF );
			sGvProfil.iGvNoyer++;
#ifdef Gm_BETA_TEST
			EMIT_SOUND( ENT( pev ), CHAN_WEAPON, Gm_BATTE_FICHIER_SON_PLOUF, 1, ATTN_NONE);
#else
			if( !GvMoveTPT_b )
			// Groove - 19112001 - Pour exe de son pour chaque joueur
				EMIT_SOUND( ENT( pev ), CHAN_WEAPON, Gm_BATTE_FICHIER_SON_PLOUF, 1, ATTN_NONE);
#endif

		}
		pev->dmgtime = gpGlobals->time + 1;
		if( GvWormsDansEauTemps_f < gpGlobals->time )
		{
			GvWormsDansEauTemps_f = gpGlobals->time + 2.0;
			switch( RANDOM_LONG( 1,2 ))
			{
			case 1: EMIT_SOUND(ENT(pev), CHAN_BODY, Gf_SOUND_DOMMAGE_ACIDE_01, 1, ATTN_NORM); break;
			case 2: EMIT_SOUND(ENT(pev), CHAN_BODY, Gf_SOUND_DOMMAGE_ACIDE_02, 1, ATTN_NORM); break;
			}
		}
	}
	// Dans l'eau
	else if( pev->waterlevel >= 3 )
	{
		sGvProfil.iGvNoyer++;

		short iGvMsg;
		if( FStrEq( m_szTeamName,"Wormsred" ))
			iGvMsg = RANDOM_LONG( Gm_MSG_ROUGE_NAGE_01, Gm_MSG_ROUGE_NAGE_04 );
		else
			iGvMsg = RANDOM_LONG( Gm_MSG_BLEU_NAGE_01, Gm_MSG_BLEU_NAGE_04 );

		MESSAGE_BEGIN( MSG_ONE, gmsgBarreMsg, NULL, pev );
			WRITE_BYTE( iGvMsg );
		MESSAGE_END( );

		if( pev->watertype == CONTENT_WATER )
		{
			pev->dmgtime = gpGlobals->time + 0.1;
			TakeDamage( VARS( eoNullEntity ), VARS( eoNullEntity ), 125, Gm_DMG_EAU ); // DMG_SLASH

	#ifdef Gm_BETA_TEST
			EMIT_SOUND( ENT( pev ), CHAN_WEAPON, Gm_BATTE_FICHIER_SON_PLOUF, 1, ATTN_NONE );
	#else
			if( !GvMoveTPT_b )
			// Groove - 19112001 - Pour exe de son pour chaque joueur
				EMIT_SOUND( ENT( pev ), CHAN_WEAPON, Gm_BATTE_FICHIER_SON_PLOUF, 1, ATTN_NONE );
	#endif

			if( GvWormsDansEauTemps_f < gpGlobals->time )
			{
				GvWormsDansEauTemps_f = gpGlobals->time + 2.0;
				switch( RANDOM_LONG( 1,4 ))
				{
				case 1: EMIT_SOUND(ENT(pev), CHAN_BODY, Gf_SOUND_DOMMAGE_EAU_01, 1, ATTN_NORM); break;
				case 2: EMIT_SOUND(ENT(pev), CHAN_BODY, Gf_SOUND_DOMMAGE_EAU_02, 1, ATTN_NORM); break;
				case 3: EMIT_SOUND(ENT(pev), CHAN_BODY, Gf_SOUND_DOMMAGE_EAU_03, 1, ATTN_NORM); break;
				case 4: EMIT_SOUND(ENT(pev), CHAN_BODY, Gf_SOUND_DOMMAGE_EAU_04, 1, ATTN_NORM); break;
				}
			}

		}
	}
	pev->velocity = pev->velocity - 0.8 * pev->waterlevel * gpGlobals->frametime * pev->velocity;
}

// TRUE if the player is attached to a ladder
BOOL CBasePlayer::IsOnLadder( void )
{ 
	return (pev->movetype == MOVETYPE_FLY);
}

void CBasePlayer::PlayerDeathThink(void)
{
	float flForward;

	if (FBitSet(pev->flags, FL_ONGROUND))
	{
		flForward = pev->velocity.Length() - 20;
		if (flForward <= 0)
			pev->velocity = g_vecZero;
		else    
			pev->velocity = flForward * pev->velocity.Normalize();
	}

	if (pev->modelindex && (!m_fSequenceFinished) && (pev->deadflag == DEAD_DYING))
	{
		StudioFrameAdvance( );

		m_iRespawnFrames++;		// Note, these aren't necessarily real "frames", so behavior is dependent on # of client movement commands
		if ( m_iRespawnFrames < 120 )   // Animations should be no longer than this
			return;
	}

	if (pev->deadflag == DEAD_DYING)
		pev->deadflag = DEAD_DEAD;
	
	StopAnimation();

	pev->effects |= EF_NOINTERP;
	pev->framerate = 0.0;

	BOOL fAnyButtonDown = (pev->button & ~IN_SCORE );
	
	// wait for all buttons released
	if (pev->deadflag == DEAD_DEAD)
	{
		if (fAnyButtonDown)
			return;

		m_fDeadTime = gpGlobals->time;
		pev->deadflag = DEAD_RESPAWNABLE;
		
		return;
	}

// if the player has been dead for one second longer than allowed by forcerespawn, 
// forcerespawn isn't on. Send the player off to an intermission camera until they 
// choose to respawn.
	if ( g_pGameRules->IsMultiplayer() && ( gpGlobals->time > (m_fDeadTime + 6) ) && !(m_afPhysicsFlags & PFLAG_OBSERVER) )
	{
		// go to dead camera. 
		StartDeathCam();
	}
	
// wait for any button down,  or mp_forcerespawn is set and the respawn time is up
	if (!fAnyButtonDown && !( g_pGameRules->IsMultiplayer() && CVAR_GET_FLOAT("mp_forcerespawn") > 0 && (gpGlobals->time > (m_fDeadTime + 5))) )
		return;

	pev->button = 0;
	m_iRespawnFrames = 0;

	// Groove - 13122001 - Pour eviter que les Worms fasse luliole une fois mort ...
	pev->effects = 0;

	short iGvMsg;
	if( FStrEq( m_szTeamName,"Wormsred" ))
		iGvMsg = RANDOM_LONG( Gm_MSG_ROUGE_MORT_01, Gm_MSG_ROUGE_MORT_07 );
	else
		iGvMsg = RANDOM_LONG( Gm_MSG_BLEU_MORT_01, Gm_MSG_BLEU_MORT_07 );

	MESSAGE_BEGIN( MSG_ONE, gmsgBarreMsg, NULL, pev );
		WRITE_BYTE( iGvMsg );
	MESSAGE_END( );

	// Groove - 28022002 - Pas d'explosion ni de tombe quand les Worms meurt noyer.
	if( pev->waterlevel < 3 )
	{
		// Groove - 12122001 - Spawn des tombes
		if( g_pGameRules->bGfTombeCanSpawn( ))
		{
			CBaseEntity *pEntity = NULL;
			Vector GvSens = Vector( 0,RANDOM_LONG( 0,360.0 ),0 );
			Vector GvOrigine = pev->origin;

			if( FStrEq( m_szTeamName,"Wormsred" ))
				pEntity = CBaseEntity::Create( "item_tombe_rouge", GvOrigine, GvSens, edict( ));
			if( FStrEq( m_szTeamName,"Wormsblue" ))
				pEntity = CBaseEntity::Create( "item_tombe_bleu", GvOrigine, GvSens, edict( ));
		//	EMIT_SOUND(ENT( GpCaisse->pev ), CHAN_ITEM, "jeu/caisse_spawn1.wav", 0.75, ATTN_NORM);
		}

		// Groove - 28022002 - Les worms explosent quand ils meurent
		ExplosionCreate( Center( ), pev->angles, edict( ), 50, TRUE );
	}

	respawn( pev, !( m_afPhysicsFlags & PFLAG_OBSERVER) );// don't copy a corpse if we're in deathcam.
	pev->nextthink = -1;
}

//=========================================================
// StartDeathCam - find an intermission spot and send the
// player off into observer mode
//=========================================================
void CBasePlayer::StartDeathCam( void )
{
	edict_t *pSpot, *pNewSpot;
	int iRand;

	// Groove - 11/08/2002 - Ecran noir quand on meurt.
	UTIL_ScreenFade( this, Vector( 1,1,1 ), 0.25, 0.25, 255, FFADE_OUT | FFADE_STAYOUT );

	if ( pev->view_ofs == g_vecZero )
	{
		// don't accept subsequent attempts to StartDeathCam()
		return;
	}

	pSpot = FIND_ENTITY_BY_CLASSNAME( NULL, "info_intermission");	

	if( !FNullEnt( pSpot ) )
	{
		// at least one intermission spot in the world.
		iRand = RANDOM_LONG( 0, 3 );

		while( iRand > 0 )
		{
			pNewSpot = FIND_ENTITY_BY_CLASSNAME( pSpot, "info_intermission");
			
			if( pNewSpot )
				pSpot = pNewSpot;

			iRand--;
		}
		StartObserver( pSpot->v.origin, pSpot->v.v_angle );
	}
	else
	{
		// no intermission spot. Push them up in the air, looking down at their corpse
		TraceResult tr;
		UTIL_TraceLine( pev->origin, pev->origin + Vector( 0, 0, 128 ), ignore_monsters, edict(), &tr );
		StartObserver( tr.vecEndPos, UTIL_VecToAngles( tr.vecEndPos - pev->origin  ) );
		return;
	}
}

void CBasePlayer::StartObserver( Vector vecPosition, Vector vecViewAngle )
{
	m_afPhysicsFlags |= PFLAG_OBSERVER;

	pev->view_ofs = g_vecZero;
	pev->angles = pev->v_angle = vecViewAngle;
	pev->fixangle = TRUE;
	pev->solid = SOLID_NOT;
	pev->takedamage = DAMAGE_NO;
	pev->movetype = MOVETYPE_NONE;
	pev->modelindex = 0;
	UTIL_SetOrigin( pev, vecPosition );
}

// 
// PlayerUse - handles USE keypress
//
#define	PLAYER_SEARCH_RADIUS	(float)64

void CBasePlayer::PlayerUse ( void )
{
	// Was use pressed or released?
	if ( ! ((pev->button | m_afButtonPressed | m_afButtonReleased) & IN_USE) )
		return;

	// Hit Use on a train?
	if ( m_afButtonPressed & IN_USE )
	{
		if ( m_pTank != NULL )
		{
			// Stop controlling the tank
			// TODO: Send HUD Update
			m_pTank->Use( this, this, USE_OFF, 0 );
			m_pTank = NULL;
			return;
		}
		else
		{
			if ( m_afPhysicsFlags & PFLAG_ONTRAIN )
			{
				m_afPhysicsFlags &= ~PFLAG_ONTRAIN;
				m_iTrain = TRAIN_NEW|TRAIN_OFF;
				return;
			}
			else
			{	// Start controlling the train!
				CBaseEntity *pTrain = CBaseEntity::Instance( pev->groundentity );

				if ( pTrain && !(pev->button & ( IN_JUMP|IN_JUMP2)) && FBitSet(pev->flags, FL_ONGROUND) && (pTrain->ObjectCaps() & FCAP_DIRECTIONAL_USE) && pTrain->OnControls(pev) )
				{
					m_afPhysicsFlags |= PFLAG_ONTRAIN;
					m_iTrain = TrainSpeed(pTrain->pev->speed, pTrain->pev->impulse);
					m_iTrain |= TRAIN_NEW;
					EMIT_SOUND( ENT(pev), CHAN_ITEM, "plats/train_use1.wav", 0.8, ATTN_NORM);
					return;
				}
			}
		}
	}

	CBaseEntity *pObject = NULL;
	CBaseEntity *pClosest = NULL;
	Vector		vecLOS;
	float flMaxDot = VIEW_FIELD_NARROW;
	float flDot;

	UTIL_MakeVectors ( pev->v_angle );// so we know which way we are facing
	
	while ((pObject = UTIL_FindEntityInSphere( pObject, pev->origin, PLAYER_SEARCH_RADIUS )) != NULL)
	{

		if (pObject->ObjectCaps() & (FCAP_IMPULSE_USE | FCAP_CONTINUOUS_USE | FCAP_ONOFF_USE))
		{
			// !!!PERFORMANCE- should this check be done on a per case basis AFTER we've determined that
			// this object is actually usable? This dot is being done for every object within PLAYER_SEARCH_RADIUS
			// when player hits the use key. How many objects can be in that area, anyway? (sjb)
			vecLOS = (VecBModelOrigin( pObject->pev ) - (pev->origin + pev->view_ofs));
			
			// This essentially moves the origin of the target to the corner nearest the player to test to see 
			// if it's "hull" is in the view cone
			vecLOS = UTIL_ClampVectorToBox( vecLOS, pObject->pev->size * 0.5 );
			
			flDot = DotProduct (vecLOS , gpGlobals->v_forward);
			if (flDot > flMaxDot )
			{// only if the item is in front of the user
				pClosest = pObject;
				flMaxDot = flDot;
//				ALERT( at_console, "%s : %f\n", STRING( pObject->pev->classname ), flDot );
			}
//			ALERT( at_console, "%s : %f\n", STRING( pObject->pev->classname ), flDot );
		}
	}
	pObject = pClosest;

	// Found an object
	if (pObject )
	{
		//!!!UNDONE: traceline here to prevent USEing buttons through walls			
		int caps = pObject->ObjectCaps();

		if ( m_afButtonPressed & IN_USE )
			EMIT_SOUND( ENT(pev), CHAN_ITEM, "common/wpn_select.wav", 0.4, ATTN_NORM);

		if ( ( (pev->button & IN_USE) && (caps & FCAP_CONTINUOUS_USE) ) ||
			 ( (m_afButtonPressed & IN_USE) && (caps & (FCAP_IMPULSE_USE|FCAP_ONOFF_USE)) ) )
		{
			if ( caps & FCAP_CONTINUOUS_USE )
				m_afPhysicsFlags |= PFLAG_USING;

			pObject->Use( this, this, USE_SET, 1 );
		}
		// UNDONE: Send different USE codes for ON/OFF.  Cache last ONOFF_USE object to send 'off' if you turn away
		else if ( (m_afButtonReleased & IN_USE) && (pObject->ObjectCaps() & FCAP_ONOFF_USE) )	// BUGBUG This is an "off" use
		{
			pObject->Use( this, this, USE_SET, 0 );
		}
	}
	else
	{
		if ( m_afButtonPressed & IN_USE )
			EMIT_SOUND( ENT(pev), CHAN_ITEM, "common/wpn_denyselect.wav", 0.4, ATTN_NORM);
	}
}



void CBasePlayer::Jump( void )
{ 
// Groove - 25022002 - Les worms ne sautent pas dans l'eau et en fin de tour si cmd
//	extern cvar_t GvJumpCMD;
	if( !GvPlayerTPT.bMove || ( pev->waterlevel > 1 ))
        return;

	Vector		vecWallCheckDir;// direction we're tracing a line to find a wall when walljumping
	Vector		vecAdjustedVelocity;
	Vector		vecSpot;
	TraceResult	tr;
	
	if (FBitSet(pev->flags, FL_WATERJUMP))
		return;
	

	// jump velocity is sqrt( height * gravity * 2)

	// If this isn't the first frame pressing the jump button, break out.
	if( !FBitSet( m_afButtonPressed, IN_JUMP ))
		return;         // don't pogo stick

	if( !FBitSet( m_afButtonPressed, IN_JUMP2 ))
		return;         // don't pogo stick

	if(!( pev->flags & FL_ONGROUND ) || !pev->groundentity )
		return;

// many features in this function use v_forward, so makevectors now.
	UTIL_MakeVectors( pev->angles );

	SetAnimation( PLAYER_JUMP );
/* Groove - 26032002 - Pas de super saut dans WormsHL
	if ( FBitSet(pev->flags, FL_DUCKING ) || FBitSet(m_afPhysicsFlags, PFLAG_DUCKING) )
	{
		if ( m_fLongJump && (pev->button & IN_DUCK) && gpGlobals->time - m_flDuckTime < 1 && pev->velocity.Length() > 50 )
		{// If jump pressed within a second of duck while moving, long jump!
			SetAnimation( PLAYER_SUPERJUMP );
		}
	}
*/	
	// If you're standing on a conveyor, add it's velocity to yours (for momentum)
	entvars_t *pevGround = VARS(pev->groundentity);
	if ( pevGround && (pevGround->flags & FL_CONVEYOR) )
	{
		// Groove - 10122001 - 2 sauts.
		Vector GvModificateur = Vector( 0,0,0 );
		if( GfControleTypeJump( )) // Groove - 10122001 - saut en hauteur
		{
			GvModificateur = pev->basevelocity + gpGlobals->v_forward * 16;
			GvModificateur.y = pev->basevelocity.y;
			GvModificateur.z = pev->basevelocity.z + 100;
			pev->velocity += GvModificateur;
		}
		else // Groove - 10122001 - saut en longueur
		{
			pev->velocity += pev->basevelocity;
		}
	}
}

bool CBasePlayer::GfControleTypeJump( void )
{
	int GvVelocity = sqrt( pev->velocity.x * pev->velocity.x + pev->velocity.y * pev->velocity.y );
	if(( GvVelocity < 10 ) && ( GvVelocity > -10 ))
		return true;
	else
		return false;

	return true;
}


// This is a glorious hack to find free space when you've crouched into some solid space
// Our crouching collisions do not work correctly for some reason and this is easier
// than fixing the problem :(
void FixPlayerCrouchStuck( edict_t *pPlayer )
{
	TraceResult trace;

	// Move up as many as 18 pixels if the player is stuck.
	for ( int i = 0; i < 18; i++ )
	{
		UTIL_TraceHull( pPlayer->v.origin, pPlayer->v.origin, dont_ignore_monsters, head_hull, pPlayer, &trace );
		if ( trace.fStartSolid )
			pPlayer->v.origin.z ++;
		else
			break;
	}
}

void CBasePlayer::Duck( )
{
	// Groove - 25022002 - Les worms ne sautent pas dans l'eau et en fin de tour si cmd
//	extern cvar_t GvJumpCMD;
	if( !GvPlayerTPT.bMove ||( pev->waterlevel > 1 ))
        return;

	if (pev->button & IN_DUCK) 
	{
		SetAnimation( PLAYER_WALK );
	}
}

//
// ID's player as such.
//
int  CBasePlayer::Classify ( void )
{
	return CLASS_PLAYER;
}


void CBasePlayer::AddPoints( int score, BOOL bAllowNegativeScore )
{
	// Positive score always adds
	if ( score < 0 )
	{
		if ( !bAllowNegativeScore )
		{
			if ( pev->frags < 0 )		// Can't go more negative
				return;
			
			if ( -score > pev->frags )	// Will this go negative?
			{
				score = -pev->frags;		// Sum will be 0
			}
		}
	}

	pev->frags += score;
/*
	MESSAGE_BEGIN( MSG_ALL, gmsgScoreInfo );
		WRITE_BYTE( ENTINDEX(edict()) );
		WRITE_SHORT( pev->frags );
		WRITE_SHORT( m_iDeaths );
	MESSAGE_END();
*/
	MESSAGE_BEGIN( MSG_ALL, gmsgScoreInfo );
	WRITE_BYTE( ENTINDEX(edict()) );
	// WRITE_SHORT( pev->frags );
	// EurOPiuM - 18032002 - fichier profil
	WRITE_SHORT( ietoiles );
	WRITE_SHORT( m_iDeaths );
	MESSAGE_END();

}

void CBasePlayer::AddPointsToTeam( int score, BOOL bAllowNegativeScore )
{
	int index = entindex();

	for ( int i = 1; i <= gpGlobals->maxClients; i++ )
	{
		CBaseEntity *pPlayer = UTIL_PlayerByIndex( i );

		if ( pPlayer && i != index )
		{
			if ( g_pGameRules->PlayerRelationship( this, pPlayer ) == GR_TEAMMATE )
			{
				pPlayer->AddPoints( score, bAllowNegativeScore );
			}
		}
	}
}

// play a footstep if it's time - this will eventually be frame-based. not time based.

#define STEP_CONCRETE	0		// default step sound
#define STEP_METAL		1		// metal floor
#define STEP_DIRT		2		// dirt, sand, rock
#define STEP_VENT		3		// ventillation duct
#define STEP_GRATE		4		// metal grating
#define STEP_TILE		5		// floor tiles
#define STEP_SLOSH		6		// shallow liquid puddle
#define STEP_WADE		7		// wading in liquid
#define STEP_LADDER		8		// climbing ladder

// Play correct step sound for material we're on or in

void CBasePlayer :: PlayStepSound(int step, float fvol)
{
	static int iSkipStep = 0;

	if ( !g_pGameRules->PlayFootstepSounds( this, fvol ) )
		return;
/*
	// Groove - 01042002 - Worm qui marche
	switch( RANDOM_LONG( 1,2 ))
	{
	case 1:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/mouvement/marche1.wav", fvol, ATTN_NORM);	break;
	case 2:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/mouvement/marche2.wav", fvol, ATTN_NORM);	break;
	}*/
	int irand = RANDOM_LONG( 0,3 );

	switch (step)
	{
	default:
		return;
/*	case STEP_CONCRETE: //Beton
		switch (irand)
		{
		// right foot
		case 0:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_step1.wav", fvol, ATTN_NORM);	break;
		case 1:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_step3.wav", fvol, ATTN_NORM);	break;
		// left foot
		case 2:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_step2.wav", fvol, ATTN_NORM);	break;
		case 3:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_step4.wav", fvol, ATTN_NORM);	break;
		}
		break;
	case STEP_METAL: //Metal
		switch(irand)
		{
		// right foot
		case 0:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_metal1.wav", fvol, ATTN_NORM);	break;
		case 1:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_metal3.wav", fvol, ATTN_NORM);	break;
		// left foot
		case 2:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_metal2.wav", fvol, ATTN_NORM);	break;
		case 3:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_metal4.wav", fvol, ATTN_NORM);	break;
		}
		break;
	case STEP_DIRT: //Terre/salet
		switch(irand)
		{
		// right foot
		case 0:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_dirt1.wav", fvol, ATTN_NORM);	break;
		case 1:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_dirt3.wav", fvol, ATTN_NORM);	break;
		// left foot
		case 2:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_dirt2.wav", fvol, ATTN_NORM);	break;
		case 3:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_dirt4.wav", fvol, ATTN_NORM);	break;
		}
		break;
	case STEP_VENT: //Tuyau
		switch(irand)
		{
		// right foot
		case 0:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_duct1.wav", fvol, ATTN_NORM);	break;
		case 1:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_duct3.wav", fvol, ATTN_NORM);	break;
		// left foot
		case 2:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_duct2.wav", fvol, ATTN_NORM);	break;
		case 3:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_duct4.wav", fvol, ATTN_NORM);	break;
		}
		break;
	case STEP_GRATE: //Grilles
		switch(irand)
		{
		// right foot
		case 0:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_grate1.wav", fvol, ATTN_NORM);	break;
		case 1:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_grate3.wav", fvol, ATTN_NORM);	break;
		// left foot
		case 2:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_grate2.wav", fvol, ATTN_NORM);	break;
		case 3:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_grate4.wav", fvol, ATTN_NORM);	break;
		}
		break;
	case STEP_TILE: //Tuile
		if (!RANDOM_LONG(0,4))
			irand = 4;
		switch(irand)
		{
		// right foot
		case 0:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_tile1.wav", fvol, ATTN_NORM);	break;
		case 1:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_tile3.wav", fvol, ATTN_NORM);	break;
		// left foot
		case 2:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_tile2.wav", fvol, ATTN_NORM);	break;
		case 3:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_tile4.wav", fvol, ATTN_NORM);	break;
		case 4: EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_tile5.wav", fvol, ATTN_NORM);	break;
		}
		break;*/
	case STEP_SLOSH: //Flaque d'eau
		switch(irand)
		{
		// right foot
		case 0:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_slosh1.wav", fvol, ATTN_NORM);	break;
		case 1:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_slosh3.wav", fvol, ATTN_NORM);	break;
		// left foot
		case 2:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_slosh2.wav", fvol, ATTN_NORM);	break;
		case 3:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_slosh4.wav", fvol, ATTN_NORM);	break;
		}
		break;
	case STEP_WADE: //Dans l'eau
		if ( iSkipStep == 0 )
		{
			iSkipStep++;
			break;
		}

		if ( iSkipStep++ == 3 )
		{
			iSkipStep = 0;
		}

		switch (irand)
		{
		// right foot
		case 0:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_wade1.wav", fvol, ATTN_NORM);	break;
		case 1:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_wade2.wav", fvol, ATTN_NORM);	break;
		// left foot
		case 2:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_wade3.wav", fvol, ATTN_NORM);	break;
		case 3:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_wade4.wav", fvol, ATTN_NORM);	break;
		}
		break;
	case STEP_LADDER: //Echelle
		switch(irand)
		{
		// right foot
		case 0:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_ladder1.wav", fvol, ATTN_NORM);	break;
		case 1:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_ladder3.wav", fvol, ATTN_NORM);	break;
		// left foot
		case 2:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_ladder2.wav", fvol, ATTN_NORM);	break;
		case 3:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_ladder4.wav", fvol, ATTN_NORM);	break;
		}
		break;
	}
	
}	

// Simple mapping from texture type character to step type

int MapTextureTypeStepType(char chTextureType)
{
switch (chTextureType)
	{
	default:
	case CHAR_TEX_CONCRETE:	return STEP_CONCRETE;	
	case CHAR_TEX_METAL: return STEP_METAL;	
	case CHAR_TEX_DIRT: return STEP_DIRT;	
	case CHAR_TEX_VENT: return STEP_VENT;	
	case CHAR_TEX_GRATE: return STEP_GRATE;	
	case CHAR_TEX_TILE: return STEP_TILE;
	case CHAR_TEX_SLOSH: return STEP_SLOSH;
	}
}

// Play left or right footstep based on material player is on or in

void CBasePlayer :: UpdateStepSound( void )
{
	int	fWalking;
	float fvol;
	char szbuffer[64];
	const char *pTextureName;
	Vector start, end;
	float rgfl1[3];
	float rgfl2[3];
	Vector knee;
	Vector feet;
	Vector center;
	float height;
	float speed;
	float velrun;
	float velwalk;
	float flduck;
	int	fLadder;
	int step;

	if (gpGlobals->time <= m_flTimeStepSound)
		return;

	if (pev->flags & FL_FROZEN)
		return;

	speed = pev->velocity.Length();

	// determine if we are on a ladder
	fLadder = IsOnLadder();

	// UNDONE: need defined numbers for run, walk, crouch, crouch run velocities!!!!	
	if (FBitSet(pev->flags, FL_DUCKING) || fLadder)
	{
		velwalk = 60;		// These constants should be based on cl_movespeedkey * cl_forwardspeed somehow
		velrun = 80;		// UNDONE: Move walking to server
		flduck = 0.1;
	}
	else
	{
		velwalk = 120;
		velrun = 210;
		flduck = 0.0;
	}

	// ALERT (at_console, "vel: %f\n", vecVel.Length());
	
	// if we're on a ladder or on the ground, and we're moving fast enough,
	// play step sound.  Also, if m_flTimeStepSound is zero, get the new
	// sound right away - we just started moving in new level.

	if ((fLadder || FBitSet (pev->flags, FL_ONGROUND)) && pev->velocity != g_vecZero 
		&& (speed >= velwalk || !m_flTimeStepSound))
	{
		SetAnimation( PLAYER_WALK );
		
		fWalking = speed < velrun;		

		center = knee = feet = (pev->absmin + pev->absmax) * 0.5;
		height = pev->absmax.z - pev->absmin.z;

		knee.z = pev->absmin.z + height * 0.2;
		feet.z = pev->absmin.z;

		// find out what we're stepping in or on...
		if (fLadder)
		{
			step = STEP_LADDER;
			fvol = 0.35;
			m_flTimeStepSound = gpGlobals->time + 0.35;
		}
		else if ( UTIL_PointContents ( knee ) == CONTENTS_WATER )
		{
			step = STEP_WADE;
			fvol = 0.65;
			m_flTimeStepSound = gpGlobals->time + 0.6;
		}
		else if (UTIL_PointContents ( feet ) == CONTENTS_WATER )
		{
			step = STEP_SLOSH;
			fvol = fWalking ? 0.2 : 0.5;
			m_flTimeStepSound = fWalking ? gpGlobals->time + 0.4 : gpGlobals->time + 0.3;		
		}
		else
		{
			// find texture under player, if different from current texture, 
			// get material type

			start = end = center;							// center point of player BB
			start.z = end.z = pev->absmin.z;				// copy zmin
			start.z += 4.0;									// extend start up
			end.z -= 24.0;									// extend end down
			
			start.CopyToArray(rgfl1);
			end.CopyToArray(rgfl2);

			pTextureName = TRACE_TEXTURE( ENT( pev->groundentity), rgfl1, rgfl2 );
			if ( pTextureName )
			{
				// strip leading '-0' or '{' or '!'
				if (*pTextureName == '-')
					pTextureName += 2;
				if (*pTextureName == '{' || *pTextureName == '!')
					pTextureName++;
				
				if (_strnicmp(pTextureName, m_szTextureName, CBTEXTURENAMEMAX-1))
				{
					// current texture is different from texture player is on...
					// set current texture
					strcpy(szbuffer, pTextureName);
					szbuffer[CBTEXTURENAMEMAX - 1] = 0;
					strcpy(m_szTextureName, szbuffer);
					
					// ALERT ( at_aiconsole, "texture: %s\n", m_szTextureName );

					// get texture type
					m_chTextureType = TEXTURETYPE_Find(m_szTextureName);	
				}
			}
			
			step = MapTextureTypeStepType(m_chTextureType);

			switch (m_chTextureType)
			{
			default:
			case CHAR_TEX_CONCRETE:						
				fvol = fWalking ? 0.2 : 0.5;
				m_flTimeStepSound = fWalking ? gpGlobals->time + 0.4 : gpGlobals->time + 0.3;
				break;

			case CHAR_TEX_METAL:	
				fvol = fWalking ? 0.2 : 0.5;
				m_flTimeStepSound = fWalking ? gpGlobals->time + 0.4 : gpGlobals->time + 0.3;
				break;

			case CHAR_TEX_DIRT:	
				fvol = fWalking ? 0.25 : 0.55;
				m_flTimeStepSound = fWalking ? gpGlobals->time + 0.4 : gpGlobals->time + 0.3;
				break;

			case CHAR_TEX_VENT:	
				fvol = fWalking ? 0.4 : 0.7;
				m_flTimeStepSound = fWalking ? gpGlobals->time + 0.4 : gpGlobals->time + 0.3;
				break;

			case CHAR_TEX_GRATE:
				fvol = fWalking ? 0.2 : 0.5;
				m_flTimeStepSound = fWalking ? gpGlobals->time + 0.4 : gpGlobals->time + 0.3;
				break;

			case CHAR_TEX_TILE:	
				fvol = fWalking ? 0.2 : 0.5;
				m_flTimeStepSound = fWalking ? gpGlobals->time + 0.4 : gpGlobals->time + 0.3;
				break;

			case CHAR_TEX_SLOSH:
				fvol = fWalking ? 0.2 : 0.5;
				m_flTimeStepSound = fWalking ? gpGlobals->time + 0.4 : gpGlobals->time + 0.3;
				break;
			}
		}
		
		m_flTimeStepSound += flduck; // slower step time if ducking

		// play the sound

		// 35% volume if ducking
		if ( pev->flags & FL_DUCKING )
			fvol *= 0.35;
	}
}

void CBasePlayer::PreThink( void )
{
	// EurOPiuM - 21042002 - Croisement
	CBaseEntity *point = FindEntityForward( this );
	if( point!=NULL && FClassnameIs( point->pev,"player" ))
	{ 
		MESSAGE_BEGIN( MSG_ONE, gmsgCroise, NULL, pev );
			WRITE_BYTE( point->entindex( ));
		MESSAGE_END( );
	}

	int buttonsChanged = (m_afButtonLast ^ pev->button);	// These buttons have changed this frame
	
	// Debounced button codes for pressed/released
	// UNDONE: Do we need auto-repeat?
	m_afButtonPressed =  buttonsChanged & pev->button;		// The changed ones still down are "pressed"
	m_afButtonReleased = buttonsChanged & (~pev->button);	// The ones not down are "released"

	g_pGameRules->PlayerThink( this );

	if ( g_fGameOver )
		return;         // intermission or finale

	ItemPreFrame( );
    
	GfWormsDansEau( );

	// JOHN: checks if new client data (for HUD and view control) needs to be sent to the client
	UpdateClientData( );
	
	CheckTimeBasedDamage( );

	if( pev->deadflag >= DEAD_DYING )
	{
		PlayerDeathThink( );
		return;
	}


	//EurOPiuM - 20/06/02 - lance flamme
	pev->vuser1 = pev->v_angle;


	// So the correct flags get sent to client asap.
	//
	if ( m_afPhysicsFlags & PFLAG_ONTRAIN )
		pev->flags |= FL_ONTRAIN;
	else 
		pev->flags &= ~FL_ONTRAIN;

	// Train speed control
	if ( m_afPhysicsFlags & PFLAG_ONTRAIN )
	{
		CBaseEntity *pTrain = CBaseEntity::Instance( pev->groundentity );
		float vel;
		
		if ( !pTrain )
		{
			TraceResult trainTrace;
			// Maybe this is on the other side of a level transition
			UTIL_TraceLine( pev->origin, pev->origin + Vector(0,0,-38), ignore_monsters, ENT(pev), &trainTrace );

			// HACKHACK - Just look for the func_tracktrain classname
			if ( trainTrace.flFraction != 1.0 && trainTrace.pHit )
			pTrain = CBaseEntity::Instance( trainTrace.pHit );


			if ( !pTrain || !(pTrain->ObjectCaps() & FCAP_DIRECTIONAL_USE) || !pTrain->OnControls(pev) )
			{
				//ALERT( at_error, "In train mode with no train!\n" );
				m_afPhysicsFlags &= ~PFLAG_ONTRAIN;
				m_iTrain = TRAIN_NEW|TRAIN_OFF;
				return;
			}
		}
		else if ( !FBitSet( pev->flags, FL_ONGROUND ) || FBitSet( pTrain->pev->spawnflags, SF_TRACKTRAIN_NOCONTROL ) || (pev->button & (IN_MOVELEFT|IN_MOVERIGHT) ) )
		{
			// Turn off the train if you jump, strafe, or the train controls go dead
			m_afPhysicsFlags &= ~PFLAG_ONTRAIN;
			m_iTrain = TRAIN_NEW|TRAIN_OFF;
			return;
		}

		pev->velocity = g_vecZero;
		vel = 0;
		if ( m_afButtonPressed & IN_FORWARD )
		{
			vel = 1;
			pTrain->Use( this, this, USE_SET, (float)vel );
		}
		else if ( m_afButtonPressed & IN_BACK )
		{
			vel = -1;
			pTrain->Use( this, this, USE_SET, (float)vel );
		}

		if (vel)
		{
			m_iTrain = TrainSpeed(pTrain->pev->speed, pTrain->pev->impulse);
			m_iTrain |= TRAIN_ACTIVE|TRAIN_NEW;
		}

	} 
	else if (m_iTrain & TRAIN_ACTIVE)
		m_iTrain = TRAIN_NEW; // turn off train

	// Groove - 27032002 - Mouvement du joueur
	if( pev->button & ( IN_JUMP|IN_JUMP2 ))
		Jump( );

	if(( pev->button & IN_DUCK )|| FBitSet( pev->flags,FL_DUCKING )||( m_afPhysicsFlags & PFLAG_DUCKING ))
		Duck();

	// Groove - 27032002 - Pas du joueur
//	UpdateStepSound( );

	if ( !FBitSet ( pev->flags, FL_ONGROUND ))
		m_flFallVelocity = -pev->velocity.z;

	m_hEnemy = NULL;

	if( m_afPhysicsFlags & PFLAG_ONBARNACLE )
		pev->velocity = g_vecZero;
}

void CBasePlayer::CheckTimeBasedDamage( void ) 
{
	int i;
	BYTE bDuration = 0;

	static float gtbdPrev = 0.0;

	if (!(m_bitsDamageType & DMG_TIMEBASED))
		return;

	// only check for time based damage approx. every 2 seconds
	if (abs(gpGlobals->time - m_tbdPrev) < 2.0)
		return;
	
	m_tbdPrev = gpGlobals->time;

	for (i = 0; i < CDMG_TIMEBASED; i++)
	{
		// make sure bit is set for damage type
		if (m_bitsDamageType & (DMG_PARALYZE << i))
		{
			switch (i)
			{
			case itbd_Paralyze:
				// UNDONE - flag movement as half-speed
				bDuration = PARALYZE_DURATION;
				break;
			case itbd_NerveGas:
//				TakeDamage(pev, pev, NERVEGAS_DAMAGE, DMG_GENERIC);	
				bDuration = NERVEGAS_DURATION;
				break;
			case itbd_Poison:
				TakeDamage(pev, pev, POISON_DAMAGE, Gm_DMG_RADIOACTIF );
				bDuration = POISON_DURATION;
				break;
			case itbd_Radiation:
//				TakeDamage(pev, pev, RADIATION_DAMAGE, DMG_GENERIC);
				bDuration = RADIATION_DURATION;
				break;
			case itbd_DrownRecover:
				// NOTE: this hack is actually used to RESTORE health
				// after the player has been drowning and finally takes a breath
				if (m_idrowndmg > m_idrownrestored)
				{
					int idif = min(m_idrowndmg - m_idrownrestored, 10);

					TakeHealth( idif, Gm_DMG_EXPLOSION );
					m_idrownrestored += idif;
				}
				bDuration = 4;	// get up to 5*10 = 50 points back
				break;
			case itbd_Acid:
//				TakeDamage(pev, pev, ACID_DAMAGE, DMG_GENERIC);
				bDuration = ACID_DURATION;
				break;
			case itbd_SlowBurn:
//				TakeDamage(pev, pev, SLOWBURN_DAMAGE, DMG_GENERIC);
				bDuration = SLOWBURN_DURATION;
				break;
			case itbd_SlowFreeze:
//				TakeDamage(pev, pev, SLOWFREEZE_DAMAGE, DMG_GENERIC);
				bDuration = SLOWFREEZE_DURATION;
				break;
			default:
				bDuration = 0;
			}

			if( m_rgbTimeBasedDamage[i] )
			{
				// decrement damage duration, detect when done.
				if (!m_rgbTimeBasedDamage[i] || --m_rgbTimeBasedDamage[i] == 0)
				{
					m_rgbTimeBasedDamage[i] = 0;
					// if we're done, clear damage bits
					m_bitsDamageType &= ~(DMG_PARALYZE << i);	
				}
			}
			else
				// first time taking this damage type - init damage duration
				m_rgbTimeBasedDamage[i] = bDuration;
		}
	}
}

// if in range of radiation source, ping geiger counter
#define GEIGERDELAY 0.25

void CBasePlayer :: UpdateGeigerCounter( void )
{
	BYTE range;

	// delay per update ie: don't flood net with these msgs
	if (gpGlobals->time < m_flgeigerDelay)
		return;

	m_flgeigerDelay = gpGlobals->time + GEIGERDELAY;
		
	// send range to radition source to client

	range = (BYTE) (m_flgeigerRange / 4);

	if (range != m_igeigerRangePrev)
	{
		m_igeigerRangePrev = range;

		MESSAGE_BEGIN( MSG_ONE, gmsgGeigerRange, NULL, pev );
			WRITE_BYTE( range );
		MESSAGE_END();
	}

	// reset counter and semaphore
	if (!RANDOM_LONG(0,3))
		m_flgeigerRange = 1000;

}

/*
================
CheckPowerups

Check for turning off powerups

GLOBALS ASSUMED SET:  g_ulModelIndexPlayer
================
*/
static void CheckPowerups(entvars_t *pev)
{
	if (pev->health <= 0)
		return;

	pev->modelindex = g_ulModelIndexPlayer;    // don't use eyes
}

// Groove - 07052002 - Sons pour l'ambiance
void CBasePlayer::GfWormsSonAmbience( void )
{ 
	if( !fGvSonAmbience ||( fGvSonAmbience < gpGlobals->time ))
	{
		fGvSonAmbience = gpGlobals->time + RANDOM_FLOAT( 10.0, 20.0 );

		if( g_pGameRules->GvMortSubite )
		{
			EMIT_SOUND( ENT(pev), CHAN_VOICE, Gf_SOUND_DOMMAGE_COEUR_01, 0.7, ATTN_NORM );
		}
		else if( pev->health < ( GvWormVieCMD.value / 4 ))
		{
			switch( RANDOM_LONG( 1,4 ))
			{
				case 1 : EMIT_SOUND( ENT(pev), CHAN_VOICE, Gf_SOUND_DOMMAGE_MALADE_01, 1, ATTN_NORM ); break;
				case 2 : EMIT_SOUND( ENT(pev), CHAN_VOICE, Gf_SOUND_DOMMAGE_MALADE_02, 1, ATTN_NORM ); break;
				case 3 : EMIT_SOUND( ENT(pev), CHAN_VOICE, Gf_SOUND_DOMMAGE_MALADE_03, 1, ATTN_NORM ); break;
				case 4 : EMIT_SOUND( ENT(pev), CHAN_VOICE, Gf_SOUND_DOMMAGE_MALADE_04, 1, ATTN_NORM ); break;
			}			
		}
		else
		{
			switch( RANDOM_LONG( 1,15 ))
			{
				case 1 : EMIT_SOUND( ENT(pev), CHAN_VOICE, Gf_SOUND_AMBIANCE_RIEN_01, 1, ATTN_NORM ); break;
				case 2 : EMIT_SOUND( ENT(pev), CHAN_VOICE, Gf_SOUND_AMBIANCE_RIEN_02, 1, ATTN_NORM ); break;
				case 3 : EMIT_SOUND( ENT(pev), CHAN_VOICE, Gf_SOUND_AMBIANCE_RIEN_03, 1, ATTN_NORM ); break;
				case 4 : EMIT_SOUND( ENT(pev), CHAN_VOICE, Gf_SOUND_AMBIANCE_RIEN_04, 1, ATTN_NORM ); break;
				case 5 : EMIT_SOUND( ENT(pev), CHAN_VOICE, Gf_SOUND_AMBIANCE_RIEN_05, 1, ATTN_NORM ); break;
				case 6 : EMIT_SOUND( ENT(pev), CHAN_VOICE, Gf_SOUND_AMBIANCE_RIEN_06, 1, ATTN_NORM ); break;
				case 7 : EMIT_SOUND( ENT(pev), CHAN_VOICE, Gf_SOUND_AMBIANCE_RIEN_07, 1, ATTN_NORM ); break;
				case 8 : EMIT_SOUND( ENT(pev), CHAN_VOICE, Gf_SOUND_AMBIANCE_RIEN_08, 1, ATTN_NORM ); break;
				case 9 : EMIT_SOUND( ENT(pev), CHAN_VOICE, Gf_SOUND_AMBIANCE_RIEN_09, 1, ATTN_NORM ); break;
				case 10 : EMIT_SOUND( ENT(pev), CHAN_VOICE, Gf_SOUND_AMBIANCE_RIEN_10, 1, ATTN_NORM ); break;
				case 11 : EMIT_SOUND( ENT(pev), CHAN_VOICE, Gf_SOUND_AMBIANCE_RIEN_11, 1, ATTN_NORM ); break;
				case 12 : EMIT_SOUND( ENT(pev), CHAN_VOICE, Gf_SOUND_AMBIANCE_RIEN_12, 1, ATTN_NORM ); break;
				case 13 : EMIT_SOUND( ENT(pev), CHAN_VOICE, Gf_SOUND_AMBIANCE_RIEN_13, 1, ATTN_NORM ); break;
				case 14 : EMIT_SOUND( ENT(pev), CHAN_VOICE, Gf_SOUND_AMBIANCE_RIEN_14, 1, ATTN_NORM ); break;
				case 15 : EMIT_SOUND( ENT(pev), CHAN_VOICE, Gf_SOUND_AMBIANCE_RIEN_15, 1, ATTN_NORM ); break;
			}
		}
	}
}

//=========================================================
// UpdatePlayerSound - updates the position of the player's
// reserved sound slot in the sound list.
//=========================================================
void CBasePlayer :: UpdatePlayerSound ( void )
{
	GfWormsSonAmbience( );
	
	int iBodyVolume;
	int iVolume;
	CSound *pSound;

	pSound = CSoundEnt::SoundPointerForIndex( CSoundEnt :: ClientSoundIndex( edict() ) );

	if ( !pSound )
	{
		ALERT ( at_console, "Client lost reserved sound!\n" );
		return;
	}

	pSound->m_iType = bits_SOUND_NONE;

	// now calculate the best target volume for the sound. If the player's weapon
	// is louder than his body/movement, use the weapon volume, else, use the body volume.
	
	if ( FBitSet ( pev->flags, FL_ONGROUND ) )
	{	
		iBodyVolume = pev->velocity.Length(); 

		// clamp the noise that can be made by the body, in case a push trigger,
		// weapon recoil, or anything shoves the player abnormally fast. 
		if ( iBodyVolume > 512 )
		{
			iBodyVolume = 512;
		}
	}
	else
	{
		iBodyVolume = 0;
	}

	if( pev->button & ( IN_JUMP|IN_JUMP2 ))
		iBodyVolume += 100;

	m_iTargetVolume = iBodyVolume;

	// if target volume is greater than the player sound's current volume, we paste the new volume in 
	// immediately. If target is less than the current volume, current volume is not set immediately to the
	// lower volume, rather works itself towards target volume over time. This gives monsters a much better chance
	// to hear a sound, especially if they don't listen every frame.
	iVolume = pSound->m_iVolume;

	if ( m_iTargetVolume > iVolume )
	{
		iVolume = m_iTargetVolume;
	}
	else if ( iVolume > m_iTargetVolume )
	{
		iVolume -= 250 * gpGlobals->frametime;

		if ( iVolume < m_iTargetVolume )
		{
			iVolume = 0;
		}
	}

	if ( gpGlobals->time > m_flStopExtraSoundTime )
	{
		// since the extra sound that a weapon emits only lasts for one client frame, we keep that sound around for a server frame or two 
		// after actual emission to make sure it gets heard.
		m_iExtraSoundTypes = 0;
	}

	if ( pSound )
	{
		pSound->m_vecOrigin = pev->origin;
		pSound->m_iType |= ( bits_SOUND_PLAYER | m_iExtraSoundTypes );
		pSound->m_iVolume = iVolume;
	}

	// keep track of virtual muzzle flash
	m_iWeaponFlash -= 256 * gpGlobals->frametime;
	if (m_iWeaponFlash < 0)
		m_iWeaponFlash = 0;

	UTIL_MakeVectors ( pev->angles );
	gpGlobals->v_forward.z = 0;

	// Below are a couple of useful little bits that make it easier to determine just how much noise the 
	// player is making. 
	// UTIL_ParticleEffect ( pev->origin + gpGlobals->v_forward * iVolume, g_vecZero, 255, 25 );
	//ALERT ( at_console, "%d/%d\n", iVolume, m_iTargetVolume );
}


void CBasePlayer::PostThink( void )
{
	if( g_fGameOver )
		goto pt_end;         // intermission or finale

	if( !IsAlive( ))
		goto pt_end;

	// Handle Tank controlling
	if( m_pTank != NULL )
	{ // if they've moved too far from the gun,  or selected a weapon, unuse the gun
		if( m_pTank->OnControls( pev ) && !pev->weaponmodel )
			m_pTank->Use( this, this, USE_SET, 2 );	// try fire the gun
		else
			m_pTank->Use( this, this, USE_OFF, 0 );
			m_pTank = NULL;
	}

// do weapon stuff
	ItemPostFrame( );

// check to see if player landed hard enough to make a sound
// falling farther than half of the maximum safe distance, but not as far a max safe distance will
// play a bootscrape sound, and no damage will be inflicted. Fallling a distance shorter than half
// of maximum safe distance will make no sound. Falling farther than max safe distance will play a 
// fallpain sound, and damage will be inflicted based on how far the player fell

	if(( FBitSet( pev->flags, FL_ONGROUND ))&&( pev->health > 0 ) && m_flFallVelocity >= PLAYER_FALL_PUNCH_THRESHHOLD )
	{
		float fvol = 0.5;

		// ALERT ( at_console, "%f\n", m_flFallVelocity );

/*		if( pev->watertype == CONTENT_WATER )
		{
			// Did he hit the world or a non-moving entity?
			// BUG - this happens all the time in water, especially when 
			// BUG - water has current force
			// if ( !pev->groundentity || VARS(pev->groundentity)->velocity.z == 0 )
				// EMIT_SOUND(ENT(pev), CHAN_BODY, "player/pl_wade1.wav", 1, ATTN_NORM);
		}
		else */if ( m_flFallVelocity > PLAYER_MAX_SAFE_FALL_SPEED )
		{// after this point, we start doing damage
			float flFallDamage = g_pGameRules->FlPlayerFallDamage( this );

			if( flFallDamage > pev->health )
			{
				// Groove - 03122001 - Une grosse chute ca fait mal ;-)
				EMIT_SOUND(ENT(pev), CHAN_BODY, Gf_SOUND_DOMMAGE_CHUTE_01, 1, ATTN_NORM);
				switch( RANDOM_LONG( 1,3 ))
				{
					case 1 : EMIT_SOUND(ENT(pev), CHAN_BODY, Gf_SOUND_DOMMAGE_CHUTE_01, 1, ATTN_NORM);break;
					case 2 : EMIT_SOUND(ENT(pev), CHAN_BODY, Gf_SOUND_DOMMAGE_CHUTE_02, 1, ATTN_NORM);break;
					case 3 : EMIT_SOUND(ENT(pev), CHAN_BODY, Gf_SOUND_DOMMAGE_CHUTE_03, 1, ATTN_NORM);break;
				}			

			}

			if( flFallDamage > 0 )
			{
				// Groove - 19022002 - Dommage avec affichage
				TakeDamage(VARS(eoNullEntity), VARS(eoNullEntity), flFallDamage, Gm_DMG_CONTACT );  //DMG_FALL
				pev->punchangle.x = 0;
			}

			fvol = 1.0;
		}
		else if ( m_flFallVelocity > PLAYER_MAX_SAFE_FALL_SPEED / 2 )
			// EMIT_SOUND(ENT(pev), CHAN_VOICE, "player/pl_jumpland2.wav", 1, ATTN_NORM);
			fvol = 0.85;
		else if ( m_flFallVelocity < PLAYER_MIN_BOUNCE_SPEED )
			fvol = 0;

		if( fvol > 0.0 )
		{
			// get current texture under player right away
			m_flTimeStepSound = 0;
//			UpdateStepSound( );
		}

		if( IsAlive( ))
			SetAnimation( PLAYER_WALK );
    }

	if( FBitSet( pev->flags, FL_ONGROUND ))
	{		
		if( m_flFallVelocity > 64 && !g_pGameRules->IsMultiplayer( ))
			CSoundEnt::InsertSound ( bits_SOUND_PLAYER, pev->origin, m_flFallVelocity, 0.2 );
			// ALERT( at_console, "fall %f\n", m_flFallVelocity );
		m_flFallVelocity = 0;
	}

	// select the proper animation for the player character	
	if( IsAlive( ))
		if( !pev->velocity.x && !pev->velocity.y )
			SetAnimation( PLAYER_IDLE );
		else if(( pev->velocity.x || pev->velocity.y )&&( FBitSet( pev->flags, FL_ONGROUND )))
			SetAnimation( PLAYER_WALK );
		else if( pev->waterlevel > 1 )
			SetAnimation( PLAYER_WALK );

	StudioFrameAdvance( );
	CheckPowerups( pev );

	UpdatePlayerSound( );

	// Track button info so we can detect 'pressed' and 'released' buttons next frame
	m_afButtonLast = pev->button;

pt_end:
#if defined( CLIENT_WEAPONS )
		// Decay timers on weapons
	// go through all of the weapons and make a list of the ones to pack
	for( int i = 0 ; i < MAX_ITEM_TYPES ; i++ )
	{
		if ( m_rgpPlayerItems[ i ] )
		{
			CBasePlayerItem *pPlayerItem = m_rgpPlayerItems[ i ];

			while( pPlayerItem )
			{
/*				CBasePlayerWeapon *gun;

				gun = (CBasePlayerWeapon *)pPlayerItem->GetWeaponPtr();
				
				if ( gun && gun->UseDecrement() )
				{
					gun->fGvAttack1		= max( gun->fGvAttack1 - gpGlobals->frametime, -1.0 );
					gun->fGvAttack2		= max( gun->fGvAttack2 - gpGlobals->frametime, -0.001 );

					if ( gun->fGvAttack0 != 1000 )
						gun->fGvAttack0		= max( gun->fGvAttack0 - gpGlobals->frametime, -0.001 );
				}*/

				pPlayerItem = pPlayerItem->m_pNext;
			}
		}
	}

	m_flNextAttack -= gpGlobals->frametime;
	if ( m_flNextAttack < -0.001 )
		m_flNextAttack = -0.001;
#else
	return;
#endif
}


// checks if the spot is clear of players
BOOL IsSpawnPointValid( CBaseEntity *pPlayer, CBaseEntity *pSpot )
{
	CBaseEntity *ent = NULL;

	if( !pSpot->IsTriggered( pPlayer ))
		return FALSE;

	while(( ent = UTIL_FindEntityInSphere( ent, pSpot->pev->origin, 128 )) != NULL )
		// if ent is a client, don't spawn on 'em
		if( ent->IsPlayer( ) && ent != pPlayer )
			return FALSE;

	return TRUE;
}


DLL_GLOBAL CBaseEntity	*g_pLastSpawn;
inline int FNullEnt( CBaseEntity *ent ) { return (ent == NULL) || FNullEnt( ent->edict() ); }

/*
============
EntSelectSpawnPoint

Returns the entity to spawn at

USES AND SETS GLOBAL g_pLastSpawn
============
*/
// Groove - 03122001 - Pts de spawn en Teamplay
edict_t *EntSelectTeamSpawnPoint( CBaseEntity *pPlayer )
{
	CBaseEntity *pSpot;
	edict_t        *player; 

	player = pPlayer->edict();
	CBasePlayer *cbPlayer = (CBasePlayer *)pPlayer; // Get a CBasePlayer

	pSpot = g_pLastSpawn;
	// Randomize the start spot
	for( int i = RANDOM_LONG( 1,5 ); i > 0; i-- )
	{
		if( FStrEq( cbPlayer->m_szTeamName, "Wormsred" ))
			pSpot = UTIL_FindEntityByClassname( pSpot, "info_player_deathmatch" );
	    else if( FStrEq(cbPlayer->m_szTeamName, "Wormsblue" ))
            pSpot = UTIL_FindEntityByClassname( pSpot, "info_player_start" );
	    else // not team observer
			pSpot = UTIL_FindEntityByClassname( pSpot, "info_player_observer" );
	}

    if( FNullEnt( pSpot )) // skip over the null point
    {
			
		if( FStrEq(cbPlayer->m_szTeamName, "Wormsred" ))
            pSpot = UTIL_FindEntityByClassname( pSpot, "info_player_deathmatch" );
        else if (FStrEq(cbPlayer->m_szTeamName, "Wormsblue"))
            pSpot = UTIL_FindEntityByClassname( pSpot, "info_player_start" );
        else
            pSpot = UTIL_FindEntityByClassname( pSpot, "info_player_observer" );
    } 

    CBaseEntity *pFirstSpot = pSpot; 

    do
    {
        if( pSpot )
        {
            // check if pSpot is valid
            if( IsSpawnPointValid( pPlayer, pSpot ))
            {
                if( pSpot->pev->origin == Vector( 0, 0, 0 ) )
                {
					
                    if( FStrEq(cbPlayer->m_szTeamName, "Wormsred"))
                        pSpot = UTIL_FindEntityByClassname( pSpot, "info_player_deathmatch" );
                    else if( FStrEq(cbPlayer->m_szTeamName, "Wormsblue"))
                        pSpot = UTIL_FindEntityByClassname( pSpot, "info_player_start" );
					else
						pSpot = UTIL_FindEntityByClassname( pSpot, "info_player_observer" );
                    continue;
                } 

                // valid pSpot, so it can be returned
                goto ReturnSpot;
            }
        }
        // increment pSpot
		
		
        if( FStrEq( cbPlayer->m_szTeamName, "Wormsred" ))
            pSpot = UTIL_FindEntityByClassname( pSpot, "info_player_deathmatch" );
        else if( FStrEq( cbPlayer->m_szTeamName, "Wormsblue" ))
            pSpot = UTIL_FindEntityByClassname( pSpot, "info_player_start" );
		else
            pSpot = UTIL_FindEntityByClassname( pSpot, "info_player_observer" );

    } while ( pSpot != pFirstSpot ); // loop if we're not back to the start 

	// we haven't found a place to spawn yet, so kill any guy at the first spawn point and spawn there

    if( !FNullEnt( pSpot ))
    {
        CBaseEntity *ent = NULL;
        while(( ent = UTIL_FindEntityInSphere( ent, pSpot->pev->origin, 128 )) != NULL )
            // if ent is a client, kill em (unless they are ourselves)
            if( ent->IsPlayer() && !(ent->edict() == player) )
                ent->TakeDamage( VARS(INDEXENT(0)), VARS(INDEXENT(0)), 300, Gm_DMG_EXPLOSION );

		goto ReturnSpot;
    } 

ReturnSpot:
    if( FNullEnt( pSpot ))
    {
        ALERT( at_error, "PutClientInServer: no spawn points on level" );
        return INDEXENT( 0 );
    } 

    g_pLastSpawn = pSpot;
    return pSpot->edict( );
}

// Groove - 03122001 - Pts de spawn en Deathmatch
edict_t *EntSelectSpawnPoint( CBaseEntity *pPlayer )
{
	CBaseEntity *pSpot;
	edict_t		*player;

	player = pPlayer->edict();

	if( g_pGameRules->IsDeathmatch( ))
	{
		pSpot = g_pLastSpawn;
		// Randomize the start spot
		for( int i = RANDOM_LONG( 1,5 ); i > 0; i-- )
			pSpot = UTIL_FindEntityByClassname( pSpot, "info_player_deathmatch" );
		if( FNullEnt( pSpot ))  // skip over the null point
			pSpot = UTIL_FindEntityByClassname( pSpot, "info_player_deathmatch" );

		CBaseEntity *pFirstSpot = pSpot;

		do 
		{
			if( pSpot )
			{
				// check if pSpot is valid
				if( IsSpawnPointValid( pPlayer, pSpot ))
				{
					if ( pSpot->pev->origin == Vector( 0, 0, 0 ) )
					{
						pSpot = UTIL_FindEntityByClassname( pSpot, "info_player_deathmatch" );
						continue;
					}

					// if so, go to pSpot
					goto ReturnSpot;
				}
			}
			// increment pSpot
			pSpot = UTIL_FindEntityByClassname( pSpot, "info_player_deathmatch" );
		} while( pSpot != pFirstSpot ); // loop if we're not back to the start

		// we haven't found a place to spawn yet,  so kill any guy at the first spawn point and spawn there
		if( !FNullEnt( pSpot ))
		{
			CBaseEntity *ent = NULL;
			while(( ent = UTIL_FindEntityInSphere( ent, pSpot->pev->origin, 128 )) != NULL )
			{
				// if ent is a client, kill em (unless they are ourselves)
				if ( ent->IsPlayer() && !(ent->edict() == player) )
					ent->TakeDamage( VARS( INDEXENT( 0 )), VARS( INDEXENT( 0 )), 300, Gm_DMG_EXPLOSION );
			}
			goto ReturnSpot;
		}
	}

	// If startspot is set, (re)spawn there.
	if ( FStringNull( gpGlobals->startspot ) || !strlen(STRING(gpGlobals->startspot)))
	{
		pSpot = UTIL_FindEntityByClassname(NULL, "info_player_start");
		if( !FNullEnt( pSpot ))
			goto ReturnSpot;
	}
	else
	{
		pSpot = UTIL_FindEntityByTargetname( NULL, STRING(gpGlobals->startspot) );
		if( !FNullEnt( pSpot ))
			goto ReturnSpot;
	}

ReturnSpot:
	if( FNullEnt( pSpot ))
	{
		ALERT( at_error, "PutClientInServer: no info_player_start on level" );
		return INDEXENT(0);
	}

	g_pLastSpawn = pSpot;
	return pSpot->edict( );
}

// Groove - 27102001 - Proprit du worm au spawn
void CBasePlayer::Spawn( void )
{
	if( GvWormVieCMD.value > 250 )
		GvWormVieCMD.value = 250;
	else if( GvWormVieCMD.value < 50 )
		GvWormVieCMD.value = 50;

	pev->classname		= MAKE_STRING( "player" );
	pev->health			= GvWormVieCMD.value;
	pev->armorvalue		= 0;
	pev->takedamage		= DAMAGE_AIM;
	pev->solid			= SOLID_SLIDEBOX;
	pev->movetype		= MOVETYPE_WALK;
	pev->max_health		= GvWormVieCMD.value;
	pev->flags			= FL_CLIENT;
	pev->air_finished	= gpGlobals->time + 1;
	pev->dmg			= 2;				// initial water damage
	pev->effects		= 0;
	pev->deadflag		= DEAD_NO;
	pev->dmg_take		= 0;
	pev->dmg_save		= 0;
	pev->friction		= 1.0;
	pev->gravity		= Gm_WORM_GRAVITE;
	pev->maxspeed		= Gm_WORM_VITESSE;
	m_bitsHUDDamage		= -1;
	m_bitsDamageType	= 0;
	m_afPhysicsFlags	= 0;

	g_engfuncs.pfnSetPhysicsKeyValue( edict( ), "slj", "0" );
	g_engfuncs.pfnSetPhysicsKeyValue( edict( ), "hl", "1" );

	m_iFOV				= 0;// init field of view.
	m_iClientFOV		= -1; // make sure fov reset is sent

	m_flNextDecalTime	= 0;// let this player decal as soon as he spawns.

	m_flgeigerDelay = gpGlobals->time + 2.0;	// wait a few seconds until user-defined message registrations
												// are recieved by all clients
	m_flTimeStepSound	= 0;
	m_flFieldOfView		= 0.5;// some monsters use this to determine whether or not the player is looking at them.

	m_flNextAttack	= UTIL_WeaponTimeBase( );
	StartSneaking();

// dont let uninitialized value here hurt the player
	m_flFallVelocity = 0;
	iGvInvisible = 0;

	// Piv - 03032002 - Choix model
//	g_pGameRules->SetDefaultPlayerTeam( this );
	g_pGameRules->GetPlayerSpawnSpot( this );

    SET_MODEL( ENT( pev ), "models/player/wormsblue/wormsblue.mdl" );
    g_ulModelIndexPlayer = pev->modelindex;
	pev->sequence		= LookupActivity( ACT_IDLE );

	if( FBitSet( pev->flags, FL_DUCKING )) 
		UTIL_SetSize( pev, VEC_DUCK_HULL_MIN, VEC_DUCK_HULL_MAX );
	else
		UTIL_SetSize( pev, VEC_HULL_MIN, VEC_HULL_MAX );

    pev->view_ofs = VEC_VIEW;
	Precache( );
	m_HackedGunPos		= Vector( 0, 32, 0 );

	m_pLastItem = NULL;
	m_fInitHUD = TRUE;
	m_iClientHideHUD = -1;  // force this to be recalculated
	m_fWeapon = FALSE;
	m_pClientActiveItem = NULL;

	// reset all ammo values to 0
	for( int i = 0; i < MAX_AMMO_SLOTS; i++ )
	{
		m_rgAmmo[i] = 0;
		m_rgAmmoLast[i] = 0;  // client ammo values also have to be reset  (the death hud clear messages does on the client side)
	}

	g_pGameRules->PlayerSpawn( this );
}

void CBasePlayer :: Precache( void )
{
	// in the event that the player JUST spawned, and the level node graph
	// was loaded, fix all of the node graph pointers before the game starts.
	
	// !!!BUGBUG - now that we have multiplayer, this needs to be moved!
	if( WorldGraph.m_fGraphPresent && !WorldGraph.m_fGraphPointersSet )
		if( !WorldGraph.FSetGraphPointers() )
			ALERT ( at_console, "**Graph pointers were not set!\n");
		else
			ALERT ( at_console, "**Graph Pointers Set!\n" );

	// SOUNDS / MODELS ARE PRECACHED in ClientPrecache() (game specific)
	// because they need to precache before any clients have connected

	// init geiger counter vars during spawn and each time
	// we cross a level transition

	m_flgeigerRange = 1000;
	m_igeigerRangePrev = 1000;

	m_bitsDamageType = 0;
	m_bitsHUDDamage = -1;

	m_iTrain = TRAIN_NEW;

	// Make sure any necessary user messages have been registered
	LinkUserMessages();

	m_iUpdateTime = 5;  // won't update for 1/2 a second

	if ( gInitHUD )
		m_fInitHUD = TRUE;
}

void CBasePlayer::SelectNextItem( int iItem )
{
	CBasePlayerItem *pItem;

	pItem = m_rgpPlayerItems[ iItem ];
	
	if( !pItem )
		return;

	if( pItem == m_pActiveItem )
	{
		// select the next one in the chain
		pItem = m_pActiveItem->m_pNext; 
		if (! pItem)
			return;

		CBasePlayerItem *pLast;
		pLast = pItem;
		while( pLast->m_pNext )
			pLast = pLast->m_pNext;

		// relink chain
		pLast->m_pNext = m_pActiveItem;
		m_pActiveItem->m_pNext = NULL;
		m_rgpPlayerItems[ iItem ] = pItem;
	}

	// FIX, this needs to queue them up and delay
	if( m_pActiveItem )
		m_pActiveItem->Holster( );
	
	m_pActiveItem = pItem;

	if( m_pActiveItem )
	{
		m_pActiveItem->Deploy( );
		m_pActiveItem->UpdateItemInfo( );
	}
}

void CBasePlayer::SelectItem( const char *pstr )
{
	if( !pstr )
		return;

	CBasePlayerItem *pItem = NULL;

	for( int i = 0; i < MAX_ITEM_TYPES; i++ )
	{
		if( m_rgpPlayerItems[i] )
		{
			pItem = m_rgpPlayerItems[i];
	
			while( pItem )
			{
				if( FClassnameIs( pItem->pev, pstr ))
					break;
				pItem = pItem->m_pNext;
			}
		}

		if( pItem )
			break;
	}

	if( !pItem )
		return;

	
	if( pItem == m_pActiveItem )
		return;

	// FIX, this needs to queue them up and delay
	if( m_pActiveItem )
		m_pActiveItem->Holster( );
	
	m_pLastItem = m_pActiveItem;
	m_pActiveItem = pItem;

	if( m_pActiveItem )
	{
		m_pActiveItem->Deploy( );
		m_pActiveItem->UpdateItemInfo( );
	}
}

void CBasePlayer::SelectLastItem(void)
{
	if( !m_pLastItem )
		return;

	if( m_pActiveItem && !m_pActiveItem->CanHolster( ))
		return;

	// FIX, this needs to queue them up and delay
	if( m_pActiveItem )
		m_pActiveItem->Holster( );
	
	CBasePlayerItem *pTemp = m_pActiveItem;
	m_pActiveItem = m_pLastItem;
	m_pLastItem = pTemp;
	m_pActiveItem->Deploy( );
	m_pActiveItem->UpdateItemInfo( );
}

//==============================================
// HasWeapons - do I have any weapons at all?
//==============================================
BOOL CBasePlayer::HasWeapons( void )
{
	for( int i = 0 ; i < MAX_ITEM_TYPES ; i++ )
		if( m_rgpPlayerItems[ i ] )
			return TRUE;

	return FALSE;
}

const char *CBasePlayer::TeamID( void )
{
	if( pev == NULL )		// Not fully connected yet
		return "";

	// return their team name
	return m_szTeamName;
}


//==============================================
// !!!UNDONE:ultra temporary SprayCan entity to apply
// decal frame at a time. For PreAlpha CD
//==============================================
// Groove - 03122001 - Le tag !
class CSprayCan : public CBaseEntity
{
public:
	void	Spawn ( entvars_t *pevOwner );
	void	Think( void );

	virtual int	ObjectCaps( void ){ return FCAP_DONT_SAVE; }
};

void CSprayCan::Spawn( entvars_t *pevOwner )
{
	pev->origin = pevOwner->origin + Vector ( 0 , 0 , 32 );
	pev->angles = pevOwner->v_angle;
	pev->owner = ENT( pevOwner );
	pev->frame = 0;

	pev->nextthink = gpGlobals->time + 0.1;
	EMIT_SOUND( ENT( pev ), CHAN_VOICE, "player/sprayer.wav", 1, ATTN_NORM );
}

void CSprayCan::Think( void )
{
	TraceResult	tr;	
	int playernum;
	int nFrames;
	CBasePlayer *pPlayer;
	
	pPlayer = (CBasePlayer *)GET_PRIVATE(pev->owner);

	if( pPlayer )
		nFrames = pPlayer->GetCustomDecalFrames( );
	else
		nFrames = -1;

	playernum = ENTINDEX(pev->owner);
	
	// ALERT(at_console, "Spray by player %i, %i of %i\n", playernum, (int)(pev->frame + 1), nFrames);

	UTIL_MakeVectors(pev->angles);
	UTIL_TraceLine ( pev->origin, pev->origin + gpGlobals->v_forward * 128, ignore_monsters, pev->owner, & tr);

	// No customization present.
	if( nFrames == -1 )
	{
		UTIL_DecalTrace( &tr, DECAL_WORMSHL );
		UTIL_Remove( this );
	}
	else
	{
		UTIL_PlayerDecalTrace( &tr, playernum, pev->frame, TRUE );
		// Just painted last custom frame.
		if( pev->frame++ >= ( nFrames - 1 ))
			UTIL_Remove( this );
	}

	pev->nextthink = gpGlobals->time + 0.1;
}


void CBasePlayer::GiveNamedItem( const char *pszName )
{
	edict_t	*pent;

	int istr = MAKE_STRING(pszName);

	pent = CREATE_NAMED_ENTITY(istr);
	if( FNullEnt( pent ))
	{
		ALERT ( at_console, "NULL Ent in GiveNamedItem!\n" );
		return;
	}
	VARS( pent )->origin = pev->origin;
	pent->v.spawnflags |= SF_NORESPAWN;

	DispatchSpawn( pent );
	DispatchTouch( pent, ENT( pev ) );
}



CBaseEntity *FindEntityForward( CBaseEntity *pMe )
{
	TraceResult tr;

	UTIL_MakeVectors( pMe->pev->v_angle );
	UTIL_TraceLine(pMe->pev->origin + pMe->pev->view_ofs,pMe->pev->origin + pMe->pev->view_ofs + gpGlobals->v_forward * 8192,dont_ignore_monsters, pMe->edict(), &tr );
	if( tr.flFraction != 1.0 && !FNullEnt( tr.pHit ))
	{
		CBaseEntity *pHit = CBaseEntity::Instance( tr.pHit );
		return pHit;
	}
	return NULL;
}

/*
===============
ForceClientDllUpdate

When recording a demo, we need to have the server tell us the entire client state
so that the client side .dll can behave correctly.
Reset stuff so that the state is transmitted.
===============
*/
void CBasePlayer::ForceClientDllUpdate( void )
{
	m_iClientHealth  = -1;
	m_iTrain |= TRAIN_NEW;  // Force new train message.
	m_fWeapon = FALSE;          // Force weapon send
	m_fKnownItem = FALSE;    // Force weaponinit messages.

	// Now force all the necessary messages
	//  to be sent.
	UpdateClientData( );
}

void CBasePlayer::ImpulseCommands( void )
{
	TraceResult	tr;// UNDONE: kill me! This is temporary for PreAlpha CDs

	// Handle use events
	PlayerUse( );
		
	int iImpulse = (int)pev->impulse;
	switch( iImpulse )
	{
	case 99:
		{

		int iOn;

		if (!gmsgLogo)
		{
			iOn = 1;
			gmsgLogo = REG_USER_MSG("Logo", 1);
		} 
		else 
			iOn = 0;
		
		ASSERT( gmsgLogo > 0 );
		// send "health" update message
		MESSAGE_BEGIN( MSG_ONE, gmsgLogo, NULL, pev );
			WRITE_BYTE( iOn );
		MESSAGE_END( );

		if( !iOn )
			gmsgLogo = 0;
		break;
		}
	case	201:// paint decal
	
		if ( gpGlobals->time < m_flNextDecalTime )
		{
			// too early!
			break;
		}

		UTIL_MakeVectors( pev->v_angle );
		UTIL_TraceLine( pev->origin + pev->view_ofs, pev->origin + pev->view_ofs + gpGlobals->v_forward * 128, ignore_monsters, ENT( pev ), & tr );

		if( tr.flFraction != 1.0 )
		{// line hit something, so paint a decal
			m_flNextDecalTime = gpGlobals->time + CVAR_GET_FLOAT( "decalfrequency" );
			CSprayCan *pCan = GetClassPtr((CSprayCan *)NULL);
			pCan->Spawn( pev );
		}

		break;

	case    204:  //  Demo recording, update client dll specific data again.
		ForceClientDllUpdate(); 
		break;
	default:
		break;
	}
	
	pev->impulse = 0;
}

//
// Add a weapon to the player (Item == Weapon == Selectable Object)
//
int CBasePlayer::AddPlayerItem( CBasePlayerItem *pItem )
{
	CBasePlayerItem *pInsert;
	
	pInsert = m_rgpPlayerItems[pItem->iItemSlot()];

	while( pInsert )
	{
		if( FClassnameIs( pInsert->pev, STRING( pItem->pev->classname )))
		{
			if( pItem->AddDuplicate( pInsert ))
			{
				// ugly hack to update clip w/o an update clip message
				pInsert->UpdateItemInfo( );
				if( m_pActiveItem )
					m_pActiveItem->UpdateItemInfo( );

				pItem->Kill( );
			}
			return FALSE;
		}
		pInsert = pInsert->m_pNext;
	}


	if( pItem->AddToPlayer( this ))
	{
		pItem->m_pNext = m_rgpPlayerItems[pItem->iItemSlot()];
		m_rgpPlayerItems[pItem->iItemSlot()] = pItem;

		// should we switch to this item?
		if( g_pGameRules->FShouldSwitchWeapon( this, pItem ))
			SwitchWeapon( pItem );

		return TRUE;
	}
	return FALSE;
}



int CBasePlayer::RemovePlayerItem( CBasePlayerItem *pItem )
{
	if( m_pActiveItem == pItem )
	{
		pItem->Holster( );
		pItem->pev->nextthink = 0;// crowbar may be trying to swing again, etc.
		pItem->SetThink( NULL );
		m_pActiveItem = NULL;
		pev->viewmodel = 0;
		pev->weaponmodel = 0;
	}
	else if( m_pLastItem == pItem )
		m_pLastItem = NULL;

	CBasePlayerItem *pPrev = m_rgpPlayerItems[pItem->iItemSlot()];

	if( pPrev == pItem )
	{
		m_rgpPlayerItems[pItem->iItemSlot()] = pItem->m_pNext;
		return TRUE;
	}
	else
	{
		while (pPrev && pPrev->m_pNext != pItem)
			pPrev = pPrev->m_pNext;

		if( pPrev )
		{
			pPrev->m_pNext = pItem->m_pNext;
			return TRUE;
		}
	}
	return FALSE;
}


//
// Returns the unique ID for the ammo, or -1 if error
//
int CBasePlayer::GiveAmmo( int iCount, char *szName, int iMax )
{
	if( !szName )
		return -1;

	if( !g_pGameRules->CanHaveAmmo( this, szName, iMax ) )
		return -1;

	int i = 0;

	i = GetAmmoIndex( szName );

	if( i < 0 || i >= MAX_AMMO_SLOTS )
		return -1;

	int iAdd = min( iCount, iMax - m_rgAmmo[i] );
	if( iAdd < 1 )
		return i;

	m_rgAmmo[ i ] += iAdd;

	if( gmsgAmmoPickup )  // make sure the ammo messages have been linked first
	{
		// Send the message that ammo has been picked up
		MESSAGE_BEGIN( MSG_ONE, gmsgAmmoPickup, NULL, pev );
			WRITE_BYTE( GetAmmoIndex( szName ));		// ammo ID
			WRITE_BYTE( iAdd );		// amount
		MESSAGE_END();
	}

	return i;
}


/*
============
ItemPreFrame

Called every frame by the player PreThink
============
*/
void CBasePlayer::ItemPreFrame( void )
{
    if( gpGlobals->time < m_flNextAttack )
		return;

	if( !m_pActiveItem )
		return;

	m_pActiveItem->ItemPreFrame( );
}

/*
============
ItemPostFrame

Called every frame by the player PostThink
============
*/
void CBasePlayer::ItemPostFrame( void )
{
//	ClientPrint( pev, HUD_PRINTCONSOLE, UTIL_VarArgs( "zglu 1 \n"));
	// check if the player is using a tank
	if( m_pTank != NULL )
		return;

    if( gpGlobals->time < m_flNextAttack )
		return;

	ImpulseCommands( );

	if( !m_pActiveItem )
		return;

	m_pActiveItem->ItemPostFrame( );
//	ClientPrint( pev, HUD_PRINTCONSOLE, UTIL_VarArgs( "zglu 2 \n"));
}

int CBasePlayer::AmmoInventory( int iAmmoIndex )
{
	if( iAmmoIndex == -1 )
		return -1;

	return m_rgAmmo[iAmmoIndex];
}

int CBasePlayer::GetAmmoIndex( const char *psz )
{
	int i;

	if( !psz )
		return -1;

	for( i = 1; i < MAX_AMMO_SLOTS; i++ )
	{
		if( !CBasePlayerItem::AmmoInfoArray[i].pszName )
			continue;

		if( stricmp( psz, CBasePlayerItem::AmmoInfoArray[i].pszName ) == 0 )
			return i;
	}

	return -1;
}

// Called from UpdateClientData
// makes sure the client has all the necessary ammo info,  if values have changed
void CBasePlayer::SendAmmoUpdate( void )
{
	for( int i = 0; i < MAX_AMMO_SLOTS; i++ )
	{
		if( m_rgAmmo[i] != m_rgAmmoLast[i] )
		{
			m_rgAmmoLast[i] = m_rgAmmo[i];

			ASSERT( m_rgAmmo[i] >= 0 );
			ASSERT( m_rgAmmo[i] < 255 );

			// send "Ammo" update message
			MESSAGE_BEGIN( MSG_ONE, gmsgAmmoX, NULL, pev );
				WRITE_BYTE( i );
				WRITE_BYTE( max( min( m_rgAmmo[i], 254 ), 0 ));  // clamp the value to one byte
			MESSAGE_END( );
		}
	}
}

/*
=========================================================
	UpdateClientData

resends any changed player HUD info to the client.
Called every frame by PlayerPreThink
Also called at start of demo recording and playback by
ForceClientDllUpdate to ensure the demo gets messages
reflecting all of the HUD state info.
=========================================================
*/
//Groove - 14112001 - a voir
void CBasePlayer :: UpdateClientData( void )
{
	if( m_fInitHUD )
	{
		m_fInitHUD = FALSE;
		gInitHUD = FALSE;

		MESSAGE_BEGIN( MSG_ONE, gmsgResetHUD, NULL, pev );
			WRITE_BYTE( 0 );
		MESSAGE_END();

		if( !m_fGameHUDInitialized )
		{
			MESSAGE_BEGIN( MSG_ONE, gmsgInitHUD, NULL, pev );
			MESSAGE_END();

			// Piv - 14112001 - affiche le menu de changement d'equipe au demarrage de la partie
//			PfChangementEquipe( );

			g_pGameRules->InitHUD( this );
			m_fGameHUDInitialized = TRUE;
			if( g_pGameRules->IsMultiplayer( ))
				FireTargets( "game_playerjoin", this, this, USE_TOGGLE, 0 );
		}
		FireTargets( "game_playerspawn", this, this, USE_TOGGLE, 0 );
	}

	if( m_iHideHUD != m_iClientHideHUD )
	{
		MESSAGE_BEGIN( MSG_ONE, gmsgHideWeapon, NULL, pev );
			WRITE_BYTE( m_iHideHUD );
		MESSAGE_END();

		m_iClientHideHUD = m_iHideHUD;
	}

	if( m_iFOV != m_iClientFOV )
	{
		MESSAGE_BEGIN( MSG_ONE, gmsgSetFOV, NULL, pev );
			WRITE_BYTE( m_iFOV );
		MESSAGE_END();

		// cache FOV change at end of function, so weapon updates can see that FOV has changed
	}

	// HACKHACK -- send the message to display the game title
	if( gDisplayTitle )
	{
		MESSAGE_BEGIN( MSG_ONE, gmsgShowGameTitle, NULL, pev );
		WRITE_BYTE( 0 );
		MESSAGE_END();
		gDisplayTitle = 0;
	}

	if( pev->health != m_iClientHealth )
	{
		int iHealth = max( pev->health, 0 );  // make sure that no negative health values are sent

		// send "health" update message
		MESSAGE_BEGIN( MSG_ONE, gmsgHealth, NULL, pev );
			WRITE_BYTE( iHealth );
		MESSAGE_END();

		m_iClientHealth = pev->health;
	}

	if( pev->dmg_take || pev->dmg_save || m_bitsHUDDamage != m_bitsDamageType )
	{
		// Comes from inside me if not set
		Vector damageOrigin = pev->origin;
		// send "damage" message
		// causes screen to flash, and pain compass to show direction of damage
		edict_t *other = pev->dmg_inflictor;
		if( other )
		{
			CBaseEntity *pEntity = CBaseEntity::Instance( other );
			if( pEntity )
				damageOrigin = pEntity->Center( );
		}

		// only send down damage type that have hud art
		int visibleDamageBits = m_bitsDamageType & DMG_SHOWNHUD;

		MESSAGE_BEGIN( MSG_ONE, gmsgDamage, NULL, pev );
			//WRITE_BYTE( pev->dmg_save );
			//WRITE_BYTE( pev->dmg_take );
			WRITE_LONG( visibleDamageBits );
			//WRITE_COORD( damageOrigin.x );
			//WRITE_COORD( damageOrigin.y );
			//WRITE_COORD( damageOrigin.z );
		MESSAGE_END();
	
		pev->dmg_take = 0;
		pev->dmg_save = 0;
		m_bitsHUDDamage = m_bitsDamageType;
		
		// Clear off non-time-based damage indicators
		m_bitsDamageType &= DMG_TIMEBASED;
	}

	if( m_iTrain & TRAIN_NEW )
	{
		ASSERT( gmsgTrain > 0 );
		// send "health" update message
		MESSAGE_BEGIN( MSG_ONE, gmsgTrain, NULL, pev );
			WRITE_BYTE( m_iTrain & 0xF );
		MESSAGE_END();

		m_iTrain &= ~TRAIN_NEW;
	}

	//
	// New Weapon?
	//
	if( !m_fKnownItem )
	{
		m_fKnownItem = TRUE;

	// WeaponInit Message
	// byte  = # of weapons
	//
	// for each weapon:
	// byte		name str length (not including null)
	// bytes... name
	// byte		Ammo Type
	// byte		Ammo2 Type
	// byte		bucket
	// byte		bucket pos
	// byte		flags	
	// ????		Icons
		
		// Send ALL the weapon info now
		int i;

		for( i = 0; i < MAX_WEAPONS; i++ )
		{
			ItemInfo& II = CBasePlayerItem::ItemInfoArray[i];

			if( !II.iId )
				continue;

			const char *pszName;
			if( !II.pszName )
				pszName = "Empty";
			else
				pszName = II.pszName;

			MESSAGE_BEGIN( MSG_ONE, gmsgWeaponList, NULL, pev );  
				WRITE_STRING( pszName );					// string	weapon name
				WRITE_BYTE( GetAmmoIndex( II.pszAmmo1 ));	// byte		Ammo Type
				WRITE_BYTE( II.iMaxAmmo1 );					// byte     Max Ammo 1
				WRITE_BYTE( II.iSlot );						// byte		bucket
				WRITE_BYTE( II.iPosition );					// byte		bucket pos
				WRITE_BYTE( II.iId );						// byte		id (bit index into pev->weapons)
				WRITE_BYTE( II.iFlags );					// byte		Flags
			MESSAGE_END( );
		}
	}

	SendAmmoUpdate( );

	// Update all the items
	for( int i = 0; i < MAX_ITEM_TYPES; i++ )
		if( m_rgpPlayerItems[i] )  // each item updates it's successors
			m_rgpPlayerItems[i]->UpdateClientData( this );

	// Cache and client weapon change
	m_pClientActiveItem = m_pActiveItem;
	m_iClientFOV = m_iFOV;
}

//=========================================================
// Illumination 
// return player light level plus virtual muzzle flash
//=========================================================
int CBasePlayer :: Illumination( void )
{
	int iIllum = CBaseEntity::Illumination( );

	iIllum += m_iWeaponFlash;
	if (iIllum > 255)
		return 255;
	return iIllum;
}


void CBasePlayer :: EnableControl( BOOL fControl )
{
	if( !fControl )
		pev->flags |= FL_FROZEN;
	else
		pev->flags &= ~FL_FROZEN;
}

/*
=============
SetCustomDecalFrames

  UNDONE:  Determine real frame limit, 8 is a placeholder.
  Note:  -1 means no custom frames present.
=============
*/
void CBasePlayer :: SetCustomDecalFrames( int nFrames )
{
	if( nFrames > 0 && nFrames < 8 )
		m_nCustomSprayFrames = nFrames;
	else
		m_nCustomSprayFrames = -1;
}

/*
=============
GetCustomDecalFrames

  Returns the # of custom frames this player's custom clan logo contains.
=============
*/
int CBasePlayer :: GetCustomDecalFrames( void )
{
	return m_nCustomSprayFrames;
}

//=========================================================
// HasPlayerItem Does the player already have this item?
//=========================================================
BOOL CBasePlayer::HasPlayerItem( CBasePlayerItem *pCheckItem )
{
	CBasePlayerItem *pItem = m_rgpPlayerItems[pCheckItem->iItemSlot()];

	while( pItem )
	{
		if( FClassnameIs( pItem->pev, STRING( pCheckItem->pev->classname )))
			return TRUE;
		pItem = pItem->m_pNext;
	}

	return FALSE;
}

//=========================================================
// HasNamedPlayerItem Does the player already have this item?
//=========================================================
BOOL CBasePlayer::HasNamedPlayerItem( const char *pszItemName )
{
	CBasePlayerItem *pItem;
	int i;
 
	for( i = 0 ; i < MAX_ITEM_TYPES ; i++ )
	{
		pItem = m_rgpPlayerItems[ i ];
		
		while( pItem )
		{
			if( !strcmp( pszItemName, STRING( pItem->pev->classname )))
				return TRUE;
			pItem = pItem->m_pNext;
		}
	}

	return FALSE;
}

//=========================================================
// 
//=========================================================
BOOL CBasePlayer :: SwitchWeapon( CBasePlayerItem *pWeapon ) 
{
	if( !pWeapon->CanDeploy( ))
		return FALSE;
	
	if( m_pActiveItem )
		m_pActiveItem->Holster( );

	m_pActiveItem = pWeapon;
	pWeapon->Deploy( );

	return TRUE;
}

// Piv - 14102001 - envoi a la dll client le n du menu a afficher grace au msg VGUIMenu
void CBasePlayer::PfShowVGUI_i( int PvMenu_i )
{
	if( PvMenu_i == MENU_TEAM )
	{
		GvPlayerTPT.bMove = false;
		GvPlayerTPT.bTire = false;
	}

	if( PvMenu_i == MENU_SCOREALL )
	{ 
		MESSAGE_BEGIN( MSG_ALL, gmsgVGUIMenu ); 
			WRITE_BYTE( PvMenu_i ); 
		MESSAGE_END( );
	} 
	else 
	{ 
		MESSAGE_BEGIN( MSG_ONE, gmsgVGUIMenu, NULL, pev );
			WRITE_BYTE( PvMenu_i ); 
		MESSAGE_END( );
	} 
}

//=========================================================
// Multiplayer intermission spots.
//=========================================================
class CInfoIntermission:public CPointEntity
{
	void Spawn( void );
	void Think( void );
};
LINK_ENTITY_TO_CLASS( info_intermission, CInfoIntermission );

void CInfoIntermission::Spawn( void )
{
	UTIL_SetOrigin( pev, pev->origin );
	pev->solid = SOLID_NOT;
	pev->effects = EF_NODRAW;
	pev->v_angle = g_vecZero;

	pev->nextthink = gpGlobals->time + 2;// let targets spawn!

}

void CInfoIntermission::Think ( void )
{
	edict_t *pTarget;

	// find my target
	pTarget = FIND_ENTITY_BY_TARGETNAME( NULL, STRING(pev->target) );

	if( !FNullEnt( pTarget ))
	{
		pev->v_angle = UTIL_VecToAngles( (pTarget->v.origin - pev->origin).Normalize() );
		pev->v_angle.x = -pev->v_angle.x;
	}
}
